/* /work2/ssa/pgplot/src/grclpl.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* *GRCLPL -- clip line against clipping rectangle */
/* + */
/*<       SUBROUTINE GRCLPL (X0,Y0,X1,Y1,VIS) >*/
/* Subroutine */ int grclpl_(x0, y0, x1, y1, vis)
real *x0, *y0, *x1, *y1;
logical *vis;
{
    static real xmin, ymin, xmax, ymax;
    static integer c__;
    static real x, y;
    static integer c0, c1;
    extern /* Subroutine */ int grclip_();


/* GRPCKG (internal routine): Change the end-points of the line (X0,Y0) */
/* (X1,Y1) to clip the line at the window boundary.  The algorithm is */
/* that of Cohen and Sutherland (ref: Newman & Sproull). */

/* Arguments: */

/* X0, Y0 (input/output, real): device coordinates of starting point */
/*       of line. */
/* X1, Y1 (input/output, real): device coordinates of end point of line. */
/* VIS (output, logical): .TRUE. if line lies wholly or partially */
/*       within the clipping rectangle; .FALSE. if it lies entirely */
/*       outside the rectangle. */
/* -- */
/* 13-Jul-1984 - [TJP]. */
/* 20-Jun-1985 - [TJP] - revise clipping algorithm. */
/* 28-Jun-1991 - [TJP] - use IAND(). */
/* 12-Jun-1992 - [TJP] - clip exactly on the boundary. */

/* Caution: IAND is a non-standard intrinsic function to do bitwise AND */
/* of two integers. If it is not supported by your Fortran compiler, you */
/* will need to modify this routine or supply an IAND function. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       LOGICAL  VIS >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       INTEGER  C0,C1,C >*/
/*<       REAL     XMIN,XMAX,YMIN,YMAX >*/
/*<       REAL     X,Y, X0,Y0, X1,Y1 >*/
/*<       INTEGER IAND >*/

/*<       XMIN = GRXMIN(GRCIDE) >*/
    xmin = grcm00_1.grxmin[grcm00_1.grcide - 1];
/*<       YMIN = GRYMIN(GRCIDE) >*/
    ymin = grcm00_1.grymin[grcm00_1.grcide - 1];
/*<       XMAX = GRXMAX(GRCIDE) >*/
    xmax = grcm00_1.grxmax[grcm00_1.grcide - 1];
/*<       YMAX = GRYMAX(GRCIDE) >*/
    ymax = grcm00_1.grymax[grcm00_1.grcide - 1];
/*<       CALL GRCLIP(X0,Y0,XMIN,XMAX,YMIN,YMAX,C0) >*/
    grclip_(x0, y0, &xmin, &xmax, &ymin, &ymax, &c0);
/*<       CALL GRCLIP(X1,Y1,XMIN,XMAX,YMIN,YMAX,C1) >*/
    grclip_(x1, y1, &xmin, &xmax, &ymin, &ymax, &c1);
/*<    10 IF (C0.NE.0 .OR. C1.NE.0) THEN >*/
L10:
    if (c0 != 0 || c1 != 0) {
/*<           IF (IAND(C0,C1).NE.0) THEN >*/
	if ((c0 & c1) != 0) {
/*             ! line is invisible */
/*<               VIS = .FALSE. >*/
	    *vis = FALSE_;
/*<               RETURN >*/
	    return 0;
/*<           END IF >*/
	}
/*<           C = C0 >*/
	c__ = c0;
/*<           IF (C.EQ.0) C = C1 >*/
	if (c__ == 0) {
	    c__ = c1;
	}
/*<           IF (IAND(C,1).NE.0) THEN >*/
	if ((c__ & 1) != 0) {
/*             ! crosses XMIN */
/*<               Y = Y0 + (Y1-Y0)*(XMIN-X0)/(X1-X0) >*/
	    y = *y0 + (*y1 - *y0) * (xmin - *x0) / (*x1 - *x0);
/*<               X = XMIN >*/
	    x = xmin;
/*<           ELSE IF (IAND(C,2).NE.0) THEN >*/
	} else if ((c__ & 2) != 0) {
/*             ! crosses XMAX */
/*<               Y = Y0 + (Y1-Y0)*(XMAX-X0)/(X1-X0) >*/
	    y = *y0 + (*y1 - *y0) * (xmax - *x0) / (*x1 - *x0);
/*<               X = XMAX >*/
	    x = xmax;
/*<           ELSE IF (IAND(C,4).NE.0) THEN >*/
	} else if ((c__ & 4) != 0) {
/*             ! crosses YMIN */
/*<               X = X0 + (X1-X0)*(YMIN-Y0)/(Y1-Y0) >*/
	    x = *x0 + (*x1 - *x0) * (ymin - *y0) / (*y1 - *y0);
/*<               Y = YMIN >*/
	    y = ymin;
/*<           ELSE IF (IAND(C,8).NE.0) THEN >*/
	} else if ((c__ & 8) != 0) {
/*             ! crosses YMAX */
/*<               X = X0 + (X1-X0)*(YMAX-Y0)/(Y1-Y0) >*/
	    x = *x0 + (*x1 - *x0) * (ymax - *y0) / (*y1 - *y0);
/*<               Y = YMAX >*/
	    y = ymax;
/*<           END IF >*/
	}
/*<           IF (C.EQ.C0) THEN >*/
	if (c__ == c0) {
/*<               X0 = X >*/
	    *x0 = x;
/*<               Y0 = Y >*/
	    *y0 = y;
/*<               CALL GRCLIP(X,Y,XMIN,XMAX,YMIN,YMAX,C0) >*/
	    grclip_(&x, &y, &xmin, &xmax, &ymin, &ymax, &c0);
/*<           ELSE >*/
	} else {
/*<               X1 = X >*/
	    *x1 = x;
/*<               Y1 = Y >*/
	    *y1 = y;
/*<               CALL GRCLIP(X,Y,XMIN,XMAX,YMIN,YMAX,C1) >*/
	    grclip_(&x, &y, &xmin, &xmax, &ymin, &ymax, &c1);
/*<           END IF >*/
	}
/*<       GOTO 10 >*/
	goto L10;
/*<       END IF >*/
    }
/*<       VIS = .TRUE. >*/
    *vis = TRUE_;
/*<       END >*/
} /* grclpl_ */

