/* /work2/ssa/pgplot/src/grctoi.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* *GRCTOI -- convert character string to integer */
/* + */
/*<       INTEGER FUNCTION GRCTOI (S, I) >*/
integer grctoi_(s, i__, s_len)
char *s;
integer *i__;
ftnlen s_len;
{
    /* Initialized data */

    static char digits[1*10+1] = "0123456789";

    /* System generated locals */
    integer ret_val;

    /* Builtin functions */
    integer i_len();

    /* Local variables */
    static integer sign, k, x;

/*<       CHARACTER*(*) S >*/
/*<       INTEGER I >*/

/* GRCTOI: attempt to read an integer from a character string, and return */
/* the result. No attempt is made to avoid integer overflow. A valid */
/* integer is any sequence of decimal digits. */

/* Returns: */
/*  GRCTOI           : the value of the integer; if the first character */
/*                    read is not a decimal digit, the value returned */
/*                    is zero. */
/* Arguments: */
/*  S      (input)  : character string to be parsed. */
/*  I      (in/out) : on input, I is the index of the first character */
/*                    in S to be examined; on output, either it points */
/*                    to the next character after a valid integer, or */
/*                    it is equal to LEN(S)+1. */

/* -- */
/*  1985 Oct  8 - New routine, based on CTOI (T. J. Pearson). */
/*  1997 Jun  3 - allow leading + or - sign (TJP). */
/* ----------------------------------------------------------------------- */
/*<       INTEGER K, SIGN, X >*/
/*<       CHARACTER*1 DIGITS(0:9) >*/
/*<       DATA  DIGITS/'0','1','2','3','4','5','6','7','8','9'/ >*/

/*<       X = 0 >*/
    x = 0;
/*<       SIGN = +1 >*/
    sign = 1;
/*<       IF (I.GT.LEN(S)) GOTO 30 >*/
    if (*i__ > i_len(s, s_len)) {
	goto L30;
    }
/*<       IF (S(I:I).EQ.'+') THEN >*/
    if (*(unsigned char *)&s[*i__ - 1] == '+') {
/*<          I = I+1 >*/
	++(*i__);
/*<       ELSE IF (S(I:I).EQ.'-') THEN >*/
    } else if (*(unsigned char *)&s[*i__ - 1] == '-') {
/*<          I = I+1 >*/
	++(*i__);
/*<          SIGN = -1 >*/
	sign = -1;
/*<       END IF >*/
    }
/*<  10   IF (I.GT.LEN(S)) GOTO 30 >*/
L10:
    if (*i__ > i_len(s, s_len)) {
	goto L30;
    }
/*<       DO 20 K=0,9 >*/
    for (k = 0; k <= 9; ++k) {
/*<          IF (S(I:I).EQ.DIGITS(K)) THEN >*/
	if (*(unsigned char *)&s[*i__ - 1] == *(unsigned char *)&digits[k]) {
/*<             X = X*10 + K >*/
	    x = x * 10 + k;
/*<             I = I+1 >*/
	    ++(*i__);
/*<             GOTO 10 >*/
	    goto L10;
/*<          END IF >*/
	}
/*<  20   CONTINUE >*/
/* L20: */
    }
/*<  30   GRCTOI = X*SIGN >*/
L30:
    ret_val = x * sign;
/*<       RETURN >*/
    return ret_val;
/*<       END >*/
} /* grctoi_ */

