/* /work2/ssa/pgplot/src/grdtyp.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* Table of constant values */

static integer c__0 = 0;
static integer c__1 = 1;

/* *GRDTYP -- decode graphics device type string */
/* + */
/*<       INTEGER FUNCTION GRDTYP (TEXT) >*/
integer grdtyp_(text, text_len)
char *text;
ftnlen text_len;
{
    /* System generated locals */
    integer ret_val, i__1, i__2;

    /* Builtin functions */
    integer i_nint(), s_cmp();

    /* Local variables */
    static integer code, lchr, nbuf, ndev;
    static real rbuf[6];
    static integer i__, l, match;
    extern /* Subroutine */ int grexec_();
    extern integer grtrim_();
    static char chr[32];


/* GRPCKG (internal routine): determine graphics device type code from */
/* type name. It compares the argument with the table of known device */
/* types in common. */

/* Argument: */

/* TEXT (input, character): device type name, eg 'PRINTRONIX'; the name */
/*       may be abbreviated to uniqueness. */

/* Returns: */

/* GRDTYP (integer): the device type code, in the range 1 to */
/*       GRTMAX, zero if the type name is not recognised, or -1 */
/*       if the type name is ambiguous. */
/* -- */
/* 27-Dec-1984 - rewrite so that is doesn't have to be modified for */
/*               new devices [TJP]. */
/*  5-Aug-1986 - add GREXEC support [AFT]. */
/* 10-Nov-1995 - ignore drivers that report no device type [TJP]. */
/* 30-Aug-1996 - check for an exact match; indicate if type is */
/*               ambiguous [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       CHARACTER*(*) TEXT >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       INTEGER  CODE, I, L, MATCH >*/
/*<       REAL     RBUF(6) >*/
/*<       INTEGER NDEV,NBUF,LCHR >*/
/*<       INTEGER GRTRIM >*/
/*<       CHARACTER*32 CHR >*/

/*<       GRDTYP = 0 >*/
    ret_val = 0;
/*<       L = GRTRIM(TEXT) >*/
    l = grtrim_(text, text_len);
/*<       IF (L.LT.1) RETURN >*/
    if (l < 1) {
	return ret_val;
    }
/*<       MATCH = 0 >*/
    match = 0;
/*<       CODE = 0 >*/
    code = 0;
/*<       CALL GREXEC(0,0,RBUF,NBUF,CHR,LCHR) >*/
    grexec_(&c__0, &c__0, rbuf, &nbuf, chr, &lchr, (ftnlen)32);
/*<       NDEV=NINT(RBUF(1)) >*/
    ndev = i_nint(rbuf);
/*<       DO 30 I=1,NDEV >*/
    i__1 = ndev;
    for (i__ = 1; i__ <= i__1; ++i__) {
/*<          CALL GREXEC(I, 1,RBUF,NBUF,CHR,LCHR) >*/
	grexec_(&i__, &c__1, rbuf, &nbuf, chr, &lchr, (ftnlen)32);
/*<          IF (LCHR.GT.0) THEN >*/
	if (lchr > 0) {
/*<             IF(TEXT(1:L).EQ.CHR(1:L)) THEN >*/
	    if (s_cmp(text, chr, l, l) == 0) {
/*<                IF (CHR(L+1:L+1).EQ.' ') THEN >*/
		i__2 = l;
		if (s_cmp(chr + i__2, " ", l + 1 - i__2, (ftnlen)1) == 0) {
/*                 -- exact match */
/*<                   GRDTYP = I >*/
		    ret_val = i__;
/*<                   GRGTYP = GRDTYP >*/
		    grcm00_1.grgtyp = ret_val;
/*<                   RETURN >*/
		    return ret_val;
/*<                ELSE >*/
		} else {
/*<                   MATCH = MATCH+1 >*/
		    ++match;
/*<                   CODE = I >*/
		    code = i__;
/*<                END IF >*/
		}
/*<             END IF >*/
	    }
/*<          END IF >*/
	}
/*<    30 CONTINUE >*/
/* L30: */
    }
/*<       IF (MATCH.EQ.0) THEN >*/
    if (match == 0) {
/*        -- no match */
/*<          GRDTYP = 0 >*/
	ret_val = 0;
/*<       ELSE IF (MATCH.EQ.1) THEN >*/
    } else if (match == 1) {
/*<          GRDTYP = CODE >*/
	ret_val = code;
/*<          GRGTYP = GRDTYP >*/
	grcm00_1.grgtyp = ret_val;
/*<       ELSE >*/
    } else {
/*<          GRDTYP = -1 >*/
	ret_val = -1;
/*<       END IF >*/
    }

/*<       END >*/
    return ret_val;
} /* grdtyp_ */

