/* /work2/ssa/pgplot/src/grgray.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* Table of constant values */

static integer c__0 = 0;
static integer c__1 = 1;

/* *GRGRAY -- gray-scale map of a 2D data array */
/* + */
/*<    >*/
/* Subroutine */ int grgray_(a, idim, jdim, i1, i2, j1, j2, fg, bg, pa, 
	minind, maxind, mode)
real *a;
integer *idim, *jdim, *i1, *i2, *j1, *j2;
real *fg, *bg, *pa;
integer *minind, *maxind, *mode;
{
    /* System generated locals */
    integer a_dim1, a_offset, i__1;
    real r__1, r__2, r__3;

    /* Local variables */
    static integer i__;
    extern /* Subroutine */ int grqcr_(), grscr_();
    static real a0, a1;
    extern /* Subroutine */ int grimg0_(), grimg3_();
    static real cg0, cb0, cg1, cr0, cr1, cb1;

/*<       INTEGER IDIM, JDIM, I1, I2, J1, J2, MININD, MAXIND, MODE >*/
/*<       REAL    A(IDIM,JDIM) >*/
/*<       REAL    FG, BG >*/
/*<       REAL    PA(6) >*/

/* This is a device-dependent support routine for PGGRAY. */

/* Draw gray-scale map of an array in current window. Array */
/* values between FG and BG are shaded in gray levels determined */
/* by linear interpolation. FG may be either less than or greater */
/* than BG.  Array values outside the range FG to BG are */
/* shaded black or white as appropriate. */

/* GRGRAY uses GRIMG0 on devices with enough color indices available. */
/* Note that it changes the color table to gray-scale. */
/* Otherwise in does a random dither with GRIMG3. */

/* Arguments: */
/*  A      (input)  : the array to be plotted. */
/*  IDIM   (input)  : the first dimension of array A. */
/*  JDIM   (input)  : the second dimension of array A. */
/*  I1, I2 (input)  : the inclusive range of the first index */
/*                    (I) to be plotted. */
/*  J1, J2 (input)  : the inclusive range of the second */
/*                    index (J) to be plotted. */
/*  FG     (input)  : the array value which is to appear in */
/*                    foreground color. */
/*  BG     (input)  : the array value which is to appear in */
/*                    background color. */
/*  PA     (input)  : transformation matrix between array grid and */
/*                    device coordinates (see GRCONT). */
/*  MODE   (input)  : transfer function. */
/* -- */
/* 12-Dec-1986 - Speed up plotting [J. Biretta]. */
/*  3-Apr-1987 - Add special code for /PS, /VPS, /GR. */
/*  2-Sep-1987 - Adapted from PGGRAY [TJP]. */
/*  1-Dec-1988 - Put random-number generator inline [TJP]. */
/*  3-Apr-1989 - Use "line of pixels" primitive where available [TJP]. */
/*  6-Sep-1989 - Changes for standard Fortran-77 [TJP]. */
/* 19-Jan-1990 - Add special code for /CPS, /VCPS [DLM] */
/*  3-Sep-1992 - Add special code for NULL device [TJP]. */
/* 25-Nov-1992 - Add special code for /NEXT [AFT]. */
/* 17-Mar-1994 - Scale in device coordinates [TJP]. */
/* 31-Aug-1994 - use GRIMG0 when appropriate [TJP]. */
/*  7-Sep-1994 - speed up random dither [TJP]. */
/*  8-Feb-1995 - use color ramp based on color indices 0 and 1 [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       INTEGER I >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       REAL    A0, A1, CR0, CG0, CB0, CR1, CG1, CB1 >*/
/*<       INTRINSIC REAL >*/
/* ----------------------------------------------------------------------- */

/* N.B. Arguments are assumed to be valid (checked by PGGRAY). */

/* Use GRIMG0 if this an appropriate device; first initialize the */
/* color table to a linear ramp between the colors assigned to color */
/* indices 0 and 1. */

/*<       IF (GRGCAP(GRCIDE)(7:7).NE.'N' .AND. MAXIND-MININD .GT. 15) THEN >*/
    /* Parameter adjustments */
    a_dim1 = *idim;
    a_offset = 1 + a_dim1 * 1;
    a -= a_offset;
    --pa;

    /* Function Body */
    if (*(unsigned char *)&grcm01_1.grgcap[(grcm00_1.grcide - 1) * 11 + 6] != 
	    'N' && *maxind - *minind > 15) {
/*<          CALL GRQCR(0, CR0, CG0, CB0) >*/
	grqcr_(&c__0, &cr0, &cg0, &cb0);
/*<          CALL GRQCR(1, CR1, CG1, CB1) >*/
	grqcr_(&c__1, &cr1, &cg1, &cb1);
/*<          DO 5 I=MININD,MAXIND >*/
	i__1 = *maxind;
	for (i__ = *minind; i__ <= i__1; ++i__) {
/*<             A0 = REAL(I-MININD)/REAL(MAXIND-MININD) >*/
	    a0 = (real) (i__ - *minind) / (real) (*maxind - *minind);
/*<             A1 = 1.0 - A0 >*/
	    a1 = (float)1. - a0;
/*<             CALL GRSCR(I, A0*CR0+A1*CR1, A0*CG0+A1*CG1, A0*CB0+A1*CB1) >*/
	    r__1 = a0 * cr0 + a1 * cr1;
	    r__2 = a0 * cg0 + a1 * cg1;
	    r__3 = a0 * cb0 + a1 * cb1;
	    grscr_(&i__, &r__1, &r__2, &r__3);
/*<  5       CONTINUE >*/
/* L5: */
	}
/*<    >*/
	grimg0_(&a[a_offset], idim, jdim, i1, i2, j1, j2, fg, bg, &pa[1], 
		minind, maxind, mode);
/*<          RETURN >*/
	return 0;

/* Otherwise use random dither in current color index. */

/*<       ELSE >*/
    } else {
/*<    >*/
	grimg3_(&a[a_offset], idim, jdim, i1, i2, j1, j2, fg, bg, &pa[1], 
		mode);
/*<       END IF >*/
    }
/* ----------------------------------------------------------------------- */
/*<       END >*/
} /* grgray_ */

