/* /work2/ssa/pgplot/src/gropen.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* Table of constant values */

static integer c__5 = 5;
static integer c__9 = 9;
static integer c__2 = 2;
static integer c__3 = 3;
static integer c__7 = 7;
static integer c__6 = 6;
static integer c__4 = 4;
static real c_b15 = (float)0.;
static real c_b17 = (float)1.;

/* *GROPEN -- open device for graphics */
/* + */
/*<       INTEGER FUNCTION GROPEN (TYPE,DUMMY,FILE,IDENT) >*/
integer gropen_(type__, dummy, file, ident, file_len)
integer *type__, *dummy;
char *file;
integer *ident;
ftnlen file_len;
{
    /* System generated locals */
    integer ret_val, i__1, i__2;

    /* Builtin functions */
    /* Subroutine */ int s_copy();
    integer s_cmp(), i_len();

    /* Local variables */
    static integer lchr, nbuf;
    static real rbuf[6];
    static char ffile[128];
    static integer ftype;
    extern /* Subroutine */ int grtrn0_();
    static logical append;
    extern /* Subroutine */ int grexec_(), grinit_();
    extern integer grpars_();
    extern /* Subroutine */ int grslct_();
    extern integer grtrim_();
    extern /* Subroutine */ int grwarn_();
    static char chr[128];
    static integer ier;

/*<       INTEGER   TYPE, DUMMY, IDENT >*/
/*<       CHARACTER*(*) FILE >*/

/* GRPCKG: assign a device and prepare for plotting.  GROPEN must be */
/* called before all other calls to GRPCKG routines. */

/* Returns: */

/* GROPEN (output, integer): 1 => success, any other value */
/*       indicates a failure (usually the value returned will */
/*       be a VMS error code). In the event of an error, a */
/*       message will be sent to the standard error unit. */

/* Arguments: */

/* TYPE (input, integer): default device type (integer code). */
/* DUMMY (input, integer): not used at present. */
/* FILE (input, character): plot specifier, of form 'device/type'. */
/* IDENT (output, integer): plot identifier to be used in later */
/*       calls to GRPCKG. */

/*  1-Jun-1984 - [TJP]. */
/*  2-Jul-1984 - change to call GRSLCT [TJP]. */
/* 13-Jul-1984 - add device initialization [TJP]. */
/* 23-Jul-1984 - add /APPEND qualifier. */
/* 19-Oct-1984 - add VV device [TJP]. */
/* 26-Dec-1984 - obtain default file name from common [TJP]. */
/* 29-Jan-1985 - add HP2648 device [KS/TJP]. */
/*  5-Aug-1986 - add GREXEC support [AFT]. */
/* 12-Oct-1986 - fix bug causing GREXEC to erase screen [AFT]. */
/*  3-Jun-1987 - remove declaration of exit handler [TJP]. */
/* 15-Dec-1988 - standardize [TJP]. */
/* 25-Jun-1989 - remove code that removes spaces from the device name */
/*               [TJP]. */
/* 26-Nov-1990 - [TJP]. */
/*  5-Jan-1993 - [TJP]. */
/*  1-Sep-1994 - store device capabilities in common for later use [TJP]. */
/* 17-Apr-1995 - zero-length string fix [TJP]. */
/*  6-Jun-1995 - explicitly initialize GRSTAT [TJP]. */
/* 29-Apr-1996 - moved initialization into GRINIT [TJP]. */
/* 12-Jul-1999 - fix bug [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       INTEGER   IER, FTYPE, NBUF, LCHR >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       INTEGER   GRPARS, GRTRIM >*/
/*<       REAL      RBUF(6) >*/
/*<       LOGICAL   APPEND >*/
/*<       CHARACTER*128 FFILE,CHR >*/

/* Initialize GRPCKG; read font file (if necessary). */

/*<       CALL GRINIT >*/
    grinit_();

/* Allocate an identifier. */

/*<       IDENT = 1 >*/
    *ident = 1;
/*<    10 IF (GRSTAT(IDENT).NE.0) THEN >*/
L10:
    if (grcm00_1.grstat[*ident - 1] != 0) {
/*<           IDENT = IDENT+1 >*/
	++(*ident);
/*<           IF (IDENT.GT.GRIMAX) THEN >*/
	if (*ident > 8) {
/*<               CALL GRWARN('Too many active plots.') >*/
	    grwarn_("Too many active plots.", (ftnlen)22);
/*<               GROPEN = -1 >*/
	    ret_val = -1;
/*<               IDENT = 0 >*/
	    *ident = 0;
/*<               RETURN >*/
	    return ret_val;
/*<           END IF >*/
	}
/*<       GOTO 10 >*/
	goto L10;
/*<       END IF >*/
    }

/* Validate the device specification. */

/*<       IER = GRPARS(FILE,FFILE,FTYPE,APPEND) >*/
    ier = grpars_(file, ffile, &ftype, &append, file_len, (ftnlen)128);
/*<       IF (IER.NE.1) THEN >*/
    if (ier != 1) {
/*<           CHR = 'Invalid device specification: ' >*/
	s_copy(chr, "Invalid device specification: ", (ftnlen)128, (ftnlen)30)
		;
/*<           CHR(31:) = FILE >*/
	s_copy(chr + 30, file, (ftnlen)98, file_len);
/*<           CALL GRWARN(CHR) >*/
	grwarn_(chr, (ftnlen)128);
/*<           GROPEN = -1 >*/
	ret_val = -1;
/*<           RETURN >*/
	return ret_val;
/*<       END IF >*/
    }
/*<       IF (FTYPE.EQ.0) FTYPE = TYPE >*/
    if (ftype == 0) {
	ftype = *type__;
    }
/*<       IF (1.LE.FTYPE) THEN >*/
    if (1 <= ftype) {
/*<           GRTYPE(IDENT) = FTYPE >*/
	grcm00_1.grtype[*ident - 1] = ftype;
/*<       ELSE >*/
    } else {
/*<           CHR = 'Device type omitted or invalid: ' >*/
	s_copy(chr, "Device type omitted or invalid: ", (ftnlen)128, (ftnlen)
		32);
/*<           CHR(33:) = FILE >*/
	s_copy(chr + 32, file, (ftnlen)96, file_len);
/*<           CALL GRWARN(CHR) >*/
	grwarn_(chr, (ftnlen)128);
/*<           GROPEN = -1 >*/
	ret_val = -1;
/*<           RETURN >*/
	return ret_val;
/*<       END IF >*/
    }

/* Install the file name, or assign default. */

/*<       IF (FFILE.EQ.' ') THEN >*/
    if (s_cmp(ffile, " ", (ftnlen)128, (ftnlen)1) == 0) {
/*<           CALL GREXEC(GRTYPE(IDENT), 5,RBUF,NBUF,FFILE,LCHR) >*/
	grexec_(&grcm00_1.grtype[*ident - 1], &c__5, rbuf, &nbuf, ffile, &
		lchr, (ftnlen)128);
/*<       END IF >*/
    }
/*<       GRFILE(IDENT) = FFILE >*/
    s_copy(grcm01_1.grfile + (*ident - 1) * 90, ffile, (ftnlen)90, (ftnlen)
	    128);
/*<       GRFNLN(IDENT) = MAX(1,GRTRIM(GRFILE(IDENT))) >*/
/* Computing MAX */
    i__1 = 1, i__2 = grtrim_(grcm01_1.grfile + (*ident - 1) * 90, (ftnlen)90);
    grcm00_1.grfnln[*ident - 1] = max(i__1,i__2);

/* Open workstation. */

/*<       RBUF(3)=0 >*/
    rbuf[2] = (float)0.;
/*<       IF (APPEND) RBUF(3)=1 >*/
    if (append) {
	rbuf[2] = (float)1.;
    }
/*<       NBUF=3 >*/
    nbuf = 3;
/*<       CALL GREXEC(GRGTYP, 9,RBUF,NBUF, GRFILE(IDENT),GRFNLN(IDENT)) >*/
    grexec_(&grcm00_1.grgtyp, &c__9, rbuf, &nbuf, grcm01_1.grfile + (*ident - 
	    1) * 90, &grcm00_1.grfnln[*ident - 1], (ftnlen)90);
/*<       GROPEN=RBUF(2) >*/
    ret_val = rbuf[1];
/*<       IF (GROPEN.NE.1) THEN >*/
    if (ret_val != 1) {
/*<          IDENT = 0 >*/
	*ident = 0;
/*<          RETURN >*/
	return ret_val;
/*<       END IF >*/
    }
/*<       GRGTYP = GRTYPE(IDENT) >*/
    grcm00_1.grgtyp = grcm00_1.grtype[*ident - 1];
/*<       GRUNIT(IDENT)=RBUF(1) >*/
    grcm00_1.grunit[*ident - 1] = rbuf[0];
/*<       GRPLTD(IDENT) = .FALSE. >*/
    grcm00_1.grpltd[*ident - 1] = FALSE_;
/*<       GRSTAT(IDENT) = 1 >*/
    grcm00_1.grstat[*ident - 1] = 1;
/*<       CALL GRSLCT(IDENT) >*/
    grslct_(ident);

/* Install the default plot parameters */

/* --- Inquire color-index range. */
/*<       CALL GREXEC(GRGTYP, 2,RBUF,NBUF,CHR,LCHR) >*/
    grexec_(&grcm00_1.grgtyp, &c__2, rbuf, &nbuf, chr, &lchr, (ftnlen)128);
/*<       GRMNCI(IDENT)=RBUF(5) >*/
    grcm00_1.grmnci[*ident - 1] = rbuf[4];
/*<       GRMXCI(IDENT)=RBUF(6) >*/
    grcm00_1.grmxci[*ident - 1] = rbuf[5];
/* --- Inquire resolution. */
/*<       CALL GREXEC(GRGTYP, 3,RBUF,NBUF,CHR,LCHR) >*/
    grexec_(&grcm00_1.grgtyp, &c__3, rbuf, &nbuf, chr, &lchr, (ftnlen)128);
/*<       GRPXPI(IDENT)=RBUF(1) >*/
    grcm00_1.grpxpi[*ident - 1] = rbuf[0];
/*<       GRPYPI(IDENT)=RBUF(2) >*/
    grcm00_1.grpypi[*ident - 1] = rbuf[1];
/* --- Inquire default character size. */
/*<       CALL GREXEC(GRGTYP, 7,RBUF,NBUF,CHR,LCHR) >*/
    grexec_(&grcm00_1.grgtyp, &c__7, rbuf, &nbuf, chr, &lchr, (ftnlen)128);
/*<       GRCSCL(IDENT) = RBUF(1) >*/
    grcm00_1.grcscl[*ident - 1] = rbuf[0];
/*<       GRCFAC(IDENT) = RBUF(1) >*/
    grcm00_1.grcfac[*ident - 1] = rbuf[0];
/* --- Inquire default plot size. */
/*<       CALL GREXEC(GRGTYP, 6,RBUF,NBUF,CHR,LCHR) >*/
    grexec_(&grcm00_1.grgtyp, &c__6, rbuf, &nbuf, chr, &lchr, (ftnlen)128);
/*<       GRXMXA(IDENT) = RBUF(2) >*/
    grcm00_1.grxmxa[*ident - 1] = rbuf[1];
/*<       GRYMXA(IDENT) = RBUF(4) >*/
    grcm00_1.grymxa[*ident - 1] = rbuf[3];
/*<       GRXMIN(IDENT) = RBUF(1) >*/
    grcm00_1.grxmin[*ident - 1] = rbuf[0];
/*<       GRXMAX(IDENT) = RBUF(2) >*/
    grcm00_1.grxmax[*ident - 1] = rbuf[1];
/*<       GRYMIN(IDENT) = RBUF(3) >*/
    grcm00_1.grymin[*ident - 1] = rbuf[2];
/*<       GRYMAX(IDENT) = RBUF(4) >*/
    grcm00_1.grymax[*ident - 1] = rbuf[3];
/* --- Inquire device capabilities. */
/*<       GRGCAP(IDENT) = 'NNNNNNNNNNN' >*/
    s_copy(grcm01_1.grgcap + (*ident - 1) * 11, "NNNNNNNNNNN", (ftnlen)11, (
	    ftnlen)11);
/*<       CALL GREXEC(GRGTYP, 4,RBUF,NBUF,CHR,LCHR) >*/
    grexec_(&grcm00_1.grgtyp, &c__4, rbuf, &nbuf, chr, &lchr, (ftnlen)128);
/*<       IF (LCHR.GT.LEN(GRGCAP(IDENT))) LCHR = LEN(GRGCAP(IDENT)) >*/
    if (lchr > i_len(grcm01_1.grgcap + (*ident - 1) * 11, (ftnlen)11)) {
	lchr = i_len(grcm01_1.grgcap + (*ident - 1) * 11, (ftnlen)11);
    }
/*<       GRGCAP(IDENT)(1:LCHR) = CHR(:LCHR) >*/
    s_copy(grcm01_1.grgcap + (*ident - 1) * 11, chr, lchr, lchr);
/* --- Current pen position. */
/*<       GRXPRE(IDENT) = 0.0 >*/
    grcm00_1.grxpre[*ident - 1] = (float)0.;
/*<       GRYPRE(IDENT) = 0.0 >*/
    grcm00_1.grypre[*ident - 1] = (float)0.;
/* --- GRSETS has not been called. */
/*<       GRADJU(IDENT) = .FALSE. >*/
    grcm00_1.gradju[*ident - 1] = FALSE_;
/* ---Default scaling. */
/*<       CALL GRTRN0(0.0, 0.0, 1.0, 1.0) >*/
    grtrn0_(&c_b15, &c_b15, &c_b17, &c_b17);

/* Default attributes. */
/*  text font (normal) */
/*  color (white) */
/*  line-style (full) */
/*  line-width (minimum) */
/*  marker number (dot) */

/*<       GRCFNT(IDENT) = 1 >*/
    grcm00_1.grcfnt[*ident - 1] = 1;
/*<       GRCCOL(IDENT) = 1 >*/
    grcm00_1.grccol[*ident - 1] = 1;
/*<       GRSTYL(IDENT) = 1 >*/
    grcm00_1.grstyl[*ident - 1] = 1;
/*<       GRWIDT(IDENT) = 1 >*/
    grcm00_1.grwidt[*ident - 1] = 1;
/*<       GRCMRK(IDENT) = 1 >*/
    grcm00_1.grcmrk[*ident - 1] = 1;
/*<       GRDASH(IDENT) = .FALSE. >*/
    grcm00_1.grdash[*ident - 1] = FALSE_;

/*<       GROPEN = 1 >*/
    ret_val = 1;

/*<       END >*/
    return ret_val;
} /* gropen_ */

