/* /work2/ssa/pgplot/src/grpars.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* *GRPARS -- parse device specification string */
/* + */
/*<       INTEGER FUNCTION GRPARS (SPEC,DEV,TYPE,APPEND) >*/
integer grpars_(spec, dev, type__, append, spec_len, dev_len)
char *spec, *dev;
integer *type__;
logical *append;
ftnlen spec_len;
ftnlen dev_len;
{
    /* Initialized data */

    static char appstr[6+1] = "APPEND";

    /* System generated locals */
    integer ret_val, i__1;

    /* Builtin functions */
    /* Subroutine */ int s_copy();
    integer i_len(), s_cmp();

    /* Local variables */
    static integer l;
    static char descr[256], ctype[32], upper[32];
    static integer lc, ls;
    extern /* Subroutine */ int grgenv_(), grwarn_(), grlgtr_();
    extern integer grtrim_(), grdtyp_();
    extern /* Subroutine */ int grtoup_();

/*<       CHARACTER*(*) SPEC, DEV >*/
/*<       INTEGER  TYPE >*/
/*<       LOGICAL  APPEND >*/

/* GRPCKG: decode a device-specification; called by GROPEN. */

/* Returns: */
/*  GRPARS (output): 1 if the device-specification is */
/*       acceptable; any other value indicates an error. */

/* Arguments: */
/*  SPEC (input): the device specification. */
/*  DEV  (output):  device name or file spec. */
/*  TYPE (output): device type (integer code); 0 if no device */
/*       type is specified. */
/*  APPEND (output): .TRUE. if /APPEND specified, .FALSE. otherwise. */
/* -- */
/* 23-Jul-1984 - [TJP]. */
/* 19-Feb-1988 - allow device part to be quoted [TJP]. */
/* 30-Mar-1989 - remove logical translation of device and type [TJP]. */
/* 17-Jun-1991 - ignore comments after ' (' [TJP]. */
/* 19-Dec-1994 - rewritten to scan backwards [TJP]. */
/*  6-Jun-1995 - correct a zero-length string problem [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       CHARACTER*32  CTYPE, UPPER >*/
/*<       CHARACTER*6   APPSTR >*/
/*<       CHARACTER*256 DESCR >*/
/*<       INTEGER       GRDTYP, GRTRIM >*/
/*<       INTEGER       L, LC, LS >*/
/*<       DATA          APPSTR/'APPEND'/ >*/

/* Default results. */

/*<       DEV = ' ' >*/
    s_copy(dev, " ", dev_len, (ftnlen)1);
/*<       TYPE = 0 >*/
    *type__ = 0;
/*<       APPEND = .FALSE. >*/
    *append = FALSE_;
/*<       GRPARS = 1 >*/
    ret_val = 1;
/*<       CTYPE = ' ' >*/
    s_copy(ctype, " ", (ftnlen)32, (ftnlen)1);

/* Null string is acceptable. */

/*<       IF (LEN(SPEC).LT.1) RETURN >*/
    if (i_len(spec, spec_len) < 1) {
	return ret_val;
    }
/*<       IF (SPEC.EQ.' ') RETURN >*/
    if (s_cmp(spec, " ", spec_len, (ftnlen)1) == 0) {
	return ret_val;
    }

/* On systems where it is possible, perform a "logical name" translation. */

/*<       DESCR = SPEC >*/
    s_copy(descr, spec, (ftnlen)256, spec_len);
/*<       CALL GRLGTR(DESCR) >*/
    grlgtr_(descr, (ftnlen)256);

/* Discard trailing blanks: L is length of remainder. */

/*<       L = GRTRIM(DESCR) >*/
    l = grtrim_(descr, (ftnlen)256);

/* Find last slash in string (position LS or 0). */

/*<       LS = L >*/
    ls = l;
/*<  20   IF (DESCR(LS:LS).NE.'/') THEN >*/
L20:
    if (*(unsigned char *)&descr[ls - 1] != '/') {
/*<          LS = LS-1 >*/
	--ls;
/*<          IF (LS.GT.0) GOTO 20 >*/
	if (ls > 0) {
	    goto L20;
	}
/*<       END IF >*/
    }

/* Check for /APPEND qualifier; if present, look again for type. */

/*<       IF (LS.GT.0) THEN >*/
    if (ls > 0) {
/*<          CTYPE = DESCR(LS+1:L) >*/
	i__1 = ls;
	s_copy(ctype, descr + i__1, (ftnlen)32, l - i__1);
/*<          CALL GRTOUP(UPPER,CTYPE) >*/
	grtoup_(upper, ctype, (ftnlen)32, (ftnlen)32);
/*<          CTYPE = UPPER >*/
	s_copy(ctype, upper, (ftnlen)32, (ftnlen)32);
/*<          IF (CTYPE.EQ.APPSTR) THEN >*/
	if (s_cmp(ctype, appstr, (ftnlen)32, (ftnlen)6) == 0) {
/*<             APPEND = .TRUE. >*/
	    *append = TRUE_;
/*<             L = LS-1 >*/
	    l = ls - 1;
/*<             LS = L >*/
	    ls = l;
/*<  30         IF (DESCR(LS:LS).NE.'/') THEN >*/
L30:
	    if (*(unsigned char *)&descr[ls - 1] != '/') {
/*<                LS = LS-1 >*/
		--ls;
/*<                IF (LS.GT.0) GOTO 30 >*/
		if (ls > 0) {
		    goto L30;
		}
/*<             END IF >*/
	    }
/*<          ELSE >*/
	} else {
/*<             APPEND = .FALSE. >*/
	    *append = FALSE_;
/*<          END IF >*/
	}
/*<       END IF >*/
    }

/* If LS=0 there is no type field: use PGPLOT_TYPE. */

/*<       IF (LS.EQ.0) THEN >*/
    if (ls == 0) {
/*<          CALL GRGENV('TYPE', CTYPE, LC) >*/
	grgenv_("TYPE", ctype, &lc, (ftnlen)4, (ftnlen)32);
/*<       ELSE >*/
    } else {
/*<          CTYPE = DESCR(LS+1:L) >*/
	i__1 = ls;
	s_copy(ctype, descr + i__1, (ftnlen)32, l - i__1);
/*<          LC = L-LS >*/
	lc = l - ls;
/*<          L = LS-1 >*/
	l = ls - 1;
/*<       END IF >*/
    }

/* Check for allowed type. */

/*<       IF (LC.GT.0) THEN >*/
    if (lc > 0) {
/*<          CALL GRTOUP(UPPER,CTYPE) >*/
	grtoup_(upper, ctype, (ftnlen)32, (ftnlen)32);
/*<          CTYPE = UPPER >*/
	s_copy(ctype, upper, (ftnlen)32, (ftnlen)32);
/*<          TYPE = GRDTYP(CTYPE) >*/
	*type__ = grdtyp_(ctype, (ftnlen)32);
/*<          IF (TYPE.EQ.0) CALL GRWARN('Unrecognized device type') >*/
	if (*type__ == 0) {
	    grwarn_("Unrecognized device type", (ftnlen)24);
	}
/*<          IF (TYPE.EQ.-1) CALL GRWARN('Device type is ambiguous') >*/
	if (*type__ == -1) {
	    grwarn_("Device type is ambiguous", (ftnlen)24);
	}
/*<       ELSE >*/
    } else {
/*<          TYPE = 0 >*/
	*type__ = 0;
/*<          CALL GRWARN('Device type omitted') >*/
	grwarn_("Device type omitted", (ftnlen)19);
/*<       END IF >*/
    }
/*<       IF (TYPE.EQ.0) GRPARS = GRPARS+2 >*/
    if (*type__ == 0) {
	ret_val += 2;
    }

/* Remove quotes from device if necessary. */

/*<       IF (L.GE.1) THEN >*/
    if (l >= 1) {
/*<          IF (DESCR(1:1).EQ.'"' .AND. DESCR(L:L).EQ.'"') THEN >*/
	if (*(unsigned char *)descr == '"' && *(unsigned char *)&descr[l - 1] 
		== '"') {
/*<             DEV = DESCR(2:L-1) >*/
	    s_copy(dev, descr + 1, dev_len, l - 2);
/*<             L = L-2 >*/
	    l += -2;
/*<          ELSE >*/
	} else {
/*<             DEV = DESCR(1:L) >*/
	    s_copy(dev, descr, dev_len, l);
/*<          END IF >*/
	}
/*<       END IF >*/
    }

/*      write (*,*) 'Device = [', DEV(1:L), ']' */
/*      write (*,*) 'Type   = [', CTYPE, ']', TYPE */
/*      write (*,*) 'APPEND = ', APPEND */

/*<       END >*/
    return ret_val;
} /* grpars_ */

