/* /work2/ssa/pgplot/src/grpocl.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static real c_b3 = (float)1.;

/* *GRPOCL -- polygon clip */
/* + */
/*<       SUBROUTINE GRPOCL (N,PX,PY, EDGE, VAL, MAXOUT, NOUT, QX, QY) >*/
/* Subroutine */ int grpocl_(n, px, py, edge, val, maxout, nout, qx, qy)
integer *n;
real *px, *py;
integer *edge;
real *val;
integer *maxout, *nout;
real *qx, *qy;
{
    /* System generated locals */
    integer i__1;
    real r__1, r__2;

    /* Builtin functions */
    double r_sign();

    /* Local variables */
    static integer i__;
    static real fx, fy, sx, sy;

/*<       INTEGER N, NOUT, EDGE, MAXOUT >*/
/*<       REAL    PX(*), PY(*), QX(*), QY(*) >*/
/*<       REAL    VAL >*/

/* Clip a polygon against a rectangle: Sutherland-Hodgman algorithm. */
/* this routine must be called four times to clip against each of the */
/* edges of the rectangle in turn. */

/* Arguments: */

/* N (input, integer): the number of vertices of the polygon (at least */
/*       3). */
/* PX, PY (input, real arrays, dimension at least N): world coordinates */
/*       of the N vertices of the input polygon. */
/* EDGE (input, integer): */
/*     1: clip against left edge,   X > XMIN=VAL */
/*     2: clip against right edge,  X < XMAX=VAL */
/*     3: clip against bottom edge, Y > YMIN=VAL */
/*     4: clip against top edge,    Y < YMIN=VAL */
/* VAL  (input, real): coordinate value of current edge. */
/* MAXOUT (input, integer): maximum number of vertices allowed in */
/*     output polygon (dimension of QX, QY). */
/* NOUT (output, integer): the number of vertices in the clipped polygon. */
/* QX, QY (output, real arrays, dimension at least MAXOUT): world */
/*       coordinates of the NOUT vertices of the output polygon. */
/* -- */
/* 19-Sep-1994 - [TJP]. */
/* 27-Feb-1996 - fix bug: overflow if coordinates are large [TJP]. */
/* 11-Jul-1996 - fix bug: left and bottom edges disappeared when precisely */
/*               on edge [Remko Scharroo] */
/* ----------------------------------------------------------------------- */
/*<       INTEGER I >*/
/*<       REAL FX, FY, SX, SY >*/

/*<       NOUT = 0 >*/
    /* Parameter adjustments */
    --qy;
    --qx;
    --py;
    --px;

    /* Function Body */
    *nout = 0;
/*<       DO 100 I=1,N >*/
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
/*<          IF (I.EQ.1) THEN >*/
	if (i__ == 1) {
/*           -- save first point */
/*<             FX = PX(I) >*/
	    fx = px[i__];
/*<             FY = PY(I) >*/
	    fy = py[i__];
/*<    >*/
	} else /* if(complicated condition) */ {
	    r__1 = px[i__] - *val;
	    r__2 = sx - *val;
	    if ((*edge == 1 || *edge == 2) && r_sign(&c_b3, &r__1) != r_sign(&
		    c_b3, &r__2)) {
/*           -- SP intersects this edge: output vertex at intersection */
/*<             NOUT = NOUT+1 >*/
		++(*nout);
/*<             IF (NOUT.LE.MAXOUT) THEN >*/
		if (*nout <= *maxout) {
/*<                QX(NOUT) = VAL >*/
		    qx[*nout] = *val;
/*<                QY(NOUT) = SY + (PY(I)-SY)*((VAL-SX)/(PX(I)-SX)) >*/
		    qy[*nout] = sy + (py[i__] - sy) * ((*val - sx) / (px[i__] 
			    - sx));
/*<             END IF >*/
		}
/*<    >*/
	    } else /* if(complicated condition) */ {
		r__1 = py[i__] - *val;
		r__2 = sy - *val;
		if ((*edge == 3 || *edge == 4) && r_sign(&c_b3, &r__1) != 
			r_sign(&c_b3, &r__2)) {
/*           -- SP intersects this edge: output vertex at intersection */
/*<             NOUT = NOUT+1 >*/
		    ++(*nout);
/*<             IF (NOUT.LE.MAXOUT) THEN >*/
		    if (*nout <= *maxout) {
/*<                QX(NOUT) = SX + (PX(I)-SX)*((VAL-SY)/(PY(I)-SY)) >*/
			qx[*nout] = sx + (px[i__] - sx) * ((*val - sy) / (py[
				i__] - sy));
/*<                QY(NOUT) = VAL >*/
			qy[*nout] = *val;
/*<             END IF >*/
		    }
/*<          END IF >*/
		}
	    }
	}
/*<          SX = PX(I) >*/
	sx = px[i__];
/*<          SY = PY(I) >*/
	sy = py[i__];
/*<    >*/
	if (*edge == 1 && sx >= *val || *edge == 2 && sx <= *val || *edge == 
		3 && sy >= *val || *edge == 4 && sy <= *val) {
/*           -- output visible vertex S */
/*<             NOUT = NOUT + 1 >*/
	    ++(*nout);
/*<             IF (NOUT.LE.MAXOUT) THEN >*/
	    if (*nout <= *maxout) {
/*<                 QX(NOUT) = SX >*/
		qx[*nout] = sx;
/*<                 QY(NOUT) = SY >*/
		qy[*nout] = sy;
/*<             END IF >*/
	    }
/*<          END IF >*/
	}
/*<  100  CONTINUE >*/
/* L100: */
    }
/*      -- Does SF intersect edge? */
/*<    >*/
    r__1 = sx - *val;
    r__2 = fx - *val;
    if ((*edge == 1 || *edge == 2) && r_sign(&c_b3, &r__1) != r_sign(&c_b3, &
	    r__2)) {
/*<          NOUT = NOUT+1 >*/
	++(*nout);
/*<          IF (NOUT.LE.MAXOUT) THEN >*/
	if (*nout <= *maxout) {
/*<             QX(NOUT) = VAL >*/
	    qx[*nout] = *val;
/*<             QY(NOUT) = SY + (FY-SY)*((VAL-SX)/(FX-SX)) >*/
	    qy[*nout] = sy + (fy - sy) * ((*val - sx) / (fx - sx));
/*<          END IF >*/
	}
/*<    >*/
    } else /* if(complicated condition) */ {
	r__1 = sy - *val;
	r__2 = fy - *val;
	if ((*edge == 3 || *edge == 4) && r_sign(&c_b3, &r__1) != r_sign(&
		c_b3, &r__2)) {
/*<          NOUT = NOUT+1 >*/
	    ++(*nout);
/*<          IF (NOUT.LE.MAXOUT) THEN >*/
	    if (*nout <= *maxout) {
/*<             QY(NOUT) = VAL >*/
		qy[*nout] = *val;
/*<             QX(NOUT) = SX + (FX-SX)*((VAL-SY)/(FY-SY)) >*/
		qx[*nout] = sx + (fx - sx) * ((*val - sy) / (fy - sy));
/*<          END IF >*/
	    }
/*<       END IF >*/
	}
    }

/*<       END >*/
} /* grpocl_ */

