/* /work2/ssa/pgplot/src/grpxpx.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* Table of constant values */

static integer c__3 = 3;
static integer c__26 = 26;

/* *GRPXPX -- Perform pixel operations using pixel primitive */
/* + */
/*<       SUBROUTINE GRPXPX (IA, IDIM, JDIM, I1, I2, J1, J2, X, Y) >*/
/* Subroutine */ int grpxpx_(ia, idim, jdim, i1, i2, j1, j2, x, y)
integer *ia, *idim, *jdim, *i1, *i2, *j1, *j2;
real *x, *y;
{
    /* System generated locals */
    integer ia_dim1, ia_offset, i__1;

    /* Local variables */
    static integer lchr, nbuf;
    static real rbuf[1282];
    static integer i__, j, l;
    static real width;
    extern /* Subroutine */ int grbpic_(), grexec_(), grqcol_();
    static integer ic1, ic2;
    static char chr[1];

/*<       INTEGER IDIM, JDIM, I1, I2, J1, J2 >*/
/*<       INTEGER IA(IDIM,JDIM) >*/
/*<       REAL    X, Y >*/

/* Arguments: */
/*  IA     (input)  : the array to be plotted. */
/*  IDIM   (input)  : the first dimension of array A. */
/*  JDIM   (input)  : the second dimension of array A. */
/*  I1, I2 (input)  : the inclusive range of the first index */
/*                    (I) to be plotted. */
/*  J1, J2 (input)  : the inclusive range of the second */
/*                    index (J) to be plotted. */
/*  X, Y   (input)  : the lower left corner of the output region */
/*                    (device coordinates) */
/* -- */
/* 16-Jan-1991 - [GvG] */
/*  4-Aug-1993 - Debugged by Remko Scharroo */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       INTEGER     NSIZE >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       PARAMETER   (NSIZE = 1280) >*/
/*<       REAL        RBUF(NSIZE + 2) >*/
/*<       REAL        WIDTH >*/
/*<       INTEGER     IC1, IC2 >*/
/*<       INTEGER     I, J, L >*/
/*<       INTEGER     NBUF, LCHR >*/
/*<       CHARACTER*1 CHR >*/
/*<       IF (.NOT.GRPLTD(GRCIDE)) CALL GRBPIC >*/
    /* Parameter adjustments */
    ia_dim1 = *idim;
    ia_offset = 1 + ia_dim1 * 1;
    ia -= ia_offset;

    /* Function Body */
    if (! grcm00_1.grpltd[grcm00_1.grcide - 1]) {
	grbpic_();
    }

/* Get allowable color range and pixel width */

/*<       CALL GRQCOL(IC1, IC2) >*/
    grqcol_(&ic1, &ic2);
/*<       CALL GREXEC(GRGTYP, 3, RBUF, NBUF, CHR, LCHR) >*/
    grexec_(&grcm00_1.grgtyp, &c__3, rbuf, &nbuf, chr, &lchr, (ftnlen)1);
/*<       WIDTH = RBUF(3) >*/
    width = rbuf[2];
/*<       DO 30 J = J1, J2 >*/
    i__1 = *j2;
    for (j = *j1; j <= i__1; ++j) {

/* Compute Y coordinate for this line */

/*<          RBUF(2) = Y + (J - J1) * WIDTH >*/
	rbuf[1] = *y + (j - *j1) * width;
/*<          I = I1 >*/
	i__ = *i1;
/*<   10        L = 1 >*/
L10:
	l = 1;

/* Compute left X coordinate for this line segment */

/*<             RBUF(1) = X + (I - I1) * WIDTH >*/
	rbuf[0] = *x + (i__ - *i1) * width;

/* Check color index */

/*<   20           IF (IA(I, J) .LT. IC1 .OR. IC2 .LT. IA(I, J)) THEN >*/
L20:
	if (ia[i__ + j * ia_dim1] < ic1 || ic2 < ia[i__ + j * ia_dim1]) {
/*<                   RBUF(L + 2) = 1 >*/
	    rbuf[l + 1] = (float)1.;
/*<                ELSE >*/
	} else {
/*<                   RBUF(L + 2) = IA(I, J) >*/
	    rbuf[l + 1] = (real) ia[i__ + j * ia_dim1];
/*<                ENDIF >*/
	}
/*<                L = L + 1 >*/
	++l;
/*<                I = I + 1 >*/
	++i__;

/* Still room in segment and something left? */

/*<             IF (L .LE. NSIZE .AND. I .LE. I2) GOTO 20 >*/
	if (l <= 1280 && i__ <= *i2) {
	    goto L20;
	}

/* Output segment */

/*           NBUF = L + 2 ! wrong ! should be: (RS) */
/*<             NBUF = L + 1 >*/
	nbuf = l + 1;
/*<             CALL GREXEC(GRGTYP, 26, RBUF, NBUF, CHR, LCHR) >*/
	grexec_(&grcm00_1.grgtyp, &c__26, rbuf, &nbuf, chr, &lchr, (ftnlen)1);

/* Something left? */

/*<          IF (I .LE. I2) GOTO 10 >*/
	if (i__ <= *i2) {
	    goto L10;
	}
/*<   30  CONTINUE >*/
/* L30: */
    }
/*<       END >*/
} /* grpxpx_ */

