/* /work2/ssa/pgplot/src/grsyds.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* *GRSYDS -- decode character string into list of symbol numbers */
/* + */
/*<       SUBROUTINE GRSYDS (SYMBOL, NSYMBS, TEXT, FONT) >*/
/* Subroutine */ int grsyds_(symbol, nsymbs, text, font, text_len)
integer *symbol, *nsymbs;
char *text;
integer *font;
ftnlen text_len;
{
    /* System generated locals */
    integer i__1, i__2;

    /* Builtin functions */
    integer i_len(), s_cmp(), i_indx();

    /* Local variables */
    static integer mark, j, ifont, ch, ig;
    extern /* Subroutine */ int grsymk_();
    static integer lentxt;

/*<       INTEGER SYMBOL(*), NSYMBS, FONT >*/
/*<       CHARACTER*(*) TEXT >*/

/* Given a character string, this routine returns a list of symbol */
/* numbers to be used to plot it. It is responsible for interpreting */
/* all escape sequences.  Negative `symbol numbers' are inserted in the */
/* list to represent pen movement. The following escape sequences are */
/* defined (the letter following the \ may be either upper or lower */
/* case): */

/* \u       :      up one level (returns -1) */
/* \d       :      down one level (returns -2) */
/* \b       :      backspace (returns -3) */
/* \A       :      (upper case only) Angstrom symbol, roman font */
/* \x       :      multiplication sign */
/* \.       :      centered dot */
/* \\       :      \, returns the code for backslash */
/* \gx      :      greek letter corresponding to roman letter x */
/* \fn      :      switch to Normal font */
/* \fr      :      switch to Roman font */
/* \fi      :      switch to Italic font */
/* \fs      :      switch to Script font */
/* \mn or \mnn :   graph marker number n or nn (1 or 2 digits) */
/* \(nnn)   :      Hershey symbol number nnn (any number of digits) */

/* Arguments: */
/*  SYMBOL (output) : receives the list of symbol numers. */
/*  NSYMBS (output) : receives the actual number of symbols specified */
/*                    by the string; it is assumed that the dimension of */
/*                    SYMBOL is big enough (not less than LEN(TEXT)). */
/*  TEXT   (input)  : the text string to be decoded. */
/*  FONT   (input)  : the font number (1..4) to be used for decoding the */
/*                    string (this can be overridden by an escape */
/*                    sequence within the string). */
/* -- */
/*  3-May-1983 - [TJP]. */
/* 13-Jun-1984 - add \A [TJP]. */
/* 15-Dec-1988 - standardize [TJP]. */
/* 29-Nov-1990 - add \m escapes [TJP]. */
/* 27-Nov-1991 - add \x escape [TJP]. */
/* 27-Jul-1995 - extend for 256-character set [TJP] */
/*  7-Nov-1995 - add \. escape [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       CHARACTER*8  FONTS >*/
/*<       CHARACTER*48 GREEK >*/
/*<       PARAMETER (FONTS = 'nrisNRIS') >*/
/*<    >*/
/*<       INTEGER  CH, IG, J, LENTXT, IFONT, MARK >*/

/* Initialize parameters. */

/*<       IFONT = FONT >*/
    /* Parameter adjustments */
    --symbol;

    /* Function Body */
    ifont = *font;
/*<       LENTXT = LEN(TEXT) >*/
    lentxt = i_len(text, text_len);
/*<       NSYMBS = 0 >*/
    *nsymbs = 0;
/*<       J = 0 >*/
    j = 0;

/* Get next character; treat non-printing characters as spaces. */

/*<   100 J = J+1 >*/
L100:
    ++j;
/*<       IF (J.GT.LENTXT) RETURN >*/
    if (j > lentxt) {
	return 0;
    }
/*<       CH = ICHAR(TEXT(J:J)) >*/
    ch = *(unsigned char *)&text[j - 1];
/*<       IF (CH.LT.0)   CH = 32 >*/
    if (ch < 0) {
	ch = 32;
    }
/*<       IF (CH.GT.303) CH = 32 >*/
    if (ch > 303) {
	ch = 32;
    }

/* Test for escape sequence (\) */

/*<       IF (CH.EQ.92) THEN >*/
    if (ch == 92) {
/*<           IF ((LENTXT-J).GE.1) THEN >*/
	if (lentxt - j >= 1) {
/*<             IF (TEXT(J+1:J+1).EQ.CHAR(92)) THEN >*/
	    i__1 = j;
	    if (s_cmp(text + i__1, "\\", j + 1 - i__1, (ftnlen)1) == 0) {
/*<                 J = J+1 >*/
		++j;
/*<    >*/
	    } else /* if(complicated condition) */ {
		i__1 = j;
		i__2 = j;
		if (s_cmp(text + i__1, "u", j + 1 - i__1, (ftnlen)1) == 0 || 
			s_cmp(text + i__2, "U", j + 1 - i__2, (ftnlen)1) == 0)
			 {
/*<                 NSYMBS = NSYMBS + 1 >*/
		    ++(*nsymbs);
/*<                 SYMBOL(NSYMBS) = -1 >*/
		    symbol[*nsymbs] = -1;
/*<                 J = J+1 >*/
		    ++j;
/*<                 GOTO 100 >*/
		    goto L100;
/*<    >*/
		} else /* if(complicated condition) */ {
		    i__1 = j;
		    i__2 = j;
		    if (s_cmp(text + i__1, "d", j + 1 - i__1, (ftnlen)1) == 0 
			    || s_cmp(text + i__2, "D", j + 1 - i__2, (ftnlen)
			    1) == 0) {
/*<                 NSYMBS = NSYMBS + 1 >*/
			++(*nsymbs);
/*<                 SYMBOL(NSYMBS) = -2 >*/
			symbol[*nsymbs] = -2;
/*<                 J = J+1 >*/
			++j;
/*<                 GOTO 100 >*/
			goto L100;
/*<    >*/
		    } else /* if(complicated condition) */ {
			i__1 = j;
			i__2 = j;
			if (s_cmp(text + i__1, "b", j + 1 - i__1, (ftnlen)1) 
				== 0 || s_cmp(text + i__2, "B", j + 1 - i__2, 
				(ftnlen)1) == 0) {
/*<                 NSYMBS = NSYMBS + 1 >*/
			    ++(*nsymbs);
/*<                 SYMBOL(NSYMBS) = -3 >*/
			    symbol[*nsymbs] = -3;
/*<                 J = J+1 >*/
			    ++j;
/*<                 GOTO 100 >*/
			    goto L100;
/*<             ELSE IF (TEXT(J+1:J+1).EQ.'A') THEN >*/
			} else /* if(complicated condition) */ {
			    i__1 = j;
			    if (s_cmp(text + i__1, "A", j + 1 - i__1, (ftnlen)
				    1) == 0) {
/*<                 NSYMBS = NSYMBS + 1 >*/
				++(*nsymbs);
/*<                 SYMBOL(NSYMBS) = 2078 >*/
				symbol[*nsymbs] = 2078;
/*<                 J = J+1 >*/
				++j;
/*<                 GOTO 100 >*/
				goto L100;
/*<             ELSE IF (TEXT(J+1:J+1).EQ.'x') THEN >*/
			    } else /* if(complicated condition) */ {
				i__1 = j;
				if (s_cmp(text + i__1, "x", j + 1 - i__1, (
					ftnlen)1) == 0) {
/*<                 NSYMBS = NSYMBS + 1 >*/
				    ++(*nsymbs);
/*<                 SYMBOL(NSYMBS) = 2235 >*/
				    symbol[*nsymbs] = 2235;
/*<                 IF (IFONT.EQ.1) SYMBOL(NSYMBS) = 727 >*/
				    if (ifont == 1) {
					symbol[*nsymbs] = 727;
				    }
/*<                 J = J+1 >*/
				    ++j;
/*<                 GOTO 100 >*/
				    goto L100;
/*<             ELSE IF (TEXT(J+1:J+1).EQ.'.') THEN >*/
				} else /* if(complicated condition) */ {
				    i__1 = j;
				    if (s_cmp(text + i__1, ".", j + 1 - i__1, 
					    (ftnlen)1) == 0) {
/*<                 NSYMBS = NSYMBS + 1 >*/
					++(*nsymbs);
/*<                 SYMBOL(NSYMBS) = 2236 >*/
					symbol[*nsymbs] = 2236;
/*<                 IF (IFONT.EQ.1) SYMBOL(NSYMBS) = 729 >*/
					if (ifont == 1) {
					    symbol[*nsymbs] = 729;
					}
/*<                 J = J+1 >*/
					++j;
/*<                 GOTO 100 >*/
					goto L100;
/*<             ELSE IF (TEXT(J+1:J+1).EQ.'(') THEN >*/
				    } else /* if(complicated condition) */ {
					i__1 = j;
					if (s_cmp(text + i__1, "(", j + 1 - 
						i__1, (ftnlen)1) == 0) {
/*<                 NSYMBS = NSYMBS + 1 >*/
					    ++(*nsymbs);
/*<                 SYMBOL(NSYMBS) = 0 >*/
					    symbol[*nsymbs] = 0;
/*<                 J = J+2 >*/
					    j += 2;
/*               -- DO WHILE ('0'.LE.TEXT(J:J).AND.TEXT(J:J).LE.'9') */
/*<    90           IF ('0'.LE.TEXT(J:J).AND.TEXT(J:J).LE.'9') THEN >*/
L90:
					    if ('0' <= *(unsigned char *)&
						    text[j - 1] && *(unsigned 
						    char *)&text[j - 1] <= 
						    '9') {
/*<    >*/
			  symbol[*nsymbs] = symbol[*nsymbs] * 10 + *(unsigned 
				  char *)&text[j - 1] - '0';
/*<                    J = J+1 >*/
			  ++j;
/*<                 GOTO 90 >*/
			  goto L90;
/*<                 END IF >*/
					    }
/*               -- end DO WHILE */
/*<                 IF (TEXT(J:J).NE.')') J = J-1 >*/
					    if (*(unsigned char *)&text[j - 1]
						     != ')') {
			  --j;
					    }
/*<                 GOTO 100 >*/
					    goto L100;
/*<    >*/
					} else /* if(complicated condition) */
						 {
					    i__1 = j;
					    i__2 = j;
					    if (s_cmp(text + i__1, "m", j + 1 
						    - i__1, (ftnlen)1) == 0 ||
						     s_cmp(text + i__2, "M", 
						    j + 1 - i__2, (ftnlen)1) 
						    == 0) {
/*<                 MARK = 0 >*/
			  mark = 0;
/*<                 J = J+2 >*/
			  j += 2;
/*<                 IF ('0'.LE.TEXT(J:J).AND.TEXT(J:J).LE.'9') THEN >*/
			  if ('0' <= *(unsigned char *)&text[j - 1] && *(
				  unsigned char *)&text[j - 1] <= '9') {
/*<                     MARK = MARK*10 + ICHAR(TEXT(J:J)) - ICHAR('0') >*/
			      mark = mark * 10 + *(unsigned char *)&text[j - 
				      1] - '0';
/*<                     J = J+1 >*/
			      ++j;
/*<                 END IF >*/
			  }
/*<                 IF ('0'.LE.TEXT(J:J).AND.TEXT(J:J).LE.'9') THEN >*/
			  if ('0' <= *(unsigned char *)&text[j - 1] && *(
				  unsigned char *)&text[j - 1] <= '9') {
/*<                     MARK = MARK*10 + ICHAR(TEXT(J:J)) - ICHAR('0') >*/
			      mark = mark * 10 + *(unsigned char *)&text[j - 
				      1] - '0';
/*<                     J = J+1 >*/
			      ++j;
/*<                 END IF >*/
			  }
/*<                 J = J-1 >*/
			  --j;
/*<                 NSYMBS = NSYMBS + 1 >*/
			  ++(*nsymbs);
/*<                 CALL GRSYMK(MARK, IFONT, SYMBOL(NSYMBS)) >*/
			  grsymk_(&mark, &ifont, &symbol[*nsymbs]);
/*<                 GOTO 100 >*/
			  goto L100;
/*<    >*/
					    } else /* if(complicated 
						    condition) */ {
			  i__1 = j;
			  i__2 = j;
			  if (s_cmp(text + i__1, "f", j + 1 - i__1, (ftnlen)1)
				   == 0 || s_cmp(text + i__2, "F", j + 1 - 
				  i__2, (ftnlen)1) == 0) {
/*<                 IFONT = INDEX(FONTS, TEXT(J+2:J+2)) >*/
			      i__1 = j + 1;
			      ifont = i_indx("nrisNRIS", text + i__1, (ftnlen)
				      8, j + 2 - i__1);
/*<                 IF (IFONT.GT.4) IFONT = IFONT-4 >*/
			      if (ifont > 4) {
				  ifont += -4;
			      }
/*<                 IF (IFONT.EQ.0) IFONT = 1 >*/
			      if (ifont == 0) {
				  ifont = 1;
			      }
/*<                 J = J+2 >*/
			      j += 2;
/*<                 GOTO 100 >*/
			      goto L100;
/*<    >*/
			  } else /* if(complicated condition) */ {
			      i__1 = j;
			      i__2 = j;
			      if (s_cmp(text + i__1, "g", j + 1 - i__1, (
				      ftnlen)1) == 0 || s_cmp(text + i__2, 
				      "G", j + 1 - i__2, (ftnlen)1) == 0) {
/*<                 IG = INDEX(GREEK, TEXT(J+2:J+2)) >*/
				  i__1 = j + 1;
				  ig = i_indx("ABGDEZYHIKLMNCOPRSTUFXQWabgde\
zyhiklmncoprstufxqw", text + i__1, (ftnlen)48, j + 2 - i__1);
/*<                 NSYMBS = NSYMBS + 1 >*/
				  ++(*nsymbs);
/*<                 CALL GRSYMK(255+IG, IFONT, SYMBOL(NSYMBS)) >*/
				  i__1 = ig + 255;
				  grsymk_(&i__1, &ifont, &symbol[*nsymbs]);
/*<                 J = J+2 >*/
				  j += 2;
/*<                 GOTO 100 >*/
				  goto L100;
/*<             END IF >*/
			      }
			  }
					    }
					}
				    }
				}
			    }
			}
		    }
		}
	    }
/*<           END IF >*/
	}
/*<       END IF >*/
    }

/* Decode character. */

/*<       NSYMBS = NSYMBS + 1 >*/
    ++(*nsymbs);
/*<       CALL GRSYMK(CH, IFONT, SYMBOL(NSYMBS)) >*/
    grsymk_(&ch, &ifont, &symbol[*nsymbs]);
/*<       GOTO 100 >*/
    goto L100;
/*<       END >*/
} /* grsyds_ */

