/* /work2/ssa/pgplot/src/grsyxd.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer nc1, nc2, index[3000];
    shortint buffer[27000];
} grsymb_;

#define grsymb_1 grsymb_

/* *GRSYXD -- obtain the polyline representation of a given symbol */
/* + */
/*<       SUBROUTINE GRSYXD (SYMBOL, XYGRID, UNUSED) >*/
/* Subroutine */ int grsyxd_(symbol, xygrid, unused)
integer *symbol, *xygrid;
logical *unused;
{
    static integer k, l, ix, iy, locbuf;

/*<       INTEGER SYMBOL >*/
/*<       INTEGER XYGRID(300) >*/
/*<       LOGICAL UNUSED >*/

/* Return the digitization coordinates of a character. Each character is */
/* defined on a grid with X and Y coordinates in the range (-49,49), */
/* with the origin (0,0) at the center of the character.  The coordinate */
/* system is right-handed, with X positive to the right, and Y positive */
/* upward. */

/* Arguments: */
/*  SYMBOL (input)  : symbol number in range (1..3000). */
/*  XYGRID (output) : height range, width range, and pairs of (x,y) */
/*                    coordinates returned.  Height range = (XYGRID(1), */
/*                    XYGRID(3)).  Width range = (XYGRID(4),XYGRID(5)). */
/*                    (X,Y) = (XYGRID(K),XYGRID(K+1)) (K=6,8,...). */
/*  UNUSED (output) : receives .TRUE. if SYMBOL is an unused symbol */
/*                    number. A character of normal height and zero width */
/*                    is returned. Receives .FALSE. if SYMBOL is a */
/*                    valid symbol number. */

/* The height range consists of 3 values: (minimum Y, baseline Y, */
/* maximum Y).  The first is reached by descenders on lower-case g, p, */
/* q, and y.  The second is the bottom of upper-case letters.  The third */
/* is the top of upper-case letters.  A coordinate pair (-64,0) requests */
/* a pen raise, and a pair (-64,-64) terminates the coordinate list. It */
/* is assumed that movement to the first coordinate position will be */
/* done with the pen raised - no raise command is explicitly included to */
/* do this. */
/* -- */
/*  7-Mar-1983. */
/* 15-Dec-1988 - standardize. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER*2    BUFFER(27000) >*/
/*<       INTEGER      INDEX(3000), IX, IY, K, L, LOCBUF >*/
/*<       INTEGER      NC1, NC2 >*/
/*<       COMMON       /GRSYMB/ NC1, NC2, INDEX, BUFFER >*/

/* Extract digitization. */

/*<       IF (SYMBOL.LT.NC1 .OR. SYMBOL.GT.NC2) GOTO 3000 >*/
    /* Parameter adjustments */
    --xygrid;

    /* Function Body */
    if (*symbol < grsymb_1.nc1 || *symbol > grsymb_1.nc2) {
	goto L3000;
    }
/*<       L = SYMBOL - NC1 + 1 >*/
    l = *symbol - grsymb_1.nc1 + 1;
/*<       LOCBUF = INDEX(L) >*/
    locbuf = grsymb_1.index[l - 1];
/*<       IF (LOCBUF .EQ. 0) GOTO 3000 >*/
    if (locbuf == 0) {
	goto L3000;
    }
/*<       XYGRID(1) = BUFFER(LOCBUF) >*/
    xygrid[1] = grsymb_1.buffer[locbuf - 1];
/*<       LOCBUF = LOCBUF + 1 >*/
    ++locbuf;
/*<       K = 2 >*/
    k = 2;
/*<       IY = -1 >*/
    iy = -1;
/*     -- DO WHILE (IY.NE.-64) */
/*<   100 IF (IY.NE.-64) THEN >*/
L100:
    if (iy != -64) {
/*<           IX = BUFFER(LOCBUF)/128 >*/
	ix = grsymb_1.buffer[locbuf - 1] / 128;
/*<           IY = BUFFER(LOCBUF) - 128*IX - 64 >*/
	iy = grsymb_1.buffer[locbuf - 1] - (ix << 7) - 64;
/*<           XYGRID(K) = IX - 64 >*/
	xygrid[k] = ix - 64;
/*<           XYGRID(K+1) = IY >*/
	xygrid[k + 1] = iy;
/*<           K = K + 2 >*/
	k += 2;
/*<           LOCBUF = LOCBUF + 1 >*/
	++locbuf;
/*<       GOTO 100 >*/
	goto L100;
/*<       END IF >*/
    }
/*     -- end DO WHILE */
/*<       UNUSED = .FALSE. >*/
    *unused = FALSE_;
/*<       RETURN >*/
    return 0;

/* Unimplemented character. */

/*< 3000  XYGRID(1) = -16 >*/
L3000:
    xygrid[1] = -16;
/*<       XYGRID(2) =  -9 >*/
    xygrid[2] = -9;
/*<       XYGRID(3) = +12 >*/
    xygrid[3] = 12;
/*<       XYGRID(4) =   0 >*/
    xygrid[4] = 0;
/*<       XYGRID(5) =   0 >*/
    xygrid[5] = 0;
/*<       XYGRID(6) = -64 >*/
    xygrid[6] = -64;
/*<       XYGRID(7) = -64 >*/
    xygrid[7] = -64;
/*<       UNUSED = .TRUE. >*/
    *unused = TRUE_;
/*<       RETURN >*/
    return 0;
/*<       END >*/
} /* grsyxd_ */

