/* /work2/ssa/pgplot/src/grvct0.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer grcide, grgtyp, grstat[8];
    logical grpltd[8];
    integer grunit[8], grfnln[8], grtype[8], grxmxa[8], grymxa[8];
    real grxmin[8], grymin[8], grxmax[8], grymax[8];
    integer grwidt[8], grccol[8], grstyl[8];
    real grxpre[8], grypre[8], grxorg[8], gryorg[8], grxscl[8], gryscl[8], 
	    grcscl[8], grcfac[8];
    logical grdash[8];
    real grpatn[64]	/* was [8][8] */, grpoff[8];
    integer gripat[8], grcfnt[8], grcmrk[8];
    real grpxpi[8], grpypi[8];
    logical gradju[8];
    integer grmnci[8], grmxci[8];
} grcm00_;

#define grcm00_1 grcm00_

struct {
    char grfile[720], grgcap[88];
} grcm01_;

#define grcm01_1 grcm01_

/* *GRVCT0 -- draw line segments or dots */
/* + */
/*<       SUBROUTINE GRVCT0 (MODE,ABSXY,POINTS,X,Y) >*/
/* Subroutine */ int grvct0_(mode, absxy, points, x, y)
integer *mode;
logical *absxy;
integer *points;
real *x, *y;
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    static real xcur, ycur;
    static integer i__;
    extern /* Subroutine */ int grlin0_(), grdot0_(), grtxy0_();


/* GRPCKG (internal routine): Draw a line or a set of dots. This */
/* is the same as GRVECT, but without device selection. It can be used to */
/* draw a single line-segment, a continuous series of line segments, or */
/* one or more single dots (pixels). */

/* Arguments: */

/* MODE (input, integer): if MODE=1, a series of line segments is drawn, */
/*       starting at the current position, moving to X(1),Y(1), ... and */
/*       ending at X(POINTS),Y(POINTS). */
/*       If MODE=2, the first vector is blanked, so the line starts at */
/*       X(1),Y(1). */
/*       If MODE=3, a single dot is placed at each coordinate pair, with */
/*       no connecting lines. */
/* ABSXY (input, logical): if TRUE, the coordinates are absolute device */
/*       coordinates; if FALSE, they are world coordinates and the */
/*       scaling transformation is applied. */
/* POINTS (input, integer): the number of coordinate pairs. */
/* X, Y (input, real arrays, dimensioned POINTS or greater): the */
/*       X and Y coordinates of the points. */
/* -- */
/* (1-Feb-1983) */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'grpckg1.inc' >*/
/*<       INTEGER  I, MODE, POINTS >*/
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */

/*<       REAL      GRCXSZ, GRCYSZ >*/
/*<       PARAMETER (GRIMAX = 8) >*/
/*<       PARAMETER (GRFNMX = 90) >*/
/*<       PARAMETER (GRCXSZ =  7.0, GRCYSZ =  9.0) >*/

/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */

/*<       INTEGER   GRCIDE, GRGTYP >*/
/*<       LOGICAL   GRPLTD(GRIMAX), GRDASH(GRIMAX), GRADJU(GRIMAX) >*/
/*<       INTEGER   GRSTAT(GRIMAX) >*/
/*<    >*/
/*<    >*/
/*<    >*/
/*<    >*/

/*<       CHARACTER*(GRFNMX) GRFILE(GRIMAX) >*/
/*<       CHARACTER*11       GRGCAP(GRIMAX) >*/
/*<       COMMON /GRCM01/ GRFILE, GRGCAP >*/
/*<       SAVE /GRCM00/, /GRCM01/ >*/
/* ----------------------------------------------------------------------- */
/*<       LOGICAL  ABSXY >*/
/*<       REAL     X(POINTS), Y(POINTS), XCUR, YCUR >*/

/*<       IF (MODE.EQ.1) THEN >*/
    /* Parameter adjustments */
    --y;
    --x;

    /* Function Body */
    if (*mode == 1) {
/*<           CALL GRTXY0(ABSXY, X(1), Y(1), XCUR, YCUR) >*/
	grtxy0_(absxy, &x[1], &y[1], &xcur, &ycur);
/*<           CALL GRLIN0(XCUR, YCUR) >*/
	grlin0_(&xcur, &ycur);
/*<       ELSE IF (MODE.EQ.2) THEN >*/
    } else if (*mode == 2) {
/*<           CALL GRTXY0(ABSXY, X(1), Y(1), GRXPRE(GRCIDE), GRYPRE(GRCIDE)) >*/
	grtxy0_(absxy, &x[1], &y[1], &grcm00_1.grxpre[grcm00_1.grcide - 1], &
		grcm00_1.grypre[grcm00_1.grcide - 1]);
/*<       END IF >*/
    }
/*<       IF (MODE.EQ.1 .OR. MODE.EQ.2) THEN >*/
    if (*mode == 1 || *mode == 2) {
/*<           DO 10 I=2,POINTS >*/
	i__1 = *points;
	for (i__ = 2; i__ <= i__1; ++i__) {
/*<               CALL GRTXY0(ABSXY, X(I), Y(I), XCUR, YCUR) >*/
	    grtxy0_(absxy, &x[i__], &y[i__], &xcur, &ycur);
/*<               CALL GRLIN0(XCUR, YCUR) >*/
	    grlin0_(&xcur, &ycur);
/*<    10     CONTINUE >*/
/* L10: */
	}
/*<       ELSE IF (MODE.EQ.3) THEN >*/
    } else if (*mode == 3) {
/*<           DO 20 I=1,POINTS >*/
	i__1 = *points;
	for (i__ = 1; i__ <= i__1; ++i__) {
/*<               CALL GRTXY0(ABSXY, X(I), Y(I), XCUR, YCUR) >*/
	    grtxy0_(absxy, &x[i__], &y[i__], &xcur, &ycur);
/*<               CALL GRDOT0(XCUR, YCUR) >*/
	    grdot0_(&xcur, &ycur);
/*<    20     CONTINUE >*/
/* L20: */
	}
/*<       END IF >*/
    }

/*<       END >*/
} /* grvct0_ */

