/* /work2/ssa/pgplot/src/grxhls.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static real c_b2 = (float)360.;

/* *GRXHLS -- convert RGB color to HLS color */
/* + */
/*<       SUBROUTINE GRXHLS (R,G,B,H,L,S) >*/
/* Subroutine */ int grxhls_(r__, g, b, h__, l, s)
real *r__, *g, *b, *h__, *l, *s;
{
    /* System generated locals */
    real r__1;

    /* Builtin functions */
    double r_mod();

    /* Local variables */
    static real d__, bb, ma, gg, mi, rr;


/* GRPCKG: Convert a color specified in the RGB color model to one in */
/* the HLS model.  This is a support routine: no graphics I/O occurs. */
/* The inverse transformation is accomplished with routine GRXRGB. */
/* Reference: SIGGRAPH Status Report of the Graphic Standards Planning */
/* Committee, Computer Graphics, Vol.13, No.3, Association for */
/* Computing Machinery, New York, NY, 1979. */

/* Arguments: */

/* R,G,B (real, input): red, green, blue color coordinates, each in the */
/*       range 0.0 to 1.0. Input outside this range causes HLS = (0,1,0) */
/*       [white] to be returned. */
/* H,L,S (real, output): hue (0 to 360), lightness (0 to 1.0), and */
/*       saturation (0 to 1.0). */
/* -- */
/*  2-Jul-1984 - new routine [TJP]. */
/* 29-Sep-1994 - force H to be in rnage 0-360 [Remko Scharroo; TJP]. */
/* ----------------------------------------------------------------------- */
/*<       REAL     R,G,B, H,L,S, MA, MI, RR, GG, BB, D >*/

/*<       H = 0.0 >*/
    *h__ = (float)0.;
/*<       L = 1.0 >*/
    *l = (float)1.;
/*<       S = 0.0 >*/
    *s = (float)0.;
/*<       MA = MAX(R,G,B) >*/
/* Computing MAX */
    r__1 = max(*r__,*g);
    ma = dmax(r__1,*b);
/*<       MI = MIN(R,G,B) >*/
/* Computing MIN */
    r__1 = min(*r__,*g);
    mi = dmin(r__1,*b);
/*<       IF (MA.GT.1.0 .OR. MI.LT.0.0) RETURN >*/
    if (ma > (float)1. || mi < (float)0.) {
	return 0;
    }
/*<       RR = (MA-R) >*/
    rr = ma - *r__;
/*<       GG = (MA-G) >*/
    gg = ma - *g;
/*<       BB = (MA-B) >*/
    bb = ma - *b;

/* Lightness */

/*<       L = 0.5*(MA+MI) >*/
    *l = (ma + mi) * (float).5;

/* Achromatic case (R=G=B) */

/*<       IF (MA.EQ.MI) THEN >*/
    if (ma == mi) {
/*<           S = 0.0 >*/
	*s = (float)0.;
/*<           H = 0.0 >*/
	*h__ = (float)0.;

/* Chromatic case */

/*<       ELSE >*/
    } else {
/*         -- Saturation */
/*<           D = MA-MI >*/
	d__ = ma - mi;
/*<           IF (L.LE.0.5) THEN >*/
	if (*l <= (float).5) {
/*<               S = D/(MA+MI) >*/
	    *s = d__ / (ma + mi);
/*<           ELSE >*/
	} else {
/*<               S = D/(2.0-MA-MI) >*/
	    *s = d__ / ((float)2. - ma - mi);
/*<           END IF >*/
	}
/*         -- Hue */
/*<           IF (R.EQ.MA) THEN >*/
	if (*r__ == ma) {
/*             -- yellow to magenta */
/*<               H = (2.0*D+BB-GG) >*/
	    *h__ = d__ * (float)2. + bb - gg;
/*<           ELSE IF (G.EQ.MA) THEN >*/
	} else if (*g == ma) {
/*<               H = (4.0*D+RR-BB) >*/
	    *h__ = d__ * (float)4. + rr - bb;
/*<           ELSE >*/
	} else {
/*             ! (B.EQ.MA) */
/*<               H = (6.0*D+GG-RR) >*/
	    *h__ = d__ * (float)6. + gg - rr;
/*<           END IF >*/
	}
/*<           H = MOD(H*60.0/D,360.0) >*/
	r__1 = *h__ * (float)60. / d__;
	*h__ = r_mod(&r__1, &c_b2);
/*<           IF (H.LT.0.0) H = H+360.0 >*/
	if (*h__ < (float)0.) {
	    *h__ += (float)360.;
	}
/*<       END IF >*/
    }

/*<       END >*/
} /* grxhls_ */

