/* /work2/ssa/pgplot/src/grxrgb.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static real c_b2 = (float)360.;

/* *GRXRGB -- convert HLS color to RGB color */
/* + */
/*<       SUBROUTINE GRXRGB (H,L,S,R,G,B) >*/
/* Subroutine */ int grxrgb_(h__, l, s, r__, g, b)
real *h__, *l, *s, *r__, *g, *b;
{
    /* System generated locals */
    real r__1, r__2;

    /* Builtin functions */
    double r_mod();

    /* Local variables */
    static real ma, hm, mi;


/* GRPCKG: Convert a color specified in the HLS color model to one in */
/* the RGB model.  This is a support routine: no graphics I/O occurs. */
/* The inverse transformation is accomplished with routine GRXHLS. */
/* Reference: SIGGRAPH Status Report of the Graphic Standards Planning */
/* Committee, Computer Graphics, Vol.13, No.3, Association for */
/* Computing Machinery, New York, NY, 1979. */

/* Arguments: */

/* H,L,S (real, input): hue (0 to 360), lightness (0 to 1.0), and */
/*       saturation (0 to 1.0). */
/* R,G,B (real, output): red, green, blue color coordinates, each in the */
/*       range 0.0 to 1.0. */
/* -- */
/*  2-Jul-1984 - new routine [TJP]. */
/* 29-Sep-1994 - take H module 360 [TJP]. */
/* 26-Nov-1996 - force results to be in range (avoid rounding error */
/*               problems on some machines) [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       REAL     H,L,S, R,G,B, MA, MI, HM >*/

/*<       HM = MOD(H, 360.0) >*/
    hm = r_mod(h__, &c_b2);
/*<       IF (HM.LT.0.0) HM = HM+360.0 >*/
    if (hm < (float)0.) {
	hm += (float)360.;
    }
/*<       IF (L.LE.0.5) THEN >*/
    if (*l <= (float).5) {
/*<           MA = L*(1.0+S) >*/
	ma = *l * (*s + (float)1.);
/*<       ELSE >*/
    } else {
/*<           MA = L + S - L*S >*/
	ma = *l + *s - *l * *s;
/*<       END IF >*/
    }
/*<       MI = 2.0*L-MA >*/
    mi = *l * (float)2. - ma;

/* R component */

/*<       IF (HM.LT.60.0) THEN >*/
    if (hm < (float)60.) {
/*<           R = MI + (MA-MI)*HM/60.0 >*/
	*r__ = mi + (ma - mi) * hm / (float)60.;
/*<       ELSE IF (HM.LT.180.0) THEN >*/
    } else if (hm < (float)180.) {
/*<           R = MA >*/
	*r__ = ma;
/*<       ELSE IF (HM.LT.240.0) THEN >*/
    } else if (hm < (float)240.) {
/*<           R = MI + (MA-MI)*(240.0-HM)/60.0 >*/
	*r__ = mi + (ma - mi) * ((float)240. - hm) / (float)60.;
/*<       ELSE >*/
    } else {
/*<           R = MI >*/
	*r__ = mi;
/*<       END IF >*/
    }

/* G component */

/*<       IF (HM.LT.120.0) THEN >*/
    if (hm < (float)120.) {
/*<           G = MI >*/
	*g = mi;
/*<       ELSE IF (HM.LT.180.0) THEN >*/
    } else if (hm < (float)180.) {
/*<           G = MI + (MA-MI)*(HM-120.0)/60.0 >*/
	*g = mi + (ma - mi) * (hm - (float)120.) / (float)60.;
/*<       ELSE IF (HM.LT.300.0) THEN >*/
    } else if (hm < (float)300.) {
/*<           G = MA >*/
	*g = ma;
/*<       ELSE >*/
    } else {
/*<           G = MI + (MA-MI)*(360.0-HM)/60.0 >*/
	*g = mi + (ma - mi) * ((float)360. - hm) / (float)60.;
/*<       END IF >*/
    }

/* B component */

/*<       IF (HM.LT.60.0 .OR. HM.GE.300.0) THEN >*/
    if (hm < (float)60. || hm >= (float)300.) {
/*<           B = MA >*/
	*b = ma;
/*<       ELSE IF (HM.LT.120.0) THEN >*/
    } else if (hm < (float)120.) {
/*<           B = MI + (MA-MI)*(120.0-HM)/60.0 >*/
	*b = mi + (ma - mi) * ((float)120. - hm) / (float)60.;
/*<       ELSE IF (HM.LT.240.0) THEN >*/
    } else if (hm < (float)240.) {
/*<           B = MI >*/
	*b = mi;
/*<       ELSE >*/
    } else {
/*<           B = MI + (MA-MI)*(HM-240.0)/60.0 >*/
	*b = mi + (ma - mi) * (hm - (float)240.) / (float)60.;
/*<       END IF >*/
    }

/*<       R = MIN(1.0, MAX(0.0,R)) >*/
/* Computing MIN */
    r__1 = (float)1., r__2 = dmax((float)0.,*r__);
    *r__ = dmin(r__1,r__2);
/*<       G = MIN(1.0, MAX(0.0,G)) >*/
/* Computing MIN */
    r__1 = (float)1., r__2 = dmax((float)0.,*g);
    *g = dmin(r__1,r__2);
/*<       B = MIN(1.0, MAX(0.0,B)) >*/
/* Computing MIN */
    r__1 = (float)1., r__2 = dmax((float)0.,*b);
    *b = dmin(r__1,r__2);

/*<       END >*/
} /* grxrgb_ */

