/* /work2/ssa/pgplot/src/pgaxlg.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__0 = 0;
static integer c__1 = 1;
static real c_b10 = (float)0.;

/* PGAXLG -- draw a logarithmic axis [internal routine] */

/*<    >*/
/* Subroutine */ int pgaxlg_(opt, x1, y1, x2, y2, v1, v2, step, dmajl, dmajr, 
	fmin, disp, orient, opt_len)
char *opt;
real *x1, *y1, *x2, *y2, *v1, *v2, *step, *dmajl, *dmajr, *fmin, *disp, *
	orient;
ftnlen opt_len;
{
    /* Initialized data */

    static real tab[9] = { (float)0.,(float).30103,(float).47712,(float)
	    .60206,(float).69897,(float).77815,(float).8451,(float).90309,(
	    float).95424 };

    /* System generated locals */
    integer i__1, i__2;
    real r__1, r__2;

    /* Builtin functions */
    integer i_indx(), i_nint();
    /* Subroutine */ int s_copy();

    /* Local variables */
    static integer llab;
    static logical xlab;
    static integer clip, form;
    static real vmin, vmax;
    static logical optn;
    static integer i__, k;
    static char label[32];
    static real v, dvmaj;
    extern doublereal pgrnd_();
    static real dvmin;
    static integer nsubt, k1, k2;
    extern /* Subroutine */ int pgbbuf_(), pgebuf_(), pgtick_(), pgdraw_(), 
	    pgqclp_(), pgsclp_(), pgnumb_(), pgmove_();

/*<       CHARACTER*(*) OPT >*/
/*<       REAL X1, Y1, X2, Y2, V1, V2, STEP >*/
/*<       REAL DMAJL, DMAJR, FMIN, DISP, ORIENT >*/

/* Draw a labelled graph axis from world-coordinate position (X1,Y1) */
/*  to (X2,Y2). The quantity described by the axis runs from 10**V1 to */
/* 10**V2. A logarithmic axis always has major, labeled, tick marks */
/* spaced by one or more decades. If the major tick marks are spaced */
/* by one decade (as specified by the STEP argument), then minor */
/* tick marks are placed at 2, 3, .., 9 times each power of 10; */
/* otherwise minor tick marks are spaced by one decade. If the axis */
/* spans less than two decades, numeric labels are placed at 1, 2, and */
/* 5 times each power of ten. */

/* It is not advisable to use this routine if the axis spans less than */
/* one decade, or if it spans many decades. In these cases it is */
/* preferable to use a linear axis labeled with the logarithm of the */
/* quantity of interest. */

/* Arguments: */
/*  OPT    (input)  : a string containing single-letter codes for */
/*                    various options. The options currently */
/*                    recognized are: */
/*                    N : write numeric labels */
/*                    1 : force decimal labelling, instead of automatic */
/*                        choice (see PGNUMB). */
/*                    2 : force exponential labelling, instead of */
/*                        automatic. */
/*  X1, Y1 (input)  : world coordinates of one endpoint of the axis. */
/*  X2, Y2 (input)  : world coordinates of the other endpoint of the axis. */
/*  V1     (input)  : logarithm of axis value at first endpoint. */
/*  V2     (input)  : logarithm of axis value at second endpoint. */
/*  STEP   (input)  : the number of decades between major (labeled) tick */
/*                    marks. */
/*  DMAJL  (input)  : length of major tick marks drawn to left of axis */
/*                    (as seen looking from first endpoint to second), in */
/*                    units of the character height. */
/*  DMAJR  (input)  : length of major tick marks drawn to right of axis, */
/*                    in units of the character height. */
/*  FMIN   (input)  : length of minor tick marks, as fraction of major. */
/*  DISP   (input)  : displacement of baseline of tick labels to */
/*                    right of axis, in units of the character height. */
/*  ORIENT (input)  : orientation of text label relative to axis (see */
/*                    PGTICK). */
/* -- */
/* 25-Mar-1997 - new routine [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       REAL V, VMIN, VMAX, DVMAJ, DVMIN, PGRND >*/
/*<       INTEGER I, K, K1, K2, LLAB, NSUBT, CLIP, FORM >*/
/*<       LOGICAL XLAB, OPTN >*/
/*<       CHARACTER*32 LABEL >*/
/*<       REAL TAB(9) >*/

/* Table of logarithms 1..9 */

/*<    >*/

/* Check arguments. */

/*<       IF (X1.EQ.X2 .AND. Y1.EQ.Y2) RETURN >*/
    if (*x1 == *x2 && *y1 == *y2) {
	return 0;
    }
/*<       IF (V1.EQ.V2) RETURN >*/
    if (*v1 == *v2) {
	return 0;
    }

/* Decode options. */

/*<       OPTN = INDEX(OPT,'N').NE.0 .OR. INDEX(OPT,'n').NE.0 >*/
    optn = i_indx(opt, "N", opt_len, (ftnlen)1) != 0 || i_indx(opt, "n", 
	    opt_len, (ftnlen)1) != 0;
/*<       FORM =0 >*/
    form = 0;
/*<       IF (INDEX(OPT,'1').NE.0) FORM = 1 >*/
    if (i_indx(opt, "1", opt_len, (ftnlen)1) != 0) {
	form = 1;
    }
/*<       IF (INDEX(OPT,'2').NE.0) FORM = 2 >*/
    if (i_indx(opt, "2", opt_len, (ftnlen)1) != 0) {
	form = 2;
    }

/* Choose major interval (DVMAJ in the logarithm, with minimum value */
/* 1.0 = one decade). The minor interval is always 1.0. */

/*<       IF (STEP.GT.0.5) THEN >*/
    if (*step > (float).5) {
/*<          DVMAJ = NINT(STEP) >*/
	dvmaj = (real) i_nint(step);
/*<       ELSE >*/
    } else {
/*<          DVMAJ = PGRND(0.20*ABS(V1-V2),NSUBT) >*/
	r__2 = (r__1 = *v1 - *v2, dabs(r__1)) * (float).2;
	dvmaj = pgrnd_(&r__2, &nsubt);
/*<          IF (DVMAJ.LT.1.0) DVMAJ = 1.0 >*/
	if (dvmaj < (float)1.) {
	    dvmaj = (float)1.;
	}
/*<       END IF >*/
    }
/*<       DVMIN = 1.0 >*/
    dvmin = (float)1.;
/*<       NSUBT = DVMAJ/DVMIN >*/
    nsubt = dvmaj / dvmin;

/*<       CALL PGBBUF >*/
    pgbbuf_();
/*<       CALL PGQCLP(CLIP) >*/
    pgqclp_(&clip);
/*<       CALL PGSCLP(0) >*/
    pgsclp_(&c__0);

/* Draw the axis. */

/*<       CALL PGMOVE(X1, Y1) >*/
    pgmove_(x1, y1);
/*<       CALL PGDRAW(X2, Y2) >*/
    pgdraw_(x2, y2);

/* Draw the tick marks. Major ticks are drawn at V = K*DVMAJ. */

/*<       VMIN = MIN(V1, V2) >*/
    vmin = dmin(*v1,*v2);
/*<       VMAX = MAX(V1, V2) >*/
    vmax = dmax(*v1,*v2);
/*<       K1 = INT(VMIN/DVMIN) >*/
    k1 = (integer) (vmin / dvmin);
/*<       IF (DVMIN*K1.LT.VMIN) K1 = K1+1 >*/
    if (dvmin * k1 < vmin) {
	++k1;
    }
/*<       K2 = INT(VMAX/DVMIN) >*/
    k2 = (integer) (vmax / dvmin);
/*<       IF (DVMIN*K2.GT.VMAX) K2 = K2-1 >*/
    if (dvmin * k2 > vmax) {
	--k2;
    }
/*<       XLAB = (K2-K1) .LE. 2 >*/
    xlab = k2 - k1 <= 2;
/*<       DO 20 K=K1,K2 >*/
    i__1 = k2;
    for (k = k1; k <= i__1; ++k) {
/*<          V = (K*DVMIN-V1)/(V2-V1) >*/
	v = (k * dvmin - *v1) / (*v2 - *v1);
/*<          IF (MOD(K,NSUBT).EQ.0) THEN >*/
	if (k % nsubt == 0) {
/*             -- major tick mark */
/*<             IF (OPTN) THEN >*/
	    if (optn) {
/*<                CALL PGNUMB(1, NINT(K*DVMIN), FORM, LABEL, LLAB) >*/
		r__1 = k * dvmin;
		i__2 = i_nint(&r__1);
		pgnumb_(&c__1, &i__2, &form, label, &llab, (ftnlen)32);
/*<             ELSE >*/
	    } else {
/*<                LABEL = ' ' >*/
		s_copy(label, " ", (ftnlen)32, (ftnlen)1);
/*<                LLAB = 1 >*/
		llab = 1;
/*<             END IF >*/
	    }
/*<    >*/
	    pgtick_(x1, y1, x2, y2, &v, dmajl, dmajr, disp, orient, label, 
		    llab);
/*<          ELSE >*/
	} else {
/*             -- minor tick mark */
/*<    >*/
	    r__1 = *dmajl * *fmin;
	    r__2 = *dmajr * *fmin;
	    pgtick_(x1, y1, x2, y2, &v, &r__1, &r__2, &c_b10, orient, " ", (
		    ftnlen)1);
/*<          END IF >*/
	}
/*<  20   CONTINUE >*/
/* L20: */
    }

/* Draw intermediate tick marks if required. */
/* Label them if axis spans less than 2 decades. */

/*<       IF (NSUBT.EQ.1) THEN >*/
    if (nsubt == 1) {
/*<          DO 30 K=K1-1,K2+1 >*/
	i__1 = k2 + 1;
	for (k = k1 - 1; k <= i__1; ++k) {
/*<             DO 25 I=2,9 >*/
	    for (i__ = 2; i__ <= 9; ++i__) {
/*<                V = (K*DVMIN + TAB(I) -V1)/(V2-V1) >*/
		v = (k * dvmin + tab[i__ - 1] - *v1) / (*v2 - *v1);
/*<                IF (V.GE.0.0 .AND. V.LE.1.0) THEN >*/
		if (v >= (float)0. && v <= (float)1.) {
/*<                   IF (OPTN.AND.(XLAB .AND.(I.EQ.2 .OR. I.EQ.5))) THEN >*/
		    if (optn && (xlab && (i__ == 2 || i__ == 5))) {
/*                    -- labeled minor tick mark */
/*<                      CALL PGNUMB(I, NINT(K*DVMIN), FORM, LABEL, LLAB) >*/
			r__1 = k * dvmin;
			i__2 = i_nint(&r__1);
			pgnumb_(&i__, &i__2, &form, label, &llab, (ftnlen)32);
/*<                   ELSE >*/
		    } else {
/*                    -- unlabeled minor tick mark */
/*<                      LABEL = ' ' >*/
			s_copy(label, " ", (ftnlen)32, (ftnlen)1);
/*<                      LLAB = 1 >*/
			llab = 1;
/*<                   END IF >*/
		    }
/*<    >*/
		    r__1 = *dmajl * *fmin;
		    r__2 = *dmajr * *fmin;
		    pgtick_(x1, y1, x2, y2, &v, &r__1, &r__2, disp, orient, 
			    label, llab);
/*<                END IF >*/
		}
/*<  25         CONTINUE >*/
/* L25: */
	    }
/*<  30      CONTINUE >*/
/* L30: */
	}
/*<       END IF >*/
    }

/*<       CALL PGSCLP(CLIP) >*/
    pgsclp_(&clip);
/*<       CALL PGEBUF >*/
    pgebuf_();
/*<       END >*/
} /* pgaxlg_ */

