/* /work2/ssa/pgplot/src/pgband.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer pgid, pgdevs[8], pgadvs[8], pgnx[8], pgny[8], pgnxc[8], pgnyc[8];
    real pgxpin[8], pgypin[8], pgxsp[8], pgysp[8], pgxsz[8], pgysz[8], pgxoff[
	    8], pgyoff[8], pgxvp[8], pgyvp[8], pgxlen[8], pgylen[8], pgxorg[8]
	    , pgyorg[8], pgxscl[8], pgyscl[8], pgxblc[8], pgxtrc[8], pgyblc[8]
	    , pgytrc[8], trans[6];
    logical pgprmp[8];
    integer pgclp[8], pgfas[8];
    real pgchsz[8];
    integer pgblev[8];
    logical pgrows[8];
    integer pgahs[8];
    real pgaha[8], pgahv[8];
    integer pgtbci[8], pgmnci[8], pgmxci[8], pgcint, pgcmin;
    logical pgpfix[8];
    integer pgitf[8];
    real pghsa[8], pghss[8], pghsp[8];
} pgplt1_;

#define pgplt1_1 pgplt1_

struct {
    char pgclab[32];
} pgplt2_;

#define pgplt2_1 pgplt2_

/* *PGBAND -- read cursor position, with anchor */
/* %int cpgband(int mode, int posn, float xref, float yref, float *x,\ */
/* %            float *y, char *ch_scalar); */
/* + */
/*<       INTEGER FUNCTION PGBAND (MODE, POSN, XREF, YREF, X, Y, CH) >*/
integer pgband_(mode, posn, xref, yref, x, y, ch, ch_len)
integer *mode, *posn;
real *xref, *yref, *x, *y;
char *ch;
ftnlen ch_len;
{
    /* System generated locals */
    integer ret_val;
    real r__1;

    /* Builtin functions */
    /* Subroutine */ int s_copy();
    integer i_nint();

    /* Local variables */
    static integer iref, jref, i__, j;
    extern /* Subroutine */ int grwarn_(), grterm_();
    extern integer grcurs_();
    extern logical pgnoto_();

/*<       INTEGER MODE, POSN >*/
/*<       REAL XREF, YREF, X, Y >*/
/*<       CHARACTER*(*) CH >*/

/* Read the cursor position and a character typed by the user. */
/* The position is returned in world coordinates.  PGBAND positions */
/* the cursor at the position specified (if POSN=1), allows the user to */
/* move the cursor using the mouse or arrow keys or whatever is available */
/* on the device. When he has positioned the cursor, the user types a */
/* single character on the keyboard; PGBAND then returns this */
/* character and the new cursor position (in world coordinates). */

/* Some interactive devices offer a selection of cursor types, */
/* implemented as thin lines that move with the cursor, but without */
/* erasing underlying graphics. Of these types, some extend between */
/* a stationary anchor-point at XREF,YREF, and the position of the */
/* cursor, while others simply follow the cursor without changing shape */
/* or size. The cursor type is specified with one of the following MODE */
/* values. Cursor types that are not supported by a given device, are */
/* treated as MODE=0. */

/* -- If MODE=0, the anchor point is ignored and the routine behaves */
/* like PGCURS. */
/* -- If MODE=1, a straight line is drawn joining the anchor point */
/* and the cursor position. */
/* -- If MODE=2, a hollow rectangle is extended as the cursor is moved, */
/* with one vertex at the anchor point and the opposite vertex at the */
/* current cursor position; the edges of the rectangle are horizontal */
/* and vertical. */
/* -- If MODE=3, two horizontal lines are extended across the width of */
/* the display, one drawn through the anchor point and the other */
/* through the moving cursor position. This could be used to select */
/* a Y-axis range when one end of the range is known. */
/* -- If MODE=4, two vertical lines are extended over the height of */
/* the display, one drawn through the anchor point and the other */
/* through the moving cursor position. This could be used to select an */
/* X-axis range when one end of the range is known. */
/* -- If MODE=5, a horizontal line is extended through the cursor */
/* position over the width of the display. This could be used to select */
/* an X-axis value such as the start of an X-axis range. The anchor point */
/* is ignored. */
/* -- If MODE=6, a vertical line is extended through the cursor */
/* position over the height of the display. This could be used to select */
/* a Y-axis value such as the start of a Y-axis range. The anchor point */
/* is ignored. */
/* -- If MODE=7, a cross-hair, centered on the cursor, is extended over */
/* the width and height of the display. The anchor point is ignored. */

/* Returns: */
/*  PGBAND          : 1 if the call was successful; 0 if the device */
/*                    has no cursor or some other error occurs. */
/* Arguments: */
/*  MODE   (input)  : display mode (0, 1, ..7: see above). */
/*  POSN   (input)  : if POSN=1, PGBAND attempts to place the cursor */
/*                    at point (X,Y); if POSN=0, it leaves the cursor */
/*                    at its current position. (On some devices this */
/*                    request may be ignored.) */
/*  XREF   (input)  : the world x-coordinate of the anchor point. */
/*  YREF   (input)  : the world y-coordinate of the anchor point. */
/*  X      (in/out) : the world x-coordinate of the cursor. */
/*  Y      (in/out) : the world y-coordinate of the cursor. */
/*  CH     (output) : the character typed by the user; if the device has */
/*                    no cursor or if some other error occurs, the value */
/*                    CHAR(0) [ASCII NUL character] is returned. */

/* Note: The cursor coordinates (X,Y) may be changed by PGBAND even if */
/* the device has no cursor or if the user does not move the cursor. */
/* Under these circumstances, the position returned in (X,Y) is that of */
/* the pixel nearest to the requested position. */
/* -- */
/* 7-Sep-1994 - new routine [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE      'pgplot.inc' >*/
/*<       INTEGER      GRCURS, I, J, IREF, JREF >*/
/* ----------------------------------------------------------------------- */
/* PGPLOT: common block definition. */
/* ----------------------------------------------------------------------- */
/* Maximum number of concurrent devices (should match GRIMAX). */
/* ----------------------------------------------------------------------- */
/*<       PARAMETER (PGMAXD=8) >*/
/* ----------------------------------------------------------------------- */
/* Indentifier of currently selected device. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER PGID >*/
/* ----------------------------------------------------------------------- */
/* Device status (indexed by device identifier). */
/* ----------------------------------------------------------------------- */
/* PGDEVS  =0 if device is not open; 1 if device is open. */
/* PGADVS  Set to 0 by PGBEGIN, set to 1 by PGPAGE; used to suppress */
/*         the prompt for the first page. */
/* PROMPT  If .TRUE., ask user before clearing page; set by PGASK */
/*         and (indirectly) by PGBEGIN, used in PGENV. */
/* PGBLEV  Buffering level: incremented by PGBBUF, decremented by */
/*         PGEBUF. */
/* PGPFIX  TRUE if PGPAP has been called, FALSE otherwise. */

/*<       INTEGER PGDEVS(PGMAXD), PGADVS(PGMAXD), PGBLEV(PGMAXD) >*/
/*<       LOGICAL PGPRMP(PGMAXD), PGPFIX(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Panel parameters (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* NX      Number of panels in x direction */
/* NY      Number of panels in y direction */
/* NXC     Ordinal number of current X panel */
/* NYC     Ordinal number of current Y panel */
/* XSZ     X dimension of panel (device units) */
/* YSZ     Y dimension of panel (device units) */
/* PGROWS  TRUE if panels are used in row order, FALSE for column */
/*         order. */

/*<       INTEGER PGNX  (PGMAXD), PGNY  (PGMAXD) >*/
/*<       INTEGER PGNXC (PGMAXD), PGNYC (PGMAXD) >*/
/*<       REAL    PGXSZ (PGMAXD), PGYSZ (PGMAXD) >*/
/*<       LOGICAL PGROWS(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Attributes (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* PGCLP   clipping enabled/disabed */
/* PGFAS   fill-area style */
/* PGCHSZ  character height */
/* PGAHS   arrow-head fill style */
/* PGAHA   arrow-head angle */
/* PGAHV   arrow-head vent */
/* PGTBCI  text background color index */
/* PGMNCI  lower range of color indices available to PGGRAY/PGIMAG */
/* PGMXCI  upper range of color indices available to PGGRAY/PGIMAG */
/* PGITF   type of transfer function used by PGGRAY/PGIMAG */
/* PGHSA   hatching line angle */
/* PGHSS   hatching line separation */
/* PGHSP   hatching line phase */

/*<       INTEGER PGCLP (PGMAXD) >*/
/*<       INTEGER PGFAS (PGMAXD) >*/
/*<       REAL    PGCHSZ(PGMAXD) >*/
/*<       INTEGER PGAHS (PGMAXD) >*/
/*<       REAL    PGAHA (PGMAXD) >*/
/*<       REAL    PGAHV (PGMAXD) >*/
/*<       INTEGER PGTBCI(PGMAXD) >*/
/*<       INTEGER PGMNCI(PGMAXD) >*/
/*<       INTEGER PGMXCI(PGMAXD) >*/
/*<       INTEGER PGITF (PGMAXD) >*/
/*<       REAL    PGHSA (PGMAXD) >*/
/*<       REAL    PGHSS (PGMAXD) >*/
/*<       REAL    PGHSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Viewport parameters (indexed by device identification); all are device */
/* coordinates: */
/* ----------------------------------------------------------------------- */
/* PGXOFF  X coordinate of blc of viewport. */
/* PGYOFF  Y coordinate of blc of viewport. */
/* PGXVP   X coordinate of blc of viewport, relative to blc of subpage. */
/* PGYVP   Y coordinate of blc of viewport, relative to blc of subpage. */
/* PGXLEN  Width of viewport. */
/* PGYLEN  Height of viewport. */

/*<       REAL   PGXOFF(PGMAXD), PGYOFF(PGMAXD) >*/
/*<       REAL   PGXVP (PGMAXD), PGYVP (PGMAXD) >*/
/*<       REAL   PGXLEN(PGMAXD), PGYLEN(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Scaling parameters (indexed by device identification): */
/* ----------------------------------------------------------------------- */
/* PGXORG  device coordinate value corresponding to world X=0 */
/* PGYORG  device coordinate value corresponding to world Y=0 */
/* PGXSCL  scale in x (device units per world coordinate unit) */
/* PGYSCL  scale in y (device units per world coordinate unit) */
/* PGXPIN  device x scale in device units/inch */
/* PGYPIN  device y scale in device units/inch */
/* PGXSP   Character X spacing (device units) */
/* PGYSP   Character Y spacing (device units) */

/*<       REAL   PGXORG(PGMAXD), PGYORG(PGMAXD) >*/
/*<       REAL   PGXSCL(PGMAXD), PGYSCL(PGMAXD) >*/
/*<       REAL   PGXPIN(PGMAXD), PGYPIN(PGMAXD) >*/
/*<       REAL   PGXSP (PGMAXD), PGYSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Window parameters (indexed by device identification); all are world */
/* coordinate values: */
/* ----------------------------------------------------------------------- */
/* PGXBLC  world X at bottom left corner of window */
/* PGXTRC  world X at top right corner of window */
/* PGYBLC  world Y at bottom left corner of window */
/* PGYTRC  world Y at top right corner of window */

/*<       REAL    PGXBLC(PGMAXD), PGXTRC(PGMAXD) >*/
/*<       REAL    PGYBLC(PGMAXD), PGYTRC(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* The following parameters are used in the contouring routines to pass */
/* information to the action routine. They do not need to be indexed. */
/* ----------------------------------------------------------------------- */
/* TRANS   Transformation matrix for contour plots; copied */
/*         from argument list by PGCONT and used by PGCP. */

/*<       INTEGER PGCINT, PGCMIN >*/
/*<       REAL    TRANS(6) >*/
/*<       CHARACTER*32 PGCLAB >*/
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*<    >*/
/*<       COMMON  /PGPLT2/ PGCLAB >*/
/*<       SAVE    /PGPLT1/ >*/
/*<       SAVE    /PGPLT2/ >*/
/* ----------------------------------------------------------------------- */
/*<       LOGICAL      PGNOTO >*/

/*<       IF (PGNOTO('PGBAND')) THEN >*/
    if (pgnoto_("PGBAND", (ftnlen)6)) {
/*<           CH = CHAR(0) >*/
	s_copy(ch, "\000", ch_len, (ftnlen)1);
/*<           PGBAND = 0 >*/
	ret_val = 0;
/*<           RETURN >*/
	return ret_val;
/*<       END IF >*/
    }
/*<    >*/
    if (*mode < 0 || *mode > 7) {
	grwarn_("Invalid MODE argument in PGBAND", (ftnlen)31);
    }
/*<    >*/
    if (*posn < 0 || *posn > 1) {
	grwarn_("Invalid POSN argument in PGBAND", (ftnlen)31);
    }

/*<       I = NINT(PGXORG(PGID) + X*PGXSCL(PGID)) >*/
    r__1 = pgplt1_1.pgxorg[pgplt1_1.pgid - 1] + *x * pgplt1_1.pgxscl[
	    pgplt1_1.pgid - 1];
    i__ = i_nint(&r__1);
/*<       J = NINT(PGYORG(PGID) + Y*PGYSCL(PGID)) >*/
    r__1 = pgplt1_1.pgyorg[pgplt1_1.pgid - 1] + *y * pgplt1_1.pgyscl[
	    pgplt1_1.pgid - 1];
    j = i_nint(&r__1);
/*<       IREF = NINT(PGXORG(PGID) + XREF*PGXSCL(PGID)) >*/
    r__1 = pgplt1_1.pgxorg[pgplt1_1.pgid - 1] + *xref * pgplt1_1.pgxscl[
	    pgplt1_1.pgid - 1];
    iref = i_nint(&r__1);
/*<       JREF = NINT(PGYORG(PGID) + YREF*PGYSCL(PGID)) >*/
    r__1 = pgplt1_1.pgyorg[pgplt1_1.pgid - 1] + *yref * pgplt1_1.pgyscl[
	    pgplt1_1.pgid - 1];
    jref = i_nint(&r__1);
/*<       PGBAND = GRCURS(PGID,I,J,IREF,JREF,MODE,POSN,CH) >*/
    ret_val = grcurs_(&pgplt1_1.pgid, &i__, &j, &iref, &jref, mode, posn, ch, 
	    ch_len);
/*<       X = (I - PGXORG(PGID))/PGXSCL(PGID) >*/
    *x = (i__ - pgplt1_1.pgxorg[pgplt1_1.pgid - 1]) / pgplt1_1.pgxscl[
	    pgplt1_1.pgid - 1];
/*<       Y = (J - PGYORG(PGID))/PGYSCL(PGID) >*/
    *y = (j - pgplt1_1.pgyorg[pgplt1_1.pgid - 1]) / pgplt1_1.pgyscl[
	    pgplt1_1.pgid - 1];
/*<       CALL GRTERM >*/
    grterm_();
/*<       END >*/
    return ret_val;
} /* pgband_ */

