/* /work2/ssa/pgplot/src/pgbeg.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* *PGBEG -- open a graphics device */
/* %int cpgbeg(int unit, const char *file, int nxsub, int nysub); */
/* + */
/*<       INTEGER FUNCTION PGBEG (UNIT, FILE, NXSUB, NYSUB) >*/
integer pgbeg_(unit, file, nxsub, nysub, file_len)
integer *unit;
char *file;
integer *nxsub, *nysub;
ftnlen file_len;
{
    /* System generated locals */
    integer ret_val;

    /* Local variables */
    extern /* Subroutine */ int pgend_();
    extern integer pgopen_();
    extern /* Subroutine */ int pginit_(), pgsubp_();
    static integer ier;

/*<       INTEGER       UNIT >*/
/*<       CHARACTER*(*) FILE >*/
/*<       INTEGER       NXSUB, NYSUB >*/

/* Note: new programs should use PGOPEN rather than PGBEG. PGOPEN */
/* is retained for compatibility with existing programs. Unlike PGOPEN, */
/* PGBEG closes any graphics devices that are already open, so it */
/* cannot be used to open devices to be used in parallel. */

/* PGBEG opens a graphical device or file and prepares it for */
/* subsequent plotting. A device must be opened with PGBEG or PGOPEN */
/* before any other calls to PGPLOT subroutines for the device. */

/* If any device  is already open for PGPLOT output, it is closed before */
/* the new device is opened. */

/* Returns: */
/*  PGBEG         : a status return value. A value of 1 indicates */
/*                    successful completion, any other value indicates */
/*                    an error. In the event of error a message is */
/*                    written on the standard error unit. */
/*                    To test the return value, call */
/*                    PGBEG as a function, eg IER=PGBEG(...); note */
/*                    that PGBEG must be declared INTEGER in the */
/*                    calling program. Some Fortran compilers allow */
/*                    you to use CALL PGBEG(...) and discard the */
/*                    return value, but this is not standard Fortran. */
/* Arguments: */
/*  UNIT  (input)   : this argument is ignored by PGBEG (use zero). */
/*  FILE  (input)   : the "device specification" for the plot device. */
/*                    (For explanation, see description of PGOPEN.) */
/*  NXSUB  (input)  : the number of subdivisions of the view surface in */
/*                    X (>0 or <0). */
/*  NYSUB  (input)  : the number of subdivisions of the view surface in */
/*                    Y (>0). */
/*                    PGPLOT puts NXSUB x NYSUB graphs on each plot */
/*                    page or screen; when the view surface is sub- */
/*                    divided in this way, PGPAGE moves to the next */
/*                    panel, not the  next physical page. If */
/*                    NXSUB > 0, PGPLOT uses the panels in row */
/*                    order; if <0, PGPLOT uses them in column order. */
/* -- */
/* 21-Dec-1995 [TJP] - changed for multiple devices; call PGOPEN. */
/* 27-Feb-1997 [TJP] - updated description. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER       IER >*/
/*<       INTEGER       PGOPEN >*/

/* Initialize PGPLOT if necessary. */

/*<       CALL PGINIT >*/
    pginit_();

/* Close the plot-file if it is already open. */

/*<       CALL PGEND >*/
    pgend_();

/* Call PGOPEN to open the device. */

/*<       IER = PGOPEN(FILE) >*/
    ier = pgopen_(file, file_len);
/*<       IF (IER.GT.0) THEN >*/
    if (ier > 0) {
/*<          CALL PGSUBP(NXSUB, NYSUB) >*/
	pgsubp_(nxsub, nysub);
/*<          PGBEG = 1 >*/
	ret_val = 1;
/*<       ELSE >*/
    } else {
/*<          PGBEG = IER >*/
	ret_val = ier;
/*<       END IF >*/
    }

/*<       RETURN >*/
    return ret_val;
/*<       END >*/
} /* pgbeg_ */

