/* /work2/ssa/pgplot/src/pgbin.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__2 = 2;
static logical c_false = FALSE_;
static integer c__3 = 3;

/* *PGBIN -- histogram of binned data */
/* %void cpgbin(int nbin, const float *x, const float *data, \ */
/* % Logical center); */
/* + */
/*<       SUBROUTINE PGBIN (NBIN, X, DATA, CENTER) >*/
/* Subroutine */ int pgbin_(nbin, x, data, center)
integer *nbin;
real *x, *data;
logical *center;
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    static integer ibin;
    extern /* Subroutine */ int grvct0_(), pgbbuf_(), pgebuf_();
    static real tx[4], ty[4];
    extern logical pgnoto_();

/*<       INTEGER NBIN >*/
/*<       REAL X(*), DATA(*) >*/
/*<       LOGICAL CENTER >*/

/* Plot a histogram of NBIN values with X(1..NBIN) values along */
/* the ordinate, and DATA(1...NBIN) along the abscissa. Bin width is */
/* spacing between X values. */

/* Arguments: */
/*  NBIN   (input)  : number of values. */
/*  X      (input)  : abscissae of bins. */
/*  DATA   (input)  : data values of bins. */
/*  CENTER (input)  : if .TRUE., the X values denote the center of the */
/*                    bin; if .FALSE., the X values denote the lower */
/*                    edge (in X) of the bin. */
/* -- */
/* 19-Aug-92: change argument check (TJP). */
/* ----------------------------------------------------------------------- */
/*<       LOGICAL  PGNOTO >*/
/*<       INTEGER  IBIN >*/
/*<       REAL     TX(4), TY(4) >*/

/* Check arguments. */

/*<       IF (NBIN.LT.2) RETURN >*/
    /* Parameter adjustments */
    --data;
    --x;

    /* Function Body */
    if (*nbin < 2) {
	return 0;
    }
/*<       IF (PGNOTO('PGBIN')) RETURN >*/
    if (pgnoto_("PGBIN", (ftnlen)5)) {
	return 0;
    }
/*<       CALL PGBBUF >*/
    pgbbuf_();

/* Draw Histogram. Centered an uncentered bins are treated separately. */

/*<       IF (CENTER) THEN >*/
    if (*center) {
/*         !set up initial point. */
/*<           TX(2) = (3.*X(1) - X(2))/2. >*/
	tx[1] = (x[1] * (float)3. - x[2]) / (float)2.;
/*<           TY(2) = DATA(1) >*/
	ty[1] = data[1];
/*<           TX(3) = (X(1) + X(2))/2. >*/
	tx[2] = (x[1] + x[2]) / (float)2.;
/*<           TY(3) = TY(2) >*/
	ty[2] = ty[1];
/*<           CALL GRVCT0(2, .FALSE., 2, TX(2), TY(2)) >*/
	grvct0_(&c__2, &c_false, &c__2, &tx[1], &ty[1]);
/*         !draw initial horizontal line */
/*         !now loop over bins */
/*<           DO 10 IBIN=2,NBIN-1 >*/
	i__1 = *nbin - 1;
	for (ibin = 2; ibin <= i__1; ++ibin) {
/*<               TX(1) = TX(3) >*/
	    tx[0] = tx[2];
/*<               TX(2) = TX(1) >*/
	    tx[1] = tx[0];
/*<               TX(3) = ( X(IBIN) + X(IBIN+1) ) / 2. >*/
	    tx[2] = (x[ibin] + x[ibin + 1]) / (float)2.;
/*<               TY(1) = TY(3) >*/
	    ty[0] = ty[2];
/*<               TY(2) = DATA(IBIN) >*/
	    ty[1] = data[ibin];
/*<               TY(3) = TY(2) >*/
	    ty[2] = ty[1];
/*<               CALL GRVCT0(2, .FALSE., 3, TX, TY) >*/
	    grvct0_(&c__2, &c_false, &c__3, tx, ty);
/*<    10     CONTINUE >*/
/* L10: */
	}
/*         !now draw last segment. */
/*<           TX(1) = TX(3) >*/
	tx[0] = tx[2];
/*<           TX(2) = TX(1) >*/
	tx[1] = tx[0];
/*<           TX(3) = (3.*X(NBIN) - X(NBIN-1) )/2. >*/
	tx[2] = (x[*nbin] * (float)3. - x[*nbin - 1]) / (float)2.;
/*<           TY(1) = TY(3) >*/
	ty[0] = ty[2];
/*<           TY(2) = DATA(NBIN) >*/
	ty[1] = data[*nbin];
/*<           TY(3) = TY(2) >*/
	ty[2] = ty[1];
/*<           CALL GRVCT0(2, .FALSE., 3, TX, TY) >*/
	grvct0_(&c__2, &c_false, &c__3, tx, ty);

/*               Uncentered bins */

/*<       ELSE >*/
    } else {
/*         !set up first line. */
/*<           TX(2) = X(1) >*/
	tx[1] = x[1];
/*<           TY(2) = DATA(1) >*/
	ty[1] = data[1];
/*<           TX(3) = X(2) >*/
	tx[2] = x[2];
/*<           TY(3) = TY(2) >*/
	ty[2] = ty[1];
/*<           CALL GRVCT0(2, .FALSE., 2, TX(2), TY(2)) >*/
	grvct0_(&c__2, &c_false, &c__2, &tx[1], &ty[1]);
/*<           DO 20 IBIN=2,NBIN >*/
	i__1 = *nbin;
	for (ibin = 2; ibin <= i__1; ++ibin) {
/*<               TX(1) = TX(3) >*/
	    tx[0] = tx[2];
/*<               TX(2) = TX(1) >*/
	    tx[1] = tx[0];
/*<               IF (IBIN.EQ.NBIN) THEN >*/
	    if (ibin == *nbin) {
/*<                   TX(3) = 2.*X(NBIN) - X(NBIN-1) >*/
		tx[2] = x[*nbin] * (float)2. - x[*nbin - 1];
/*<               ELSE >*/
	    } else {
/*<                   TX(3) = X(IBIN+1) >*/
		tx[2] = x[ibin + 1];
/*<               END IF >*/
	    }
/*<               TY(1) = TY(3) >*/
	    ty[0] = ty[2];
/*             !get height for last segment. */
/*<               TY(2) = DATA(IBIN) >*/
	    ty[1] = data[ibin];
/*<               TY(3) = TY(2) >*/
	    ty[2] = ty[1];
/*<               CALL GRVCT0(2, .FALSE., 3, TX, TY) >*/
	    grvct0_(&c__2, &c_false, &c__3, tx, ty);
/*<    20     CONTINUE >*/
/* L20: */
	}
/*<       END IF >*/
    }

/*<       CALL PGEBUF >*/
    pgebuf_();
/*<       END >*/
} /* pgbin_ */

