/* /work2/ssa/pgplot/src/pgconb.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* *PGCONB -- contour map of a 2D data array, with blanking */
/* %void cpgconb(const float *a, int idim, int jdim, int i1, int i2, \ */
/* % int j1, int j2, const float *c, int nc, const float *tr, \ */
/* % float blank); */
/* + */
/*<    >*/
/* Subroutine */ int pgconb_(a, idim, jdim, i1, i2, j1, j2, c__, nc, tr, 
	blank)
real *a;
integer *idim, *jdim, *i1, *i2, *j1, *j2;
real *c__;
integer *nc;
real *tr, *blank;
{
    /* Initialized data */

    static integer idelt[6] = { 0,-1,-1,0,0,-1 };
    static integer ioff[8] = { -2,-2,-1,-1,0,0,1,1 };
    static integer joff[8] = { 0,-1,-2,1,-2,1,-1,0 };

    /* System generated locals */
    integer a_dim1, a_offset, i__1, i__2, i__3;

    /* Local variables */
    static integer ienc;
    static real dval[5];
    static integer itmp, jtmp, itot, i__, j, k;
    static real x[4], delta, y[4];
    static integer icorn, ic;
    extern /* Subroutine */ int pgbbuf_(), pgebuf_();
    static real xx, yy;
    extern /* Subroutine */ int pgdraw_(), pgmove_();
    extern logical pgnoto_();
    static integer ilo;
    static real ctr;
    static integer npt;

/*<       INTEGER IDIM, JDIM, I1, I2, J1, J2, NC >*/
/*<       REAL    A(IDIM,JDIM), C(*), TR(6), BLANK >*/

/* Draw a contour map of an array. This routine is the same as PGCONS, */
/* except that array elements that have the "magic value" defined by */
/* argument BLANK are ignored, making gaps in the contour map. The */
/* routine may be useful for data measured on most but not all of the */
/* points of a grid. */

/* Arguments: */
/*  A      (input)  : data array. */
/*  IDIM   (input)  : first dimension of A. */
/*  JDIM   (input)  : second dimension of A. */
/*  I1,I2  (input)  : range of first index to be contoured (inclusive). */
/*  J1,J2  (input)  : range of second index to be contoured (inclusive). */
/*  C      (input)  : array of contour levels (in the same units as the */
/*                    data in array A); dimension at least NC. */
/*  NC     (input)  : number of contour levels (less than or equal to */
/*                    dimension of C). The absolute value of this */
/*                    argument is used (for compatibility with PGCONT, */
/*                    where the sign of NC is significant). */
/*  TR     (input)  : array defining a transformation between the I,J */
/*                    grid of the array and the world coordinates. The */
/*                    world coordinates of the array point A(I,J) are */
/*                    given by: */
/*                      X = TR(1) + TR(2)*I + TR(3)*J */
/*                      Y = TR(4) + TR(5)*I + TR(6)*J */
/*                    Usually TR(3) and TR(5) are zero - unless the */
/*                    coordinate transformation involves a rotation */
/*                    or shear. */
/*  BLANK   (input) : elements of array A that are exactly equal to */
/*                    this value are ignored (blanked). */
/* -- */
/* 21-Sep-1989 - Derived from PGCONS [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER  I, IC, ICORN, IDELT(6), J, K, NPT >*/
/*<       INTEGER  IOFF(8), JOFF(8), IENC, ITMP, JTMP, ILO, ITOT >*/
/*<       LOGICAL  PGNOTO >*/
/*<       REAL     CTR, DELTA, DVAL(5), XX, YY, X(4), Y(4) >*/
/*<       INTRINSIC ABS >*/
/*<       DATA     IDELT/0,-1,-1,0,0,-1/ >*/
    /* Parameter adjustments */
    a_dim1 = *idim;
    a_offset = 1 + a_dim1 * 1;
    a -= a_offset;
    --c__;
    --tr;

    /* Function Body */
/*<       DATA     IOFF/-2,-2,-1,-1, 0, 0, 1, 1/ >*/
/*<       DATA     JOFF/ 0,-1,-2, 1,-2, 1,-1, 0/ >*/

/* Check arguments. */

/*<       IF (PGNOTO('PGCONB')) RETURN >*/
    if (pgnoto_("PGCONB", (ftnlen)6)) {
	return 0;
    }
/*<    >*/
    if (*i1 < 1 || *i2 > *idim || *i1 >= *i2 || *j1 < 1 || *j2 > *jdim || *j1 
	    >= *j2) {
	return 0;
    }
/*<       IF (NC.EQ.0) RETURN >*/
    if (*nc == 0) {
	return 0;
    }
/*<       CALL PGBBUF >*/
    pgbbuf_();

/*<       DO 130 J=J1+1,J2 >*/
    i__1 = *j2;
    for (j = *j1 + 1; j <= i__1; ++j) {
/*<       DO 130 I=I1+1,I2 >*/
	i__2 = *i2;
	for (i__ = *i1 + 1; i__ <= i__2; ++i__) {
/*<           DVAL(1) = A(I-1,J) >*/
	    dval[0] = a[i__ - 1 + j * a_dim1];
/*<           DVAL(2) = A(I-1,J-1) >*/
	    dval[1] = a[i__ - 1 + (j - 1) * a_dim1];
/*<           DVAL(3) = A(I,J-1) >*/
	    dval[2] = a[i__ + (j - 1) * a_dim1];
/*<           DVAL(4) = A(I,J) >*/
	    dval[3] = a[i__ + j * a_dim1];
/*<           DVAL(5) = DVAL(1) >*/
	    dval[4] = dval[0];
/*<    >*/
	    if (dval[0] == *blank || dval[1] == *blank || dval[2] == *blank ||
		     dval[3] == *blank) {
		goto L130;
	    }
/*<       DO 110 IC=1,ABS(NC) >*/
	    i__3 = abs(*nc);
	    for (ic = 1; ic <= i__3; ++ic) {
/*<           CTR = C(IC) >*/
		ctr = c__[ic];
/*<           NPT = 0 >*/
		npt = 0;
/*<           DO 120 ICORN=1,4 >*/
		for (icorn = 1; icorn <= 4; ++icorn) {
/*<    >*/
		    if (dval[icorn - 1] < ctr && dval[icorn] < ctr || dval[
			    icorn - 1] >= ctr && dval[icorn] >= ctr) {
			goto L120;
		    }
/*<             NPT=NPT+1 >*/
		    ++npt;
/*<             DELTA = (CTR-DVAL(ICORN))/(DVAL(ICORN+1)-DVAL(ICORN)) >*/
		    delta = (ctr - dval[icorn - 1]) / (dval[icorn] - dval[
			    icorn - 1]);
/*<             GOTO (60,70,60,70), ICORN >*/
		    switch ((int)icorn) {
			case 1:  goto L60;
			case 2:  goto L70;
			case 3:  goto L60;
			case 4:  goto L70;
		    }

/*<    60       XX = I+IDELT(ICORN+1) >*/
L60:
		    xx = (real) (i__ + idelt[icorn]);
/*<    >*/
		    yy = (real) (j + idelt[icorn - 1]) + delta * (real) (
			    idelt[icorn] - idelt[icorn - 1]);
/*<             GOTO 80 >*/
		    goto L80;

/*<    >*/
L70:
		    xx = (real) (i__ + idelt[icorn]) + delta * (real) (idelt[
			    icorn + 1] - idelt[icorn]);
/*<             YY  = J+IDELT(ICORN) >*/
		    yy = (real) (j + idelt[icorn - 1]);

/*<    80       X(NPT) = TR(1) + TR(2)*XX + TR(3)*YY >*/
L80:
		    x[npt - 1] = tr[1] + tr[2] * xx + tr[3] * yy;
/*<             Y(NPT) = TR(4) + TR(5)*XX + TR(6)*YY >*/
		    y[npt - 1] = tr[4] + tr[5] * xx + tr[6] * yy;

/*<   120     CONTINUE >*/
L120:
		    ;
		}
/*<           IF (NPT.EQ.2) THEN >*/
		if (npt == 2) {
/*             -- Contour crosses two sides of cell. Draw line-segment. */
/*<               CALL PGMOVE(X(1),Y(1)) >*/
		    pgmove_(x, y);
/*<               CALL PGDRAW(X(2),Y(2)) >*/
		    pgdraw_(&x[1], &y[1]);
/*<           ELSE IF (NPT.EQ.4) THEN >*/
		} else if (npt == 4) {
/*             -- The 'ambiguous' case.  The routine must draw two line */
/*             segments here and there are two ways to do so.  The */
/*             following 4 lines would implement the original PGPLOT */
/*             method: */
/*            CALL PGCP(0,X(1),Y(1),CTR) */
/*            CALL PGCP(1,X(2),Y(2),CTR) */
/*            CALL PGCP(0,X(3),Y(3),CTR) */
/*            CALL PGCP(1,X(4),Y(4),CTR) */
/*            -- Choose between \\ and // based on the 8 points just */
/*            outside the current box.  If half or more of these points */
/*            lie below the contour level, then draw the lines such that */
/*            the high corners lie between the lines, otherwise, draw */
/*            the lines such that the low corners are enclosed.  Care is */
/*            taken to avoid going off the edge. */
/*<             ITOT=0 >*/
		    itot = 0;
/*<             ILO=0 >*/
		    ilo = 0;
/*<             DO 140 K=1,8 >*/
		    for (k = 1; k <= 8; ++k) {
/*<                ITMP=I+IOFF(K) >*/
			itmp = i__ + ioff[k - 1];
/*<                JTMP=J+JOFF(K) >*/
			jtmp = j + joff[k - 1];
/*<                IF(ITMP.LT.I1 .OR. ITMP.GT.I2) GOTO 140 >*/
			if (itmp < *i1 || itmp > *i2) {
			    goto L140;
			}
/*<                IF(JTMP.LT.J1 .OR. JTMP.GT.J2) GOTO 140 >*/
			if (jtmp < *j1 || jtmp > *j2) {
			    goto L140;
			}
/*<                IF(A(ITMP,JTMP).EQ.BLANK) GOTO 140 >*/
			if (a[itmp + jtmp * a_dim1] == *blank) {
			    goto L140;
			}
/*<                ITOT=ITOT+1 >*/
			++itot;
/*<                IF(A(ITMP,JTMP).LT.CTR) ILO=ILO+1 >*/
			if (a[itmp + jtmp * a_dim1] < ctr) {
			    ++ilo;
			}
/*<   140       CONTINUE >*/
L140:
			;
		    }
/*<             IENC=+1 >*/
		    ienc = 1;
/*<             IF(ILO.LT.ITOT/2) IENC=-1 >*/
		    if (ilo < itot / 2) {
			ienc = -1;
		    }
/*<    >*/
		    if (ienc < 0 && dval[0] < ctr || ienc > 0 && dval[0] >= 
			    ctr) {
/*<                CALL PGMOVE(X(1),Y(1)) >*/
			pgmove_(x, y);
/*<                CALL PGDRAW(X(2),Y(2)) >*/
			pgdraw_(&x[1], &y[1]);
/*<                CALL PGMOVE(X(3),Y(3)) >*/
			pgmove_(&x[2], &y[2]);
/*<                CALL PGDRAW(X(4),Y(4)) >*/
			pgdraw_(&x[3], &y[3]);
/*<             ELSE >*/
		    } else {
/*<                CALL PGMOVE(X(1),Y(1)) >*/
			pgmove_(x, y);
/*<                CALL PGDRAW(X(4),Y(4)) >*/
			pgdraw_(&x[3], &y[3]);
/*<                CALL PGMOVE(X(3),Y(3)) >*/
			pgmove_(&x[2], &y[2]);
/*<                CALL PGDRAW(X(2),Y(2)) >*/
			pgdraw_(&x[1], &y[1]);
/*<             END IF >*/
		    }
/*<           END IF >*/
		}
/*<   110     CONTINUE >*/
/* L110: */
	    }
/*<   130 CONTINUE >*/
L130:
	    ;
	}
    }

/*<       CALL PGEBUF >*/
    pgebuf_();
/*<       END >*/
} /* pgconb_ */

