/* /work2/ssa/pgplot/src/pgctab.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static real c_b2 = (float).00390625;

/* *PGCTAB -- install the color table to be used by PGIMAG */
/* %void cpgctab(const float *l, const float *r, const float *g, \ */
/* % const float *b, int nc, float contra, float bright); */
/* + */
/*<       SUBROUTINE PGCTAB(L, R, G, B, NC, CONTRA, BRIGHT) >*/
/* Subroutine */ int pgctab_(l, r__, g, b, nc, contra, bright)
real *l, *r__, *g, *b;
integer *nc;
real *contra, *bright;
{
    /* System generated locals */
    integer i__1;

    /* Builtin functions */
    double r_sign();

    /* Local variables */
    static real blue, span, ldiff, lfrac;
    static integer above;
    static real green, level;
    static integer below;
    extern /* Subroutine */ int pgscr_();
    static integer nspan;
    static real ca, cb;
    static integer ci;
    static real cifrac;
    extern /* Subroutine */ int pgbbuf_(), pgebuf_();
    static integer minind, maxind;
    extern /* Subroutine */ int pgqcir_();
    static integer ntotal;
    static logical forwrd;
    static real red;

/*<       INTEGER NC >*/
/*<       REAL    L(NC), R(NC), G(NC), B(NC), CONTRA, BRIGHT >*/

/* Use the given color table to change the color representations of */
/* all color indexes marked for use by PGIMAG. To change which */
/* color indexes are thus marked, call PGSCIR before calling PGCTAB */
/* or PGIMAG. On devices that can change the color representations */
/* of previously plotted graphics, PGCTAB will also change the colors */
/* of existing graphics that were plotted with the marked color */
/* indexes. This feature can then be combined with PGBAND to */
/* interactively manipulate the displayed colors of data previously */
/* plotted with PGIMAG. */

/* Limitations: */
/*  1. Some devices do not propagate color representation changes */
/*     to previously drawn graphics. */
/*  2. Some devices ignore requests to change color representations. */
/*  3. The appearance of specific color representations on grey-scale */
/*     devices is device-dependent. */

/* Notes: */
/*  To reverse the sense of a color table, change the chosen contrast */
/*  and brightness to -CONTRA and 1-BRIGHT. */

/*  In the following, the term 'color table' refers to the input */
/*  L,R,G,B arrays, whereas 'color ramp' refers to the resulting */
/*  ramp of colors that would be seen with PGWEDG. */

/* Arguments: */
/*  L      (input)  : An array of NC normalized ramp-intensity levels */
/*                    corresponding to the RGB primary color intensities */
/*                    in R(),G(),B(). Colors on the ramp are linearly */
/*                    interpolated from neighbouring levels. */
/*                    Levels must be sorted in increasing order. */
/*                     0.0 places a color at the beginning of the ramp. */
/*                     1.0 places a color at the end of the ramp. */
/*                    Colors outside these limits are legal, but will */
/*                    not be visible if CONTRA=1.0 and BRIGHT=0.5. */
/*  R      (input)  : An array of NC normalized red intensities. */
/*  G      (input)  : An array of NC normalized green intensities. */
/*  B      (input)  : An array of NC normalized blue intensities. */
/*  NC     (input)  : The number of color table entries. */
/*  CONTRA (input)  : The contrast of the color ramp (normally 1.0). */
/*                    Negative values reverse the direction of the ramp. */
/*  BRIGHT (input)  : The brightness of the color ramp. This is normally */
/*                    0.5, but can sensibly hold any value between 0.0 */
/*                    and 1.0. Values at or beyond the latter two */
/*                    extremes, saturate the color ramp with the colors */
/*                    of the respective end of the color table. */
/* -- */
/*  17-Sep-1994 - New routine [MCS]. */
/*  14-Apr-1997 - Modified to implement a more conventional */
/*                interpretation of contrast and brightness [MCS]. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER MININD, MAXIND, CI >*/
/*<       INTEGER NTOTAL, NSPAN >*/
/*<       INTEGER BELOW, ABOVE >*/
/*<       LOGICAL FORWRD >*/
/*<       REAL CA, CB, CIFRAC, SPAN >*/
/*<       REAL LEVEL >*/
/*<       REAL LDIFF, LFRAC >*/
/*<       REAL RED, GREEN, BLUE >*/

/* Set the minimum absolute contrast - this prevents a divide by zero. */

/*<       REAL MINCTR >*/
/*<       PARAMETER (MINCTR = 1.0/256) >*/

/* No colormap entries? */

/*<       IF(NC .EQ. 0) RETURN >*/
    /* Parameter adjustments */
    --b;
    --g;
    --r__;
    --l;

    /* Function Body */
    if (*nc == 0) {
	return 0;
    }

/* Determine the range of color indexes to be used. */

/*<       CALL PGQCIR(MININD, MAXIND) >*/
    pgqcir_(&minind, &maxind);

/* Count the total number of color indexes to be processed. */

/*<       NTOTAL = MAXIND - MININD + 1 >*/
    ntotal = maxind - minind + 1;

/* No definable colors? */

/*<       IF(NTOTAL .LT. 1 .OR. MININD .LT. 0) RETURN >*/
    if (ntotal < 1 || minind < 0) {
	return 0;
    }

/* Prevent a divide by zero later by ensuring that CONTRA >= ABS(MINCTR). */

/*<       IF(ABS(CONTRA) .LT. MINCTR) THEN >*/
    if (dabs(*contra) < (float).00390625) {
/*<         CONTRA = SIGN(MINCTR, CONTRA) >*/
	*contra = r_sign(&c_b2, contra);
/*<       END IF >*/
    }

/* Convert contrast to the normalized stretch of the */
/* color table across the available color index range. */

/*<       SPAN = 1.0 / ABS(CONTRA) >*/
    span = (float)1. / dabs(*contra);

/* Translate from brightness and contrast to the normalized color index */
/* coordinates, CA and CB, at which to place the start and end of the */
/* color table. */

/*<       IF(CONTRA .GE. 0.0) THEN >*/
    if (*contra >= (float)0.) {
/*<         CA = 1.0 - BRIGHT * (1.0 + SPAN) >*/
	ca = (float)1. - *bright * (span + (float)1.);
/*<         CB = CA + SPAN >*/
	cb = ca + span;
/*<       ELSE >*/
    } else {
/*<         CA = BRIGHT * (1.0 + SPAN) >*/
	ca = *bright * (span + (float)1.);
/*<         CB = CA - SPAN >*/
	cb = ca - span;
/*<       END IF >*/
    }

/* Determine the number of color indexes spanned by the color table. */

/*<       NSPAN = INT(SPAN * NTOTAL) >*/
    nspan = (integer) (span * ntotal);

/* Determine the direction in which the color table should be traversed. */

/*<       FORWRD = CA .LE. CB >*/
    forwrd = ca <= cb;

/* Initialize the indexes at which to start searching the color table. */

/* Set the start index for traversing the table from NC to 1. */

/*<       BELOW = NC >*/
    below = *nc;

/* Set the start index for traversing the table from 1 to NC. */

/*<       ABOVE = 1 >*/
    above = 1;

/* Buffer PGPLOT commands until the color map has been completely */
/* installed. */

/*<       CALL PGBBUF >*/
    pgbbuf_();

/* Linearly interpolate the color table RGB values onto each color index. */

/*<       DO 1 CI=MININD, MAXIND >*/
    i__1 = maxind;
    for (ci = minind; ci <= i__1; ++ci) {

/* Turn the color index into a fraction of the range MININD..MAXIND. */

/*<         CIFRAC = REAL(CI-MININD) / REAL(MAXIND-MININD) >*/
	cifrac = (real) (ci - minind) / (real) (maxind - minind);

/* Determine the color table position that corresponds to color index, */
/* CI. */

/*<         IF(NSPAN .GT. 0) THEN >*/
	if (nspan > 0) {
/*<           LEVEL = (CIFRAC-CA) / (CB-CA) >*/
	    level = (cifrac - ca) / (cb - ca);
/*<         ELSE >*/
	} else {
/*<           IF(CIFRAC .LE. CA) THEN >*/
	    if (cifrac <= ca) {
/*<             LEVEL = 0.0 >*/
		level = (float)0.;
/*<           ELSE >*/
	    } else {
/*<             LEVEL = 1.0 >*/
		level = (float)1.;
/*<           END IF >*/
	    }
/*<         END IF >*/
	}

/* Search for the indexes of the two color table entries that straddle */
/* LEVEL. The search algorithm assumes that values in L() are */
/* arranged in increasing order. This allows us to search the color table */
/* from the point at which the last search left off, rather than having */
/* to search the whole color table each time. */

/*<         IF(FORWRD) THEN >*/
	if (forwrd) {
/*<  2        IF(ABOVE.LE.NC .AND. L(ABOVE).LT.LEVEL) THEN >*/
L2:
	    if (above <= *nc && l[above] < level) {
/*<             ABOVE = ABOVE + 1 >*/
		++above;
/*<             GOTO 2 >*/
		goto L2;
/*<           END IF >*/
	    }
/*<           BELOW = ABOVE - 1 >*/
	    below = above - 1;
/*<         ELSE >*/
	} else {
/*<  3        IF(BELOW.GE.1 .AND. L(BELOW).GT.LEVEL) THEN >*/
L3:
	    if (below >= 1 && l[below] > level) {
/*<             BELOW = BELOW - 1 >*/
		--below;
/*<             GOTO 3 >*/
		goto L3;
/*<           END IF >*/
	    }
/*<           ABOVE = BELOW + 1 >*/
	    above = below + 1;
/*<         END IF >*/
	}

/* If the indexes lie outside the table, substitute the index of the */
/* nearest edge of the table. */

/*<         IF(BELOW .LT. 1) THEN >*/
	if (below < 1) {
/*<           LEVEL = 0.0 >*/
	    level = (float)0.;
/*<           BELOW = 1 >*/
	    below = 1;
/*<           ABOVE = 1 >*/
	    above = 1;
/*<         ELSE IF(ABOVE .GT. NC) THEN >*/
	} else if (above > *nc) {
/*<           LEVEL = 1.0 >*/
	    level = (float)1.;
/*<           BELOW = NC >*/
	    below = *nc;
/*<           ABOVE = NC >*/
	    above = *nc;
/*<         END IF >*/
	}

/* Linearly interpolate the primary color intensities from color table */
/* entries, BELOW and ABOVE. */

/*<         LDIFF = L(ABOVE) - L(BELOW) >*/
	ldiff = l[above] - l[below];
/*<         IF(LDIFF .GT. MINCTR) THEN >*/
	if (ldiff > (float).00390625) {
/*<           LFRAC = (LEVEL - L(BELOW)) / LDIFF >*/
	    lfrac = (level - l[below]) / ldiff;
/*<         ELSE >*/
	} else {
/*<           LFRAC = 0.0 >*/
	    lfrac = (float)0.;
/*<         END IF >*/
	}
/*<         RED   = R(BELOW) + (R(ABOVE) - R(BELOW)) * LFRAC >*/
	red = r__[below] + (r__[above] - r__[below]) * lfrac;
/*<         GREEN = G(BELOW) + (G(ABOVE) - G(BELOW)) * LFRAC >*/
	green = g[below] + (g[above] - g[below]) * lfrac;
/*<         BLUE  = B(BELOW) + (B(ABOVE) - B(BELOW)) * LFRAC >*/
	blue = b[below] + (b[above] - b[below]) * lfrac;

/* Intensities are only defined between 0 and 1. */

/*<         IF(RED   .LT. 0.0)   RED = 0.0 >*/
	if (red < (float)0.) {
	    red = (float)0.;
	}
/*<         IF(RED   .GT. 1.0)   RED = 1.0 >*/
	if (red > (float)1.) {
	    red = (float)1.;
	}
/*<         IF(GREEN .LT. 0.0) GREEN = 0.0 >*/
	if (green < (float)0.) {
	    green = (float)0.;
	}
/*<         IF(GREEN .GT. 1.0) GREEN = 1.0 >*/
	if (green > (float)1.) {
	    green = (float)1.;
	}
/*<         IF(BLUE  .LT. 0.0)  BLUE = 0.0 >*/
	if (blue < (float)0.) {
	    blue = (float)0.;
	}
/*<         IF(BLUE  .GT. 1.0)  BLUE = 1.0 >*/
	if (blue > (float)1.) {
	    blue = (float)1.;
	}

/* Install the new color representation. */

/*<         CALL PGSCR(CI, RED, GREEN, BLUE) >*/
	pgscr_(&ci, &red, &green, &blue);
/*<  1    CONTINUE >*/
/* L1: */
    }

/* Reveal the changed color map. */

/*<       CALL PGEBUF >*/
    pgebuf_();
/*<       RETURN >*/
    return 0;
/*<       END >*/
} /* pgctab_ */

