/* /work2/ssa/pgplot/src/pgerr1.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* *PGERR1 -- horizontal or vertical error bar */
/* %void cpgerr1(int dir, float x, float y, float e, float t); */
/* + */
/*<       SUBROUTINE PGERR1 (DIR, X, Y, E, T) >*/
/* Subroutine */ int pgerr1_(dir, x, y, e, t)
integer *dir;
real *x, *y, *e, *t;
{
    /* System generated locals */
    real r__1;

    /* Local variables */
    static real xtik, ytik;
    extern /* Subroutine */ int pgbbuf_(), pgebuf_(), grlina_();
    static real xx, yy;
    extern /* Subroutine */ int pgtikl_(), grmova_();
    extern logical pgnoto_();

/*<       INTEGER DIR >*/
/*<       REAL X, Y, E >*/
/*<       REAL T >*/

/* Plot a single error bar in the direction specified by DIR. */
/* This routine draws an error bar only; to mark the data point at */
/* the start of the error bar, an additional call to PGPT is required. */
/* To plot many error bars, use PGERRB. */

/* Arguments: */
/*  DIR    (input)  : direction to plot the error bar relative to */
/*                    the data point. */
/*                    One-sided error bar: */
/*                      DIR is 1 for +X (X to X+E); */
/*                             2 for +Y (Y to Y+E); */
/*                             3 for -X (X to X-E); */
/*                             4 for -Y (Y to Y-E). */
/*                    Two-sided error bar: */
/*                      DIR is 5 for +/-X (X-E to X+E); */
/*                             6 for +/-Y (Y-E to Y+E). */
/*  X      (input)  : world x-coordinate of the data. */
/*  Y      (input)  : world y-coordinate of the data. */
/*  E      (input)  : value of error bar distance to be added to the */
/*                    data position in world coordinates. */
/*  T      (input)  : length of terminals to be drawn at the ends */
/*                    of the error bar, as a multiple of the default */
/*                    length; if T = 0.0, no terminals will be drawn. */
/* -- */
/* 31-Mar-1997 - new routine [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       LOGICAL  PGNOTO >*/
/*<       REAL     XTIK, YTIK, XX, YY >*/

/*<       IF (PGNOTO('PGERR1')) RETURN >*/
    if (pgnoto_("PGERR1", (ftnlen)6)) {
	return 0;
    }
/*<       IF (DIR.LT.1 .OR. DIR.GT.6) RETURN >*/
    if (*dir < 1 || *dir > 6) {
	return 0;
    }
/*<       CALL PGBBUF >*/
    pgbbuf_();

/* Determine terminal length. */

/*<       CALL PGTIKL(T, XTIK, YTIK) >*/
    pgtikl_(t, &xtik, &ytik);

/* Draw terminal at starting point if required. */

/*<       IF (DIR.EQ.5) THEN >*/
    if (*dir == 5) {
/*<          XX = X-E >*/
	xx = *x - *e;
/*<          YY = Y >*/
	yy = *y;
/*<       ELSE IF (DIR.EQ.6) THEN >*/
    } else if (*dir == 6) {
/*<          XX = X >*/
	xx = *x;
/*<          YY = Y-E >*/
	yy = *y - *e;
/*<       ELSE >*/
    } else {
/*<          XX = X >*/
	xx = *x;
/*<          YY = Y >*/
	yy = *y;
/*<       END IF >*/
    }
/*<       IF (T.NE.0.0) THEN >*/
    if (*t != (float)0.) {
/*<          IF (DIR.EQ.5) THEN >*/
	if (*dir == 5) {
/*<             CALL GRMOVA(XX,YY-YTIK) >*/
	    r__1 = yy - ytik;
	    grmova_(&xx, &r__1);
/*<             CALL GRLINA(XX,YY+YTIK) >*/
	    r__1 = yy + ytik;
	    grlina_(&xx, &r__1);
/*<          ELSE IF (DIR.EQ.6) THEN >*/
	} else if (*dir == 6) {
/*<             CALL GRMOVA(XX-XTIK,YY) >*/
	    r__1 = xx - xtik;
	    grmova_(&r__1, &yy);
/*<             CALL GRLINA(XX+XTIK,YY) >*/
	    r__1 = xx + xtik;
	    grlina_(&r__1, &yy);
/*<          END IF >*/
	}
/*<       END IF >*/
    }

/* Draw the error bar itself. */

/*<       CALL GRMOVA(XX,YY) >*/
    grmova_(&xx, &yy);
/*<       IF (DIR.EQ.1 .OR. DIR.EQ.5) THEN >*/
    if (*dir == 1 || *dir == 5) {
/*<          XX = X+E >*/
	xx = *x + *e;
/*<          YY = Y >*/
	yy = *y;
/*<       ELSE IF (DIR.EQ.2 .OR. DIR.EQ.6) THEN >*/
    } else if (*dir == 2 || *dir == 6) {
/*<          XX = X >*/
	xx = *x;
/*<          YY = Y+E >*/
	yy = *y + *e;
/*<       ELSE IF (DIR.EQ.3) THEN >*/
    } else if (*dir == 3) {
/*<          XX = X-E >*/
	xx = *x - *e;
/*<          YY = Y >*/
	yy = *y;
/*<       ELSE IF (DIR.EQ.4) THEN >*/
    } else if (*dir == 4) {
/*<          XX = X >*/
	xx = *x;
/*<          YY = Y-E >*/
	yy = *y - *e;
/*<       END IF >*/
    }
/*<       CALL GRLINA(XX,YY) >*/
    grlina_(&xx, &yy);

/* Draw terminal at end point. */

/*<       IF (T.NE.0.0) THEN >*/
    if (*t != (float)0.) {
/*<          IF (MOD(DIR,2).EQ.1) THEN >*/
	if (*dir % 2 == 1) {
/*<             CALL GRMOVA(XX,YY-YTIK) >*/
	    r__1 = yy - ytik;
	    grmova_(&xx, &r__1);
/*<             CALL GRLINA(XX,YY+YTIK) >*/
	    r__1 = yy + ytik;
	    grlina_(&xx, &r__1);
/*<          ELSE >*/
	} else {
/*<             CALL GRMOVA(XX-XTIK,YY) >*/
	    r__1 = xx - xtik;
	    grmova_(&r__1, &yy);
/*<             CALL GRLINA(XX+XTIK,YY) >*/
	    r__1 = xx + xtik;
	    grlina_(&r__1, &yy);
/*<          END IF >*/
	}
/*<       END IF >*/
    }

/*<       CALL PGEBUF >*/
    pgebuf_();
/*<       END >*/
} /* pgerr1_ */

