/* /work2/ssa/pgplot/src/pgerrb.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* *PGERRB -- horizontal or vertical error bar */
/* %void cpgerrb(int dir, int n, const float *x, const float *y, \ */
/* % const float *e, float t); */
/* + */
/*<       SUBROUTINE PGERRB (DIR, N, X, Y, E, T) >*/
/* Subroutine */ int pgerrb_(dir, n, x, y, e, t)
integer *dir, *n;
real *x, *y, *e, *t;
{
    /* System generated locals */
    integer i__1;
    real r__1;

    /* Local variables */
    static real xtik, ytik;
    static integer i__;
    extern /* Subroutine */ int pgbbuf_(), pgebuf_(), grlina_();
    static real xx, yy;
    extern /* Subroutine */ int pgtikl_(), grmova_();
    extern logical pgnoto_();

/*<       INTEGER DIR, N >*/
/*<       REAL X(*), Y(*), E(*) >*/
/*<       REAL T >*/

/* Plot error bars in the direction specified by DIR. */
/* This routine draws an error bar only; to mark the data point at */
/* the start of the error bar, an additional call to PGPT is required. */

/* Arguments: */
/*  DIR    (input)  : direction to plot the error bar relative to */
/*                    the data point. */
/*                    One-sided error bar: */
/*                      DIR is 1 for +X (X to X+E); */
/*                             2 for +Y (Y to Y+E); */
/*                             3 for -X (X to X-E); */
/*                             4 for -Y (Y to Y-E). */
/*                    Two-sided error bar: */
/*                      DIR is 5 for +/-X (X-E to X+E); */
/*                             6 for +/-Y (Y-E to Y+E). */
/*  N      (input)  : number of error bars to plot. */
/*  X      (input)  : world x-coordinates of the data. */
/*  Y      (input)  : world y-coordinates of the data. */
/*  E      (input)  : value of error bar distance to be added to the */
/*                    data position in world coordinates. */
/*  T      (input)  : length of terminals to be drawn at the ends */
/*                    of the error bar, as a multiple of the default */
/*                    length; if T = 0.0, no terminals will be drawn. */

/* Note: the dimension of arrays X, Y, and E must be greater */
/* than or equal to N. If N is 1, X, Y, and E may be scalar */
/* variables, or expressions. */
/* -- */
/*  1-Mar-1991 - new routine [JM]. */
/* 20-Apr-1992 - correct bug [ALF, TJP]. */
/* 28-Mar-1995 - add options DIR = 5 or 6 [TJP]. */
/* 31-Mar-1997 - use pgtikl [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER  I >*/
/*<       LOGICAL  PGNOTO >*/
/*<       REAL     XTIK, YTIK, XX, YY >*/

/*<       IF (PGNOTO('PGERRB')) RETURN >*/
    /* Parameter adjustments */
    --e;
    --y;
    --x;

    /* Function Body */
    if (pgnoto_("PGERRB", (ftnlen)6)) {
	return 0;
    }
/*<       IF (N.LT.1) RETURN >*/
    if (*n < 1) {
	return 0;
    }
/*<       IF (DIR.LT.1 .OR. DIR.GT.6) RETURN >*/
    if (*dir < 1 || *dir > 6) {
	return 0;
    }
/*<       CALL PGBBUF >*/
    pgbbuf_();

/* Determine terminal length. */

/*<       CALL PGTIKL(T, XTIK, YTIK) >*/
    pgtikl_(t, &xtik, &ytik);

/* Loop through points. */

/*<       DO 10 I=1,N >*/
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {

/* Draw terminal at starting point if required. */

/*<          IF (DIR.EQ.5) THEN >*/
	if (*dir == 5) {
/*<             XX = X(I)-E(I) >*/
	    xx = x[i__] - e[i__];
/*<             YY = Y(I) >*/
	    yy = y[i__];
/*<          ELSE IF (DIR.EQ.6) THEN >*/
	} else if (*dir == 6) {
/*<             XX = X(I) >*/
	    xx = x[i__];
/*<             YY = Y(I)-E(I) >*/
	    yy = y[i__] - e[i__];
/*<          ELSE >*/
	} else {
/*<             XX = X(I) >*/
	    xx = x[i__];
/*<             YY = Y(I) >*/
	    yy = y[i__];
/*<          END IF >*/
	}
/*<          IF (T.NE.0.0) THEN >*/
	if (*t != (float)0.) {
/*<             IF (DIR.EQ.5) THEN >*/
	    if (*dir == 5) {
/*<                CALL GRMOVA(XX,YY-YTIK) >*/
		r__1 = yy - ytik;
		grmova_(&xx, &r__1);
/*<                CALL GRLINA(XX,YY+YTIK) >*/
		r__1 = yy + ytik;
		grlina_(&xx, &r__1);
/*<             ELSE IF (DIR.EQ.6) THEN >*/
	    } else if (*dir == 6) {
/*<                CALL GRMOVA(XX-XTIK,YY) >*/
		r__1 = xx - xtik;
		grmova_(&r__1, &yy);
/*<                CALL GRLINA(XX+XTIK,YY) >*/
		r__1 = xx + xtik;
		grlina_(&r__1, &yy);
/*<             END IF >*/
	    }
/*<          END IF >*/
	}

/* Draw the error bar itself. */

/*<          CALL GRMOVA(XX,YY) >*/
	grmova_(&xx, &yy);
/*<          IF (DIR.EQ.1 .OR. DIR.EQ.5) THEN >*/
	if (*dir == 1 || *dir == 5) {
/*<             XX = X(I)+E(I) >*/
	    xx = x[i__] + e[i__];
/*<             YY = Y(I) >*/
	    yy = y[i__];
/*<          ELSE IF (DIR.EQ.2 .OR. DIR.EQ.6) THEN >*/
	} else if (*dir == 2 || *dir == 6) {
/*<             XX = X(I) >*/
	    xx = x[i__];
/*<             YY = Y(I)+E(I) >*/
	    yy = y[i__] + e[i__];
/*<          ELSE IF (DIR.EQ.3) THEN >*/
	} else if (*dir == 3) {
/*<             XX = X(I)-E(I) >*/
	    xx = x[i__] - e[i__];
/*<             YY = Y(I) >*/
	    yy = y[i__];
/*<          ELSE IF (DIR.EQ.4) THEN >*/
	} else if (*dir == 4) {
/*<             XX = X(I) >*/
	    xx = x[i__];
/*<             YY = Y(I)-E(I) >*/
	    yy = y[i__] - e[i__];
/*<          END IF >*/
	}
/*<          CALL GRLINA(XX,YY) >*/
	grlina_(&xx, &yy);

/* Draw terminal at end point. */

/*<          IF (T.NE.0.0) THEN >*/
	if (*t != (float)0.) {
/*<             IF (MOD(DIR,2).EQ.1) THEN >*/
	    if (*dir % 2 == 1) {
/*<                CALL GRMOVA(XX,YY-YTIK) >*/
		r__1 = yy - ytik;
		grmova_(&xx, &r__1);
/*<                CALL GRLINA(XX,YY+YTIK) >*/
		r__1 = yy + ytik;
		grlina_(&xx, &r__1);
/*<             ELSE >*/
	    } else {
/*<                CALL GRMOVA(XX-XTIK,YY) >*/
		r__1 = xx - xtik;
		grmova_(&r__1, &yy);
/*<                CALL GRLINA(XX+XTIK,YY) >*/
		r__1 = xx + xtik;
		grlina_(&r__1, &yy);
/*<             END IF >*/
	    }
/*<          END IF >*/
	}

/*<  10   CONTINUE >*/
/* L10: */
    }
/*<       CALL PGEBUF >*/
    pgebuf_();
/*<       END >*/
} /* pgerrb_ */

