/* /work2/ssa/pgplot/src/pgerrx.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* *PGERRX -- horizontal error bar */
/* %void cpgerrx(int n, const float *x1, const float *x2, \ */
/* % const float *y, float t); */
/* + */
/*<       SUBROUTINE PGERRX (N, X1, X2, Y, T) >*/
/* Subroutine */ int pgerrx_(n, x1, x2, y, t)
integer *n;
real *x1, *x2, *y, *t;
{
    /* System generated locals */
    integer i__1;
    real r__1;

    /* Local variables */
    static real xtik, ytik;
    static integer i__;
    extern /* Subroutine */ int pgbbuf_(), pgebuf_(), grlina_(), pgtikl_(), 
	    grmova_();
    extern logical pgnoto_();

/*<       INTEGER N >*/
/*<       REAL X1(*), X2(*), Y(*) >*/
/*<       REAL T >*/

/* Plot horizontal error bars. */
/* This routine draws an error bar only; to mark the data point in */
/* the middle of the error bar, an additional call to PGPT or */
/* PGERRY is required. */

/* Arguments: */
/*  N      (input)  : number of error bars to plot. */
/*  X1     (input)  : world x-coordinates of lower end of the */
/*                    error bars. */
/*  X2     (input)  : world x-coordinates of upper end of the */
/*                    error bars. */
/*  Y      (input)  : world y-coordinates of the data. */
/*  T      (input)  : length of terminals to be drawn at the ends */
/*                    of the error bar, as a multiple of the default */
/*                    length; if T = 0.0, no terminals will be drawn. */

/* Note: the dimension of arrays X1, X2, and Y must be greater */
/* than or equal to N. If N is 1, X1, X2, and Y may be scalar */
/* variables, or expressions, eg: */
/*       CALL PGERRX(1,X-SIGMA,X+SIGMA,Y) */
/* -- */
/* (6-Oct-1983) */
/* 31-Mar-1997 - use pgtikl [TJP[. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER  I >*/
/*<       LOGICAL  PGNOTO >*/
/*<       REAL     XTIK, YTIK >*/

/*<       IF (PGNOTO('PGERRX')) RETURN >*/
    /* Parameter adjustments */
    --y;
    --x2;
    --x1;

    /* Function Body */
    if (pgnoto_("PGERRX", (ftnlen)6)) {
	return 0;
    }
/*<       IF (N.LT.1) RETURN >*/
    if (*n < 1) {
	return 0;
    }
/*<       CALL PGBBUF >*/
    pgbbuf_();

/*<       CALL PGTIKL(T, XTIK, YTIK) >*/
    pgtikl_(t, &xtik, &ytik);
/*<       DO 10 I=1,N >*/
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
/*<           IF (T.NE.0.0) THEN >*/
	if (*t != (float)0.) {
/*<               CALL GRMOVA(X1(I),Y(I)-YTIK) >*/
	    r__1 = y[i__] - ytik;
	    grmova_(&x1[i__], &r__1);
/*<               CALL GRLINA(X1(I),Y(I)+YTIK) >*/
	    r__1 = y[i__] + ytik;
	    grlina_(&x1[i__], &r__1);
/*<           END IF >*/
	}
/*<           CALL GRMOVA(X1(I),Y(I)) >*/
	grmova_(&x1[i__], &y[i__]);
/*<           CALL GRLINA(X2(I),Y(I)) >*/
	grlina_(&x2[i__], &y[i__]);
/*<           IF (T.NE.0.0) THEN >*/
	if (*t != (float)0.) {
/*<               CALL GRMOVA(X2(I),Y(I)-YTIK) >*/
	    r__1 = y[i__] - ytik;
	    grmova_(&x2[i__], &r__1);
/*<               CALL GRLINA(X2(I),Y(I)+YTIK) >*/
	    r__1 = y[i__] + ytik;
	    grlina_(&x2[i__], &r__1);
/*<           END IF >*/
	}
/*<    10 CONTINUE >*/
/* L10: */
    }
/*<       CALL PGEBUF >*/
    pgebuf_();
/*<       END >*/
} /* pgerrx_ */

