/* /work2/ssa/pgplot/src/pgfunt.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__0 = 0;

/* *PGFUNT -- function defined by X = F(T), Y = G(T) */
/* + */
/*<       SUBROUTINE PGFUNT (FX, FY, N, TMIN, TMAX, PGFLAG) >*/
/* Subroutine */ int pgfunt_(fx, fy, n, tmin, tmax, pgflag)
doublereal (*fx) (), (*fy) ();
integer *n;
real *tmin, *tmax;
integer *pgflag;
{
    /* System generated locals */
    integer i__1;
    real r__1, r__2;

    /* Local variables */
    static real xmin, ymin, xmax, ymax;
    static integer i__;
    static real x[1001], y[1001];
    extern /* Subroutine */ int pgenv_();
    static real dt;
    extern /* Subroutine */ int pgbbuf_(), pgebuf_(), pgdraw_(), pgmove_(), 
	    grwarn_();

/*<       REAL FX, FY >*/
/*<       EXTERNAL FX, FY >*/
/*<       INTEGER N >*/
/*<       REAL TMIN, TMAX >*/
/*<       INTEGER PGFLAG >*/

/* Draw a curve defined by parametric equations X = FX(T), Y = FY(T). */

/* Arguments: */
/*  FX     (external real function): supplied by the user, evaluates */
/*                    X-coordinate. */
/*  FY     (external real function): supplied by the user, evaluates */
/*                    Y-coordinate. */
/*  N      (input)  : the number of points required to define the */
/*                    curve. The functions FX and FY will each be */
/*                    called N+1 times. */
/*  TMIN   (input)  : the minimum value for the parameter T. */
/*  TMAX   (input)  : the maximum value for the parameter T. */
/*  PGFLAG (input)  : if PGFLAG = 1, the curve is plotted in the */
/*                    current window and viewport; if PGFLAG = 0, */
/*                    PGENV is called automatically by PGFUNT to */
/*                    start a new plot with automatic scaling. */

/* Note: The functions FX and FY must be declared EXTERNAL in the */
/* Fortran program unit that calls PGFUNT. */
/* -- */
/*  5-Oct-1983 */
/* 11-May-1990 - remove unnecessary include [TJP]. */
/* 13-Dec-1990 - make errors non-fatal [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER MAXP >*/
/*<       PARAMETER (MAXP=1000) >*/
/*<       INTEGER  I >*/
/*<       REAL     X(0:MAXP), Y(0:MAXP), DT >*/
/*<       REAL     XMIN, XMAX, YMIN, YMAX >*/

/*<       IF (N.LT.1 .OR. N.GT.MAXP) THEN >*/
    if (*n < 1 || *n > 1000) {
/*<           CALL GRWARN('PGFUNT: invalid arguments') >*/
	grwarn_("PGFUNT: invalid arguments", (ftnlen)25);
/*<           RETURN >*/
	return 0;
/*<       END IF >*/
    }
/*<       CALL PGBBUF >*/
    pgbbuf_();

/* Evaluate function. */

/*<       DT = (TMAX-TMIN)/N >*/
    dt = (*tmax - *tmin) / *n;
/*<       X(0) = FX(TMIN) >*/
    x[0] = (*fx)(tmin);
/*<       Y(0) = FY(TMIN) >*/
    y[0] = (*fy)(tmin);
/*<       XMIN = X(0) >*/
    xmin = x[0];
/*<       XMAX = X(0) >*/
    xmax = x[0];
/*<       YMIN = Y(0) >*/
    ymin = y[0];
/*<       YMAX = Y(0) >*/
    ymax = y[0];
/*<       DO 10 I=1,N >*/
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
/*<           X(I) = FX(TMIN+DT*I) >*/
	r__1 = *tmin + dt * i__;
	x[i__] = (*fx)(&r__1);
/*<           Y(I) = FY(TMIN+DT*I) >*/
	r__1 = *tmin + dt * i__;
	y[i__] = (*fy)(&r__1);
/*<           XMIN = MIN(XMIN,X(I)) >*/
/* Computing MIN */
	r__1 = xmin, r__2 = x[i__];
	xmin = dmin(r__1,r__2);
/*<           XMAX = MAX(XMAX,X(I)) >*/
/* Computing MAX */
	r__1 = xmax, r__2 = x[i__];
	xmax = dmax(r__1,r__2);
/*<           YMIN = MIN(YMIN,Y(I)) >*/
/* Computing MIN */
	r__1 = ymin, r__2 = y[i__];
	ymin = dmin(r__1,r__2);
/*<           YMAX = MAX(YMAX,Y(I)) >*/
/* Computing MAX */
	r__1 = ymax, r__2 = y[i__];
	ymax = dmax(r__1,r__2);
/*<    10 CONTINUE >*/
/* L10: */
    }
/*<       DT = 0.05*(XMAX-XMIN) >*/
    dt = (xmax - xmin) * (float).05;
/*<       IF (DT.EQ.0.0) THEN >*/
    if (dt == (float)0.) {
/*<           XMIN = XMIN - 1.0 >*/
	xmin += (float)-1.;
/*<           XMAX = XMAX + 1.0 >*/
	xmax += (float)1.;
/*<       ELSE >*/
    } else {
/*<           XMIN = XMIN - DT >*/
	xmin -= dt;
/*<           XMAX = XMAX + DT >*/
	xmax += dt;
/*<       END IF >*/
    }
/*<       DT = 0.05*(YMAX-YMIN) >*/
    dt = (ymax - ymin) * (float).05;
/*<       IF (DT.EQ.0.0) THEN >*/
    if (dt == (float)0.) {
/*<           YMIN = YMIN - 1.0 >*/
	ymin += (float)-1.;
/*<           YMAX = YMAX + 1.0 >*/
	ymax += (float)1.;
/*<       ELSE >*/
    } else {
/*<           YMIN = YMIN - DT >*/
	ymin -= dt;
/*<           YMAX = YMAX + DT >*/
	ymax += dt;
/*<       END IF >*/
    }

/* Define environment if necessary. */

/*<       IF (PGFLAG.EQ.0) CALL PGENV(XMIN,XMAX,YMIN,YMAX,0,0) >*/
    if (*pgflag == 0) {
	pgenv_(&xmin, &xmax, &ymin, &ymax, &c__0, &c__0);
    }

/* Draw curve. */

/*<       CALL PGMOVE(X(0),Y(0)) >*/
    pgmove_(x, y);
/*<       DO 20 I=1,N >*/
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
/*<           CALL PGDRAW(X(I),Y(I)) >*/
	pgdraw_(&x[i__], &y[i__]);
/*<    20 CONTINUE >*/
/* L20: */
    }

/*<       CALL PGEBUF >*/
    pgebuf_();
/*<       END >*/
} /* pgfunt_ */

