/* /work2/ssa/pgplot/src/pgfunx.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__0 = 0;

/* *PGFUNX -- function defined by Y = F(X) */
/* + */
/*<       SUBROUTINE PGFUNX (FY, N, XMIN, XMAX, PGFLAG) >*/
/* Subroutine */ int pgfunx_(fy, n, xmin, xmax, pgflag)
doublereal (*fy) ();
integer *n;
real *xmin, *xmax;
integer *pgflag;
{
    /* System generated locals */
    integer i__1;
    real r__1, r__2, r__3;

    /* Local variables */
    static real ymin, ymax;
    static integer i__;
    static real y[1001];
    extern /* Subroutine */ int pgenv_();
    static real dt;
    static integer nn;
    static real dy;
    extern /* Subroutine */ int pgbbuf_(), pgebuf_(), pgdraw_(), pgmove_();

/*<       REAL FY >*/
/*<       EXTERNAL FY >*/
/*<       INTEGER N >*/
/*<       REAL XMIN, XMAX >*/
/*<       INTEGER PGFLAG >*/

/* Draw a curve defined by the equation Y = FY(X), where FY is a */
/* user-supplied subroutine. */

/* Arguments: */
/*  FY     (external real function): supplied by the user, evaluates */
/*                    Y value at a given X-coordinate. */
/*  N      (input)  : the number of points required to define the */
/*                    curve. The function FY will be called N+1 times. */
/*                    If PGFLAG=0 and N is greater than 1000, 1000 */
/*                    will be used instead.  If N is less than 1, */
/*                    nothing will be drawn. */
/*  XMIN   (input)  : the minimum value of X. */
/*  XMAX   (input)  : the maximum value of X. */
/*  PGFLAG (input)  : if PGFLAG = 1, the curve is plotted in the */
/*                    current window and viewport; if PGFLAG = 0, */
/*                    PGENV is called automatically by PGFUNX to */
/*                    start a new plot with X limits (XMIN, XMAX) */
/*                    and automatic scaling in Y. */

/* Note: The function FY must be declared EXTERNAL in the Fortran */
/* program unit that calls PGFUNX.  It has one argument, the */
/* x-coordinate at which the y value is required, e.g. */
/*   REAL FUNCTION FY(X) */
/*   REAL X */
/*   FY = ..... */
/*   END */
/* -- */
/*  6-Oct-1983 - TJP. */
/*  6-May-1985 - fix Y(0) bug - TJP. */
/* 11-May-1990 - remove unnecessary include - TJP. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER MAXP >*/
/*<       PARAMETER (MAXP=1000) >*/
/*<       INTEGER  I, NN >*/
/*<       REAL     Y(0:MAXP), DT, DY >*/
/*<       REAL     YMIN, YMAX >*/

/* Check N > 1, and find parameter increment. */

/*<       IF (N.LT.1) RETURN >*/
    if (*n < 1) {
	return 0;
    }
/*<       DT = (XMAX-XMIN)/N >*/
    dt = (*xmax - *xmin) / *n;
/*<       CALL PGBBUF >*/
    pgbbuf_();

/* Case 1: we do not have to find limits. */

/*<       IF (PGFLAG.NE.0) THEN >*/
    if (*pgflag != 0) {
/*<           CALL PGMOVE(XMIN,FY(XMIN)) >*/
	r__1 = (*fy)(xmin);
	pgmove_(xmin, &r__1);
/*<           DO 10 I=1,N >*/
	i__1 = *n;
	for (i__ = 1; i__ <= i__1; ++i__) {
/*<               CALL PGDRAW(XMIN+I*DT,FY(XMIN+I*DT)) >*/
	    r__1 = *xmin + i__ * dt;
	    r__3 = *xmin + i__ * dt;
	    r__2 = (*fy)(&r__3);
	    pgdraw_(&r__1, &r__2);
/*<    10     CONTINUE >*/
/* L10: */
	}

/* Case 2: find limits and scale plot; function values must be stored */
/* in an array. */

/*<       ELSE >*/
    } else {
/*<           NN = MIN(N,MAXP) >*/
	nn = min(*n,1000);
/*<           Y(0) = FY(XMIN) >*/
	y[0] = (*fy)(xmin);
/*<           YMIN = Y(0) >*/
	ymin = y[0];
/*<           YMAX = Y(0) >*/
	ymax = y[0];
/*<           DO 20 I=1,NN >*/
	i__1 = nn;
	for (i__ = 1; i__ <= i__1; ++i__) {
/*<               Y(I) = FY(XMIN+DT*I) >*/
	    r__1 = *xmin + dt * i__;
	    y[i__] = (*fy)(&r__1);
/*<               YMIN = MIN(YMIN,Y(I)) >*/
/* Computing MIN */
	    r__1 = ymin, r__2 = y[i__];
	    ymin = dmin(r__1,r__2);
/*<               YMAX = MAX(YMAX,Y(I)) >*/
/* Computing MAX */
	    r__1 = ymax, r__2 = y[i__];
	    ymax = dmax(r__1,r__2);
/*<    20     CONTINUE >*/
/* L20: */
	}
/*<           DY = 0.05*(YMAX-YMIN) >*/
	dy = (ymax - ymin) * (float).05;
/*<           IF (DY.EQ.0.0) THEN >*/
	if (dy == (float)0.) {
/*<               YMIN = YMIN - 1.0 >*/
	    ymin += (float)-1.;
/*<               YMAX = YMAX + 1.0 >*/
	    ymax += (float)1.;
/*<           ELSE >*/
	} else {
/*<               YMIN = YMIN - DY >*/
	    ymin -= dy;
/*<               YMAX = YMAX + DY >*/
	    ymax += dy;
/*<           END IF >*/
	}
/*<           CALL PGENV(XMIN,XMAX,YMIN,YMAX,0,0) >*/
	pgenv_(xmin, xmax, &ymin, &ymax, &c__0, &c__0);
/*<           CALL PGMOVE(XMIN,Y(0)) >*/
	pgmove_(xmin, y);
/*<           DO 30 I=1,NN >*/
	i__1 = nn;
	for (i__ = 1; i__ <= i__1; ++i__) {
/*<               CALL PGDRAW(XMIN+DT*I,Y(I)) >*/
	    r__1 = *xmin + dt * i__;
	    pgdraw_(&r__1, &y[i__]);
/*<    30     CONTINUE >*/
/* L30: */
	}
/*<       END IF >*/
    }

/*<       CALL PGEBUF >*/
    pgebuf_();
/*<       END >*/
} /* pgfunx_ */

