/* /work2/ssa/pgplot/src/pgfuny.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__0 = 0;

/* *PGFUNY -- function defined by X = F(Y) */
/* + */
/*<       SUBROUTINE PGFUNY (FX, N, YMIN, YMAX, PGFLAG) >*/
/* Subroutine */ int pgfuny_(fx, n, ymin, ymax, pgflag)
doublereal (*fx) ();
integer *n;
real *ymin, *ymax;
integer *pgflag;
{
    /* System generated locals */
    integer i__1;
    real r__1, r__2;

    /* Local variables */
    static real xmin, xmax;
    static integer i__;
    static real x[1001], y[1001];
    extern /* Subroutine */ int pgenv_();
    static real dt;
    extern /* Subroutine */ int pgbbuf_(), pgebuf_(), pgdraw_(), pgmove_(), 
	    grwarn_();

/*<       REAL    FX >*/
/*<       EXTERNAL FX >*/
/*<       INTEGER N >*/
/*<       REAL    YMIN, YMAX >*/
/*<       INTEGER PGFLAG >*/

/* Draw a curve defined by the equation X = FX(Y), where FY is a */
/* user-supplied subroutine. */

/* Arguments: */
/*  FX     (external real function): supplied by the user, evaluates */
/*                    X value at a given Y-coordinate. */
/*  N      (input)  : the number of points required to define the */
/*                    curve. The function FX will be called N+1 times. */
/*                    If PGFLAG=0 and N is greater than 1000, 1000 */
/*                    will be used instead.  If N is less than 1, */
/*                    nothing will be drawn. */
/*  YMIN   (input)  : the minimum value of Y. */
/*  YMAX   (input)  : the maximum value of Y. */
/*  PGFLAG (input)  : if PGFLAG = 1, the curve is plotted in the */
/*                    current window and viewport; if PGFLAG = 0, */
/*                    PGENV is called automatically by PGFUNY to */
/*                    start a new plot with Y limits (YMIN, YMAX) */
/*                    and automatic scaling in X. */

/* Note: The function FX must be declared EXTERNAL in the Fortran */
/* program unit that calls PGFUNY.  It has one argument, the */
/* y-coordinate at which the x value is required, e.g. */
/*   REAL FUNCTION FX(Y) */
/*   REAL Y */
/*   FX = ..... */
/*   END */
/* -- */
/*  5-Oct-1983 */
/* 11-May-1990 - remove unnecessary include [TJP]. */
/* 13-DEc-1990 - make errors non-fatal [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER MAXP >*/
/*<       PARAMETER (MAXP=1000) >*/
/*<       INTEGER  I >*/
/*<       REAL     X(0:MAXP), Y(0:MAXP), DT >*/
/*<       REAL     XMIN, XMAX >*/

/*<       IF (N.LT.1 .OR. N.GT.MAXP) THEN >*/
    if (*n < 1 || *n > 1000) {
/*<           CALL GRWARN('PGFUNY: invalid arguments') >*/
	grwarn_("PGFUNY: invalid arguments", (ftnlen)25);
/*<           RETURN >*/
	return 0;
/*<       END IF >*/
    }
/*<       CALL PGBBUF >*/
    pgbbuf_();

/* Evaluate function. */

/*<       DT = (YMAX-YMIN)/N >*/
    dt = (*ymax - *ymin) / *n;
/*<       X(0) = FX(YMIN) >*/
    x[0] = (*fx)(ymin);
/*<       Y(0) = YMIN >*/
    y[0] = *ymin;
/*<       XMIN = X(0) >*/
    xmin = x[0];
/*<       XMAX = X(0) >*/
    xmax = x[0];
/*<       DO 10 I=1,N >*/
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
/*<           X(I) = FX(YMIN+DT*I) >*/
	r__1 = *ymin + dt * i__;
	x[i__] = (*fx)(&r__1);
/*<           Y(I) = YMIN + DT*I >*/
	y[i__] = *ymin + dt * i__;
/*<           XMIN = MIN(XMIN,X(I)) >*/
/* Computing MIN */
	r__1 = xmin, r__2 = x[i__];
	xmin = dmin(r__1,r__2);
/*<           XMAX = MAX(XMAX,X(I)) >*/
/* Computing MAX */
	r__1 = xmax, r__2 = x[i__];
	xmax = dmax(r__1,r__2);
/*<    10 CONTINUE >*/
/* L10: */
    }
/*<       DT = 0.05*(XMAX-XMIN) >*/
    dt = (xmax - xmin) * (float).05;
/*<       IF (DT.EQ.0.0) THEN >*/
    if (dt == (float)0.) {
/*<           XMIN = XMIN - 1.0 >*/
	xmin += (float)-1.;
/*<           XMAX = XMAX + 1.0 >*/
	xmax += (float)1.;
/*<       ELSE >*/
    } else {
/*<           XMIN = XMIN - DT >*/
	xmin -= dt;
/*<           XMAX = XMAX + DT >*/
	xmax += dt;
/*<       END IF >*/
    }

/* Define environment if necessary. */

/*<       IF (PGFLAG.EQ.0) CALL PGENV(XMIN,XMAX,YMIN,YMAX,0,0) >*/
    if (*pgflag == 0) {
	pgenv_(&xmin, &xmax, ymin, ymax, &c__0, &c__0);
    }

/* Draw curve. */

/*<       CALL PGMOVE(X(0),Y(0)) >*/
    pgmove_(x, y);
/*<       DO 20 I=1,N >*/
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
/*<           CALL PGDRAW(X(I),Y(I)) >*/
	pgdraw_(&x[i__], &y[i__]);
/*<    20 CONTINUE >*/
/* L20: */
    }

/*<       CALL PGEBUF >*/
    pgebuf_();
/*<       END >*/
} /* pgfuny_ */

