/* /work2/ssa/pgplot/src/pggray.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer pgid, pgdevs[8], pgadvs[8], pgnx[8], pgny[8], pgnxc[8], pgnyc[8];
    real pgxpin[8], pgypin[8], pgxsp[8], pgysp[8], pgxsz[8], pgysz[8], pgxoff[
	    8], pgyoff[8], pgxvp[8], pgyvp[8], pgxlen[8], pgylen[8], pgxorg[8]
	    , pgyorg[8], pgxscl[8], pgyscl[8], pgxblc[8], pgxtrc[8], pgyblc[8]
	    , pgytrc[8], trans[6];
    logical pgprmp[8];
    integer pgclp[8], pgfas[8];
    real pgchsz[8];
    integer pgblev[8];
    logical pgrows[8];
    integer pgahs[8];
    real pgaha[8], pgahv[8];
    integer pgtbci[8], pgmnci[8], pgmxci[8], pgcint, pgcmin;
    logical pgpfix[8];
    integer pgitf[8];
    real pghsa[8], pghss[8], pghsp[8];
} pgplt1_;

#define pgplt1_1 pgplt1_

struct {
    char pgclab[32];
} pgplt2_;

#define pgplt2_1 pgplt2_

/* Table of constant values */

static integer c__1 = 1;

/* *PGGRAY -- gray-scale map of a 2D data array */
/* %void cpggray(const float *a, int idim, int jdim, int i1, int i2, \ */
/* % int j1, int j2, float fg, float bg, const float *tr); */
/* + */
/*<    >*/
/* Subroutine */ int pggray_(a, idim, jdim, i1, i2, j1, j2, fg, bg, tr)
real *a;
integer *idim, *jdim, *i1, *i2, *j1, *j2;
real *fg, *bg, *tr;
{
    /* System generated locals */
    integer a_dim1, a_offset;

    /* Local variables */
    extern /* Subroutine */ int pgsci_();
    static real pa[6];
    extern /* Subroutine */ int pgbbuf_(), pgebuf_(), pgsave_(), grgray_(), 
	    grwarn_(), pgunsa_();
    extern logical pgnoto_();

/*<       INTEGER IDIM, JDIM, I1, I2, J1, J2 >*/
/*<       REAL    A(IDIM,JDIM), FG, BG, TR(6) >*/

/* Draw gray-scale map of an array in current window. The subsection */
/* of the array A defined by indices (I1:I2, J1:J2) is mapped onto */
/* the view surface world-coordinate system by the transformation */
/* matrix TR. The resulting quadrilateral region is clipped at the edge */
/* of the window and shaded with the shade at each point determined */
/* by the corresponding array value.  The shade is a number in the */
/* range 0 to 1 obtained by linear interpolation between the background */
/* level (BG) and the foreground level (FG), i.e., */

/*   shade = [A(i,j) - BG] / [FG - BG] */

/* The background level BG can be either less than or greater than the */
/* foreground level FG.  Points in the array that are outside the range */
/* BG to FG are assigned shade 0 or 1 as appropriate. */

/* PGGRAY uses two different algorithms, depending how many color */
/* indices are available in the color index range specified for images. */
/* (This range is set with routine PGSCIR, and the current or default */
/* range can be queried by calling routine PGQCIR). */

/* If 16 or more color indices are available, PGGRAY first assigns */
/* color representations to these color indices to give a linear ramp */
/* between the background color (color index 0) and the foreground color */
/* (color index 1), and then calls PGIMAG to draw the image using these */
/* color indices. In this mode, the shaded region is "opaque": every */
/* pixel is assigned a color. */

/* If less than 16 color indices are available, PGGRAY uses only */
/* color index 1, and uses  a "dithering" algorithm to fill in pixels, */
/* with the shade (computed as above) determining the faction of pixels */
/* that are filled. In this mode the shaded region is "transparent" and */
/* allows previously-drawn graphics to show through. */

/* The transformation matrix TR is used to calculate the world */
/* coordinates of the center of the "cell" that represents each */
/* array element. The world coordinates of the center of the cell */
/* corresponding to array element A(I,J) are given by: */

/*          X = TR(1) + TR(2)*I + TR(3)*J */
/*          Y = TR(4) + TR(5)*I + TR(6)*J */

/* Usually TR(3) and TR(5) are zero -- unless the coordinate */
/* transformation involves a rotation or shear.  The corners of the */
/* quadrilateral region that is shaded by PGGRAY are given by */
/* applying this transformation to (I1-0.5,J1-0.5), (I2+0.5, J2+0.5). */

/* Arguments: */
/*  A      (input)  : the array to be plotted. */
/*  IDIM   (input)  : the first dimension of array A. */
/*  JDIM   (input)  : the second dimension of array A. */
/*  I1, I2 (input)  : the inclusive range of the first index */
/*                    (I) to be plotted. */
/*  J1, J2 (input)  : the inclusive range of the second */
/*                    index (J) to be plotted. */
/*  FG     (input)  : the array value which is to appear with the */
/*                    foreground color (corresponding to color index 1). */
/*  BG     (input)  : the array value which is to appear with the */
/*                    background color (corresponding to color index 0). */
/*  TR     (input)  : transformation matrix between array grid and */
/*                    world coordinates. */
/* -- */
/*  2-Sep-1987: remove device-dependent code to routine GRGRAY (TJP). */
/*  7-Jun-1988: change documentation and argument names (TJP). */
/* 31-May-1989: allow 1-pixel wide arrays to be plotted (TJP). */
/* 17-Mar-1994: pass PG scaling info to lower routines (TJP). */
/* 15-Sep-1994: use PGITF attribute (TJP). */
/*  8-Feb-1995: use color ramp based on current foreground and background */
/*              colors (TJP). */
/*  6-May-1996: allow multiple devives (TJP). */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE  'pgplot.inc' >*/
/*<       REAL PA(6) >*/
/* ----------------------------------------------------------------------- */
/* PGPLOT: common block definition. */
/* ----------------------------------------------------------------------- */
/* Maximum number of concurrent devices (should match GRIMAX). */
/* ----------------------------------------------------------------------- */
/*<       PARAMETER (PGMAXD=8) >*/
/* ----------------------------------------------------------------------- */
/* Indentifier of currently selected device. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER PGID >*/
/* ----------------------------------------------------------------------- */
/* Device status (indexed by device identifier). */
/* ----------------------------------------------------------------------- */
/* PGDEVS  =0 if device is not open; 1 if device is open. */
/* PGADVS  Set to 0 by PGBEGIN, set to 1 by PGPAGE; used to suppress */
/*         the prompt for the first page. */
/* PROMPT  If .TRUE., ask user before clearing page; set by PGASK */
/*         and (indirectly) by PGBEGIN, used in PGENV. */
/* PGBLEV  Buffering level: incremented by PGBBUF, decremented by */
/*         PGEBUF. */
/* PGPFIX  TRUE if PGPAP has been called, FALSE otherwise. */

/*<       INTEGER PGDEVS(PGMAXD), PGADVS(PGMAXD), PGBLEV(PGMAXD) >*/
/*<       LOGICAL PGPRMP(PGMAXD), PGPFIX(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Panel parameters (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* NX      Number of panels in x direction */
/* NY      Number of panels in y direction */
/* NXC     Ordinal number of current X panel */
/* NYC     Ordinal number of current Y panel */
/* XSZ     X dimension of panel (device units) */
/* YSZ     Y dimension of panel (device units) */
/* PGROWS  TRUE if panels are used in row order, FALSE for column */
/*         order. */

/*<       INTEGER PGNX  (PGMAXD), PGNY  (PGMAXD) >*/
/*<       INTEGER PGNXC (PGMAXD), PGNYC (PGMAXD) >*/
/*<       REAL    PGXSZ (PGMAXD), PGYSZ (PGMAXD) >*/
/*<       LOGICAL PGROWS(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Attributes (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* PGCLP   clipping enabled/disabed */
/* PGFAS   fill-area style */
/* PGCHSZ  character height */
/* PGAHS   arrow-head fill style */
/* PGAHA   arrow-head angle */
/* PGAHV   arrow-head vent */
/* PGTBCI  text background color index */
/* PGMNCI  lower range of color indices available to PGGRAY/PGIMAG */
/* PGMXCI  upper range of color indices available to PGGRAY/PGIMAG */
/* PGITF   type of transfer function used by PGGRAY/PGIMAG */
/* PGHSA   hatching line angle */
/* PGHSS   hatching line separation */
/* PGHSP   hatching line phase */

/*<       INTEGER PGCLP (PGMAXD) >*/
/*<       INTEGER PGFAS (PGMAXD) >*/
/*<       REAL    PGCHSZ(PGMAXD) >*/
/*<       INTEGER PGAHS (PGMAXD) >*/
/*<       REAL    PGAHA (PGMAXD) >*/
/*<       REAL    PGAHV (PGMAXD) >*/
/*<       INTEGER PGTBCI(PGMAXD) >*/
/*<       INTEGER PGMNCI(PGMAXD) >*/
/*<       INTEGER PGMXCI(PGMAXD) >*/
/*<       INTEGER PGITF (PGMAXD) >*/
/*<       REAL    PGHSA (PGMAXD) >*/
/*<       REAL    PGHSS (PGMAXD) >*/
/*<       REAL    PGHSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Viewport parameters (indexed by device identification); all are device */
/* coordinates: */
/* ----------------------------------------------------------------------- */
/* PGXOFF  X coordinate of blc of viewport. */
/* PGYOFF  Y coordinate of blc of viewport. */
/* PGXVP   X coordinate of blc of viewport, relative to blc of subpage. */
/* PGYVP   Y coordinate of blc of viewport, relative to blc of subpage. */
/* PGXLEN  Width of viewport. */
/* PGYLEN  Height of viewport. */

/*<       REAL   PGXOFF(PGMAXD), PGYOFF(PGMAXD) >*/
/*<       REAL   PGXVP (PGMAXD), PGYVP (PGMAXD) >*/
/*<       REAL   PGXLEN(PGMAXD), PGYLEN(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Scaling parameters (indexed by device identification): */
/* ----------------------------------------------------------------------- */
/* PGXORG  device coordinate value corresponding to world X=0 */
/* PGYORG  device coordinate value corresponding to world Y=0 */
/* PGXSCL  scale in x (device units per world coordinate unit) */
/* PGYSCL  scale in y (device units per world coordinate unit) */
/* PGXPIN  device x scale in device units/inch */
/* PGYPIN  device y scale in device units/inch */
/* PGXSP   Character X spacing (device units) */
/* PGYSP   Character Y spacing (device units) */

/*<       REAL   PGXORG(PGMAXD), PGYORG(PGMAXD) >*/
/*<       REAL   PGXSCL(PGMAXD), PGYSCL(PGMAXD) >*/
/*<       REAL   PGXPIN(PGMAXD), PGYPIN(PGMAXD) >*/
/*<       REAL   PGXSP (PGMAXD), PGYSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Window parameters (indexed by device identification); all are world */
/* coordinate values: */
/* ----------------------------------------------------------------------- */
/* PGXBLC  world X at bottom left corner of window */
/* PGXTRC  world X at top right corner of window */
/* PGYBLC  world Y at bottom left corner of window */
/* PGYTRC  world Y at top right corner of window */

/*<       REAL    PGXBLC(PGMAXD), PGXTRC(PGMAXD) >*/
/*<       REAL    PGYBLC(PGMAXD), PGYTRC(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* The following parameters are used in the contouring routines to pass */
/* information to the action routine. They do not need to be indexed. */
/* ----------------------------------------------------------------------- */
/* TRANS   Transformation matrix for contour plots; copied */
/*         from argument list by PGCONT and used by PGCP. */

/*<       INTEGER PGCINT, PGCMIN >*/
/*<       REAL    TRANS(6) >*/
/*<       CHARACTER*32 PGCLAB >*/
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*<    >*/
/*<       COMMON  /PGPLT2/ PGCLAB >*/
/*<       SAVE    /PGPLT1/ >*/
/*<       SAVE    /PGPLT2/ >*/
/* ----------------------------------------------------------------------- */
/*<       LOGICAL PGNOTO >*/

/* Check inputs. */

/*<       IF (PGNOTO('PGGRAY')) RETURN >*/
    /* Parameter adjustments */
    a_dim1 = *idim;
    a_offset = 1 + a_dim1 * 1;
    a -= a_offset;
    --tr;

    /* Function Body */
    if (pgnoto_("PGGRAY", (ftnlen)6)) {
	return 0;
    }
/*<    >*/
    if (*i1 < 1 || *i2 > *idim || *i1 > *i2 || *j1 < 1 || *j2 > *jdim || *j1 
	    > *j2) {
/*<           CALL GRWARN('PGGRAY: invalid range I1:I2, J1:J2') >*/
	grwarn_("PGGRAY: invalid range I1:I2, J1:J2", (ftnlen)34);
/*<       ELSE IF (FG.EQ.BG) THEN >*/
    } else if (*fg == *bg) {
/*<           CALL GRWARN('PGGRAY: foreground level = background level') >*/
	grwarn_("PGGRAY: foreground level = background level", (ftnlen)43);
/*<       ELSE >*/
    } else {

/* Call lower-level routine to do the work. */

/*<           CALL PGBBUF >*/
	pgbbuf_();
/*<           CALL PGSAVE >*/
	pgsave_();
/*<           CALL PGSCI(1) >*/
	pgsci_(&c__1);
/*<           PA(1) = TR(1)*PGXSCL(PGID) + PGXORG(PGID) >*/
	pa[0] = tr[1] * pgplt1_1.pgxscl[pgplt1_1.pgid - 1] + pgplt1_1.pgxorg[
		pgplt1_1.pgid - 1];
/*<           PA(2) = TR(2)*PGXSCL(PGID) >*/
	pa[1] = tr[2] * pgplt1_1.pgxscl[pgplt1_1.pgid - 1];
/*<           PA(3) = TR(3)*PGXSCL(PGID) >*/
	pa[2] = tr[3] * pgplt1_1.pgxscl[pgplt1_1.pgid - 1];
/*<           PA(4) = TR(4)*PGYSCL(PGID) + PGYORG(PGID) >*/
	pa[3] = tr[4] * pgplt1_1.pgyscl[pgplt1_1.pgid - 1] + pgplt1_1.pgyorg[
		pgplt1_1.pgid - 1];
/*<           PA(5) = TR(5)*PGYSCL(PGID) >*/
	pa[4] = tr[5] * pgplt1_1.pgyscl[pgplt1_1.pgid - 1];
/*<           PA(6) = TR(6)*PGYSCL(PGID) >*/
	pa[5] = tr[6] * pgplt1_1.pgyscl[pgplt1_1.pgid - 1];
/*<    >*/
	grgray_(&a[a_offset], idim, jdim, i1, i2, j1, j2, fg, bg, pa, &
		pgplt1_1.pgmnci[pgplt1_1.pgid - 1], &pgplt1_1.pgmxci[
		pgplt1_1.pgid - 1], &pgplt1_1.pgitf[pgplt1_1.pgid - 1]);
/*<           CALL PGEBUF >*/
	pgebuf_();
/*<           CALL PGUNSA >*/
	pgunsa_();
/*<       END IF >*/
    }
/* ----------------------------------------------------------------------- */
/*<       END >*/
} /* pggray_ */

