/* /work2/ssa/pgplot/src/pghi2d.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer pgid, pgdevs[8], pgadvs[8], pgnx[8], pgny[8], pgnxc[8], pgnyc[8];
    real pgxpin[8], pgypin[8], pgxsp[8], pgysp[8], pgxsz[8], pgysz[8], pgxoff[
	    8], pgyoff[8], pgxvp[8], pgyvp[8], pgxlen[8], pgylen[8], pgxorg[8]
	    , pgyorg[8], pgxscl[8], pgyscl[8], pgxblc[8], pgxtrc[8], pgyblc[8]
	    , pgytrc[8], trans[6];
    logical pgprmp[8];
    integer pgclp[8], pgfas[8];
    real pgchsz[8];
    integer pgblev[8];
    logical pgrows[8];
    integer pgahs[8];
    real pgaha[8], pgahv[8];
    integer pgtbci[8], pgmnci[8], pgmxci[8], pgcint, pgcmin;
    logical pgpfix[8];
    integer pgitf[8];
    real pghsa[8], pghss[8], pghsp[8];
} pgplt1_;

#define pgplt1_1 pgplt1_

struct {
    char pgclab[32];
} pgplt2_;

#define pgplt2_1 pgplt2_

/* *PGHI2D -- cross-sections through a 2D data array */
/* %void cpghi2d(const float *data, int nxv, int nyv, int ix1, \ */
/* % int ix2, int iy1, int iy2, const float *x, int ioff, float bias, \ */
/* % Logical center, float *ylims); */
/* + */
/*<    >*/
/* Subroutine */ int pghi2d_(data, nxv, nyv, ix1, ix2, iy1, iy2, x, ioff, 
	bias, center, ylims)
real *data;
integer *nxv, *nyv, *ix1, *ix2, *iy1, *iy2;
real *x;
integer *ioff;
real *bias;
logical *center;
real *ylims;
{
    /* System generated locals */
    integer data_dim1, data_offset, i__1, i__2, i__3, i__4;
    real r__1;

    /* Local variables */
    static integer noff;
    static real ylim;
    static integer ixpt;
    static real cbias;
    static integer nelmx;
    static logical hplot, first;
    static real vfrom, xnwas, ynwas;
    static logical vplot;
    extern doublereal pghis1_();
    static integer ix, iy;
    extern /* Subroutine */ int pgbbuf_();
    static real xn, yn;
    extern /* Subroutine */ int pgebuf_(), grlina_(), grmova_();
    static logical pendow;
    extern logical pgnoto_();
    static real ylimws;
    static integer inc;
    static real vto;

/*<       INTEGER NXV, NYV, IX1, IX2, IY1, IY2 >*/
/*<       REAL    DATA(NXV,NYV) >*/
/*<       REAL    X(IX2-IX1+1), YLIMS(IX2-IX1+1) >*/
/*<       INTEGER IOFF >*/
/*<       REAL    BIAS >*/
/*<       LOGICAL CENTER >*/

/* Plot a series of cross-sections through a 2D data array. */
/* Each cross-section is plotted as a hidden line histogram.  The plot */
/* can be slanted to give a pseudo-3D effect - if this is done, the */
/* call to PGENV may have to be changed to allow for the increased X */
/* range that will be needed. */

/* Arguments: */
/*  DATA   (input)  : the data array to be plotted. */
/*  NXV    (input)  : the first dimension of DATA. */
/*  NYV    (input)  : the second dimension of DATA. */
/*  IX1    (input) */
/*  IX2    (input) */
/*  IY1    (input) */
/*  IY2    (input)  : PGHI2D plots a subset of the input array DATA. */
/*                    This subset is delimited in the first (x) */
/*                    dimension by IX1 and IX2 and the 2nd (y) by IY1 */
/*                    and IY2, inclusively. Note: IY2 < IY1 is */
/*                    permitted, resulting in a plot with the */
/*                    cross-sections plotted in reverse Y order. */
/*                    However, IX2 must be => IX1. */
/*  X      (input)  : the abscissae of the bins to be plotted. That is, */
/*                    X(1) should be the X value for DATA(IX1,IY1), and */
/*                    X should have (IX2-IX1+1) elements.  The program */
/*                    has to assume that the X value for DATA(x,y) is */
/*                    the same for all y. */
/*  IOFF   (input)  : an offset in array elements applied to successive */
/*                    cross-sections to produce a slanted effect.  A */
/*                    plot with IOFF > 0 slants to the right, one with */
/*                    IOFF < 0 slants left. */
/*  BIAS   (input)  : a bias value applied to each successive cross- */
/*                    section in order to raise it above the previous */
/*                    cross-section.  This is in the same units as the */
/*                    data. */
/*  CENTER (input)  : if .true., the X values denote the center of the */
/*                    bins; if .false. the X values denote the lower */
/*                    edges (in X) of the bins. */
/*  YLIMS  (input)  : workspace.  Should be an array of at least */
/*                    (IX2-IX1+1) elements. */
/* -- */
/* 21-Feb-1984 - Keith Shortridge. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'pgplot.inc' >*/
/*<       LOGICAL FIRST,PENDOW,HPLOT,VPLOT >*/
/* ----------------------------------------------------------------------- */
/* PGPLOT: common block definition. */
/* ----------------------------------------------------------------------- */
/* Maximum number of concurrent devices (should match GRIMAX). */
/* ----------------------------------------------------------------------- */
/*<       PARAMETER (PGMAXD=8) >*/
/* ----------------------------------------------------------------------- */
/* Indentifier of currently selected device. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER PGID >*/
/* ----------------------------------------------------------------------- */
/* Device status (indexed by device identifier). */
/* ----------------------------------------------------------------------- */
/* PGDEVS  =0 if device is not open; 1 if device is open. */
/* PGADVS  Set to 0 by PGBEGIN, set to 1 by PGPAGE; used to suppress */
/*         the prompt for the first page. */
/* PROMPT  If .TRUE., ask user before clearing page; set by PGASK */
/*         and (indirectly) by PGBEGIN, used in PGENV. */
/* PGBLEV  Buffering level: incremented by PGBBUF, decremented by */
/*         PGEBUF. */
/* PGPFIX  TRUE if PGPAP has been called, FALSE otherwise. */

/*<       INTEGER PGDEVS(PGMAXD), PGADVS(PGMAXD), PGBLEV(PGMAXD) >*/
/*<       LOGICAL PGPRMP(PGMAXD), PGPFIX(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Panel parameters (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* NX      Number of panels in x direction */
/* NY      Number of panels in y direction */
/* NXC     Ordinal number of current X panel */
/* NYC     Ordinal number of current Y panel */
/* XSZ     X dimension of panel (device units) */
/* YSZ     Y dimension of panel (device units) */
/* PGROWS  TRUE if panels are used in row order, FALSE for column */
/*         order. */

/*<       INTEGER PGNX  (PGMAXD), PGNY  (PGMAXD) >*/
/*<       INTEGER PGNXC (PGMAXD), PGNYC (PGMAXD) >*/
/*<       REAL    PGXSZ (PGMAXD), PGYSZ (PGMAXD) >*/
/*<       LOGICAL PGROWS(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Attributes (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* PGCLP   clipping enabled/disabed */
/* PGFAS   fill-area style */
/* PGCHSZ  character height */
/* PGAHS   arrow-head fill style */
/* PGAHA   arrow-head angle */
/* PGAHV   arrow-head vent */
/* PGTBCI  text background color index */
/* PGMNCI  lower range of color indices available to PGGRAY/PGIMAG */
/* PGMXCI  upper range of color indices available to PGGRAY/PGIMAG */
/* PGITF   type of transfer function used by PGGRAY/PGIMAG */
/* PGHSA   hatching line angle */
/* PGHSS   hatching line separation */
/* PGHSP   hatching line phase */

/*<       INTEGER PGCLP (PGMAXD) >*/
/*<       INTEGER PGFAS (PGMAXD) >*/
/*<       REAL    PGCHSZ(PGMAXD) >*/
/*<       INTEGER PGAHS (PGMAXD) >*/
/*<       REAL    PGAHA (PGMAXD) >*/
/*<       REAL    PGAHV (PGMAXD) >*/
/*<       INTEGER PGTBCI(PGMAXD) >*/
/*<       INTEGER PGMNCI(PGMAXD) >*/
/*<       INTEGER PGMXCI(PGMAXD) >*/
/*<       INTEGER PGITF (PGMAXD) >*/
/*<       REAL    PGHSA (PGMAXD) >*/
/*<       REAL    PGHSS (PGMAXD) >*/
/*<       REAL    PGHSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Viewport parameters (indexed by device identification); all are device */
/* coordinates: */
/* ----------------------------------------------------------------------- */
/* PGXOFF  X coordinate of blc of viewport. */
/* PGYOFF  Y coordinate of blc of viewport. */
/* PGXVP   X coordinate of blc of viewport, relative to blc of subpage. */
/* PGYVP   Y coordinate of blc of viewport, relative to blc of subpage. */
/* PGXLEN  Width of viewport. */
/* PGYLEN  Height of viewport. */

/*<       REAL   PGXOFF(PGMAXD), PGYOFF(PGMAXD) >*/
/*<       REAL   PGXVP (PGMAXD), PGYVP (PGMAXD) >*/
/*<       REAL   PGXLEN(PGMAXD), PGYLEN(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Scaling parameters (indexed by device identification): */
/* ----------------------------------------------------------------------- */
/* PGXORG  device coordinate value corresponding to world X=0 */
/* PGYORG  device coordinate value corresponding to world Y=0 */
/* PGXSCL  scale in x (device units per world coordinate unit) */
/* PGYSCL  scale in y (device units per world coordinate unit) */
/* PGXPIN  device x scale in device units/inch */
/* PGYPIN  device y scale in device units/inch */
/* PGXSP   Character X spacing (device units) */
/* PGYSP   Character Y spacing (device units) */

/*<       REAL   PGXORG(PGMAXD), PGYORG(PGMAXD) >*/
/*<       REAL   PGXSCL(PGMAXD), PGYSCL(PGMAXD) >*/
/*<       REAL   PGXPIN(PGMAXD), PGYPIN(PGMAXD) >*/
/*<       REAL   PGXSP (PGMAXD), PGYSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Window parameters (indexed by device identification); all are world */
/* coordinate values: */
/* ----------------------------------------------------------------------- */
/* PGXBLC  world X at bottom left corner of window */
/* PGXTRC  world X at top right corner of window */
/* PGYBLC  world Y at bottom left corner of window */
/* PGYTRC  world Y at top right corner of window */

/*<       REAL    PGXBLC(PGMAXD), PGXTRC(PGMAXD) >*/
/*<       REAL    PGYBLC(PGMAXD), PGYTRC(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* The following parameters are used in the contouring routines to pass */
/* information to the action routine. They do not need to be indexed. */
/* ----------------------------------------------------------------------- */
/* TRANS   Transformation matrix for contour plots; copied */
/*         from argument list by PGCONT and used by PGCP. */

/*<       INTEGER PGCINT, PGCMIN >*/
/*<       REAL    TRANS(6) >*/
/*<       CHARACTER*32 PGCLAB >*/
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*<    >*/
/*<       COMMON  /PGPLT2/ PGCLAB >*/
/*<       SAVE    /PGPLT1/ >*/
/*<       SAVE    /PGPLT2/ >*/
/* ----------------------------------------------------------------------- */
/*<       INTEGER IY,INC,IX,NELMX,IXPT,NOFF >*/
/*<       REAL CBIAS,YNWAS,XNWAS,YN,XN,VTO,VFROM,YLIMWS,YLIM >*/
/*<       REAL PGHIS1 >*/
/*<       LOGICAL PGNOTO >*/

/* Check arguments. */

/*<       IF (IX1.GT.IX2) RETURN >*/
    /* Parameter adjustments */
    data_dim1 = *nxv;
    data_offset = 1 + data_dim1 * 1;
    data -= data_offset;
    --ylims;
    --x;

    /* Function Body */
    if (*ix1 > *ix2) {
	return 0;
    }
/*<       IF (PGNOTO('PGHI2D')) RETURN >*/
    if (pgnoto_("PGHI2D", (ftnlen)6)) {
	return 0;
    }
/*<       CALL PGBBUF >*/
    pgbbuf_();

/* Check Y order. */

/*<       IF (IY1.GT.IY2) THEN >*/
    if (*iy1 > *iy2) {
/*<          INC = -1 >*/
	inc = -1;
/*<       ELSE >*/
    } else {
/*<          INC = 1 >*/
	inc = 1;
/*<       END IF >*/
    }

/* Clear limits array. */

/*<       NELMX = IX2 - IX1 + 1 >*/
    nelmx = *ix2 - *ix1 + 1;
/*<       DO 10 IX=1,NELMX >*/
    i__1 = nelmx;
    for (ix = 1; ix <= i__1; ++ix) {
/*<          YLIMS(IX) = PGYBLC(PGID) >*/
	ylims[ix] = pgplt1_1.pgyblc[pgplt1_1.pgid - 1];
/*<  10   CONTINUE >*/
/* L10: */
    }

/* Loop through Y values. */

/*<       NOFF = 0 >*/
    noff = 0;
/*<       CBIAS = 0. >*/
    cbias = (float)0.;
/*<       DO 200 IY=IY1,IY2,INC >*/
    i__1 = *iy2;
    i__2 = inc;
    for (iy = *iy1; i__2 < 0 ? iy >= i__1 : iy <= i__1; iy += i__2) {
/*<          YNWAS = CBIAS >*/
	ynwas = cbias;
/*<          YLIMWS = YNWAS >*/
	ylimws = ynwas;
/*<          XNWAS = PGHIS1(X,NELMX,CENTER,1+NOFF) >*/
	i__3 = noff + 1;
	xnwas = pghis1_(&x[1], &nelmx, center, &i__3);
/*<          PENDOW = .FALSE. >*/
	pendow = FALSE_;
/*<          FIRST = .TRUE. >*/
	first = TRUE_;
/*<          IXPT = 1 >*/
	ixpt = 1;

/* Draw histogram for this Y value. */

/*<          DO 100 IX=IX1,IX2 >*/
	i__3 = *ix2;
	for (ix = *ix1; ix <= i__3; ++ix) {
/*<             YN = DATA(IX,IY) + CBIAS >*/
	    yn = data[ix + iy * data_dim1] + cbias;
/*<             XN = PGHIS1(X,NELMX,CENTER,IXPT+NOFF+1) >*/
	    i__4 = ixpt + noff + 1;
	    xn = pghis1_(&x[1], &nelmx, center, &i__4);
/*<             YLIM = YLIMS(IXPT) >*/
	    ylim = ylims[ixpt];

/* Given X and Y old and new values, and limits, see which parts of the */
/* lines are to be drawn. */

/*<             IF (YN.GT.YLIM) THEN >*/
	    if (yn > ylim) {
/*<                YLIMS(IXPT) = YN >*/
		ylims[ixpt] = yn;
/*<                HPLOT = .TRUE. >*/
		hplot = TRUE_;
/*<                VPLOT = .TRUE. >*/
		vplot = TRUE_;
/*<                VTO = YN >*/
		vto = yn;
/*<                VFROM = YLIM >*/
		vfrom = ylim;
/*<                IF (YNWAS.GT.YLIMWS) VFROM = YNWAS >*/
		if (ynwas > ylimws) {
		    vfrom = ynwas;
		}
/*<             ELSE >*/
	    } else {
/*<                HPLOT = .FALSE. >*/
		hplot = FALSE_;
/*<                IF (YNWAS.GT.YLIMWS) THEN >*/
		if (ynwas > ylimws) {
/*<                   VPLOT = .TRUE. >*/
		    vplot = TRUE_;
/*<                   VFROM = YNWAS >*/
		    vfrom = ynwas;
/*<                   VTO = YLIM >*/
		    vto = ylim;
/*<                ELSE >*/
		} else {
/*<                   VPLOT = .FALSE. >*/
		    vplot = FALSE_;
/*<                END IF >*/
		}
/*<             END IF >*/
	    }

/* Plot the bin. */

/*<             IF (VPLOT) THEN >*/
	    if (vplot) {
/*<                IF (.NOT.PENDOW) THEN >*/
		if (! pendow) {
/*<                   IF (FIRST) THEN >*/
		    if (first) {
/*<                      CALL GRMOVA(XNWAS,MAX(VTO,CBIAS)) >*/
			r__1 = dmax(vto,cbias);
			grmova_(&xnwas, &r__1);
/*<                      FIRST = .FALSE. >*/
			first = FALSE_;
/*<                   ELSE >*/
		    } else {
/*<                      CALL GRMOVA(XNWAS,VFROM) >*/
			grmova_(&xnwas, &vfrom);
/*<                   END IF >*/
		    }
/*<                END IF >*/
		}
/*<                CALL GRLINA(XNWAS,VTO) >*/
		grlina_(&xnwas, &vto);
/*<                IF (HPLOT) THEN >*/
		if (hplot) {
/*<                   CALL GRLINA(XN,YN) >*/
		    grlina_(&xn, &yn);
/*<                END IF >*/
		}
/*<             END IF >*/
	    }
/*<             PENDOW = HPLOT >*/
	    pendow = hplot;
/*<             YLIMWS = YLIM >*/
	    ylimws = ylim;
/*<             YNWAS = YN >*/
	    ynwas = yn;
/*<             XNWAS = XN >*/
	    xnwas = xn;
/*<             IXPT = IXPT + 1 >*/
	    ++ixpt;
/*<  100     CONTINUE >*/
/* L100: */
	}
/*<          IF (PENDOW) CALL GRLINA(XN,MAX(YLIM,CBIAS)) >*/
	if (pendow) {
	    r__1 = dmax(ylim,cbias);
	    grlina_(&xn, &r__1);
	}

/* If any offset in operation, shift limits array to compensate for it. */

/*<          IF (IOFF.GT.0) THEN >*/
	if (*ioff > 0) {
/*<             DO 110 IX=1,NELMX-IOFF >*/
	    i__3 = nelmx - *ioff;
	    for (ix = 1; ix <= i__3; ++ix) {
/*<                YLIMS(IX) = YLIMS(IX+IOFF) >*/
		ylims[ix] = ylims[ix + *ioff];
/*<  110        CONTINUE >*/
/* L110: */
	    }
/*<             DO 120 IX=NELMX-IOFF+1,NELMX >*/
	    i__3 = nelmx;
	    for (ix = nelmx - *ioff + 1; ix <= i__3; ++ix) {
/*<                YLIMS(IX) = PGYBLC(PGID) >*/
		ylims[ix] = pgplt1_1.pgyblc[pgplt1_1.pgid - 1];
/*<  120        CONTINUE >*/
/* L120: */
	    }
/*<          ELSE IF (IOFF.LT.0) THEN >*/
	} else if (*ioff < 0) {
/*<             DO 130 IX=NELMX,1-IOFF,-1 >*/
	    i__3 = 1 - *ioff;
	    for (ix = nelmx; ix >= i__3; --ix) {
/*<                YLIMS(IX) = YLIMS(IX+IOFF) >*/
		ylims[ix] = ylims[ix + *ioff];
/*<  130        CONTINUE >*/
/* L130: */
	    }
/*<             DO 140 IX=1,-IOFF >*/
	    i__3 = -(*ioff);
	    for (ix = 1; ix <= i__3; ++ix) {
/*<                YLIMS(IX) = PGYBLC(PGID) >*/
		ylims[ix] = pgplt1_1.pgyblc[pgplt1_1.pgid - 1];
/*<  140        CONTINUE >*/
/* L140: */
	    }
/*<          END IF >*/
	}
/*<          CBIAS = CBIAS + BIAS >*/
	cbias += *bias;
/*<          NOFF = NOFF + IOFF >*/
	noff += *ioff;
/*<  200  CONTINUE >*/
/* L200: */
    }

/*<       CALL PGEBUF >*/
    pgebuf_();
/*<       END >*/
} /* pghi2d_ */

