/* /work2/ssa/pgplot/src/pghist.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__0 = 0;
static real c_b9 = (float)0.;

/* *PGHIST -- histogram of unbinned data */
/* %void cpghist(int n, const float *data, float datmin, float datmax, \ */
/* % int nbin, int pgflag); */
/* + */
/*<       SUBROUTINE PGHIST(N, DATA, DATMIN, DATMAX, NBIN, PGFLAG) >*/
/* Subroutine */ int pghist_(n, data, datmin, datmax, nbin, pgflag)
integer *n;
real *data, *datmin, *datmax;
integer *nbin, *pgflag;
{
    /* System generated locals */
    integer i__1, i__2, i__3;
    real r__1;

    /* Local variables */
    static integer ibin, junk;
    static real prev;
    static integer i__;
    extern doublereal pgrnd_();
    extern /* Subroutine */ int pgenv_(), pgbbuf_(), pgebuf_(), grlina_(), 
	    pgrect_(), grmova_();
    static real binsiz;
    extern /* Subroutine */ int grwarn_();
    static integer nummax;
    extern logical pgnoto_();
    static real xhi, cur, yhi;
    static integer num[200];
    static real xlo, ylo;

/*<       INTEGER N >*/
/*<       REAL    DATA(*) >*/
/*<       REAL    DATMIN, DATMAX >*/
/*<       INTEGER NBIN, PGFLAG >*/

/* Draw a histogram of N values of a variable in array */
/* DATA(1...N) in the range DATMIN to DATMAX using NBIN bins.  Note */
/* that array elements which fall exactly on the boundary between */
/* two bins will be counted in the higher bin rather than the */
/* lower one; and array elements whose value is less than DATMIN or */
/* greater than or equal to DATMAX will not be counted at all. */

/* Arguments: */
/*  N      (input)  : the number of data values. */
/*  DATA   (input)  : the data values. Note: the dimension of array */
/*                    DATA must be greater than or equal to N. The */
/*                    first N elements of the array are used. */
/*  DATMIN (input)  : the minimum data value for the histogram. */
/*  DATMAX (input)  : the maximum data value for the histogram. */
/*  NBIN   (input)  : the number of bins to use: the range DATMIN to */
/*                    DATMAX is divided into NBIN equal bins and */
/*                    the number of DATA values in each bin is */
/*                    determined by PGHIST.  NBIN may not exceed 200. */
/*  PGFLAG (input)  : if PGFLAG = 1, the histogram is plotted in the */
/*                    current window and viewport; if PGFLAG = 0, */
/*                    PGENV is called automatically by PGHIST to start */
/*                    a new plot (the x-limits of the window will be */
/*                    DATMIN and DATMAX; the y-limits will be chosen */
/*                    automatically. */
/*                    IF PGFLAG = 2,3 the histogram will be in the same */
/*                    window and viewport but with a filled area style. */
/*                    If pgflag=4,5 as for pgflag = 0,1, but simple */
/*                    line drawn as for PGBIN */

/* -- */
/* Side effects: */

/* The pen position is changed to (DATMAX,0.0) in world coordinates. */
/* -- */
/*  6-Sep-83: */
/* 11-Feb-92: fill options added. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER  MAXBIN >*/
/*<       PARAMETER (MAXBIN=200) >*/
/*<       INTEGER  I, IBIN, NUM(MAXBIN), NUMMAX, JUNK >*/
/*<       REAL     BINSIZ, PGRND >*/
/*<       REAL     CUR, PREV, XLO, XHI, YLO, YHI >*/
/*<       LOGICAL  PGNOTO >*/

/*<    >*/
    /* Parameter adjustments */
    --data;

    /* Function Body */
    if (*n < 1 || *datmax <= *datmin || *nbin < 1 || *nbin > 200) {
/*<           CALL GRWARN('PGHIST: invalid arguments') >*/
	grwarn_("PGHIST: invalid arguments", (ftnlen)25);
/*<           RETURN >*/
	return 0;
/*<       END IF >*/
    }
/*<       IF (PGNOTO('PGHIST')) RETURN >*/
    if (pgnoto_("PGHIST", (ftnlen)6)) {
	return 0;
    }
/*<       CALL PGBBUF >*/
    pgbbuf_();

/* How many values in each bin? */

/*<       DO 10 IBIN=1,NBIN >*/
    i__1 = *nbin;
    for (ibin = 1; ibin <= i__1; ++ibin) {
/*<           NUM(IBIN) = 0 >*/
	num[ibin - 1] = 0;
/*<    10 CONTINUE >*/
/* L10: */
    }
/*<       DO 20 I=1,N >*/
    i__1 = *n;
    for (i__ = 1; i__ <= i__1; ++i__) {
/*<           IBIN = (DATA(I)-DATMIN)/(DATMAX-DATMIN)*NBIN+1 >*/
	ibin = (data[i__] - *datmin) / (*datmax - *datmin) * *nbin + 1;
/*<           IF (IBIN.GE.1 .AND. IBIN.LE.NBIN) NUM(IBIN) = NUM(IBIN)+1 >*/
	if (ibin >= 1 && ibin <= *nbin) {
	    ++num[ibin - 1];
	}
/*<    20 CONTINUE >*/
/* L20: */
    }
/*<       NUMMAX = 0 >*/
    nummax = 0;
/*<       DO 30 IBIN=1,NBIN >*/
    i__1 = *nbin;
    for (ibin = 1; ibin <= i__1; ++ibin) {
/*<           NUMMAX = MAX(NUMMAX,NUM(IBIN)) >*/
/* Computing MAX */
	i__2 = nummax, i__3 = num[ibin - 1];
	nummax = max(i__2,i__3);
/*<    30 CONTINUE >*/
/* L30: */
    }
/*<       BINSIZ = (DATMAX-DATMIN)/NBIN >*/
    binsiz = (*datmax - *datmin) / *nbin;

/* Boundaries of plot. */

/*<       XLO = DATMIN >*/
    xlo = *datmin;
/*<       XHI = DATMAX >*/
    xhi = *datmax;
/*<       YLO = 0.0 >*/
    ylo = (float)0.;
/*<       YHI = PGRND(1.01*NUMMAX,JUNK) >*/
    r__1 = nummax * (float)1.01;
    yhi = pgrnd_(&r__1, &junk);

/* Define environment if necessary. */

/*<       IF (MOD(PGFLAG,2).EQ.0) THEN >*/
    if (*pgflag % 2 == 0) {
/*<          CALL PGENV(XLO,XHI,YLO,YHI,0,0) >*/
	pgenv_(&xlo, &xhi, &ylo, &yhi, &c__0, &c__0);
/*<       END IF >*/
    }

/* Draw Histogram. */

/*<       IF (PGFLAG/2.EQ.0) THEN >*/
    if (*pgflag / 2 == 0) {
/*<          PREV = 0.0 >*/
	prev = (float)0.;
/*<          XHI=DATMIN >*/
	xhi = *datmin;
/*<          CALL GRMOVA(DATMIN,0.0) >*/
	grmova_(datmin, &c_b9);
/*<          DO 40 IBIN=1,NBIN >*/
	i__1 = *nbin;
	for (ibin = 1; ibin <= i__1; ++ibin) {
/*<             CUR = NUM(IBIN) >*/
	    cur = (real) num[ibin - 1];
/*<             XLO=XHI >*/
	    xlo = xhi;
/*<             XHI = DATMIN + IBIN*BINSIZ >*/
	    xhi = *datmin + ibin * binsiz;
/*<             IF (CUR.EQ.0.0) THEN >*/
	    if (cur == (float)0.) {
/*<                CONTINUE >*/
/*<             ELSE IF (CUR.LE.PREV) THEN >*/
	    } else if (cur <= prev) {
/*<                CALL GRMOVA(XLO,CUR) >*/
		grmova_(&xlo, &cur);
/*<                CALL GRLINA(XHI,CUR) >*/
		grlina_(&xhi, &cur);
/*<             ELSE >*/
	    } else {
/*<                CALL GRMOVA(XLO,PREV) >*/
		grmova_(&xlo, &prev);
/*<                CALL GRLINA(XLO,CUR) >*/
		grlina_(&xlo, &cur);
/*<                CALL GRLINA(XHI,CUR) >*/
		grlina_(&xhi, &cur);
/*<             END IF >*/
	    }
/*<             CALL GRLINA(XHI,0.0) >*/
	    grlina_(&xhi, &c_b9);
/*<             PREV = CUR >*/
	    prev = cur;
/*<  40      CONTINUE >*/
/* L40: */
	}
/*<       ELSE IF (PGFLAG/2.EQ.1) THEN >*/
    } else if (*pgflag / 2 == 1) {
/*<          PREV = 0.0 >*/
	prev = (float)0.;
/*<          XHI = DATMIN >*/
	xhi = *datmin;
/*<          DO 50 IBIN=1,NBIN >*/
	i__1 = *nbin;
	for (ibin = 1; ibin <= i__1; ++ibin) {
/*<             CUR = NUM(IBIN) >*/
	    cur = (real) num[ibin - 1];
/*<             XLO=XHI >*/
	    xlo = xhi;
/*<             XHI = DATMIN + IBIN*BINSIZ >*/
	    xhi = *datmin + ibin * binsiz;
/*<             IF (CUR.EQ.0.0) THEN >*/
	    if (cur == (float)0.) {
/*<                CONTINUE >*/
/*<             ELSE >*/
	    } else {
/*<                CALL PGRECT(XLO,XHI,0.0,CUR) >*/
		pgrect_(&xlo, &xhi, &c_b9, &cur);
/*<             END IF >*/
	    }
/*<  50      CONTINUE >*/
/* L50: */
	}
/*<       ELSE IF (PGFLAG/2.EQ.2) THEN >*/
    } else if (*pgflag / 2 == 2) {
/*<          PREV = 0.0 >*/
	prev = (float)0.;
/*<          CALL GRMOVA(DATMIN,0.0) >*/
	grmova_(datmin, &c_b9);
/*<          XHI=DATMIN >*/
	xhi = *datmin;
/*<          DO 60 IBIN=1,NBIN >*/
	i__1 = *nbin;
	for (ibin = 1; ibin <= i__1; ++ibin) {
/*<             CUR = NUM(IBIN) >*/
	    cur = (real) num[ibin - 1];
/*<             XLO = XHI >*/
	    xlo = xhi;
/*<             XHI = DATMIN + IBIN*BINSIZ >*/
	    xhi = *datmin + ibin * binsiz;
/*<             IF (CUR.EQ.0.0 .AND. PREV.EQ.0.0) THEN >*/
	    if (cur == (float)0. && prev == (float)0.) {
/*<                CALL GRMOVA(XHI,0.0) >*/
		grmova_(&xhi, &c_b9);
/*<             ELSE  >*/
	    } else {
/*<                CALL GRLINA(XLO,CUR) >*/
		grlina_(&xlo, &cur);
/*<                IF(CUR.NE.0.0) THEN >*/
		if (cur != (float)0.) {
/*<                   CALL GRLINA(XHI,CUR) >*/
		    grlina_(&xhi, &cur);
/*<                ELSE >*/
		} else {
/*<                   CALL GRMOVA(XHI,CUR) >*/
		    grmova_(&xhi, &cur);
/*<                ENDIF >*/
		}
/*<             END IF >*/
	    }
/*<             PREV = CUR >*/
	    prev = cur;
/*<  60      CONTINUE >*/
/* L60: */
	}
/*<       END IF >*/
    }

/*<       CALL PGEBUF >*/
    pgebuf_();
/*<       END >*/
} /* pghist_ */

