/* /work2/ssa/pgplot/src/pghtch.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;

/* .PGHTCH -- hatch a polygonal area (internal routine) */
/* . */
/*<       SUBROUTINE PGHTCH(N, X, Y, DA) >*/
/* Subroutine */ int pghtch_(n, x, y, da)
integer *n;
real *x, *y, *da;
{
    /* System generated locals */
    integer i__1, i__2, i__3;
    real r__1, r__2, r__3, r__4;

    /* Builtin functions */
    double cos(), sin();

    /* Local variables */
    static real cmid, cmin, cmax;
    static integer nmin, nmax;
    static real sepn, c__;
    static integer i__, j;
    static real r__, angle, delta, phase, dindx, dindy;
    extern /* Subroutine */ int pgqhs_(), pgqvp_();
    static real dh;
    static integer ii, jj, ni;
    static real bx, by, dx, dy;
    static integer np[32];
    static real ex, ey, xi, yi, yb, xl;
    extern /* Subroutine */ int pgbbuf_();
    static integer nx;
    extern /* Subroutine */ int pgebuf_();
    static real qx, qy, sx, sy, xr, yt;
    extern /* Subroutine */ int pgdraw_(), pgmove_(), pgqwin_(), pgqvsz_();
    static real xs1, xs2, ys1, ys2;
    static integer nnp;
    static real rmu[32], rmu1, rmu2;

/*<       INTEGER N >*/
/*<       REAL X(*), Y(*), DA >*/

/* Hatch a polygonal area using equi-spaced parallel lines. The lines */
/* are drawn using the current line attributes: line style, line width, */
/* and color index. Cross-hatching can be achieved by calling this */
/* routine twice. */

/* Limitations: the hatching will not be done correctly if the */
/* polygon is so complex that a hatch line intersects more than */
/* 32 of its sides. */

/* Arguments: */
/*  N      (input)  : the number of vertices of the polygonal. */
/*  X,Y    (input)  : the (x,y) world-coordinates of the vertices */
/*                    (in order). */
/*  DA      (input) : 0.0 for normal hatching, 90.0 for perpendicular */
/*                    hatching. */
/* -- */
/* Reference: I.O. Angel and G. Griffith "High-resolution computer */
/* graphics using Fortran 77", Halsted Press, 1987. */

/* 18-Feb-1995 [TJP]. */
/* ----------------------------------------------------------------------- */

/* MAXP is the maximum number of intersections any hatch line may make */
/* with the sides of the polygon. */

/*<       INTEGER MAXP >*/
/*<       PARAMETER (MAXP=32) >*/
/*<       INTEGER NP(MAXP), I,J, II,JJ, NMIN,NMAX, NX, NI, NNP >*/
/*<       REAL ANGLE, SEPN, PHASE >*/
/*<       REAL RMU(MAXP), DX,DY, C, CMID,CMIN,CMAX, SX,SY, EX,EY, DELTA >*/
/*<       REAL QX,QY, R, RMU1, RMU2, XI,YI, BX,BY >*/
/*<       REAL DH, XS1, XS2, YS1, YS2, XL, XR, YT, YB, DINDX, DINDY >*/

/* Check arguments. */

/*<       IF (N.LT.3) RETURN >*/
    /* Parameter adjustments */
    --y;
    --x;

    /* Function Body */
    if (*n < 3) {
	return 0;
    }
/*<       CALL PGQHS(ANGLE, SEPN, PHASE) >*/
    pgqhs_(&angle, &sepn, &phase);
/*<       ANGLE = ANGLE + DA >*/
    angle += *da;
/*<       IF (SEPN.EQ.0.0) RETURN >*/
    if (sepn == (float)0.) {
	return 0;
    }

/* The unit spacing is 1 percent of the smaller of the height or */
/* width of the view surface. The line-spacing (DH), in inches, is */
/* obtained by multiplying this by argument SEPN. */

/*<       CALL PGQVSZ(1, XS1, XS2, YS1, YS2) >*/
    pgqvsz_(&c__1, &xs1, &xs2, &ys1, &ys2);
/*<       DH = SEPN*MIN(ABS(XS2-XS1),ABS(YS2-YS1))/100.0 >*/
/* Computing MIN */
    r__3 = (r__1 = xs2 - xs1, dabs(r__1)), r__4 = (r__2 = ys2 - ys1, dabs(
	    r__2));
    dh = sepn * dmin(r__3,r__4) / (float)100.;

/* DINDX and DINDY are the scales in inches per world-coordinate unit. */

/*<       CALL PGQVP(1, XS1, XS2, YS1, YS2) >*/
    pgqvp_(&c__1, &xs1, &xs2, &ys1, &ys2);
/*<       CALL PGQWIN(XL, XR, YB, YT) >*/
    pgqwin_(&xl, &xr, &yb, &yt);
/*<       IF (XR.NE.XL .AND. YT.NE.YB) THEN >*/
    if (xr != xl && yt != yb) {
/*<          DINDX = (XS2 - XS1) / (XR - XL) >*/
	dindx = (xs2 - xs1) / (xr - xl);
/*<          DINDY = (YS2 - YS1) / (YT - YB) >*/
	dindy = (ys2 - ys1) / (yt - yb);
/*<       ELSE >*/
    } else {
/*<          RETURN >*/
	return 0;
/*<       END IF >*/
    }

/* Initialize. */

/*<       CALL PGBBUF >*/
    pgbbuf_();

/* The vector (SX,SY) is a vector length DH perpendicular to */
/* the hatching lines, which have vector (DX,DY). */

/*<       DX = COS(ANGLE/57.29578) >*/
    dx = cos(angle / (float)57.29578);
/*<       DY = SIN(ANGLE/57.29578) >*/
    dy = sin(angle / (float)57.29578);
/*<       SX = (-DH)*DY >*/
    sx = -dh * dy;
/*<       SY = DH*DX >*/
    sy = dh * dx;

/* The hatch lines are labelled by a parameter C, the distance from */
/* the coordinate origin. Calculate CMID, the C-value of the line */
/* that passes through the hatching reference point (BX,BY), and */
/* CMIN and CMAX, the range of C-values spanned by lines that intersect */
/* the polygon. */

/*<       BX = PHASE*SX >*/
    bx = phase * sx;
/*<       BY = PHASE*SY >*/
    by = phase * sy;
/*<       CMID = DX*BY - DY*BX >*/
    cmid = dx * by - dy * bx;
/*<       CMIN = DX*Y(1)*DINDY - DY*X(1)*DINDX >*/
    cmin = dx * y[1] * dindy - dy * x[1] * dindx;
/*<       CMAX = CMIN >*/
    cmax = cmin;
/*<       DO 10 I=2,N >*/
    i__1 = *n;
    for (i__ = 2; i__ <= i__1; ++i__) {
/*<          C = DX*Y(I)*DINDY - DY*X(I)*DINDX >*/
	c__ = dx * y[i__] * dindy - dy * x[i__] * dindx;
/*<          CMIN = MIN(C,CMIN) >*/
	cmin = dmin(c__,cmin);
/*<          CMAX = MAX(C,CMAX) >*/
	cmax = dmax(c__,cmax);
/*<  10   CONTINUE >*/
/* L10: */
    }

/* Compute integer labels for the hatch lines; N=0 is the line */
/* which passes through the reference point; NMIN and NMAX define */
/* the range of labels for lines that intersect the polygon. */
/* [Note that INT truncates towards zero; we need FLOOR and CEIL */
/* functions.] */

/*<       CMIN = (CMIN-CMID)/DH >*/
    cmin = (cmin - cmid) / dh;
/*<       CMAX = (CMAX-CMID)/DH >*/
    cmax = (cmax - cmid) / dh;
/*<       NMIN = INT(CMIN) >*/
    nmin = (integer) cmin;
/*<       IF (REAL(NMIN).LT.CMIN) NMIN = NMIN+1 >*/
    if ((real) nmin < cmin) {
	++nmin;
    }
/*<       NMAX = INT(CMAX) >*/
    nmax = (integer) cmax;
/*<       IF (REAL(NMAX).GT.CMAX) NMAX = NMAX-1 >*/
    if ((real) nmax > cmax) {
	--nmax;
    }

/* Each iteration of the following loop draws one hatch line. */

/*<       DO 60 J=NMIN,NMAX >*/
    i__1 = nmax;
    for (j = nmin; j <= i__1; ++j) {

/* The parametric representation of this hatch line is */
/* (X,Y) = (QX,QY) + RMU*(DX,DY). */

/*<          QX = BX + REAL(J)*SX >*/
	qx = bx + (real) j * sx;
/*<          QY = BY + REAL(J)*SY >*/
	qy = by + (real) j * sy;

/* Find the NX intersections of this line with the edges of the polygon. */

/*<          NX = 0 >*/
	nx = 0;
/*<          NI = N >*/
	ni = *n;
/*<          DO 20 I=1,N >*/
	i__2 = *n;
	for (i__ = 1; i__ <= i__2; ++i__) {
/*<             EX = (X(I) - X(NI))*DINDX >*/
	    ex = (x[i__] - x[ni]) * dindx;
/*<             EY = (Y(I) - Y(NI))*DINDY >*/
	    ey = (y[i__] - y[ni]) * dindy;
/*<             DELTA = EX*DY - EY*DX >*/
	    delta = ex * dy - ey * dx;
/*<             IF (ABS(DELTA).LT.1E-5) THEN >*/
	    if (dabs(delta) < (float)1e-5) {
/*                 -- lines are parallel */
/*<             ELSE >*/
	    } else {
/*                 -- lines intersect in (XI,YI) */
/*<                R = ((QX-X(NI)*DINDX)*DY - (QY-Y(NI)*DINDY)*DX)/DELTA >*/
		r__ = ((qx - x[ni] * dindx) * dy - (qy - y[ni] * dindy) * dx) 
			/ delta;
/*<                IF (R.GT.0.0 .AND. R.LE.1.0) THEN >*/
		if (r__ > (float)0. && r__ <= (float)1.) {
/*<                   IF (NX.LT.MAXP) NX = NX+1 >*/
		    if (nx < 32) {
			++nx;
		    }
/*<                   NP(NX) = NX >*/
		    np[nx - 1] = nx;
/*<                   IF (ABS(DX).GT.0.5) THEN >*/
		    if (dabs(dx) > (float).5) {
/*<                      XI = X(NI)*DINDX + R*EX >*/
			xi = x[ni] * dindx + r__ * ex;
/*<                      RMU(NX) = (XI-QX)/DX >*/
			rmu[nx - 1] = (xi - qx) / dx;
/*<                   ELSE >*/
		    } else {
/*<                      YI = Y(NI)*DINDY + R*EY >*/
			yi = y[ni] * dindy + r__ * ey;
/*<                      RMU(NX) = (YI-QY)/DY >*/
			rmu[nx - 1] = (yi - qy) / dy;
/*<                   END IF >*/
		    }
/*<                END IF >*/
		}
/*<             END IF >*/
	    }
/*<             NI = I >*/
	    ni = i__;
/*<  20      CONTINUE >*/
/* L20: */
	}

/* The RMU array now contains the intersections. Sort them into order. */

/*<          DO 40 II=1,NX-1 >*/
	i__2 = nx - 1;
	for (ii = 1; ii <= i__2; ++ii) {
/*<             DO 30 JJ=II+1,NX >*/
	    i__3 = nx;
	    for (jj = ii + 1; jj <= i__3; ++jj) {
/*<                IF (RMU(NP(II)).LT.RMU(NP(JJ))) THEN >*/
		if (rmu[np[ii - 1] - 1] < rmu[np[jj - 1] - 1]) {
/*<                   NNP = NP(II) >*/
		    nnp = np[ii - 1];
/*<                   NP(II) = NP(JJ) >*/
		    np[ii - 1] = np[jj - 1];
/*<                   NP(JJ) = NNP >*/
		    np[jj - 1] = nnp;
/*<                END IF >*/
		}
/*<  30         CONTINUE >*/
/* L30: */
	    }
/*<  40      CONTINUE >*/
/* L40: */
	}

/* Join the intersections in pairs. */

/*<          NI = 1 >*/
	ni = 1;
/*         -- do while NI < NX */
/*<  50      IF (NI .LT. NX) THEN >*/
L50:
	if (ni < nx) {
/*<             RMU1 = RMU(NP(NI)) >*/
	    rmu1 = rmu[np[ni - 1] - 1];
/*<             RMU2 = RMU(NP(NI+1)) >*/
	    rmu2 = rmu[np[ni] - 1];
/*<             CALL PGMOVE((QX+RMU1*DX)/DINDX, (QY+RMU1*DY)/DINDY) >*/
	    r__1 = (qx + rmu1 * dx) / dindx;
	    r__2 = (qy + rmu1 * dy) / dindy;
	    pgmove_(&r__1, &r__2);
/*<             CALL PGDRAW((QX+RMU2*DX)/DINDX, (QY+RMU2*DY)/DINDY) >*/
	    r__1 = (qx + rmu2 * dx) / dindx;
	    r__2 = (qy + rmu2 * dy) / dindy;
	    pgdraw_(&r__1, &r__2);
/*<             NI = NI+2 >*/
	    ni += 2;
/*<             GOTO 50 >*/
	    goto L50;
/*<          END IF >*/
	}
/*<  60   CONTINUE >*/
/* L60: */
    }

/* Tidy up. */

/*<       CALL PGEBUF >*/
    pgebuf_();

/*<       END >*/
} /* pghtch_ */

