/* /work2/ssa/pgplot/src/pglcur.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;
static integer c__0 = 0;

/* *PGLCUR -- draw a line using the cursor */
/* %void cpglcur(int maxpt, int *npt, float *x, float *y); */
/* + */
/*<       SUBROUTINE PGLCUR (MAXPT, NPT, X, Y) >*/
/* Subroutine */ int pglcur_(maxpt, npt, x, y)
integer *maxpt, *npt;
real *x, *y;
{
    /* System generated locals */
    integer i__1;

    /* Local variables */
    static integer mode;
    static real xblc, yblc, xref, yref;
    extern /* Subroutine */ int pgpt_();
    static real xtrc, ytrc;
    static integer i__;
    extern /* Subroutine */ int grqci_(), grsci_(), grmsg_();
    extern integer pgband_();
    static real xp, yp;
    extern /* Subroutine */ int grlina_();
    static integer savcol;
    extern /* Subroutine */ int grmova_();
    static char letter[1];
    extern /* Subroutine */ int grterm_(), pgqwin_();
    extern logical pgnoto_();
    extern /* Subroutine */ int gretxt_(), grtoup_();

/*<       INTEGER MAXPT, NPT >*/
/*<       REAL    X(*), Y(*) >*/

/* Interactive routine for user to enter a polyline by use of */
/* the cursor.  Routine allows user to Add and Delete vertices; */
/* vertices are joined by straight-line segments. */

/* Arguments: */
/*  MAXPT  (input)  : maximum number of points that may be accepted. */
/*  NPT    (in/out) : number of points entered; should be zero on */
/*                    first call. */
/*  X      (in/out) : array of x-coordinates (dimension at least MAXPT). */
/*  Y      (in/out) : array of y-coordinates (dimension at least MAXPT). */

/* Notes: */

/* (1) On return from the program, cursor points are returned in */
/* the order they were entered. Routine may be (re-)called with points */
/* already defined in X,Y (# in NPT), and they will be plotted */
/* first, before editing. */

/* (2) User commands: the user types single-character commands */
/* after positioning the cursor: the following are accepted: */
/*   A (Add)    - add point at current cursor location. */
/*   D (Delete) - delete last-entered point. */
/*   X (eXit)   - leave subroutine. */
/* -- */
/*  5-Aug-1984 - new routine [TJP]. */
/* 16-Jul-1988 - correct error in delete operation [TJP]. */
/* 13-Dec-1990 - change warnings to messages [TJP]. */
/*  3-Sep-1992 - fixed erase first point bug under Add option [JM/TJP]. */
/*  7-Sep-1994 - use PGBAND [TJP]. */
/*  2-Aug-1995 - remove dependence on common block [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       LOGICAL  PGNOTO >*/
/*<       CHARACTER*1 LETTER >*/
/*<       INTEGER  PGBAND, I, SAVCOL, MODE >*/
/*<       REAL     XP, YP, XREF, YREF >*/
/*<       REAL     XBLC, XTRC, YBLC, YTRC >*/

/* Check that PGPLOT is in the correct state. */

/*<       IF (PGNOTO('PGLCUR')) RETURN >*/
    /* Parameter adjustments */
    --y;
    --x;

    /* Function Body */
    if (pgnoto_("PGLCUR", (ftnlen)6)) {
	return 0;
    }

/* Save current color. */

/*<       CALL GRQCI(SAVCOL) >*/
    grqci_(&savcol);

/* Put current line-segments on screen. */

/*<       IF (NPT.EQ.1) THEN >*/
    if (*npt == 1) {
/*<           CALL PGPT(1,X(1),Y(1),1) >*/
	pgpt_(&c__1, &x[1], &y[1], &c__1);
/*<       END IF >*/
    }
/*<       IF (NPT.GT.0) THEN >*/
    if (*npt > 0) {
/*<           CALL GRMOVA(X(1),Y(1)) >*/
	grmova_(&x[1], &y[1]);
/*<           DO 10 I=2,NPT >*/
	i__1 = *npt;
	for (i__ = 2; i__ <= i__1; ++i__) {
/*<               CALL GRLINA(X(I),Y(I)) >*/
	    grlina_(&x[i__], &y[i__]);
/*<    10     CONTINUE >*/
/* L10: */
	}
/*<       END IF >*/
    }

/* Start with the cursor in the middle of the box, */
/* unless lines have already been drawn. */

/*<       CALL PGQWIN(XBLC, XTRC, YBLC, YTRC) >*/
    pgqwin_(&xblc, &xtrc, &yblc, &ytrc);
/*<       IF (NPT.GT.0) THEN >*/
    if (*npt > 0) {
/*<           XP = X(NPT) >*/
	xp = x[*npt];
/*<           YP = Y(NPT) >*/
	yp = y[*npt];
/*<       ELSE >*/
    } else {
/*<           XP = 0.5*(XBLC+XTRC) >*/
	xp = (xblc + xtrc) * (float).5;
/*<           YP = 0.5*(YBLC+YTRC) >*/
	yp = (yblc + ytrc) * (float).5;
/*<       END IF >*/
    }

/* Loop over cursor inputs. */

/*<       MODE = 0 >*/
    mode = 0;
/*<   100 XREF = XP >*/
L100:
    xref = xp;
/*<       YREF = YP >*/
    yref = yp;
/*<       IF (PGBAND(MODE,1,XREF,YREF,XP,YP,LETTER).NE.1) RETURN >*/
    if (pgband_(&mode, &c__1, &xref, &yref, &xp, &yp, letter, (ftnlen)1) != 1)
	     {
	return 0;
    }
/*<       CALL GRTOUP(LETTER,LETTER) >*/
    grtoup_(letter, letter, (ftnlen)1, (ftnlen)1);
/*<       MODE = 1 >*/
    mode = 1;

/* A (ADD) command: */

/*<       IF (LETTER .EQ. 'A') THEN >*/
    if (*(unsigned char *)letter == 'A') {
/*<           IF (NPT.GE.MAXPT) THEN >*/
	if (*npt >= *maxpt) {
/*<             CALL GRMSG('ADD ignored (too many points).') >*/
	    grmsg_("ADD ignored (too many points).", (ftnlen)30);
/*<               GOTO 100 >*/
	    goto L100;
/*<           END IF >*/
	}
/*<           NPT = NPT+1 >*/
	++(*npt);
/*<           X(NPT) = XP >*/
	x[*npt] = xp;
/*<           Y(NPT) = YP >*/
	y[*npt] = yp;
/*<           IF (NPT.EQ.1) THEN >*/
	if (*npt == 1) {
/*           -- first point: draw a dot */
/*<             CALL GRMOVA(X(NPT),Y(NPT)) >*/
	    grmova_(&x[*npt], &y[*npt]);
/*<             CALL PGPT(1,X(NPT),Y(NPT),1) >*/
	    pgpt_(&c__1, &x[*npt], &y[*npt], &c__1);
/*<           ELSE >*/
	} else {
/*           -- nth point: draw from (n-1) to (n) */
/*<             CALL GRLINA(X(NPT),Y(NPT)) >*/
	    grlina_(&x[*npt], &y[*npt]);
/*<           END IF >*/
	}
/*<           CALL GRTERM >*/
	grterm_();

/* D (DELETE) command: */

/*<       ELSE IF (LETTER.EQ.'D') THEN >*/
    } else if (*(unsigned char *)letter == 'D') {
/*<           IF (NPT.LE.0) THEN >*/
	if (*npt <= 0) {
/*<             CALL GRMSG('DELETE ignored (there are no points left).') >*/
	    grmsg_("DELETE ignored (there are no points left).", (ftnlen)42);
/*<             GOTO 100 >*/
	    goto L100;
/*<           END IF >*/
	}
/*<           IF (NPT.GT.1) THEN >*/
	if (*npt > 1) {
/*           -- delete nth point: erase from (n-1) to (n) */
/*<             CALL GRMOVA(X(NPT-1),Y(NPT-1)) >*/
	    grmova_(&x[*npt - 1], &y[*npt - 1]);
/*<             CALL GRSCI(0) >*/
	    grsci_(&c__0);
/*<             CALL GRLINA(X(NPT),Y(NPT)) >*/
	    grlina_(&x[*npt], &y[*npt]);
/*<             CALL GRSCI(SAVCOL) >*/
	    grsci_(&savcol);
/*<             CALL GRMOVA(X(NPT-1),Y(NPT-1)) >*/
	    grmova_(&x[*npt - 1], &y[*npt - 1]);
/*<             CALL GRTERM >*/
	    grterm_();
/*<           ELSE IF (NPT.EQ.1) THEN >*/
	} else if (*npt == 1) {
/*           -- delete first point: erase dot */
/*<             CALL GRSCI(0) >*/
	    grsci_(&c__0);
/*<             CALL PGPT(1,X(NPT),Y(NPT),1) >*/
	    pgpt_(&c__1, &x[*npt], &y[*npt], &c__1);
/*<             CALL GRSCI(SAVCOL) >*/
	    grsci_(&savcol);
/*<           END IF >*/
	}
/*<           NPT = NPT-1 >*/
	--(*npt);
/*<           IF (NPT.EQ.0) THEN >*/
	if (*npt == 0) {
/*<             XP = 0.5*(XBLC+XTRC) >*/
	    xp = (xblc + xtrc) * (float).5;
/*<             YP = 0.5*(YBLC+YTRC) >*/
	    yp = (yblc + ytrc) * (float).5;
/*<           ELSE >*/
	} else {
/*<             XP = X(NPT) >*/
	    xp = x[*npt];
/*<             YP = Y(NPT) >*/
	    yp = y[*npt];
/*<           END IF >*/
	}
/*<           IF (NPT.EQ.1) THEN >*/
	if (*npt == 1) {
/*           -- delete 2nd point: redraw dot at first point */
/*<             CALL PGPT(1,X(1),Y(1),1) >*/
	    pgpt_(&c__1, &x[1], &y[1], &c__1);
/*<           END IF >*/
	}

/* X (EXIT) command: */

/*<       ELSE IF (LETTER.EQ.'X') THEN >*/
    } else if (*(unsigned char *)letter == 'X') {
/*<           CALL GRETXT >*/
	gretxt_();
/*<           RETURN >*/
	return 0;

/* Illegal command: */

/*<       ELSE >*/
    } else {
/*<           CALL GRMSG('Commands are A (add), D (delete), X (exit).') >*/
	grmsg_("Commands are A (add), D (delete), X (exit).", (ftnlen)43);
/*<       END IF >*/
    }

/*<       GOTO 100 >*/
    goto L100;
/*<       END >*/
} /* pglcur_ */

