/* /work2/ssa/pgplot/src/pgnpl.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"


/* .PGNPL -- Work out how many numerals there are in an integer */
/* . */
/*<       SUBROUTINE PGNPL (NMAX, N, NPL) >*/
/* Subroutine */ int pgnpl_(nmax, n, npl)
integer *nmax, *n, *npl;
{
    /* System generated locals */
    real r__1;

    /* Builtin functions */
    double r_lg10();

    /* Local variables */
    extern /* Subroutine */ int grwarn_();


/*<       INTEGER NMAX, N, NPL >*/

/*     Work out how many numerals there are in an integer for use with */
/*     format statements. */
/*     e.g.  N=280 => NPL=3,   N=-3 => NPL=2 */

/*     Input: */
/*       NMAX   :   If > 0, issue a warning that N is going to */
/*                  exceed the format statement field size if NPL */
/*                  exceeds NMAX */
/*       N      :   Integer of interest */
/*     Output: */
/*       NPL    :   Number of numerals */

/* - */
/*  20-Apr-1991 -- new routine (Neil Killeen) */
/* ------------------------------------------------------------------------- */
/*<       IF (N.EQ.0) THEN >*/
    if (*n == 0) {
/*<         NPL = 1 >*/
	*npl = 1;
/*<       ELSE >*/
    } else {
/*<         NPL = INT(LOG10(REAL(ABS(N)))) + 1 >*/
	r__1 = (real) abs(*n);
	*npl = (integer) r_lg10(&r__1) + 1;
/*<       END IF >*/
    }
/*<       IF (N.LT.0) NPL = NPL + 1 >*/
    if (*n < 0) {
	++(*npl);
    }

/*<    >*/
    if (*nmax > 0 && *npl > *nmax) {
	grwarn_("PGNPL: output conversion error likely; number too big for f\
ormat", (ftnlen)64);
    }

/*<       RETURN >*/
    return 0;
/*<       END >*/
} /* pgnpl_ */

