/* /work2/ssa/pgplot/src/pgnumb.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__2 = 2;
static integer c__3 = 3;

/* *PGNUMB -- convert a number into a plottable character string */
/* %void cpgnumb(int mm, int pp, int form, char *string, \ */
/* % int *string_length); */
/* + */
/*<       SUBROUTINE PGNUMB (MM, PP, FORM, STRING, NC) >*/
/* Subroutine */ int pgnumb_(mm, pp, form, string, nc, string_len)
integer *mm, *pp, *form;
char *string;
integer *nc;
ftnlen string_len;
{
    /* System generated locals */
    address a__1[2], a__2[3];
    integer i__1[2], i__2, i__3[3], i__4;
    char ch__1[3];

    /* Builtin functions */
    /* Subroutine */ int s_cat(), s_copy();
    integer s_cmp(), i_len();

    /* Local variables */
    static char temp[20], down[2], work[20], wexp[20];
    static integer i__, j, k, m, p;
    static char times[2];
    static logical minus;
    static integer nd;
    static char up[2], bslash[1];
    static integer nbp;

/*<       INTEGER MM, PP, FORM >*/
/*<       CHARACTER*(*) STRING >*/
/*<       INTEGER NC >*/

/* This routine converts a number into a decimal character */
/* representation. To avoid problems of floating-point roundoff, the */
/* number must be provided as an integer (MM) multiplied by a power of 10 */
/* (10**PP).  The output string retains only significant digits of MM, */
/* and will be in either integer format (123), decimal format (0.0123), */
/* or exponential format (1.23x10**5). Standard escape sequences \u, \d */
/* raise the exponent and \x is used for the multiplication sign. */
/* This routine is used by PGBOX to create numeric labels for a plot. */

/* Formatting rules: */
/*   (a) Decimal notation (FORM=1): */
/*       - Trailing zeros to the right of the decimal sign are */
/*         omitted */
/*       - The decimal sign is omitted if there are no digits */
/*         to the right of it */
/*       - When the decimal sign is placed before the first digit */
/*         of the number, a zero is placed before the decimal sign */
/*       - The decimal sign is a period (.) */
/*       - No spaces are placed between digits (ie digits are not */
/*         grouped in threes as they should be) */
/*       - A leading minus (-) is added if the number is negative */
/*   (b) Exponential notation (FORM=2): */
/*       - The exponent is adjusted to put just one (non-zero) */
/*         digit before the decimal sign */
/*       - The mantissa is formatted as in (a), unless its value is */
/*         1 in which case it and the multiplication sign are omitted */
/*       - If the power of 10 is not zero and the mantissa is not */
/*         zero, an exponent of the form \x10\u[-]nnn is appended, */
/*         where \x is a multiplication sign (cross), \u is an escape */
/*         sequence to raise the exponent, and as many digits nnn */
/*         are used as needed */
/*   (c) Automatic choice (FORM=0): */
/*         Decimal notation is used if the absolute value of the */
/*         number is less than 10000 or greater than or equal to */
/*         0.01. Otherwise exponential notation is used. */

/* Arguments: */
/*  MM     (input) */
/*  PP     (input)  : the value to be formatted is MM*10**PP. */
/*  FORM   (input)  : controls how the number is formatted: */
/*                    FORM = 0 -- use either decimal or exponential */
/*                    FORM = 1 -- use decimal notation */
/*                    FORM = 2 -- use exponential notation */
/*  STRING (output) : the formatted character string, left justified. */
/*                    If the length of STRING is insufficient, a single */
/*                    asterisk is returned, and NC=1. */
/*  NC     (output) : the number of characters used in STRING: */
/*                    the string to be printed is STRING(1:NC). */
/* -- */
/* 23-Nov-1983 */
/*  9-Feb-1988 [TJP] - Use temporary variable to avoid illegal character */
/*                     assignments; remove non-standard DO loops. */
/* 15-Dec-1988 [TJP] - More corrections of the same sort. */
/* 27-Nov-1991 [TJP] - Change code for multiplication sign. */
/* 23-Jun-1994 [TJP] - Partial implementation of FORM=1 and 2. */
/* ----------------------------------------------------------------------- */
/*<       CHARACTER*1 BSLASH >*/
/*<       CHARACTER*2 TIMES, UP, DOWN >*/
/*<       CHARACTER*20 WORK, WEXP, TEMP >*/
/*<       INTEGER M, P, ND, I, J, K, NBP >*/
/*<       LOGICAL MINUS >*/

/* Define backslash (escape) character and escape sequences. */

/*<       BSLASH = CHAR(92) >*/
    *(unsigned char *)bslash = '\\';
/*<       TIMES  = BSLASH//'x' >*/
/* Writing concatenation */
    i__1[0] = 1, a__1[0] = bslash;
    i__1[1] = 1, a__1[1] = "x";
    s_cat(times, a__1, i__1, &c__2, (ftnlen)2);
/*<       UP     = BSLASH//'u' >*/
/* Writing concatenation */
    i__1[0] = 1, a__1[0] = bslash;
    i__1[1] = 1, a__1[1] = "u";
    s_cat(up, a__1, i__1, &c__2, (ftnlen)2);
/*<       DOWN   = BSLASH//'d' >*/
/* Writing concatenation */
    i__1[0] = 1, a__1[0] = bslash;
    i__1[1] = 1, a__1[1] = "d";
    s_cat(down, a__1, i__1, &c__2, (ftnlen)2);

/* Zero is always printed as "0". */

/*<       IF (MM.EQ.0) THEN >*/
    if (*mm == 0) {
/*<           STRING = '0' >*/
	s_copy(string, "0", string_len, (ftnlen)1);
/*<           NC = 1 >*/
	*nc = 1;
/*<           RETURN >*/
	return 0;
/*<       END IF >*/
    }

/* If negative, make a note of that fact. */

/*<       MINUS = MM.LT.0 >*/
    minus = *mm < 0;
/*<       M = ABS(MM) >*/
    m = abs(*mm);
/*<       P = PP >*/
    p = *pp;

/* Convert M to a left-justified digit string in WORK. As M is a */
/* positive integer, it cannot use more than 10 digits (2147483647). */

/*<       J = 10 >*/
    j = 10;
/*<    10 IF (M.NE.0) THEN >*/
L10:
    if (m != 0) {
/*<           K = MOD(M,10) >*/
	k = m % 10;
/*<           M = M/10 >*/
	m /= 10;
/*<           WORK(J:J) = CHAR(ICHAR('0')+K) >*/
	*(unsigned char *)&work[j - 1] = (char) ('0' + k);
/*<           J = J-1 >*/
	--j;
/*<        GOTO 10 >*/
	goto L10;
/*<       END IF >*/
    }
/*<       TEMP = WORK(J+1:) >*/
    i__2 = j;
    s_copy(temp, work + i__2, (ftnlen)20, 20 - i__2);
/*<       WORK = TEMP >*/
    s_copy(work, temp, (ftnlen)20, (ftnlen)20);
/*<       ND = 10-J >*/
    nd = 10 - j;

/* Remove right-hand zeros, and increment P for each one removed. */
/* ND is the final number of significant digits in WORK, and P the */
/* power of 10 to be applied. Number of digits before decimal point */
/* is NBP. */

/*<    20 IF (WORK(ND:ND).EQ.'0') THEN >*/
L20:
    if (*(unsigned char *)&work[nd - 1] == '0') {
/*<           ND = ND-1 >*/
	--nd;
/*<           P = P+1 >*/
	++p;
/*<        GOTO 20 >*/
	goto L20;
/*<       END IF >*/
    }
/*<       NBP = ND+MIN(P,0) >*/
    nbp = nd + min(p,0);

/* Integral numbers of 4 or less digits are formatted as such. */

/*<    >*/
    if (p >= 0 && (*form == 0 && p + nd <= 4 || *form == 1 && p + nd <= 10)) {
/*<           DO 30 I=1,P >*/
	i__2 = p;
	for (i__ = 1; i__ <= i__2; ++i__) {
/*<               ND = ND+1 >*/
	    ++nd;
/*<               WORK(ND:ND) = '0' >*/
	    *(unsigned char *)&work[nd - 1] = '0';
/*<    30     CONTINUE >*/
/* L30: */
	}
/*<           P = 0 >*/
	p = 0;

/* If NBP is 4 or less, simply insert a decimal point in the right place. */

/*<       ELSE IF (FORM.NE.2.AND.NBP.GE.1.AND.NBP.LE.4.AND.NBP.LT.ND) THEN >*/
    } else if (*form != 2 && nbp >= 1 && nbp <= 4 && nbp < nd) {
/*<           TEMP = WORK(NBP+1:ND) >*/
	i__2 = nbp;
	s_copy(temp, work + i__2, (ftnlen)20, nd - i__2);
/*<           WORK(NBP+2:ND+1) = TEMP >*/
	i__2 = nbp + 1;
	s_copy(work + i__2, temp, nd + 1 - i__2, (ftnlen)20);
/*<           WORK(NBP+1:NBP+1) = '.' >*/
	i__2 = nbp;
	s_copy(work + i__2, ".", nbp + 1 - i__2, (ftnlen)1);
/*<           ND = ND+1 >*/
	++nd;
/*<           P = 0 >*/
	p = 0;

/* Otherwise insert a decimal point after the first digit, and adjust P. */

/*<       ELSE >*/
    } else {
/*<           P = P + ND - 1 >*/
	p = p + nd - 1;
/*<           IF (FORM.NE.2 .AND. P.EQ.-1) THEN >*/
	if (*form != 2 && p == -1) {
/*<               TEMP = WORK >*/
	    s_copy(temp, work, (ftnlen)20, (ftnlen)20);
/*<               WORK = '0'//TEMP >*/
/* Writing concatenation */
	    i__1[0] = 1, a__1[0] = "0";
	    i__1[1] = 20, a__1[1] = temp;
	    s_cat(work, a__1, i__1, &c__2, (ftnlen)20);
/*<               ND = ND+1 >*/
	    ++nd;
/*<               P = 0 >*/
	    p = 0;
/*<           ELSE IF (FORM.NE.2 .AND. P.EQ.-2) THEN >*/
	} else if (*form != 2 && p == -2) {
/*<               TEMP = WORK >*/
	    s_copy(temp, work, (ftnlen)20, (ftnlen)20);
/*<               WORK = '00'//TEMP >*/
/* Writing concatenation */
	    i__1[0] = 2, a__1[0] = "00";
	    i__1[1] = 20, a__1[1] = temp;
	    s_cat(work, a__1, i__1, &c__2, (ftnlen)20);
/*<               ND = ND+2 >*/
	    nd += 2;
/*<               P = 0 >*/
	    p = 0;
/*<           END IF >*/
	}
/*<           IF (ND.GT.1) THEN >*/
	if (nd > 1) {
/*<               TEMP = WORK(2:ND) >*/
	    s_copy(temp, work + 1, (ftnlen)20, nd - 1);
/*<               WORK(3:ND+1) = TEMP >*/
	    s_copy(work + 2, temp, nd - 1, (ftnlen)20);
/*<               WORK(2:2) = '.' >*/
	    *(unsigned char *)&work[1] = '.';
/*<               ND = ND + 1 >*/
	    ++nd;
/*<           END IF >*/
	}
/*<       END IF >*/
    }

/* Add exponent if necessary. */

/*<       IF (P.NE.0) THEN >*/
    if (p != 0) {
/*<           WORK(ND+1:ND+6) = TIMES//'10'//UP >*/
	i__2 = nd;
/* Writing concatenation */
	i__3[0] = 2, a__2[0] = times;
	i__3[1] = 2, a__2[1] = "10";
	i__3[2] = 2, a__2[2] = up;
	s_cat(work + i__2, a__2, i__3, &c__3, nd + 6 - i__2);
/*<           ND = ND+6 >*/
	nd += 6;
/*<           IF (P.LT.0) THEN >*/
	if (p < 0) {
/*<               P = -P >*/
	    p = -p;
/*<               ND = ND+1 >*/
	    ++nd;
/*<               WORK(ND:ND) = '-' >*/
	    *(unsigned char *)&work[nd - 1] = '-';
/*<           END IF >*/
	}
/*<           J = 10 >*/
	j = 10;
/*<    40     IF (P.NE.0) THEN >*/
L40:
	if (p != 0) {
/*<               K = MOD(P,10) >*/
	    k = p % 10;
/*<               P = P/10 >*/
	    p /= 10;
/*<               WEXP(J:J) = CHAR(ICHAR('0')+K) >*/
	    *(unsigned char *)&wexp[j - 1] = (char) ('0' + k);
/*<               J = J-1 >*/
	    --j;
/*<            GOTO 40 >*/
	    goto L40;
/*<           END IF >*/
	}
/*<           WORK(ND+1:) = WEXP(J+1:10) >*/
	i__2 = nd;
	i__4 = j;
	s_copy(work + i__2, wexp + i__4, 20 - i__2, 10 - i__4);
/*<           ND = ND+10-J >*/
	nd = nd + 10 - j;
/*<           IF (WORK(1:3).EQ.'1'//TIMES) THEN >*/
/* Writing concatenation */
	i__1[0] = 1, a__1[0] = "1";
	i__1[1] = 2, a__1[1] = times;
	s_cat(ch__1, a__1, i__1, &c__2, (ftnlen)3);
	if (s_cmp(work, ch__1, (ftnlen)3, (ftnlen)3) == 0) {
/*<               TEMP = WORK(4:) >*/
	    s_copy(temp, work + 3, (ftnlen)20, (ftnlen)17);
/*<               WORK = TEMP >*/
	    s_copy(work, temp, (ftnlen)20, (ftnlen)20);
/*<               ND = ND-3 >*/
	    nd += -3;
/*<           END IF >*/
	}
/*<           WORK(ND+1:ND+2) = DOWN >*/
	i__2 = nd;
	s_copy(work + i__2, down, nd + 2 - i__2, (ftnlen)2);
/*<           ND = ND+2 >*/
	nd += 2;
/*<       END IF >*/
    }

/* Add minus sign if necessary and move result to output. */

/*<       IF (MINUS) THEN >*/
    if (minus) {
/*<          TEMP = WORK(1:ND) >*/
	s_copy(temp, work, (ftnlen)20, nd);
/*<          STRING = '-'//TEMP >*/
/* Writing concatenation */
	i__1[0] = 1, a__1[0] = "-";
	i__1[1] = 20, a__1[1] = temp;
	s_cat(string, a__1, i__1, &c__2, string_len);
/*<          NC = ND+1 >*/
	*nc = nd + 1;
/*<       ELSE >*/
    } else {
/*<          STRING = WORK(1:ND) >*/
	s_copy(string, work, string_len, nd);
/*<          NC = ND >*/
	*nc = nd;
/*<       END IF >*/
    }

/* Check result fits. */

/*<       IF (NC.GT.LEN(STRING)) THEN >*/
    if (*nc > i_len(string, string_len)) {
/*<           STRING = '*' >*/
	s_copy(string, "*", string_len, (ftnlen)1);
/*<           NC = 1 >*/
	*nc = 1;
/*<       END IF >*/
    }
/*<       END >*/
} /* pgnumb_ */

