/* /work2/ssa/pgplot/src/pgolin.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__0 = 0;
static integer c__1 = 1;

/* *PGOLIN -- mark a set of points using the cursor */
/* %void cpgolin(int maxpt, int *npt, float *x, float *y, int symbol); */
/* + */
/*<       SUBROUTINE PGOLIN (MAXPT, NPT, X, Y, SYMBOL) >*/
/* Subroutine */ int pgolin_(maxpt, npt, x, y, symbol)
integer *maxpt, *npt;
real *x, *y;
integer *symbol;
{
    static real xblc, yblc, xref, yref;
    extern /* Subroutine */ int pgpt_();
    static real xtrc, ytrc;
    extern /* Subroutine */ int grqci_(), grsci_(), grmsg_();
    extern integer pgband_();
    static real xp, yp;
    static integer savcol;
    static char letter[1];
    extern /* Subroutine */ int grterm_();
    extern logical pgnoto_();
    extern /* Subroutine */ int pgqwin_(), gretxt_(), grtoup_();

/*<       INTEGER MAXPT, NPT >*/
/*<       REAL    X(*), Y(*) >*/
/*<       INTEGER SYMBOL >*/

/* Interactive routine for user to enter data points by use of */
/* the cursor.  Routine allows user to Add and Delete points.  The */
/* points are returned in the order that they were entered (unlike */
/* PGNCUR). */

/* Arguments: */
/*  MAXPT  (input)  : maximum number of points that may be accepted. */
/*  NPT    (in/out) : number of points entered; should be zero on */
/*                    first call. */
/*  X      (in/out) : array of x-coordinates. */
/*  Y      (in/out) : array of y-coordinates. */
/*  SYMBOL (input)  : code number of symbol to use for marking */
/*                    entered points (see PGPT). */

/* Note (1): The dimension of arrays X and Y must be greater than or */
/* equal to MAXPT. */

/* Note (2): On return from the program, cursor points are returned in */
/* the order they were entered. Routine may be (re-)called with points */
/* already defined in X,Y (number in NPT), and they will be plotted */
/* first, before editing. */

/* Note (3): User commands: the user types single-character commands */
/* after positioning the cursor: the following are accepted: */
/* A (Add)    - add point at current cursor location. */
/* D (Delete) - delete the last point entered. */
/* X (eXit)   - leave subroutine. */
/* -- */
/*  4-Nov-1985 - new routine (adapted from PGNCUR) - TJP. */
/* 13-Dec-1990 - change warnings to messages [TJP]. */
/*  7-Sep-1994 - use PGBAND [TJP]. */
/*  2-Aug-1995 - remove dependence on common block [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       LOGICAL  PGNOTO >*/
/*<       CHARACTER*1 LETTER >*/
/*<       INTEGER  PGBAND, SAVCOL >*/
/*<       REAL     XP, YP, XREF, YREF >*/
/*<       REAL     XBLC, XTRC, YBLC, YTRC >*/

/* Check that PGPLOT is in the correct state. */

/*<       IF (PGNOTO('PGOLIN')) RETURN >*/
    /* Parameter adjustments */
    --y;
    --x;

    /* Function Body */
    if (pgnoto_("PGOLIN", (ftnlen)6)) {
	return 0;
    }

/* Save current color. */

/*<       CALL GRQCI(SAVCOL) >*/
    grqci_(&savcol);

/* Put current points on screen.  Position cursor on last point, */
/* or in middle viewport if there are no current points. */

/*<       CALL PGQWIN(XBLC, XTRC, YBLC, YTRC) >*/
    pgqwin_(&xblc, &xtrc, &yblc, &ytrc);
/*<       IF (NPT.NE.0) THEN >*/
    if (*npt != 0) {
/*<           CALL PGPT(NPT,X,Y,SYMBOL) >*/
	pgpt_(npt, &x[1], &y[1], symbol);
/*<           XP = X(NPT) >*/
	xp = x[*npt];
/*<           YP = Y(NPT) >*/
	yp = y[*npt];
/*<       ELSE >*/
    } else {
/*<           XP = 0.5*(XBLC+XTRC) >*/
	xp = (xblc + xtrc) * (float).5;
/*<           YP = 0.5*(YBLC+YTRC) >*/
	yp = (yblc + ytrc) * (float).5;
/*<       END IF >*/
    }

/* Loop over cursor inputs. */

/*<   100 XREF = XP >*/
L100:
    xref = xp;
/*<       YREF = YP >*/
    yref = yp;
/*<       IF (PGBAND(0,1,XREF,YREF,XP,YP,LETTER).NE.1) RETURN >*/
    if (pgband_(&c__0, &c__1, &xref, &yref, &xp, &yp, letter, (ftnlen)1) != 1)
	     {
	return 0;
    }
/*<       IF (LETTER.EQ.CHAR(0)) RETURN >*/
    if (*(unsigned char *)letter == '\0') {
	return 0;
    }
/*<       CALL GRTOUP(LETTER,LETTER) >*/
    grtoup_(letter, letter, (ftnlen)1, (ftnlen)1);

/* A (ADD) command: */

/*<       IF (LETTER .EQ. 'A') THEN >*/
    if (*(unsigned char *)letter == 'A') {
/*<           IF (NPT.GE.MAXPT) THEN >*/
	if (*npt >= *maxpt) {
/*<               CALL GRMSG('ADD ignored (too many points).') >*/
	    grmsg_("ADD ignored (too many points).", (ftnlen)30);
/*<           ELSE >*/
	} else {
/*<               NPT = NPT + 1 >*/
	    ++(*npt);
/*<               X(NPT) = XP >*/
	    x[*npt] = xp;
/*<               Y(NPT) = YP >*/
	    y[*npt] = yp;
/*<               CALL PGPT(1,X(NPT),Y(NPT),SYMBOL) >*/
	    pgpt_(&c__1, &x[*npt], &y[*npt], symbol);
/*<               CALL GRTERM >*/
	    grterm_();
/*<           END IF >*/
	}

/* D (DELETE) command: */

/*<       ELSE IF (LETTER.EQ.'D') THEN >*/
    } else if (*(unsigned char *)letter == 'D') {
/*<           IF (NPT.LE.0) THEN >*/
	if (*npt <= 0) {
/*<               CALL GRMSG('DELETE ignored (there are no points left).') >*/
	    grmsg_("DELETE ignored (there are no points left).", (ftnlen)42);
/*<           ELSE >*/
	} else {
/*<               CALL GRSCI(0) >*/
	    grsci_(&c__0);
/*<               CALL PGPT(1,X(NPT),Y(NPT),SYMBOL) >*/
	    pgpt_(&c__1, &x[*npt], &y[*npt], symbol);
/*<               XP = X(NPT) >*/
	    xp = x[*npt];
/*<               YP = Y(NPT) >*/
	    yp = y[*npt];
/*<               CALL GRSCI(SAVCOL) >*/
	    grsci_(&savcol);
/*<               CALL GRTERM >*/
	    grterm_();
/*<               NPT = NPT-1 >*/
	    --(*npt);
/*<           END IF >*/
	}

/* X (EXIT) command: */

/*<       ELSE IF (LETTER.EQ.'X') THEN >*/
    } else if (*(unsigned char *)letter == 'X') {
/*<           CALL GRETXT >*/
	gretxt_();
/*<           RETURN >*/
	return 0;

/* Illegal command: */

/*<       ELSE >*/
    } else {
/*<           CALL GRMSG('Commands are A (add), D (delete), X (exit).') >*/
	grmsg_("Commands are A (add), D (delete), X (exit).", (ftnlen)43);
/*<       END IF >*/
    }

/*<       GOTO 100 >*/
    goto L100;
/*<       END >*/
} /* pgolin_ */

