/* /work2/ssa/pgplot/src/pgqcs.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer pgid, pgdevs[8], pgadvs[8], pgnx[8], pgny[8], pgnxc[8], pgnyc[8];
    real pgxpin[8], pgypin[8], pgxsp[8], pgysp[8], pgxsz[8], pgysz[8], pgxoff[
	    8], pgyoff[8], pgxvp[8], pgyvp[8], pgxlen[8], pgylen[8], pgxorg[8]
	    , pgyorg[8], pgxscl[8], pgyscl[8], pgxblc[8], pgxtrc[8], pgyblc[8]
	    , pgytrc[8], trans[6];
    logical pgprmp[8];
    integer pgclp[8], pgfas[8];
    real pgchsz[8];
    integer pgblev[8];
    logical pgrows[8];
    integer pgahs[8];
    real pgaha[8], pgahv[8];
    integer pgtbci[8], pgmnci[8], pgmxci[8], pgcint, pgcmin;
    logical pgpfix[8];
    integer pgitf[8];
    real pghsa[8], pghss[8], pghsp[8];
} pgplt1_;

#define pgplt1_1 pgplt1_

struct {
    char pgclab[32];
} pgplt2_;

#define pgplt2_1 pgplt2_

/* *PGQCS  -- inquire character height in a variety of units */
/* %void cpgqcs(int units, float *xch, float *ych); */
/* + */
/*<       SUBROUTINE PGQCS(UNITS, XCH, YCH) >*/
/* Subroutine */ int pgqcs_(units, xch, ych)
integer *units;
real *xch, *ych;
{
    static real ratio;
    extern /* Subroutine */ int grwarn_();
    extern logical pgnoto_();

/*<       INTEGER UNITS >*/
/*<       REAL XCH, YCH >*/

/* Return the current PGPLOT character height in a variety of units. */
/* This routine provides facilities that are not available via PGQCH. */
/* Use PGQCS if the character height is required in units other than */
/* those used in PGSCH. */

/* The PGPLOT "character height" is a dimension that scales with the */
/* size of the view surface and with the scale-factor specified with */
/* routine PGSCH. The default value is 1/40th of the height or width */
/* of the view surface (whichever is less); this value is then */
/* multiplied by the scale-factor supplied with PGSCH. Note that it */
/* is a nominal height only; the actual character size depends on the */
/* font and is usually somewhat smaller. */

/* Arguments: */
/*  UNITS  (input)  : Used to specify the units of the output value: */
/*                    UNITS = 0 : normalized device coordinates */
/*                    UNITS = 1 : inches */
/*                    UNITS = 2 : millimeters */
/*                    UNITS = 3 : pixels */
/*                    UNITS = 4 : world coordinates */
/*                    Other values give an error message, and are */
/*                    treated as 0. */
/*  XCH    (output) : The character height for text written with a */
/*                    vertical baseline. */
/*  YCH    (output) : The character height for text written with */
/*                    a horizontal baseline (the usual case). */

/* The character height is returned in both XCH and YCH. */

/* If UNITS=1 or UNITS=2, XCH and YCH both receive the same value. */

/* If UNITS=3, XCH receives the height in horizontal pixel units, and YCH */
/* receives the height in vertical pixel units; on devices for which the */
/* pixels are not square, XCH and YCH will be different. */

/* If UNITS=4, XCH receives the height in horizontal world coordinates */
/* (as used for the x-axis), and YCH receives the height in vertical */
/* world coordinates (as used for the y-axis). Unless special care has */
/* been taken to achive equal world-coordinate scales on both axes, the */
/* values of XCH and YCH will be different. */

/* If UNITS=0, XCH receives the character height as a fraction of the */
/* horizontal dimension of the view surface, and YCH receives the */
/* character height as a fraction of the vertical dimension of the view */
/* surface. */
/* -- */
/* 15-Oct-1992 - new routine [MCS]. */
/*  4-Dec-1992 - added more explanation [TJP]. */
/*  5-Sep-1995 - add UNITS=4; correct error for non-square pixels [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'pgplot.inc' >*/
/*<       LOGICAL PGNOTO >*/
/* ----------------------------------------------------------------------- */
/* PGPLOT: common block definition. */
/* ----------------------------------------------------------------------- */
/* Maximum number of concurrent devices (should match GRIMAX). */
/* ----------------------------------------------------------------------- */
/*<       PARAMETER (PGMAXD=8) >*/
/* ----------------------------------------------------------------------- */
/* Indentifier of currently selected device. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER PGID >*/
/* ----------------------------------------------------------------------- */
/* Device status (indexed by device identifier). */
/* ----------------------------------------------------------------------- */
/* PGDEVS  =0 if device is not open; 1 if device is open. */
/* PGADVS  Set to 0 by PGBEGIN, set to 1 by PGPAGE; used to suppress */
/*         the prompt for the first page. */
/* PROMPT  If .TRUE., ask user before clearing page; set by PGASK */
/*         and (indirectly) by PGBEGIN, used in PGENV. */
/* PGBLEV  Buffering level: incremented by PGBBUF, decremented by */
/*         PGEBUF. */
/* PGPFIX  TRUE if PGPAP has been called, FALSE otherwise. */

/*<       INTEGER PGDEVS(PGMAXD), PGADVS(PGMAXD), PGBLEV(PGMAXD) >*/
/*<       LOGICAL PGPRMP(PGMAXD), PGPFIX(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Panel parameters (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* NX      Number of panels in x direction */
/* NY      Number of panels in y direction */
/* NXC     Ordinal number of current X panel */
/* NYC     Ordinal number of current Y panel */
/* XSZ     X dimension of panel (device units) */
/* YSZ     Y dimension of panel (device units) */
/* PGROWS  TRUE if panels are used in row order, FALSE for column */
/*         order. */

/*<       INTEGER PGNX  (PGMAXD), PGNY  (PGMAXD) >*/
/*<       INTEGER PGNXC (PGMAXD), PGNYC (PGMAXD) >*/
/*<       REAL    PGXSZ (PGMAXD), PGYSZ (PGMAXD) >*/
/*<       LOGICAL PGROWS(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Attributes (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* PGCLP   clipping enabled/disabed */
/* PGFAS   fill-area style */
/* PGCHSZ  character height */
/* PGAHS   arrow-head fill style */
/* PGAHA   arrow-head angle */
/* PGAHV   arrow-head vent */
/* PGTBCI  text background color index */
/* PGMNCI  lower range of color indices available to PGGRAY/PGIMAG */
/* PGMXCI  upper range of color indices available to PGGRAY/PGIMAG */
/* PGITF   type of transfer function used by PGGRAY/PGIMAG */
/* PGHSA   hatching line angle */
/* PGHSS   hatching line separation */
/* PGHSP   hatching line phase */

/*<       INTEGER PGCLP (PGMAXD) >*/
/*<       INTEGER PGFAS (PGMAXD) >*/
/*<       REAL    PGCHSZ(PGMAXD) >*/
/*<       INTEGER PGAHS (PGMAXD) >*/
/*<       REAL    PGAHA (PGMAXD) >*/
/*<       REAL    PGAHV (PGMAXD) >*/
/*<       INTEGER PGTBCI(PGMAXD) >*/
/*<       INTEGER PGMNCI(PGMAXD) >*/
/*<       INTEGER PGMXCI(PGMAXD) >*/
/*<       INTEGER PGITF (PGMAXD) >*/
/*<       REAL    PGHSA (PGMAXD) >*/
/*<       REAL    PGHSS (PGMAXD) >*/
/*<       REAL    PGHSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Viewport parameters (indexed by device identification); all are device */
/* coordinates: */
/* ----------------------------------------------------------------------- */
/* PGXOFF  X coordinate of blc of viewport. */
/* PGYOFF  Y coordinate of blc of viewport. */
/* PGXVP   X coordinate of blc of viewport, relative to blc of subpage. */
/* PGYVP   Y coordinate of blc of viewport, relative to blc of subpage. */
/* PGXLEN  Width of viewport. */
/* PGYLEN  Height of viewport. */

/*<       REAL   PGXOFF(PGMAXD), PGYOFF(PGMAXD) >*/
/*<       REAL   PGXVP (PGMAXD), PGYVP (PGMAXD) >*/
/*<       REAL   PGXLEN(PGMAXD), PGYLEN(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Scaling parameters (indexed by device identification): */
/* ----------------------------------------------------------------------- */
/* PGXORG  device coordinate value corresponding to world X=0 */
/* PGYORG  device coordinate value corresponding to world Y=0 */
/* PGXSCL  scale in x (device units per world coordinate unit) */
/* PGYSCL  scale in y (device units per world coordinate unit) */
/* PGXPIN  device x scale in device units/inch */
/* PGYPIN  device y scale in device units/inch */
/* PGXSP   Character X spacing (device units) */
/* PGYSP   Character Y spacing (device units) */

/*<       REAL   PGXORG(PGMAXD), PGYORG(PGMAXD) >*/
/*<       REAL   PGXSCL(PGMAXD), PGYSCL(PGMAXD) >*/
/*<       REAL   PGXPIN(PGMAXD), PGYPIN(PGMAXD) >*/
/*<       REAL   PGXSP (PGMAXD), PGYSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Window parameters (indexed by device identification); all are world */
/* coordinate values: */
/* ----------------------------------------------------------------------- */
/* PGXBLC  world X at bottom left corner of window */
/* PGXTRC  world X at top right corner of window */
/* PGYBLC  world Y at bottom left corner of window */
/* PGYTRC  world Y at top right corner of window */

/*<       REAL    PGXBLC(PGMAXD), PGXTRC(PGMAXD) >*/
/*<       REAL    PGYBLC(PGMAXD), PGYTRC(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* The following parameters are used in the contouring routines to pass */
/* information to the action routine. They do not need to be indexed. */
/* ----------------------------------------------------------------------- */
/* TRANS   Transformation matrix for contour plots; copied */
/*         from argument list by PGCONT and used by PGCP. */

/*<       INTEGER PGCINT, PGCMIN >*/
/*<       REAL    TRANS(6) >*/
/*<       CHARACTER*32 PGCLAB >*/
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*<    >*/
/*<       COMMON  /PGPLT2/ PGCLAB >*/
/*<       SAVE    /PGPLT1/ >*/
/*<       SAVE    /PGPLT2/ >*/
/* ----------------------------------------------------------------------- */
/*<       REAL RATIO >*/
/*                                        Conversion factor inches -> mm */
/*<       REAL INTOMM >*/
/*<       PARAMETER (INTOMM=25.4) >*/
/* ----------------------------------------------------------------------- */
/*<       IF (PGNOTO('PGQCS')) RETURN >*/
    if (pgnoto_("PGQCS", (ftnlen)5)) {
	return 0;
    }
/*<       RATIO = PGYPIN(PGID)/PGXPIN(PGID) >*/
    ratio = pgplt1_1.pgypin[pgplt1_1.pgid - 1] / pgplt1_1.pgxpin[
	    pgplt1_1.pgid - 1];

/* Return the character height in the required units. */

/*                                        Inches. */
/*<       IF (UNITS.EQ.1) THEN >*/
    if (*units == 1) {
/*<         XCH = PGYSP(PGID)/PGXPIN(PGID) >*/
	*xch = pgplt1_1.pgysp[pgplt1_1.pgid - 1] / pgplt1_1.pgxpin[
		pgplt1_1.pgid - 1];
/*<         YCH = XCH >*/
	*ych = *xch;
/*                                        Millimeters. */
/*<       ELSE IF (UNITS.EQ.2) THEN >*/
    } else if (*units == 2) {
/*<         XCH = PGYSP(PGID)/PGXPIN(PGID) * INTOMM >*/
	*xch = pgplt1_1.pgysp[pgplt1_1.pgid - 1] / pgplt1_1.pgxpin[
		pgplt1_1.pgid - 1] * (float)25.4;
/*<         YCH = XCH >*/
	*ych = *xch;
/*                                        Pixels. */
/*<       ELSE IF (UNITS.EQ.3) THEN >*/
    } else if (*units == 3) {
/*<         XCH = PGYSP(PGID) >*/
	*xch = pgplt1_1.pgysp[pgplt1_1.pgid - 1];
/*<         YCH = PGYSP(PGID)*RATIO >*/
	*ych = pgplt1_1.pgysp[pgplt1_1.pgid - 1] * ratio;
/*                                        World coordinates. */
/*<       ELSE IF (UNITS.EQ.4) THEN >*/
    } else if (*units == 4) {
/*<          XCH = PGYSP(PGID)/PGXSCL(PGID) >*/
	*xch = pgplt1_1.pgysp[pgplt1_1.pgid - 1] / pgplt1_1.pgxscl[
		pgplt1_1.pgid - 1];
/*<          YCH = PGYSP(PGID)*RATIO/PGYSCL(PGID) >*/
	*ych = pgplt1_1.pgysp[pgplt1_1.pgid - 1] * ratio / pgplt1_1.pgyscl[
		pgplt1_1.pgid - 1];
/*                                        Normalized device coords, or */
/*                                        unknown. */
/*<       ELSE >*/
    } else {
/*<         XCH = PGYSP(PGID)/PGXSZ(PGID) >*/
	*xch = pgplt1_1.pgysp[pgplt1_1.pgid - 1] / pgplt1_1.pgxsz[
		pgplt1_1.pgid - 1];
/*<         YCH = PGYSP(PGID)*RATIO/PGYSZ(PGID) >*/
	*ych = pgplt1_1.pgysp[pgplt1_1.pgid - 1] * ratio / pgplt1_1.pgysz[
		pgplt1_1.pgid - 1];
/*<    >*/
	if (*units != 0) {
	    grwarn_("Invalid \"UNITS\" argument in PGQCS.", (ftnlen)34);
	}
/*<       END IF >*/
    }
/*<       END >*/
} /* pgqcs_ */

