/* /work2/ssa/pgplot/src/pgrnd.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static real c_b2 = (float)10.;

/* *PGRND -- find the smallest `round' number greater than x */
/* %float cpgrnd(float x, int *nsub); */
/* + */
/*<       REAL FUNCTION PGRND (X, NSUB) >*/
doublereal pgrnd_(x, nsub)
real *x;
integer *nsub;
{
    /* Initialized data */

    static real nice[3] = { (float)2.,(float)5.,(float)10. };

    /* System generated locals */
    real ret_val, r__1;

    /* Builtin functions */
    double r_lg10(), pow_ri(), r_sign();

    /* Local variables */
    static real frac;
    static integer ilog;
    static real xlog;
    static integer i__;
    static real xx, pwr;

/*<       REAL X >*/
/*<       INTEGER NSUB >*/

/* Routine to find the smallest "round" number larger than x, a */
/* "round" number being 1, 2 or 5 times a power of 10. If X is negative, */
/* PGRND(X) = -PGRND(ABS(X)). eg PGRND(8.7) = 10.0, */
/* PGRND(-0.4) = -0.5.  If X is zero, the value returned is zero. */
/* This routine is used by PGBOX for choosing  tick intervals. */

/* Returns: */
/*  PGRND         : the "round" number. */
/* Arguments: */
/*  X      (input)  : the number to be rounded. */
/*  NSUB   (output) : a suitable number of subdivisions for */
/*                    subdividing the "nice" number: 2 or 5. */
/* -- */
/*  6-Sep-1989 - Changes for standard Fortran-77 [TJP]. */
/*  2-Dec-1991 - Fix for bug found on Fujitsu [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER  I,ILOG >*/
/*<       REAL     FRAC,NICE(3),PWR,XLOG,XX >*/
/*<       INTRINSIC ABS, LOG10, SIGN >*/
/*<       DATA     NICE/2.0,5.0,10.0/ >*/

/*<       IF (X.EQ.0.0) THEN >*/
    if (*x == (float)0.) {
/*<           PGRND = 0.0 >*/
	ret_val = (float)0.;
/*<           NSUB = 2 >*/
	*nsub = 2;
/*<           RETURN >*/
	return ret_val;
/*<       END IF >*/
    }
/*<       XX   = ABS(X) >*/
    xx = dabs(*x);
/*<       XLOG = LOG10(XX) >*/
    xlog = r_lg10(&xx);
/*<       ILOG = XLOG >*/
    ilog = xlog;
/*<       IF (XLOG.LT.0) ILOG=ILOG-1 >*/
    if (xlog < (float)0.) {
	--ilog;
    }
/*<       PWR  = 10.0**ILOG >*/
    pwr = pow_ri(&c_b2, &ilog);
/*<       FRAC = XX/PWR >*/
    frac = xx / pwr;
/*<       I = 3 >*/
    i__ = 3;
/*<       IF (FRAC.LE.NICE(2)) I = 2 >*/
    if (frac <= nice[1]) {
	i__ = 2;
    }
/*<       IF (FRAC.LE.NICE(1)) I = 1 >*/
    if (frac <= nice[0]) {
	i__ = 1;
    }
/*<       PGRND = SIGN(PWR*NICE(I),X) >*/
    r__1 = pwr * nice[i__ - 1];
    ret_val = r_sign(&r__1, x);
/*<       NSUB = 5 >*/
    *nsub = 5;
/*<       IF (I.EQ.1) NSUB = 2 >*/
    if (i__ == 1) {
	*nsub = 2;
    }
/*<       END >*/
    return ret_val;
} /* pgrnd_ */

