/* /work2/ssa/pgplot/src/pgtbox.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static logical c_true = TRUE_;
static logical c_false = FALSE_;
static real c_b63 = (float)60.;
static real c_b64 = (float)3600.;
static real c_b65 = (float)86400.;
static integer c__19 = 19;
static integer c__0 = 0;
static integer c__8 = 8;
static integer c__10 = 10;
static integer c__6 = 6;
static integer c_n1 = -1;
static integer c__4 = 4;
static integer c__2 = 2;
static integer c__5 = 5;
static integer c__1 = 1;
static integer c__3 = 3;

/* *PGTBOX -- draw frame and write (DD) HH MM SS.S labelling */
/* %void cpgtbox(const char *xopt, float xtick, int nxsub, \ */
/* % const char *yopt, float ytick, int nysub); */
/* + */
/*<       SUBROUTINE PGTBOX (XOPT, XTICK, NXSUB, YOPT, YTICK, NYSUB) >*/
/* Subroutine */ int pgtbox_(xopt, xtick, nxsub, yopt, ytick, nysub, xopt_len,
	 yopt_len)
char *xopt;
real *xtick;
integer *nxsub;
char *yopt;
real *ytick;
integer *nysub;
ftnlen xopt_len;
ftnlen yopt_len;
{
    /* System generated locals */
    real r__1;

    /* Builtin functions */
    integer i_indx();
    /* Subroutine */ int s_copy();

    /* Local variables */
    static logical mod24;
    static real xmin, ymin, xmax, ymax;
    extern /* Subroutine */ int pgbox_();
    static logical xtime, ytime, first;
    static char xxopt[15], yyopt[15];
    extern /* Subroutine */ int pgtbx1_(), pgtbx4_();
    static logical dopara;
    static real xtickd, ytickd;
    static logical dodayx, dodayy;
    static integer tscalx, tscaly;
    extern /* Subroutine */ int grwarn_();
    static integer nxsubd, nysubd;
    static logical do2;
    extern /* Subroutine */ int pgqwin_(), grtoup_();
    static char suptyp[4];
    static integer ipt;


/*<       REAL XTICK, YTICK >*/
/*<       INTEGER NXSUB, NYSUB >*/
/*<       CHARACTER XOPT*(*), YOPT*(*) >*/

/* Draw a box and optionally label one or both axes with (DD) HH MM SS */
/* style numeric labels (useful for time or RA - DEC plots).   If this */
/* style of labelling is desired, then PGSWIN should have been called */
/* previously with the extrema in SECONDS of time. */

/* In the seconds field, you can have at most 3 places after the decimal */
/* point, so that 1 ms is the smallest time interval you can time label. */

/* Large numbers are coped with by fields of 6 characters long.  Thus */
/* you could have times with days or hours as big as 999999.  However, */
/* in practice, you might have trouble with labels overwriting  themselves */
/* with such large numbers unless you a) use a small time INTERVAL, */
/* b) use a small character size or c) choose your own sparse ticks in */
/* the call to PGTBOX. */

/* PGTBOX will attempt, when choosing its own ticks, not to overwrite */
/* the labels, but this algorithm is not very bright and may fail. */

/* Note that small intervals but large absolute times such as */
/* TMIN = 200000.0 s and TMAX=200000.1 s will cause the algorithm */
/* to fail.  This is inherent in PGPLOT's use of single precision */
/* and cannot be avoided.  In such cases, you should use relative */
/* times if possible. */

/* PGTBOX's labelling philosophy is that the left-most or bottom tick of */
/* the axis contains a full label.  Thereafter, only changing fields are */
/* labelled.  Negative fields are given a '-' label, positive fields */
/* have none.   Axes that have the DD (or HH if the day field is not */
/* used) field on each major tick carry the sign on each field.  If the */
/* axis crosses zero, the zero tick will carry a full label and sign. */

/* This labelling style can cause a little confusion with some special */
/* cases, but as long as you know its philosophy, the truth can be divined. */
/* Consider an axis with TMIN=20s, TMAX=-20s.   The labels will look like */

/*        +----------+----------+----------+----------+ */
/*     0h0m20s      10s      -0h0m0s      10s        20s */

/* Knowing that the left field always has a full label and that */
/* positive fields are unsigned, informs that time is decreasing */
/* from left to right, not vice versa.   This can become very */
/* unclear if you have used the 'F' option, but that is your problem ! */

/* Exceptions to this labelling philosophy are when the finest time */
/* increment being displayed is hours (with option 'Y') or days. */
/* Then all fields carry a label.  For example, */

/*        +----------+----------+----------+----------+ */
/*      -10h        -8h        -6h        -4h        -2h */


/* PGTBOX can be used in place of PGBOX; it calls PGBOX and only invokes */
/* time labelling if requested. Other options are passed intact to PGBOX. */

/* Inputs: */
/*  XOPT   :  X-options for PGTBOX.  Same as for PGBOX plus */

/*             'Z' for (DD) HH MM SS.S time labelling */
/*             'Y' means don't include the day field so that labels */
/*                 are HH MM SS.S rather than DD HH MM SS.S   The hours */
/*                 will accumulate beyond 24 if necessary in this case. */
/*             'X' label the HH field as modulo 24.  Thus, a label */
/*                 such as 25h 10m would come out as 1h 10m */
/*             'H' means superscript numbers with d, h, m, & s  symbols */
/*             'D' means superscript numbers with    o, ', & '' symbols */
/*             'F' causes the first label (left- or bottom-most) to */
/*                 be omitted. Useful for sub-panels that abut each other. */
/*                 Care is needed because first label carries sign as well. */
/*             'O' means omit leading zeros in numbers < 10 */
/*                 E.g.  3h 3m 1.2s rather than 03h 03m 01.2s  Useful */
/*                 to help save space on X-axes. The day field does not */
/*                 use this facility. */

/*  YOPT   :  Y-options for PGTBOX.  See above. */
/*  XTICK  :  X-axis major tick increment.  0.0 for default. */
/*  YTICK  :  Y-axis major tick increment.  0.0 for default. */
/*            If the 'Z' option is used then XTICK and/or YTICK must */
/*            be in seconds. */
/*  NXSUB  :  Number of intervals for minor ticks on X-axis. 0 for default */
/*  NYSUB  :  Number of intervals for minor ticks on Y-axis. 0 for default */

/*  The regular XOPT and YOPT axis options for PGBOX are */

/*  A : draw Axis (X axis is horizontal line Y=0, Y axis is vertical */
/*      line X=0). */
/*  B : draw bottom (X) or left (Y) edge of frame. */
/*  C : draw top (X) or right (Y) edge of frame. */
/*  G : draw Grid of vertical (X) or horizontal (Y) lines. */
/*  I : Invert the tick marks; ie draw them outside the viewport */
/*      instead of inside. */
/*  L : label axis Logarithmically (see below). */
/*  N : write Numeric labels in the conventional location below the */
/*      viewport (X) or to the left of the viewport (Y). */
/*  P : extend ("Project") major tick marks outside the box (ignored if */
/*      option I is specified). */
/*  M : write numeric labels in the unconventional location above the */
/*      viewport (X) or to the right of the viewport (Y). */
/*  T : draw major Tick marks at the major coordinate interval. */
/*  S : draw minor tick marks (Subticks). */
/*  V : orient numeric labels Vertically. This is only applicable to Y. */
/*      The default is to write Y-labels parallel to the axis. */
/*  1 : force decimal labelling, instead of automatic choice (see PGNUMB). */
/*  2 : force exponential labelling, instead of automatic. */

/*      The default is to write Y-labels parallel to the axis */


/*        ******************        EXCEPTIONS       ******************* */

/*        Note that */
/*          1) PGBOX option 'L' (log labels) is ignored with option 'Z' */
/*          2) The 'O' option will be ignored for the 'V' option as it */
/*             makes it impossible to align the labels nicely */
/*          3) Option 'Y' is forced with option 'D' */

/*        *************************************************************** */


/* -- */
/* 05-Sep-1988 - new routine (Neil Killeen) */
/* 20-Apr-1991 - add support for new DD (day) field and implement */
/*               labelling on any axis (bottom,top,left,right) [nebk] */
/* 10-Jun-1993 - add option 'O' for leading zeros, correctly deal with */
/*               user ticks, fully support 'V' and 'NM' options, modify */
/*               slightly meaning of 'F' option [nebk] */
/* 16-Jan-1995 - add option 'X' [nebk] */
/* 16-Aug-1996 - Bring axis labelling displacements more in line with */
/*               those of pgbox.f [nebk] */
/* ----------------------------------------------------------------------- */
/*<       REAL XTICKD, YTICKD, XMIN, XMAX, YMIN, YMAX >*/
/*<       INTEGER IPT, TSCALX, TSCALY, NXSUBD, NYSUBD >*/
/*<       CHARACTER XXOPT*15, YYOPT*15, SUPTYP*4 >*/
/*<       LOGICAL XTIME, YTIME, FIRST, DODAYX, DODAYY, DO2, DOPARA, MOD24 >*/
/* ------------------------------------------------------------------------ */

/*  Copy inputs */

/*<       XTICKD = XTICK >*/
    xtickd = *xtick;
/*<       YTICKD = YTICK >*/
    ytickd = *ytick;
/*<       NXSUBD = NXSUB >*/
    nxsubd = *nxsub;
/*<       NYSUBD = NYSUB >*/
    nysubd = *nysub;

/*  Get window in world coordinates */

/*<       CALL PGQWIN (XMIN, XMAX, YMIN, YMAX) >*/
    pgqwin_(&xmin, &xmax, &ymin, &ymax);

/*  X-axis first */

/*<       CALL GRTOUP (XXOPT, XOPT) >*/
    grtoup_(xxopt, xopt, (ftnlen)15, xopt_len);
/*<       XTIME = .FALSE. >*/
    xtime = FALSE_;
/*<       IF (INDEX(XXOPT,'Z').NE.0) THEN >*/
    if (i_indx(xxopt, "Z", (ftnlen)15, (ftnlen)1) != 0) {

/*  Work out units for labelling and find the tick increments. */

/*<         IF (ABS(XMAX-XMIN).LT.0.001) THEN >*/
	if ((r__1 = xmax - xmin, dabs(r__1)) < (float).001) {
/*<    >*/
	    grwarn_("PGTBOX: X-axis time interval too small (< 1 ms) for tim\
e labels", (ftnlen)63);
/*<         ELSE >*/
	} else {
/*<           XTIME = .TRUE. >*/
	    xtime = TRUE_;
/*<           DODAYX = .TRUE. >*/
	    dodayx = TRUE_;
/*<    >*/
	    if (i_indx(xxopt, "Y", (ftnlen)15, (ftnlen)1) != 0 || i_indx(
		    xxopt, "D", (ftnlen)15, (ftnlen)1) != 0) {
		dodayx = FALSE_;
	    }

/*<           DOPARA = .TRUE. >*/
	    dopara = TRUE_;
/*<    >*/
	    pgtbx1_("X", &dodayx, &dopara, &xmin, &xmax, &xtickd, &nxsubd, &
		    tscalx, (ftnlen)1);
/*<         END IF >*/
	}
/*<       END IF >*/
    }

/*  Same again for Y-axis */

/*<       CALL GRTOUP (YYOPT, YOPT) >*/
    grtoup_(yyopt, yopt, (ftnlen)15, yopt_len);
/*<       YTIME = .FALSE. >*/
    ytime = FALSE_;
/*<       IF (INDEX(YYOPT,'Z').NE.0) THEN >*/
    if (i_indx(yyopt, "Z", (ftnlen)15, (ftnlen)1) != 0) {
/*<         IF (ABS(YMAX-YMIN).LT.0.001) THEN >*/
	if ((r__1 = ymax - ymin, dabs(r__1)) < (float).001) {
/*<    >*/
	    grwarn_("PGTBOX: Y-axis time interval too small (< 1ms) for time\
 labels", (ftnlen)62);
/*<         ELSE >*/
	} else {
/*<           YTIME = .TRUE. >*/
	    ytime = TRUE_;
/*<           DODAYY = .TRUE. >*/
	    dodayy = TRUE_;
/*<    >*/
	    if (i_indx(yyopt, "Y", (ftnlen)15, (ftnlen)1) != 0 || i_indx(
		    yyopt, "D", (ftnlen)15, (ftnlen)1) != 0) {
		dodayy = FALSE_;
	    }

/*<           DOPARA = .TRUE. >*/
	    dopara = TRUE_;
/*<           IF (INDEX(YYOPT,'V').NE.0) DOPARA = .FALSE. >*/
	    if (i_indx(yyopt, "V", (ftnlen)15, (ftnlen)1) != 0) {
		dopara = FALSE_;
	    }

/*<    >*/
	    pgtbx1_("Y", &dodayy, &dopara, &ymin, &ymax, &ytickd, &nysubd, &
		    tscaly, (ftnlen)1);
/*<         END IF >*/
	}
/*<       END IF >*/
    }

/*  Parse options list.  For call to PGBOX when doing time labelling, we */
/*  don't want L (log), N or M (write numeric labels). */

/*<       IF (XTIME) THEN >*/
    if (xtime) {
/*<         IPT = INDEX(XXOPT,'L') >*/
	ipt = i_indx(xxopt, "L", (ftnlen)15, (ftnlen)1);
/*<         IF (IPT.NE.0) XXOPT(IPT:IPT) = ' ' >*/
	if (ipt != 0) {
	    *(unsigned char *)&xxopt[ipt - 1] = ' ';
	}
/*<         IPT = INDEX(XXOPT,'N') >*/
	ipt = i_indx(xxopt, "N", (ftnlen)15, (ftnlen)1);
/*<         IF (IPT.NE.0) XXOPT(IPT:IPT) = ' ' >*/
	if (ipt != 0) {
	    *(unsigned char *)&xxopt[ipt - 1] = ' ';
	}
/*<         IPT = INDEX(XXOPT,'M') >*/
	ipt = i_indx(xxopt, "M", (ftnlen)15, (ftnlen)1);
/*<         IF (IPT.NE.0) XXOPT(IPT:IPT) = ' ' >*/
	if (ipt != 0) {
	    *(unsigned char *)&xxopt[ipt - 1] = ' ';
	}
/*<       END IF >*/
    }

/*<       IF (YTIME) THEN >*/
    if (ytime) {
/*<         IPT = INDEX(YYOPT,'L') >*/
	ipt = i_indx(yyopt, "L", (ftnlen)15, (ftnlen)1);
/*<         IF (IPT.NE.0) YYOPT(IPT:IPT) = ' ' >*/
	if (ipt != 0) {
	    *(unsigned char *)&yyopt[ipt - 1] = ' ';
	}
/*<         IPT = INDEX(YYOPT,'N') >*/
	ipt = i_indx(yyopt, "N", (ftnlen)15, (ftnlen)1);
/*<         IF (IPT.NE.0) YYOPT(IPT:IPT) = ' ' >*/
	if (ipt != 0) {
	    *(unsigned char *)&yyopt[ipt - 1] = ' ';
	}
/*<         IPT = INDEX(YYOPT,'M') >*/
	ipt = i_indx(yyopt, "M", (ftnlen)15, (ftnlen)1);
/*<         IF (IPT.NE.0) YYOPT(IPT:IPT) = ' ' >*/
	if (ipt != 0) {
	    *(unsigned char *)&yyopt[ipt - 1] = ' ';
	}
/*<       END IF >*/
    }

/*  Draw box and ticks */

/*<       CALL PGBOX (XXOPT, XTICKD, NXSUBD, YYOPT, YTICKD, NYSUBD) >*/
    pgbox_(xxopt, &xtickd, &nxsubd, yyopt, &ytickd, &nysubd, (ftnlen)15, (
	    ftnlen)15);

/*  Add (DD) HH MM SS labels if desired.  Go back to the original user */
/*  specified options list. */

/*<       XXOPT = ' ' >*/
    s_copy(xxopt, " ", (ftnlen)15, (ftnlen)1);
/*<       CALL GRTOUP (XXOPT, XOPT) >*/
    grtoup_(xxopt, xopt, (ftnlen)15, xopt_len);
/*<    >*/
    if (xtime && (i_indx(xxopt, "N", (ftnlen)15, (ftnlen)1) != 0 || i_indx(
	    xxopt, "M", (ftnlen)15, (ftnlen)1) != 0)) {
/*<         FIRST = .TRUE. >*/
	first = TRUE_;
/*<         IF (INDEX(XXOPT,'F').NE.0) FIRST = .FALSE. >*/
	if (i_indx(xxopt, "F", (ftnlen)15, (ftnlen)1) != 0) {
	    first = FALSE_;
	}

/*<         SUPTYP = 'NONE' >*/
	s_copy(suptyp, "NONE", (ftnlen)4, (ftnlen)4);
/*<         IF (INDEX(XXOPT,'D').NE.0) SUPTYP = ' DMS' >*/
	if (i_indx(xxopt, "D", (ftnlen)15, (ftnlen)1) != 0) {
	    s_copy(suptyp, " DMS", (ftnlen)4, (ftnlen)4);
	}
/*<         IF (INDEX(XXOPT,'H').NE.0) SUPTYP = 'DHMS' >*/
	if (i_indx(xxopt, "H", (ftnlen)15, (ftnlen)1) != 0) {
	    s_copy(suptyp, "DHMS", (ftnlen)4, (ftnlen)4);
	}

/*<         DO2 = .TRUE. >*/
	do2 = TRUE_;
/*<         IF (INDEX(XXOPT,'O').NE.0) DO2 = .FALSE. >*/
	if (i_indx(xxopt, "O", (ftnlen)15, (ftnlen)1) != 0) {
	    do2 = FALSE_;
	}

/*<         DOPARA = .TRUE. >*/
	dopara = TRUE_;

/*<         MOD24 = .FALSE. >*/
	mod24 = FALSE_;
/*<         IF (INDEX(XXOPT,'X').NE.0) MOD24 = .TRUE. >*/
	if (i_indx(xxopt, "X", (ftnlen)15, (ftnlen)1) != 0) {
	    mod24 = TRUE_;
	}

/*<    >*/
	if (i_indx(xxopt, "N", (ftnlen)15, (ftnlen)1) != 0) {
	    pgtbx4_(&dodayx, suptyp, "X", &c_true, &first, &xmin, &xmax, &
		    tscalx, &xtickd, &do2, &dopara, &mod24, (ftnlen)4, (
		    ftnlen)1);
	}

/*<    >*/
	if (i_indx(xxopt, "M", (ftnlen)15, (ftnlen)1) != 0) {
	    pgtbx4_(&dodayx, suptyp, "X", &c_false, &first, &xmin, &xmax, &
		    tscalx, &xtickd, &do2, &dopara, &mod24, (ftnlen)4, (
		    ftnlen)1);
	}
/*<       END IF >*/
    }

/*<       YYOPT = ' ' >*/
    s_copy(yyopt, " ", (ftnlen)15, (ftnlen)1);
/*<       CALL GRTOUP (YYOPT, YOPT) >*/
    grtoup_(yyopt, yopt, (ftnlen)15, yopt_len);
/*<    >*/
    if (ytime && (i_indx(yyopt, "N", (ftnlen)15, (ftnlen)1) != 0 || i_indx(
	    yyopt, "M", (ftnlen)15, (ftnlen)1) != 0)) {
/*<         FIRST = .TRUE. >*/
	first = TRUE_;
/*<         IF (INDEX(YYOPT,'F').NE.0) FIRST = .FALSE. >*/
	if (i_indx(yyopt, "F", (ftnlen)15, (ftnlen)1) != 0) {
	    first = FALSE_;
	}

/*<         SUPTYP = 'NONE' >*/
	s_copy(suptyp, "NONE", (ftnlen)4, (ftnlen)4);
/*<         IF (INDEX(YYOPT,'D').NE.0) SUPTYP = ' DMS' >*/
	if (i_indx(yyopt, "D", (ftnlen)15, (ftnlen)1) != 0) {
	    s_copy(suptyp, " DMS", (ftnlen)4, (ftnlen)4);
	}
/*<         IF (INDEX(YYOPT,'H').NE.0) SUPTYP = 'DHMS' >*/
	if (i_indx(yyopt, "H", (ftnlen)15, (ftnlen)1) != 0) {
	    s_copy(suptyp, "DHMS", (ftnlen)4, (ftnlen)4);
	}

/*<         DOPARA = .TRUE. >*/
	dopara = TRUE_;
/*<         IF (INDEX(YYOPT,'V').NE.0) DOPARA = .FALSE. >*/
	if (i_indx(yyopt, "V", (ftnlen)15, (ftnlen)1) != 0) {
	    dopara = FALSE_;
	}

/*<         DO2 = .TRUE. >*/
	do2 = TRUE_;
/*<         IF (DOPARA .AND. INDEX(YYOPT,'O').NE.0) DO2 = .FALSE. >*/
	if (dopara && i_indx(yyopt, "O", (ftnlen)15, (ftnlen)1) != 0) {
	    do2 = FALSE_;
	}

/*<         MOD24 = .FALSE. >*/
	mod24 = FALSE_;
/*<         IF (INDEX(YYOPT,'X').NE.0) MOD24 = .TRUE. >*/
	if (i_indx(yyopt, "X", (ftnlen)15, (ftnlen)1) != 0) {
	    mod24 = TRUE_;
	}

/*<    >*/
	if (i_indx(yyopt, "N", (ftnlen)15, (ftnlen)1) != 0) {
	    pgtbx4_(&dodayy, suptyp, "Y", &c_true, &first, &ymin, &ymax, &
		    tscaly, &ytickd, &do2, &dopara, &mod24, (ftnlen)4, (
		    ftnlen)1);
	}

/*<    >*/
	if (i_indx(yyopt, "M", (ftnlen)15, (ftnlen)1) != 0) {
	    pgtbx4_(&dodayy, suptyp, "Y", &c_false, &first, &ymin, &ymax, &
		    tscaly, &ytickd, &do2, &dopara, &mod24, (ftnlen)4, (
		    ftnlen)1);
	}

/*<       END IF >*/
    }

/*<       RETURN >*/
    return 0;
/*<       END >*/
} /* pgtbox_ */

/* PGTBX1 -- support routine for PGTBOX */

/*<    >*/
/* Subroutine */ int pgtbx1_(axis, doday, dopara, tmin, tmax, tick, nsub, 
	tscale, axis_len)
char *axis;
logical *doday, *dopara;
real *tmin, *tmax, *tick;
integer *nsub, *tscale;
ftnlen axis_len;
{
    /* Initialized data */

    static real ticks1[19] = { (float).001,(float).002,(float).005,(float).01,
	    (float).02,(float).05,(float).1,(float).2,(float).5,(float)1.,(
	    float)2.,(float)3.,(float)4.,(float)5.,(float)6.,(float)10.,(
	    float)15.,(float)20.,(float)30. };
    static integer nsubs1[19] = { 4,4,2,4,4,2,4,4,2,4,4,3,4,5,3,2,3,2,3 };
    static real ticks2[10] = { (float)1.,(float)2.,(float)3.,(float)4.,(float)
	    5.,(float)6.,(float)10.,(float)15.,(float)20.,(float)30. };
    static integer nsubs2[10] = { 4,4,3,4,5,3,2,3,2,3 };
    static real ticks3[6] = { (float)1.,(float)2.,(float)3.,(float)4.,(float)
	    6.,(float)12. };
    static integer nsubs3[6] = { 4,4,3,4,3,2 };
    static real ticks4[8] = { (float)1.,(float)2.,(float)3.,(float)4.,(float)
	    5.,(float)6.,(float)8.,(float)9. };
    static integer nsubs4[8] = { 4,4,3,4,5,3,4,3 };

    /* System generated locals */
    integer i__1;
    real r__1, r__2;

    /* Builtin functions */
    double r_mod();
    /* Subroutine */ int s_copy();
    integer i_nint(), pow_ii();

    /* Local variables */
    static real tock, tint, tock2;
    static integer itick, ntick;
    extern /* Subroutine */ int pgnpl_();
    static real tmins, tmaxs, tints;
    extern /* Subroutine */ int pgtbx2_(), pgtbx3_(), grwarn_();
    static integer strlen, npl;
    static char str[15];


/*<       REAL TMIN, TMAX, TICK >*/
/*<       INTEGER NSUB, TSCALE >*/
/*<       LOGICAL DODAY, DOPARA >*/
/*<       CHARACTER AXIS*1 >*/

/* Work out what the finest units the time labels will be in and */
/* return the tick increments if the user does not set them. */

/* This is a support routine for PGTBOX and should not */
/* be called by the user. */

/* Input: */
/*  AXIS   :  'X' or 'Y' for use in determining if labels overwrite */
/*  TMIN   :  Start time in seconds */
/*  TMAX   :  End   time in seconds */
/*  DOPARA :  True if label to be parallel to axis, else perpendicular */
/* Input/output: */
/*  DODAY  :  Write labels as DD HH MM SS.S else HH MM SS.S with */
/*            hours ranging above 24.  Useful for declination labels */
/*  TICK   :  Major tick interval in seconds.  If 0.0 on input, will */
/*            be set here. */
/*  NSUB   :  Number of minor ticks between major ticks. If 0 on input */
/*            will be set here. */
/* Outputs: */
/*  TSCALE :  Determines finest unit of labelling */
/*            (1 => ss, 60 => mm, 3600 => hh, 3600*24 => dd) */

/* 05-Sep-1988 - new routine (Neil Killeen) */
/* 08-Apr-1991 - correctly work out HH MM SS when the time > 60 h [nebk] */
/* 20-Apr-1991 - revise to add support for new DD (day) field and */
/*               do lots of work on tick algorithm [nebk] */
/* 10-Jun-1993 - deal with user given ticks & rename from PGTIME [nebk/jm] */
/* ----------------------------------------------------------------------- */
/*<       INTEGER NLIST1, NLIST2, NLIST3, NLIST4, NTICMX >*/
/*<    >*/

/*<    >*/
/*<    >*/
/*<       CHARACTER STR*15 >*/

/*<       SAVE TICKS1, TICKS2, TICKS3, TICKS4 >*/
/*<       SAVE NSUBS1, NSUBS2, NSUBS3, NSUBS4 >*/

/*<    >*/
/*<    >*/

/*<    >*/
/*<    >*/

/*<       DATA TICKS3 /1.0,    2.0,   3.0,    4.0,    6.0,   12.0/ >*/
/*<       DATA NSUBS3 / 4,      4,     3,      4,      3,      2/ >*/

/*<       DATA TICKS4 /1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 8.0, 9.0/ >*/
/*<       DATA NSUBS4 / 4,   4,   3,   4,   5,   3,   4,   3 / >*/
/* ---------------------------------------------------------------------- */

/*  Turn off DD (day) field if it has been unnecessarily asked for */

/*<    >*/
    if (dabs(*tmin) < (float)86400. && dabs(*tmax) < (float)86400.) {
	*doday = FALSE_;
    }

/*  If a tick size is provided, use it to determine TSCALE */

/*<       TINT = ABS(TMAX - TMIN) >*/
    tint = (r__1 = *tmax - *tmin, dabs(r__1));
/*<       TICK = ABS(TICK) >*/
    *tick = dabs(*tick);
/*<       IF (TICK.NE.0.0) THEN >*/
    if (*tick != (float)0.) {
/*<         IF (TICK.GE.TINT) THEN >*/
	if (*tick >= tint) {
/*<    >*/
	    grwarn_("PGTBX1: user given tick bigger than time interval; will\
 auto-tick", (ftnlen)65);
/*<           TICK = 0.0 >*/
	    *tick = (float)0.;
/*<         ELSE IF (TICK.LT.0.001) THEN >*/
	} else if (*tick < (float).001) {
/*<    >*/
	    grwarn_("PGTBX1: user given tick too small (< 1 ms); will auto-t\
ick", (ftnlen)58);
/*<           TICK = 0.0 >*/
	    *tick = (float)0.;
/*<         ELSE  >*/
	} else {
/*<           IF (MOD(TICK, 60.0) .NE. 0.0) THEN >*/
	    if (r_mod(tick, &c_b63) != (float)0.) {
/*<             TSCALE = 1 >*/
		*tscale = 1;
/*<           ELSE IF (MOD(TICK, 3600.0).NE.0.0) THEN >*/
	    } else if (r_mod(tick, &c_b64) != (float)0.) {
/*<             TSCALE = 60 >*/
		*tscale = 60;
/*<           ELSE IF (.NOT.DODAY) THEN >*/
	    } else if (! (*doday)) {
/*<             TSCALE = 3600 >*/
		*tscale = 3600;
/*<           ELSE IF (MOD(TICK,(24.0*3600.0)).NE.0.0) THEN >*/
	    } else if (r_mod(tick, &c_b65) != (float)0.) {
/*<             TSCALE = 3600 >*/
		*tscale = 3600;
/*<           ELSE >*/
	    } else {
/*<             TSCALE = 24 * 3600 >*/
		*tscale = 86400;
/*<           ENDIF >*/
	    }

/*  Make a simple default for the number of minor ticks and bug out */

/*<           IF (NSUB.EQ.0) NSUB = 2 >*/
	    if (*nsub == 0) {
		*nsub = 2;
	    }
/*<           RETURN >*/
	    return 0;
/*<         END IF >*/
	}
/*<       END IF >*/
    }

/*  Work out label units depending on time interval if user */
/*  wants auto-ticking */

/*<       IF (TINT.LE.5*60) THEN >*/
    if (tint <= (float)300.) {
/*<         TSCALE = 1 >*/
	*tscale = 1;
/*<       ELSE IF (TINT.LE.5*3600) THEN >*/
    } else if (tint <= (float)1.8e4) {
/*<         TSCALE = 60 >*/
	*tscale = 60;
/*<       ELSE  >*/
    } else {
/*<         IF (.NOT.DODAY) THEN >*/
	if (! (*doday)) {
/*<           TSCALE = 3600 >*/
	    *tscale = 3600;
/*<         ELSE >*/
	} else {
/*<           IF (TINT.LE.5*24*3600) THEN >*/
	    if (tint <= (float)4.32e5) {
/*<             TSCALE = 3600 >*/
		*tscale = 3600;
/*<           ELSE >*/
	    } else {
/*<             TSCALE = 3600*24 >*/
		*tscale = 86400;
/*<           END IF >*/
	    }
/*<         END IF >*/
	}
/*<       END IF >*/
    }

/* CCCC */
/*  Divide interval into NTICK major ticks and NSUB minor intervals */
/*  The tick choosing algorithm is not very robust, so watch out */
/*  if you fiddle anything. */
/* CCCC */

/*<       TINTS = TINT / TSCALE >*/
    tints = tint / *tscale;
/*<       IF (TSCALE.EQ.1) THEN >*/
    if (*tscale == 1) {

/*  Time in seconds.  If the time interval is very small, may need to */
/*  label with up to 3 decimal places.  Have less ticks to help prevent */
/*  label overwrite. STR is a dummy tick label to assess label */
/*  overwrite potential */

/*<         IF (DOPARA) THEN >*/
	if (*dopara) {
/*<           IF (TINTS.LE.0.01) THEN >*/
	    if (tints <= (float).01) {
/*<             NTICK = 4 >*/
		ntick = 4;
/*<             STR = '60.423' >*/
		s_copy(str, "60.423", (ftnlen)15, (ftnlen)6);
/*<             STRLEN = 6 >*/
		strlen = 6;
/*<           ELSE IF (TINTS.LE.0.1) THEN >*/
	    } else if (tints <= (float).1) {
/*<             NTICK = 5 >*/
		ntick = 5;
/*<             STR = '60.42' >*/
		s_copy(str, "60.42", (ftnlen)15, (ftnlen)5);
/*<             STRLEN = 5 >*/
		strlen = 5;
/*<           ELSE IF (TINTS.LE.1.0) THEN >*/
	    } else if (tints <= (float)1.) {
/*<             NTICK = 6 >*/
		ntick = 6;
/*<             STR = '60.4' >*/
		s_copy(str, "60.4", (ftnlen)15, (ftnlen)4);
/*<             STRLEN = 4 >*/
		strlen = 4;
/*<           ELSE >*/
	    } else {
/*<             NTICK = 6 >*/
		ntick = 6;
/*<             STR = '60s' >*/
		s_copy(str, "60s", (ftnlen)15, (ftnlen)3);
/*<             STRLEN = 3 >*/
		strlen = 3;
/*<           END IF >*/
	    }
/*<         ELSE >*/
	} else {
/*<           NTICK = 6 >*/
	    ntick = 6;
/*<           STR = ' ' >*/
	    s_copy(str, " ", (ftnlen)15, (ftnlen)1);
/*<           STRLEN = 1 >*/
	    strlen = 1;
/*<         END IF >*/
	}
/*<         TOCK = TINTS / NTICK >*/
	tock = tints / ntick;

/*  Select nearest tick to TOCK from list. */

/*<         CALL PGTBX2 (TOCK, NLIST1, TICKS1, NSUBS1, TICK, NSUB, ITICK) >*/
	pgtbx2_(&tock, &c__19, ticks1, nsubs1, tick, nsub, &itick);

/*  Check label overwrite and/or too many ticks. */

/*<    >*/
	pgtbx3_(doday, &c__0, tscale, &tints, &c__8, &c__19, ticks1, nsubs1, &
		itick, axis, dopara, str, tick, nsub, (ftnlen)1, strlen);
/*<       ELSE IF (TSCALE.EQ.60) THEN >*/
    } else if (*tscale == 60) {

/*  Time in minutes */

/*<         NTICK = 6 >*/
	ntick = 6;
/*<         TOCK = TINTS / NTICK >*/
	tock = tints / ntick;

/*  Select nearest tick from list */

/*<         CALL PGTBX2 (TOCK, NLIST2, TICKS2, NSUBS2, TICK, NSUB, ITICK) >*/
	pgtbx2_(&tock, &c__10, ticks2, nsubs2, tick, nsub, &itick);

/*  Check label overwrite and/or too many ticks. */

/*<         IF (DOPARA) THEN >*/
	if (*dopara) {
/*<           STR = '42m' >*/
	    s_copy(str, "42m", (ftnlen)15, (ftnlen)3);
/*<           STRLEN = 3 >*/
	    strlen = 3;
/*<         ELSE >*/
	} else {
/*<           STR = ' ' >*/
	    s_copy(str, " ", (ftnlen)15, (ftnlen)1);
/*<           STRLEN = 1 >*/
	    strlen = 1;
/*<         END IF >*/
	}
/*<    >*/
	pgtbx3_(doday, &c__0, tscale, &tints, &c__8, &c__10, ticks2, nsubs2, &
		itick, axis, dopara, str, tick, nsub, (ftnlen)1, strlen);
/*<       ELSE  >*/
    } else {
/*<         IF (TSCALE.EQ.3600 .AND. DODAY) THEN >*/
	if (*tscale == 3600 && *doday) {

/*  Time in hours with the day field */

/*<           NTICK = 6 >*/
	    ntick = 6;
/*<           TOCK = TINTS / NTICK >*/
	    tock = tints / ntick;

/*  Select nearest tick from list */

/*<           CALL PGTBX2 (TOCK, NLIST3, TICKS3, NSUBS3, TICK, NSUB, ITICK) >*/
	    pgtbx2_(&tock, &c__6, ticks3, nsubs3, tick, nsub, &itick);

/*   Check label overwrite and/or too many ticks. */

/*<           IF (DOPARA) THEN >*/
	    if (*dopara) {
/*<             STR = '42h' >*/
		s_copy(str, "42h", (ftnlen)15, (ftnlen)3);
/*<             STRLEN = 3 >*/
		strlen = 3;
/*<           ELSE >*/
	    } else {
/*<             STR = ' ' >*/
		s_copy(str, " ", (ftnlen)15, (ftnlen)1);
/*<             STRLEN = 1 >*/
		strlen = 1;
/*<           END IF >*/
	    }
/*<    >*/
	    pgtbx3_(doday, &c__0, tscale, &tints, &c__8, &c__6, ticks3, 
		    nsubs3, &itick, axis, dopara, str, tick, nsub, (ftnlen)1, 
		    strlen);
/*<         ELSE >*/
	} else {

/*  Time in hours with no day field or time in days. Have less */
/*  ticks for big numbers or the parallel labels will overwrite. */
/*<           IF (DOPARA) THEN >*/
	    if (*dopara) {
/*<             TMINS = ABS(TMIN) / TSCALE >*/
		tmins = dabs(*tmin) / *tscale;
/*<             TMAXS = ABS(TMAX) / TSCALE             >*/
		tmaxs = dabs(*tmax) / *tscale;
/*<             CALL PGNPL (-1, NINT(MAX(TINTS,TMINS,TMAXS)), NPL) >*/
/* Computing MAX */
		r__2 = max(tints,tmins);
		r__1 = dmax(r__2,tmaxs);
		i__1 = i_nint(&r__1);
		pgnpl_(&c_n1, &i__1, &npl);
/*<             IF (NPL.LE.3) THEN >*/
		if (npl <= 3) {
/*<               NTICK = 6 >*/
		    ntick = 6;
/*<             ELSE IF (NPL.EQ.4) THEN >*/
		} else if (npl == 4) {
/*<               NTICK = 5 >*/
		    ntick = 5;
/*<             ELSE >*/
		} else {
/*<               NTICK = 4 >*/
		    ntick = 4;
/*<             END IF >*/
		}
/*<             STR = '345678912' >*/
		s_copy(str, "345678912", (ftnlen)15, (ftnlen)9);
/*<             STR(NPL+1:) = 'd' >*/
		i__1 = npl;
		s_copy(str + i__1, "d", 15 - i__1, (ftnlen)1);
/*<             STRLEN = NPL + 1 >*/
		strlen = npl + 1;
/*<           ELSE >*/
	    } else {
/*<             STR = ' ' >*/
		s_copy(str, " ", (ftnlen)15, (ftnlen)1);
/*<             STRLEN = 1 >*/
		strlen = 1;
/*<             NTICK = 6 >*/
		ntick = 6;
/*<           END IF >*/
	    }
/*<           TOCK = TINTS / NTICK >*/
	    tock = tints / ntick;

/*   Select nearest tick from list; 1 choose nearest nice integer */
/*   scaled by the appropriate power of 10 */

/*<           CALL PGNPL (-1, NINT(TOCK), NPL) >*/
	    i__1 = i_nint(&tock);
	    pgnpl_(&c_n1, &i__1, &npl);
/*<           TOCK2 = TOCK / 10**(NPL-1) >*/
	    i__1 = npl - 1;
	    tock2 = tock / pow_ii(&c__10, &i__1);

/*<           CALL PGTBX2 (TOCK2, NLIST4, TICKS4, NSUBS4, TICK, NSUB, ITICK) >*/
	    pgtbx2_(&tock2, &c__8, ticks4, nsubs4, tick, nsub, &itick);
/*<           TICK = TICK * 10**(NPL-1) >*/
	    i__1 = npl - 1;
	    *tick *= pow_ii(&c__10, &i__1);

/*  Check label overwrite and/or too many ticks. */

/*<    >*/
	    pgtbx3_(doday, &npl, tscale, &tints, &c__8, &c__8, ticks4, nsubs4,
		     &itick, axis, dopara, str, tick, nsub, (ftnlen)1, strlen)
		    ;
/*<         END IF >*/
	}
/*<       END IF >*/
    }

/*  Convert tick to seconds */

/*<       TICK = TICK * TSCALE >*/
    *tick *= *tscale;

/*<       RETURN >*/
    return 0;
/*<       END >*/
} /* pgtbx1_ */

/* PGTBX2 -- support routine for PGTBOX */

/*<       SUBROUTINE PGTBX2 (TOCK, NTICKS, TICKS, NSUBS, TICK, NSUB, ITICK) >*/
/* Subroutine */ int pgtbx2_(tock, nticks, ticks, nsubs, tick, nsub, itick)
real *tock;
integer *nticks;
real *ticks;
integer *nsubs;
real *tick;
integer *nsub, *itick;
{
    /* System generated locals */
    integer i__1;
    real r__1;

    /* Local variables */
    static real diff, dmin__;
    static integer i__, nsubd;


/*<       INTEGER NTICKS, NSUBS(NTICKS), NSUB, ITICK >*/
/*<       REAL TOCK, TICKS(NTICKS), TICK >*/

/* Find the nearest tick in a list to a given value. */

/* This is a support routine for PGTBOX and should not be called */
/* by the user. */

/* Input: */
/*  TOCK   :  Try to find the nearest tick in the list to TOCK */
/*  NTICKS :  Number of ticks in list */
/*  TICKS  :  List of ticks */
/*  NSUBS  :  List of number of minor ticks between ticks to go with TICKS */
/* Output: */
/*  TICK   :  The selected tick */
/*  ITICK  :  The index of the selected tick from the list TICKS */
/* Input/output */
/*  NSUB   :  Number of minor ticks between major ticks. If 0 on input */
/*            will be set here. */

/* 10-Jun-1993 - new routine [nebk] */
/* ----------------------------------------------------------------------- */
/*<       INTEGER I, NSUBD >*/
/*<       REAL DMIN, DIFF >*/
/* ---------------------------------------------------------------------- */
/*<       NSUBD = NSUB >*/
    /* Parameter adjustments */
    --nsubs;
    --ticks;

    /* Function Body */
    nsubd = *nsub;
/*<       DMIN = 1.0E30 >*/
    dmin__ = (float)1e30;
/*<       DO 100 I = 1, NTICKS >*/
    i__1 = *nticks;
    for (i__ = 1; i__ <= i__1; ++i__) {
/*<         DIFF = ABS(TOCK - TICKS(I)) >*/
	diff = (r__1 = *tock - ticks[i__], dabs(r__1));
/*<         IF (DIFF.LT.DMIN) THEN >*/
	if (diff < dmin__) {
/*<           TICK = TICKS(I) >*/
	    *tick = ticks[i__];
/*<           IF (NSUBD.EQ.0) NSUB = NSUBS(I) >*/
	    if (nsubd == 0) {
		*nsub = nsubs[i__];
	    }
/*<           ITICK = I >*/
	    *itick = i__;

/*<           DMIN = DIFF >*/
	    dmin__ = diff;
/*<         END IF >*/
	}
/*<  100  CONTINUE >*/
/* L100: */
    }

/*<       RETURN >*/
    return 0;
/*<       END >*/
} /* pgtbx2_ */

/* PGTBX3 -- support routine for PGTBOX */

/*<    >*/
/* Subroutine */ int pgtbx3_(doday, npl, tscale, tints, nticmx, nticks, ticks,
	 nsubs, itick, axis, dopara, str, tick, nsub, axis_len, str_len)
logical *doday;
integer *npl, *tscale;
real *tints;
integer *nticmx, *nticks;
real *ticks;
integer *nsubs, *itick;
char *axis;
logical *dopara;
char *str;
real *tick;
integer *nsub;
ftnlen axis_len;
ftnlen str_len;
{
    /* System generated locals */
    integer i__1;

    /* Builtin functions */
    integer pow_ii();

    /* Local variables */
    static real lens, lenx, leny;
    extern /* Subroutine */ int pglen_();
    static integer ntick;


/*<       INTEGER TSCALE, NTICMX, NTICKS, ITICK, NSUB, NSUBS(NTICKS), NPL >*/
/*<       REAL TINTS, TICKS(NTICKS), TICK >*/
/*<       CHARACTER AXIS*1, STR*(*) >*/
/*<       LOGICAL DODAY, DOPARA >*/

/* Try to see if label overwrite is going to occur with this tick */
/* selection, or if there are going to be more than a reasonable */
/* number of ticks in the displayed time range.  If so, choose, */
/* if available, the next tick (bigger separation) up in the list. */
/* If the overwrite requires that we would need to go up to the bext */
/* TSCALE, give up.  They will need to choose a smaller character size */

/* This is a support routine for PGTBOX and should not */
/* be called by the user. */

/* Input: */
/*  DODAY  :  True if day field being used */
/*  NPL    :  Number of characters needed to format TICK on input */
/*  TSCALE :  Dictates what the finest units of the labelling are. */
/*            1 = sec, 60 = min, 3600 = hr, 24*3600 = days */
/*  TINTS  :  Absolute time interval in units of TSCALE */
/*  NTICMX :  Max. reasonable number of ticks to allow in the time range */
/*  NTICKS :  Number of ticks in list of ticks to choose from */
/*  TICKS  :  List of ticks from which the current tick was chosen */
/*  NSUBS  :  List of number of minor ticks/major tick to choose NSUB from */
/*  ITICK  :  Index of chosen tick in list TICKS */
/*  AXIS   :  'X' or 'Y' axis */
/*  DOPARA :  Labels parallel or perpendicualr to axis */
/*  STR    :  A typical formatted string used for checking overwrite */
/* Input/output: */
/*  TICK   :  Current major tick interval in units of TSCALE. May be */
/*            made larger if possible if overwrite likely. */
/*  NSUB   :  Number of minor ticks between major ticks. */

/* 10-Jun-1993 - new routine [nebk] */
/* ----------------------------------------------------------------------- */
/*<       INTEGER NTICK >*/
/*<       REAL LENS, LENX, LENY >*/
/* ---------------------------------------------------------------------- */
/*<       CALL PGLEN (4, STR, LENX, LENY) >*/
    /* Parameter adjustments */
    --nsubs;
    --ticks;

    /* Function Body */
    pglen_(&c__4, str, &lenx, &leny, str_len);
/*<       LENS = LENX >*/
    lens = lenx;
/*<    >*/
    if (*dopara && *(unsigned char *)axis == 'Y' || ! (*dopara) && *(unsigned 
	    char *)axis == 'X') {
	lens = leny;
    }

/*<    >*/
    if (*tscale == 1 || *tscale == 60 || *tscale == 3600 && *doday) {

/*  Time in seconds or minutes, or in hours with a day field */

/*<         NTICK = INT(TINTS / TICK) >*/
	ntick = (integer) (*tints / *tick);
/*<    >*/
	if (*itick < *nticks && (*dopara && lens / *tscale > *tick * (float)
		.9 || ntick > *nticmx)) {
/*<           IF (TICKS(ITICK+1).LT.TINTS) THEN >*/
	    if (ticks[*itick + 1] < *tints) {
/*<             NSUB = NSUBS(ITICK+1) >*/
		*nsub = nsubs[*itick + 1];
/*<             TICK = TICKS(ITICK+1) >*/
		*tick = ticks[*itick + 1];
/*<           END IF >*/
	    }
/*<         END IF >*/
	}
/*<       ELSE >*/
    } else {

/*  Time in hours and no day field or time in days */

/*<         NTICK = INT(TINTS / TICK) >*/
	ntick = (integer) (*tints / *tick);
/*<    >*/
	if (*dopara && lens / *tscale > *tick * (float).9 || ntick > *nticmx) 
		{
/*<           IF (ITICK.LT.NTICKS) THEN >*/
	    if (*itick < *nticks) {
/*<             IF (TICKS(ITICK+1)*10**(NPL-1).LT.TINTS) THEN >*/
		i__1 = *npl - 1;
		if (ticks[*itick + 1] * pow_ii(&c__10, &i__1) < *tints) {
/*<               NSUB = NSUBS(ITICK+1) >*/
		    *nsub = nsubs[*itick + 1];
/*<               TICK = TICKS(ITICK+1) * 10**(NPL-1) >*/
		    i__1 = *npl - 1;
		    *tick = ticks[*itick + 1] * pow_ii(&c__10, &i__1);
/*<             END IF >*/
		}
/*<           ELSE >*/
	    } else {
/*<             IF (TICKS(1)*10**NPL.LT.TINTS) THEN >*/
		if (ticks[1] * pow_ii(&c__10, npl) < *tints) {
/*<               NSUB = NSUBS(1) >*/
		    *nsub = nsubs[1];
/*<               TICK = TICKS(1) * 10**NPL >*/
		    *tick = ticks[1] * pow_ii(&c__10, npl);
/*<             END IF >*/
		}
/*<           END IF >*/
	    }
/*<         END IF >*/
	}
/*<       END IF >*/
    }

/*<       RETURN >*/
    return 0;
/*<       END >*/
} /* pgtbx3_ */

/* PGTBX4 -- support routine for PGTBOX */

/*<    >*/
/* Subroutine */ int pgtbx4_(doday, suptyp, axis, convtl, first, tmin, tmax, 
	tscale, tick, do2, dopara, mod24, suptyp_len, axis_len)
logical *doday;
char *suptyp, *axis;
logical *convtl, *first;
real *tmin, *tmax;
integer *tscale;
real *tick;
logical *do2, *dopara, *mod24;
ftnlen suptyp_len;
ftnlen axis_len;
{
    /* System generated locals */
    address a__1[2];
    integer i__1[2], i__2, i__3, i__4;
    char ch__1[82], ch__2[81];

    /* Builtin functions */
    integer s_cmp();
    /* Subroutine */ int s_copy(), s_cat();

    /* Local variables */
    static integer jend[2], ineg, ival[3];
    static real time, disp;
    static integer tlen, last;
    static real rval, xlen, ylen;
    static integer ipos;
    static char text[80];
    static logical writ[4];
    static real xlen2, ylen2;
    static integer i__, j, k;
    static real tfrac[1000];
    static char asign[1*1000];
    static integer ivalf[3];
    extern /* Subroutine */ int pglen_();
    static real coord;
    static integer ivall[3];
    static char signf[1], axloc[2];
    static integer ivalo[3], sprec;
    extern /* Subroutine */ int pgqcs_();
    static integer npass, ivalz[3], izero;
    static real fjust;
    static integer dd[1000];
    extern /* Subroutine */ int pgtbx5_(), pgtbx6_(), pgtbx7_();
    static integer hh[1000], sd, mm[1000], is, it, nt;
    extern /* Subroutine */ int pgbbuf_();
    static real ss[1000];
    extern /* Subroutine */ int pgebuf_();
    static char asignl[1];
    extern /* Subroutine */ int grwarn_(), pgmtxt_();
    static integer ddl, inc, hhl, mml, jst[2];
    static real ssl;


/*<       REAL TMIN, TMAX, TICK >*/
/*<       INTEGER TSCALE >*/
/*<       CHARACTER AXIS*(*), SUPTYP*(*) >*/
/*<       LOGICAL FIRST, DODAY, CONVTL, DO2, DOPARA, MOD24 >*/

/* Label an axis in (DD) HH MM SS.S style.    This is the main */
/* workhorse of the PGTBOX routines. */

/* This is a support subroutine for PGTBOX and should not be */
/* called by the user. */

/* Inputs: */
/*  DODAY  :  Write labels as DD HH MM SS.S else HH MM SS.S with */
/*            hours ranging above 24.  Useful for declination labels */
/*  SUPTYP :  If 'DHMS' then superscript the fields with d, h, m, & s */
/*            If ' DMS' then superscript the fields with    o, '  & '' */
/*              Good for declination plots.  You should obviously not */
/*              ask for the day field for this to do anything sensible. */
/*            If '    ' then no superscripting is done. */
/*  AXIS   :  'X' for x-axis, 'Y' for y-axis */
/*  CONVTL :  If .true., write the labels in the conventional axis */
/*            locations (bottom and left for 'X' and 'Y').  Otherwise */
/*            write them on the top and right axes ('X' and 'Y') */
/*  FIRST  :  If .false. then omit the first label. */
/*  TMIN   :  Start time (seconds) */
/*  TMAX   :  End time (seconds) */
/*  TSCALE :  Determines finest units of axis */
/*              1 => ss, 60 => mm, 3600 => hh, 3600*24 => dd */
/*  TICK   :  Major tick interval in seconds */
/*  DO2    :  If .true., write labels less than 10 with a leading zero. */
/*  DOPARA :  Y axis label parallel to axis, else perpendicular */
/*  MOD24  :  HH field labelled as modulo 24 */

/* 05-Sep-1988 - new routine (Neil Killeen) */
/* 20-Apr-1991 - add support for new DD (day) field [nebk] */
/* 10-Jun-1993 - complete rewrite & rename from PGTLAB. Fixes user given */
/*               ticks bug too [nebk] */
/* 15-Jan-1995 - Add argument MOD24 */
/* ----------------------------------------------------------------------- */
/*<       INTEGER MAXTIK >*/
/*<       LOGICAL T, F >*/
/*<       PARAMETER (MAXTIK = 1000, T = .TRUE., F = .FALSE.) >*/

/*<       REAL SS(MAXTIK), TFRAC(MAXTIK) >*/
/*<       INTEGER DD(MAXTIK), HH(MAXTIK), MM(MAXTIK) >*/
/*<       CHARACTER*1 ASIGN(MAXTIK), ASIGNL >*/

/*<    >*/
/*<    >*/
/*<       CHARACTER SIGNF*1, TEXT*80, AXLOC*2 >*/
/*<       LOGICAL WRIT(4) >*/
/* ----------------------------------------------------------------------- */
/*<       CALL PGBBUF >*/
    pgbbuf_();

/*  Direction signs */

/*<       SD = 1 >*/
    sd = 1;
/*<       IF (TMAX.LT.TMIN) SD = -1 >*/
    if (*tmax < *tmin) {
	sd = -1;
    }
/*<       IS = 1 >*/
    is = 1;
/*<       IF (TMIN.LT.0.0) IS = -1 >*/
    if (*tmin < (float)0.) {
	is = -1;
    }

/*  Find first tick.  Return if none. */

/*<       NT = TMIN / TICK >*/
    nt = *tmin / *tick;
/*<       IF (IS*SD.EQ.1 .AND. ABS(TMIN).GT.ABS(NT)*TICK) NT = NT + SD >*/
    if (is * sd == 1 && dabs(*tmin) > abs(nt) * *tick) {
	nt += sd;
    }
/*<       TIME = NT * TICK >*/
    time = nt * *tick;
/*<    >*/
    if (sd == 1 && (time < *tmin || time > *tmax) || sd == -1 && (time > *
	    tmin || time < *tmax)) {
	return 0;
    }

/*  Now step through time range in TICK increments and convert */
/*  times in seconds at each tick to  +/- (DD) HH MM SS.S */

/*<       IZERO = 0 >*/
    izero = 0;
/*<       IT = 1 >*/
    it = 1;
/*<  1 >*/
L100:
    if (sd == 1 && time > *tmax + (float)1e-5 || sd == -1 && time < *tmax - (
	    float)1e-5) {
	goto L200;
    }
/*<         IF (IT.GT.MAXTIK) THEN >*/
    if (it > 1000) {
/*<    >*/
	grwarn_("PGTBX4: storage exhausted -- you haveasked for far too many\
 ticks", (ftnlen)65);
/*<           GOTO 200 >*/
	goto L200;
/*<         END IF >*/
    }

/*  Convert to (DD) HH MM SS.S and find fraction of window that this */
/*  tick falls at */

/*<    >*/
    pgtbx5_(doday, &time, asign + (it - 1), &dd[it - 1], &hh[it - 1], &mm[it 
	    - 1], &ss[it - 1], (ftnlen)1);
/*<         TFRAC(IT) = (TIME - TMIN) / (TMAX - TMIN) >*/
    tfrac[it - 1] = (time - *tmin) / (*tmax - *tmin);

/*  Note zero tick */

/*<         IF (NT.EQ.0) IZERO = IT >*/
    if (nt == 0) {
	izero = it;
    }

/*  Increment time */

/*<         NT = NT + SD >*/
    nt += sd;
/*<         TIME = NT * TICK >*/
    time = nt * *tick;
/*<         IT = IT + 1 >*/
    ++it;

/*<         GOTO 100 >*/
    goto L100;
/*<  200  CONTINUE >*/
L200:
/*<       IT = IT - 1 >*/
    --it;

/*   Work out the precision with which to write fractional seconds */
/*   labels into the SS.S field.   All other fields have integer labels. */

/*<       SPREC = 0 >*/
    sprec = 0;
/*<       IF (TSCALE.EQ.1) THEN >*/
    if (*tscale == 1) {
/*<         IF (TICK.LT.0.01) THEN >*/
	if (*tick < (float).01) {
/*<           SPREC = 3 >*/
	    sprec = 3;
/*<         ELSE IF (TICK.LT.0.1) THEN >*/
	} else if (*tick < (float).1) {
/*<           SPREC = 2 >*/
	    sprec = 2;
/*<         ELSE IF (TICK.LT.1.0) THEN >*/
	} else if (*tick < (float)1.) {
/*<           SPREC = 1 >*/
	    sprec = 1;
/*<         END IF >*/
	}
/*<       END IF >*/
    }

/*  Label special case of first tick.  Prepare fields and label */

/*<    >*/
    pgtbx6_(doday, mod24, tscale, dd, hh, mm, ss, ivalf, &rval, writ);
/*<       SIGNF = 'H' >*/
    *(unsigned char *)signf = 'H';
/*<       IF (DODAY) SIGNF = 'D' >*/
    if (*doday) {
	*(unsigned char *)signf = 'D';
    }
/*<    >*/
    pgtbx7_(suptyp, signf, asign, ivalf, &rval, writ, &sprec, do2, text, &
	    tlen, &last, suptyp_len, (ftnlen)1, (ftnlen)1, (ftnlen)80);

/*   Set label displacements from axes.  This is messy for labels oriented */
/*   perpendicularly on the right hand axis as we need to know how long */
/*   the longest string we are going to write is before we write any */
/*   labels as they are right justified. */

/*<       IF (AXIS.EQ.'X') THEN >*/
    if (s_cmp(axis, "X", axis_len, (ftnlen)1) == 0) {
/*<         IF (CONVTL) THEN >*/
	if (*convtl) {
/*<           AXLOC = 'B' >*/
	    s_copy(axloc, "B", (ftnlen)2, (ftnlen)1);
/*<           IF (SUPTYP.NE.'NONE') THEN >*/
	    if (s_cmp(suptyp, "NONE", suptyp_len, (ftnlen)4) != 0) {
/*<             DISP = 1.4 >*/
		disp = (float)1.4;
/*<           ELSE >*/
	    } else {
/*<             DISP = 1.2 >*/
		disp = (float)1.2;
/*<           END IF >*/
	    }
/*<         ELSE >*/
	} else {
/*<           AXLOC = 'T' >*/
	    s_copy(axloc, "T", (ftnlen)2, (ftnlen)1);
/*<           DISP = 0.7 >*/
	    disp = (float).7;
/*<         END IF >*/
	}
/*<       ELSE IF (AXIS.EQ.'Y') THEN >*/
    } else if (s_cmp(axis, "Y", axis_len, (ftnlen)1) == 0) {
/*<         IF (CONVTL) THEN >*/
	if (*convtl) {
/*<           AXLOC = 'LV' >*/
	    s_copy(axloc, "LV", (ftnlen)2, (ftnlen)2);
/*<           IF (DOPARA) AXLOC = 'L' >*/
	    if (*dopara) {
		s_copy(axloc, "L", (ftnlen)2, (ftnlen)1);
	    }
/*<           DISP = 0.7 >*/
	    disp = (float).7;
/*<         ELSE >*/
	} else {
/*<           IF (DOPARA) THEN >*/
	    if (*dopara) {
/*<             AXLOC = 'R' >*/
		s_copy(axloc, "R", (ftnlen)2, (ftnlen)1);
/*<             IF (SUPTYP.NE.'NONE') THEN >*/
		if (s_cmp(suptyp, "NONE", suptyp_len, (ftnlen)4) != 0) {
/*<               DISP = 1.7 >*/
		    disp = (float)1.7;
/*<             ELSE >*/
		} else {
/*<               DISP = 1.9 >*/
		    disp = (float)1.9;
/*<             END IF >*/
		}
/*<           ELSE >*/
	    } else {

/*  Work out number of characters in first label */

/*<             AXLOC = 'RV' >*/
		s_copy(axloc, "RV", (ftnlen)2, (ftnlen)2);
/*<             IF (ASIGN(1).NE.'-' .AND. TMIN*TMAX.LT.0.0) THEN >*/
		if (*(unsigned char *)&asign[0] != '-' && *tmin * *tmax < (
			float)0.) {
/*<               CALL PGLEN (2, ' -'//TEXT(1:TLEN), XLEN, YLEN) >*/
/* Writing concatenation */
		    i__1[0] = 2, a__1[0] = " -";
		    i__1[1] = tlen, a__1[1] = text;
		    s_cat(ch__1, a__1, i__1, &c__2, (ftnlen)82);
		    pglen_(&c__2, ch__1, &xlen, &ylen, tlen + 2);
/*<             ELSE >*/
		} else {
/*<               CALL PGLEN (2, ' '//TEXT(1:TLEN), XLEN, YLEN) >*/
/* Writing concatenation */
		    i__1[0] = 1, a__1[0] = " ";
		    i__1[1] = tlen, a__1[1] = text;
		    s_cat(ch__2, a__1, i__1, &c__2, (ftnlen)81);
		    pglen_(&c__2, ch__2, &xlen, &ylen, tlen + 1);
/*<             END IF >*/
		}
/*<             CALL PGQCS (2, XLEN2, YLEN2) >*/
		pgqcs_(&c__2, &xlen2, &ylen2);
/*<             DISP = (XLEN/XLEN2) >*/
		disp = xlen / xlen2;
/*<           END IF >*/
	    }
/*<         END IF >*/
	}
/*<       END IF >*/
    }

/*  Now write the label to the plot.  The X-axis label for the first tick is */
/*  centred such that the last field of the label is centred on the tick */

/*<       IF (FIRST) THEN >*/
    if (*first) {
/*<         CALL PGLEN (5, TEXT(LAST:TLEN), XLEN, YLEN) >*/
	pglen_(&c__5, text + (last - 1), &xlen, &ylen, tlen - (last - 1));

/*<         IF (AXIS.EQ.'X') THEN >*/
	if (s_cmp(axis, "X", axis_len, (ftnlen)1) == 0) {
/*<           COORD = TFRAC(1) + XLEN / 2.0 >*/
	    coord = tfrac[0] + xlen / (float)2.;
/*<           FJUST = 1.0 >*/
	    fjust = (float)1.;
/*<         ELSE IF (AXIS.EQ.'Y') THEN >*/
	} else if (s_cmp(axis, "Y", axis_len, (ftnlen)1) == 0) {
/*<           IF (DOPARA) THEN >*/
	    if (*dopara) {
/*<             COORD = TFRAC(1) + YLEN / 2.0 >*/
		coord = tfrac[0] + ylen / (float)2.;
/*<             FJUST = 1.0 >*/
		fjust = (float)1.;
/*<           ELSE >*/
	    } else {
/*<             FJUST = 1.0 >*/
		fjust = (float)1.;
/*<             COORD = TFRAC(1) >*/
		coord = tfrac[0];
/*<           END IF >*/
	    }
/*<         END IF >*/
	}
/*<         CALL PGMTXT (AXLOC, DISP, COORD, FJUST, TEXT(1:TLEN)) >*/
	pgmtxt_(axloc, &disp, &coord, &fjust, text, (ftnlen)2, tlen);
/*<       END IF >*/
    }
/*<       IF (IT.EQ.1) RETURN >*/
    if (it == 1) {
	return 0;
    }

/*   Designate which field out of DD or HH will carry the sign, depending */
/*   on whether you want the day field or not for the rest of the ticks */

/*<       SIGNF = 'H' >*/
    *(unsigned char *)signf = 'H';
/*<       IF (DODAY) SIGNF = 'D' >*/
    if (*doday) {
	*(unsigned char *)signf = 'D';
    }

/*  Set up labelling justifications for the rest of the labels */

/*<       IF (AXIS.EQ.'X') THEN >*/
    if (s_cmp(axis, "X", axis_len, (ftnlen)1) == 0) {
/*<         FJUST = 0.5 >*/
	fjust = (float).5;
/*<       ELSE IF (AXIS.EQ.'Y') THEN >*/
    } else if (s_cmp(axis, "Y", axis_len, (ftnlen)1) == 0) {
/*<         IF (DOPARA) THEN >*/
	if (*dopara) {
/*<           FJUST = 0.5 >*/
	    fjust = (float).5;
/*<         ELSE >*/
	} else {
/*<           FJUST = 1.0 >*/
	    fjust = (float)1.;
/*<         END IF >*/
	}
/*<       END IF >*/
    }

/*  Note zero crossings; IPOS is the first positive tick and */
/*  INEG is the first negative tick on either side of 0 */

/*<       IPOS = 0 >*/
    ipos = 0;
/*<       INEG = 0 >*/
    ineg = 0;

/*<       IF (IZERO.NE.0) THEN >*/
    if (izero != 0) {
/*<         J = IZERO - 1 >*/
	j = izero - 1;
/*<         IF (J.GE.1) THEN >*/
	if (j >= 1) {
/*<           IF (ASIGN(J).EQ.'-') THEN >*/
	    if (*(unsigned char *)&asign[j - 1] == '-') {
/*<             INEG = J >*/
		ineg = j;
/*<           ELSE IF (ASIGN(J).EQ.' ') THEN >*/
	    } else if (*(unsigned char *)&asign[j - 1] == ' ') {
/*<             IPOS = J >*/
		ipos = j;
/*<           END IF >*/
	    }
/*<         END IF >*/
	}
/*<         J = IZERO + 1 >*/
	j = izero + 1;
/*<         IF (J.LE.IT) THEN >*/
	if (j <= it) {
/*<           IF (ASIGN(J).EQ.'-') THEN >*/
	    if (*(unsigned char *)&asign[j - 1] == '-') {
/*<             INEG = J >*/
		ineg = j;
/*<           ELSE IF (ASIGN(J).EQ.' ') THEN >*/
	    } else if (*(unsigned char *)&asign[j - 1] == ' ') {
/*<             IPOS = J >*/
		ipos = j;
/*<           END IF >*/
	    }
/*<         END IF >*/
	}
/*<       END IF >*/
    }

/*  Now label special case of zero tick. It carries the sign change */
/*  when going from positive to negative time, left to right. */

/*<       IF (IZERO.NE.0 .AND. IZERO.NE.1) THEN >*/
    if (izero != 0 && izero != 1) {
/*<    >*/
	pgtbx6_(doday, mod24, tscale, &dd[izero - 1], &hh[izero - 1], &mm[
		izero - 1], &ss[izero - 1], ivalz, &rval, writ);

/*<         IF (ASIGN(IZERO-1).EQ.' ') ASIGN(IZERO) = '-' >*/
	if (*(unsigned char *)&asign[izero - 2] == ' ') {
	    *(unsigned char *)&asign[izero - 1] = '-';
	}
/*<    >*/
	pgtbx7_(suptyp, signf, asign + (izero - 1), ivalz, &rval, writ, &
		sprec, do2, text, &tlen, &last, suptyp_len, (ftnlen)1, (
		ftnlen)1, (ftnlen)80);

/*<         COORD = TFRAC(IZERO) >*/
	coord = tfrac[izero - 1];
/*<         CALL PGMTXT (AXLOC, DISP, COORD, FJUST, TEXT(1:TLEN)) >*/
	pgmtxt_(axloc, &disp, &coord, &fjust, text, (ftnlen)2, tlen);
/*<       END IF >*/
    }

/*   We may need an extra "virtual" tick if there is no zero crossing */
/*   and SD=-1 & IS=1 or SD=1 & IS=-1.  It is used to work out which */
/*   fields to label on the right most tick which is labelled first. */

/*<       IF (IZERO.EQ.0) THEN >*/
    if (izero == 0) {
/*<         IF (SD*IS.EQ.-1) THEN  >*/
	if (sd * is == -1) {
/*<    >*/
	    if (sd == -1 && time <= (float)0. || sd == 1 && time >= (float)0.)
		     {
		time = (float)0.;
	    }
/*<           CALL PGTBX5 (DODAY, TIME, ASIGNL, DDL, HHL, MML, SSL) >*/
	    pgtbx5_(doday, &time, asignl, &ddl, &hhl, &mml, &ssl, (ftnlen)1);
/*<    >*/
	    pgtbx6_(doday, mod24, tscale, &ddl, &hhl, &mml, &ssl, ivall, &
		    rval, writ);
/*<         END IF >*/
	}
/*<       END IF >*/
    }

/*  We want to label in the direction(s) away from zero, so we may  need */
/*  two passes. Determine the start and end ticks for each required pass. */

/*<       JST(2) = 0 >*/
    jst[1] = 0;
/*<       JEND(2) = 0 >*/
    jend[1] = 0;
/*<       NPASS = 1 >*/
    npass = 1;
/*<       IF (IZERO.EQ.0) THEN >*/
    if (izero == 0) {
/*<         IF (IS*SD.EQ.1) THEN >*/
	if (is * sd == 1) {
/*<           JST(1) = 1 >*/
	    jst[0] = 1;
/*<           JEND(1) = IT >*/
	    jend[0] = it;
/*<         ELSE >*/
	} else {
/*<           JST(1) = IT >*/
	    jst[0] = it;
/*<           JEND(1) = 1 >*/
	    jend[0] = 1;
/*<         END IF >*/
	}
/*<       ELSE >*/
    } else {
/*<         IF (INEG.EQ.0 .OR. IPOS.EQ.0) THEN >*/
	if (ineg == 0 || ipos == 0) {
/*<           JST(1) = IZERO >*/
	    jst[0] = izero;
/*<           JEND(1) = IT >*/
	    jend[0] = it;
/*<           IF (IZERO.EQ.IT) JEND(1) = 1 >*/
	    if (izero == it) {
		jend[0] = 1;
	    }
/*<         ELSE >*/
	} else {
/*<           NPASS = 2 >*/
	    npass = 2;
/*<           JST(1) = IZERO >*/
	    jst[0] = izero;
/*<           JEND(1) = 1 >*/
	    jend[0] = 1;
/*<           JST(2) = IZERO >*/
	    jst[1] = izero;
/*<           JEND(2) = IT >*/
	    jend[1] = it;
/*<         END IF >*/
	}
/*<       END IF >*/
    }

/*  Now label the rest of the ticks.  Always label away from 0 */

/*<       DO 400 I = 1, NPASS >*/
    i__2 = npass;
    for (i__ = 1; i__ <= i__2; ++i__) {

/*  Initialize previous tick values.  Use virtual tick if labelling */
/*  left to right without a zero (one pass) */

/*<         DO 250 K = 1, 3 >*/
	for (k = 1; k <= 3; ++k) {
/*<           IVALO(K) = IVALZ(K) >*/
	    ivalo[k - 1] = ivalz[k - 1];
/*<           IF (IZERO.EQ.0) THEN >*/
	    if (izero == 0) {
/*<             IVALO(K) = IVALL(K) >*/
		ivalo[k - 1] = ivall[k - 1];
/*<             IF (JST(I).EQ.1) IVALO(K) = IVALF(K) >*/
		if (jst[i__ - 1] == 1) {
		    ivalo[k - 1] = ivalf[k - 1];
		}
/*<           END IF >*/
	    }
/*<   250   CONTINUE >*/
/* L250: */
	}

/*<         INC = 1 >*/
	inc = 1;
/*<         IF (JEND(I).LT.JST(I)) INC = -1 >*/
	if (jend[i__ - 1] < jst[i__ - 1]) {
	    inc = -1;
	}
/*<         DO 300 J = JST(I), JEND(I), INC >*/
	i__3 = jend[i__ - 1];
	i__4 = inc;
	for (j = jst[i__ - 1]; i__4 < 0 ? j >= i__3 : j <= i__3; j += i__4) {

/*  First and zero tick already labelled */

/*<           IF (J.NE.1 .AND. J.NE.IZERO) THEN >*/
	    if (j != 1 && j != izero) {

/*  Prepare fields */

/*<    >*/
		pgtbx6_(doday, mod24, tscale, &dd[j - 1], &hh[j - 1], &mm[j - 
			1], &ss[j - 1], ival, &rval, writ);

/*  Don't write unchanging fields */

/*<             DO 275 K = 1, 3 >*/
		for (k = 1; k <= 3; ++k) {
/*<               IF (IVAL(K).EQ.IVALO(K)) WRIT(K) = F >*/
		    if (ival[k - 1] == ivalo[k - 1]) {
			writ[k - 1] = FALSE_;
		    }
/*<  275        CONTINUE >*/
/* L275: */
		}

/*  Prepare label */

/*<    >*/
		pgtbx7_(suptyp, signf, asign + (j - 1), ival, &rval, writ, &
			sprec, do2, text, &tlen, &last, suptyp_len, (ftnlen)1,
			 (ftnlen)1, (ftnlen)80);

/*  Write label */

/*<             COORD = TFRAC(J) >*/
		coord = tfrac[j - 1];
/*<             CALL PGMTXT (AXLOC, DISP, COORD, FJUST, TEXT(1:TLEN)) >*/
		pgmtxt_(axloc, &disp, &coord, &fjust, text, (ftnlen)2, tlen);

/*  Update old values */

/*<             DO 280 K = 1, 3 >*/
		for (k = 1; k <= 3; ++k) {
/*<               IVALO(K) = IVAL(K) >*/
		    ivalo[k - 1] = ival[k - 1];
/*<   280       CONTINUE >*/
/* L280: */
		}
/*<           END IF >*/
	    }
/*<  300    CONTINUE >*/
/* L300: */
	}
/*<  400  CONTINUE >*/
/* L400: */
    }
/*<       CALL PGEBUF >*/
    pgebuf_();

/*<       RETURN >*/
    return 0;
/*<       END >*/
} /* pgtbx4_ */

/* PGTBX5 -- support routine for PGTBOX */

/*<       SUBROUTINE PGTBX5 (DODAY, TSEC, ASIGN, D, H, M, S) >*/
/* Subroutine */ int pgtbx5_(doday, tsec, asign, d__, h__, m, s, asign_len)
logical *doday;
real *tsec;
char *asign;
integer *d__, *h__, *m;
real *s;
ftnlen asign_len;
{
    /* System generated locals */
    real r__1;

    /* Builtin functions */
    double r_mod();
    integer i_nint();

    /* Local variables */
    static integer it;


/*<       REAL S, TSEC >*/
/*<       INTEGER  D, H, M >*/
/*<       LOGICAL DODAY >*/
/*<       CHARACTER*1 ASIGN >*/

/*  Convert time in seconds to (DD) HH MM SS.S */

/* Input */
/*  DODAY  :  Use day field if true, else hours accumulates beyond 24 */
/*  TSEC   :  Time in seconds (signed) */
/* Output */
/*  ASIGN  :  Sign, ' ' or '-' */
/*  D,H,M  :  DD, HH, MM (unsigned) */
/*  S      :  SS.S       (unsigned) */

/* 10-Jun-1993 - new routine [nebk] */
/* ----------------------------------------------------------------------- */
/*<       INTEGER IT >*/
/* ---------------------------------------------------------------------- */
/*<       ASIGN = ' ' >*/
    *(unsigned char *)asign = ' ';
/*<       IF (TSEC.LT.0.0) ASIGN = '-' >*/
    if (*tsec < (float)0.) {
	*(unsigned char *)asign = '-';
    }

/*<       S = MOD(ABS(TSEC),60.0) >*/
    r__1 = dabs(*tsec);
    *s = r_mod(&r__1, &c_b63);

/*<       IT = NINT(ABS(TSEC)-S) / 60 >*/
    r__1 = dabs(*tsec) - *s;
    it = i_nint(&r__1) / 60;
/*<       M = MOD(IT,60) >*/
    *m = it % 60;

/*<       IT = (IT - M) / 60 >*/
    it = (it - *m) / 60;
/*<       IF (DODAY) THEN >*/
    if (*doday) {
/*<         H = MOD(IT,24) >*/
	*h__ = it % 24;
/*<         D = (IT-H) / 24 >*/
	*d__ = (it - *h__) / 24;
/*<       ELSE >*/
    } else {
/*<         H = IT >*/
	*h__ = it;
/*<         D = 0 >*/
	*d__ = 0;
/*<       END IF >*/
    }

/*<       RETURN >*/
    return 0;
/*<       END >*/
} /* pgtbx5_ */

/* PGTBX6 -- support routine for PGTBOX */

/*<    >*/
/* Subroutine */ int pgtbx6_(doday, mod24, tscale, dd, hh, mm, ss, ival, rval,
	 writ)
logical *doday, *mod24;
integer *tscale, *dd, *hh, *mm;
real *ss;
integer *ival;
real *rval;
logical *writ;
{
    /* System generated locals */
    real r__1;

    /* Builtin functions */
    integer i_nint();

    /* Local variables */
    static integer wm;


/*<       INTEGER TSCALE, IVAL(3), DD, HH, MM >*/
/*<       REAL SS, RVAL >*/
/*<       LOGICAL WRIT(4), DODAY, MOD24 >*/

/*   Find out which of the DD HH MM SS.S fields we want to write */
/*   into the label according to TSCALE and make a round off */
/*   error check. */

/*  Input: */
/*    DODAY  :  Use day field if true else hours accrue beyond 24 */
/*    MOD24  :  HH field labelled as modulo 24 */
/*    TSCALE :  Dictates which fields appear in labels */
/*    DD     :  Day of time  (will be 0 if DODAY=F and HH will compensate) */
/*    HH     :  Hour of time */
/*    MM     :  Minute of time */
/*    SS     :  Second of time */
/*  Output: */
/*    IVAL(3):  DD HH MM to write into label */
/*    RVAL   :  SS.S to write into label */
/*    WRIT(4):  T or F if DD,HH,MM,SS are to be written into the label */
/*              or not.  IVAL and RVAL fields are set explicitly to */
/*              zero if the corresponding WRIT field is false. */
/*              This really is overkill. */

/*  10-Jun-1993 - New routine [nebk] */
/*  16-Jan-1995 - Add argument MOD24 */
/* ----------------------------------------------------------------------- */
/*<       LOGICAL T, F >*/
/*<       PARAMETER (T = .TRUE., F = .FALSE.) >*/
/*<       INTEGER WM >*/
/* ----------------------------------------------------------------------- */
/*<       IVAL(1) = DD >*/
    /* Parameter adjustments */
    --writ;
    --ival;

    /* Function Body */
    ival[1] = *dd;
/*<       IVAL(2) = HH >*/
    ival[2] = *hh;
/*<       IVAL(3) = MM >*/
    ival[3] = *mm;
/*<       RVAL    = SS >*/
    *rval = *ss;

/*  SS should be 0.0; round off may get us 59.999 or the like but */
/*  not 60.001 (see PGTBX5) */

/*<       IF (TSCALE.GT.1) THEN >*/
    if (*tscale > 1) {
/*<         WM = NINT(SS/60.0) >*/
	r__1 = *ss / (float)60.;
	wm = i_nint(&r__1);
/*<         IVAL(3) = IVAL(3) + WM >*/
	ival[3] += wm;
/*<         IF (IVAL(3).EQ.60) THEN >*/
	if (ival[3] == 60) {
/*<           IVAL(3) = 0 >*/
	    ival[3] = 0;
/*<           IVAL(2) = IVAL(2) + 1 >*/
	    ++ival[2];
/*<           IF (DODAY .AND. IVAL(2).EQ.24) THEN >*/
	    if (*doday && ival[2] == 24) {
/*<             IVAL(2) = 0 >*/
		ival[2] = 0;
/*<             IVAL(1) = IVAL(1) + 1 >*/
		++ival[1];
/*<           END IF >*/
	    }
/*<         END IF >*/
	}
/*<       END IF >*/
    }

/* Make HH field modulo 24 if desired */

/*<       IF (MOD24) IVAL(2) = MOD(IVAL(2),24) >*/
    if (*mod24) {
	ival[2] %= 24;
    }

/*<       IF (TSCALE.EQ.1) THEN >*/
    if (*tscale == 1) {

/*  Label contains (DD) HH MM SS.S */

/*<         WRIT(1) = DODAY >*/
	writ[1] = *doday;
/*<         WRIT(2) = T >*/
	writ[2] = TRUE_;
/*<         WRIT(3) = T >*/
	writ[3] = TRUE_;
/*<         WRIT(4) = T >*/
	writ[4] = TRUE_;
/*<       ELSE IF (TSCALE.EQ.60) THEN >*/
    } else if (*tscale == 60) {

/*  Label contains (DD) HH MM */

/*<         WRIT(1) = DODAY >*/
	writ[1] = *doday;
/*<         WRIT(2) = T >*/
	writ[2] = TRUE_;
/*<         WRIT(3) = T >*/
	writ[3] = TRUE_;

/*<         RVAL    = 0.0 >*/
	*rval = (float)0.;
/*<         WRIT(4) = F >*/
	writ[4] = FALSE_;
/*<       ELSE IF (TSCALE.EQ.3600) THEN >*/
    } else if (*tscale == 3600) {

/*  Label contains (DD) HH */

/*<         WRIT(1) = DODAY >*/
	writ[1] = *doday;
/*<         WRIT(2) = T >*/
	writ[2] = TRUE_;

/*<         IVAL(3) = 0 >*/
	ival[3] = 0;
/*<         WRIT(3) = F >*/
	writ[3] = FALSE_;

/*<         RVAL    = 0.0 >*/
	*rval = (float)0.;
/*<         WRIT(4) = F >*/
	writ[4] = FALSE_;
/*<       ELSE IF (TSCALE.EQ.3600*24) THEN >*/
    } else if (*tscale == 86400) {

/*  Label contains DD */

/*<         WRIT(1) = T >*/
	writ[1] = TRUE_;

/*<         IVAL(2) = 0 >*/
	ival[2] = 0;
/*<         WRIT(2) = F >*/
	writ[2] = FALSE_;

/*<         IVAL(3) = 0 >*/
	ival[3] = 0;
/*<         WRIT(3) = F >*/
	writ[3] = FALSE_;

/*<         RVAL    = 0.0 >*/
	*rval = (float)0.;
/*<         WRIT(4) = F >*/
	writ[4] = FALSE_;
/*<       END IF >*/
    }

/*<       RETURN >*/
    return 0;
/*<       END >*/
} /* pgtbx6_ */

/*<    >*/
/* Subroutine */ int pgtbx7_(suptyp, signf, asign, ival, rval, writ, sprec, 
	do2, text, tlen, last, suptyp_len, signf_len, asign_len, text_len)
char *suptyp, *signf, *asign;
integer *ival;
real *rval;
logical *writ;
integer *sprec;
logical *do2;
char *text;
integer *tlen, *last;
ftnlen suptyp_len;
ftnlen signf_len;
ftnlen asign_len;
ftnlen text_len;
{
    /* Initialized data */

    static char frmat2[2*3+1] = "I1I2I3";
    static integer trlen[3] = { 5,11,5 };

    /* System generated locals */
    address a__1[4], a__2[6], a__3[5], a__4[3], a__5[2];
    integer i__1[4], i__2[6], i__3[5], i__4[3], i__5, i__6[2], i__7;
    real r__1;
    char ch__1[13], ch__2[5];

    /* Builtin functions */
    /* Subroutine */ int s_copy(), s_cat();
    integer s_cmp(), s_wsfi(), do_fio(), e_wsfi(), pow_ii(), i_nint();

    /* Local variables */
    static integer flen, fmax, tlen2;
    static char field[30], frmat[30];
    extern /* Subroutine */ int pgnpl_();
    static char super[11*4*3];
    static integer tmpnt, ip, ir1, ir2, suppnt;
    static char bsl[1];
    static integer fst;
    static char tmp[100];

    /* Fortran I/O blocks */
    static icilist io___105 = { 0, field, 0, "(I6)", 30, 1 };
    static icilist io___111 = { 0, field, 0, "(I6)", 30, 1 };
    static icilist io___112 = { 0, field, 0, "(I2, A)", 30, 1 };
    static icilist io___116 = { 0, field, 0, frmat, 30, 1 };
    static icilist io___118 = { 0, field, 0, "(I2,A)", 30, 1 };



/*<       REAL RVAL >*/
/*<       INTEGER IVAL(3), TLEN, SPREC, LAST >*/
/*<       CHARACTER ASIGN*1, TEXT*(*), SIGNF*1, SUPTYP*4 >*/
/*<       LOGICAL WRIT(4), DO2 >*/

/* Write (DD) HH MM SS.S time labels into a string */

/* This is a support routine for PGTBOX and should not be */
/* called by the user */

/* Inputs */
/*  SUPTYP :  '    ', 'DHMS', or ' DMS' for no superscript labelling, */
/*            d,h,m,s   or   o,','' superscripting */
/*  SIGNF  :  Tells which field the sign is associated with. */
/*            One of 'D', 'H', 'M', or 'S' */
/*  ASIGN  :  ' ' or '-' for positive or negative times */
/*  IVAL(3):  Day, hour, minutes of time */
/*  RVAL   :  Seconds of time */
/*  WRIT(4):  If .true. then write DD, HH, MM, SS  into label */
/*  SPREC  :  Number of places after the decimal to write seconds */
/*            string to.  Must be in the range 0-3 */
/*  DO2    :  If true, add a leading zero to numbers < 10 */
/* Outputs */
/*  TEXT   :  Label */
/*  TLEN   :  Length of label */
/*  LAST   :  Is the location of the start character of the last */
/*            field written into TEXT */

/*  05-Sep-1989 -- New routine (Neil Killeen) */
/*  20-Apr-1991 -- Complete rewrite; support for new DD (day) field and */
/*                 superscripted labels [nebk] */
/*  14-May-1991 -- Removed BSL as a parameter (Char(92)) and made it */
/*                 a variable to appease Cray compiler [mjs/nebk] */
/*  10-Jun-1993 -- Rename from PGTLB1, add code to label superscript */
/*                 seconds above the '.' and add DO2 option [nebk/jm] */
/* ----------------------------------------------------------------------- */
/*<    >*/
/*<    >*/

/*<       SAVE FRMAT2 >*/
/*<       SAVE TRLEN >*/

/*<       DATA FRMAT2 /'I1', 'I2', 'I3'/ >*/
    /* Parameter adjustments */
    --writ;
    --ival;

    /* Function Body */
/*<       DATA TRLEN /5, 11, 5/ >*/
/* ----------------------------------------------------------------------- */

/*   Initialize */

/*<       BSL = CHAR(92) >*/
    *(unsigned char *)bsl = '\\';
/*<       TLEN = 0 >*/
    *tlen = 0;
/*<       TEXT = ' ' >*/
    s_copy(text, " ", text_len, (ftnlen)1);

/*   Assign superscripting strings.  Use CHAR(92) for backslash as the */
/*   latter must be escaped on SUNs thus requiring preprocessing.  The */
/*   concatenator operator precludes the use of a data statement */

/*<       SUPER(1,1) = BSL//'ud'//BSL//'d' >*/
/* Writing concatenation */
    i__1[0] = 1, a__1[0] = bsl;
    i__1[1] = 2, a__1[1] = "ud";
    i__1[2] = 1, a__1[2] = bsl;
    i__1[3] = 1, a__1[3] = "d";
    s_cat(super, a__1, i__1, &c__4, (ftnlen)11);
/*<       SUPER(2,1) = BSL//'uh'//BSL//'d' >*/
/* Writing concatenation */
    i__1[0] = 1, a__1[0] = bsl;
    i__1[1] = 2, a__1[1] = "uh";
    i__1[2] = 1, a__1[2] = bsl;
    i__1[3] = 1, a__1[3] = "d";
    s_cat(super + 11, a__1, i__1, &c__4, (ftnlen)11);
/*<       SUPER(3,1) = BSL//'um'//BSL//'d' >*/
/* Writing concatenation */
    i__1[0] = 1, a__1[0] = bsl;
    i__1[1] = 2, a__1[1] = "um";
    i__1[2] = 1, a__1[2] = bsl;
    i__1[3] = 1, a__1[3] = "d";
    s_cat(super + 22, a__1, i__1, &c__4, (ftnlen)11);
/*<       SUPER(4,1) = BSL//'us'//BSL//'d' >*/
/* Writing concatenation */
    i__1[0] = 1, a__1[0] = bsl;
    i__1[1] = 2, a__1[1] = "us";
    i__1[2] = 1, a__1[2] = bsl;
    i__1[3] = 1, a__1[3] = "d";
    s_cat(super + 33, a__1, i__1, &c__4, (ftnlen)11);

/*<       SUPER(1,2) = BSL//'u'//BSL//'(2199)'//BSL//'d' >*/
/* Writing concatenation */
    i__2[0] = 1, a__2[0] = bsl;
    i__2[1] = 1, a__2[1] = "u";
    i__2[2] = 1, a__2[2] = bsl;
    i__2[3] = 6, a__2[3] = "(2199)";
    i__2[4] = 1, a__2[4] = bsl;
    i__2[5] = 1, a__2[5] = "d";
    s_cat(super + 44, a__2, i__2, &c__6, (ftnlen)11);
/*<       SUPER(2,2) = BSL//'u'//BSL//'(2729)'//BSL//'d' >*/
/* Writing concatenation */
    i__2[0] = 1, a__2[0] = bsl;
    i__2[1] = 1, a__2[1] = "u";
    i__2[2] = 1, a__2[2] = bsl;
    i__2[3] = 6, a__2[3] = "(2729)";
    i__2[4] = 1, a__2[4] = bsl;
    i__2[5] = 1, a__2[5] = "d";
    s_cat(super + 55, a__2, i__2, &c__6, (ftnlen)11);
/*<       SUPER(3,2) = BSL//'u'//BSL//'(2727)'//BSL//'d' >*/
/* Writing concatenation */
    i__2[0] = 1, a__2[0] = bsl;
    i__2[1] = 1, a__2[1] = "u";
    i__2[2] = 1, a__2[2] = bsl;
    i__2[3] = 6, a__2[3] = "(2727)";
    i__2[4] = 1, a__2[4] = bsl;
    i__2[5] = 1, a__2[5] = "d";
    s_cat(super + 66, a__2, i__2, &c__6, (ftnlen)11);
/*<       SUPER(4,2) = BSL//'u'//BSL//'(2728)'//BSL//'d' >*/
/* Writing concatenation */
    i__2[0] = 1, a__2[0] = bsl;
    i__2[1] = 1, a__2[1] = "u";
    i__2[2] = 1, a__2[2] = bsl;
    i__2[3] = 6, a__2[3] = "(2728)";
    i__2[4] = 1, a__2[4] = bsl;
    i__2[5] = 1, a__2[5] = "d";
    s_cat(super + 77, a__2, i__2, &c__6, (ftnlen)11);

/*<       SUPER(1,3) = BSL//'u'//' '//BSL//'d' >*/
/* Writing concatenation */
    i__3[0] = 1, a__3[0] = bsl;
    i__3[1] = 1, a__3[1] = "u";
    i__3[2] = 1, a__3[2] = " ";
    i__3[3] = 1, a__3[3] = bsl;
    i__3[4] = 1, a__3[4] = "d";
    s_cat(super + 88, a__3, i__3, &c__5, (ftnlen)11);
/*<       SUPER(2,3) = BSL//'u'//' '//BSL//'d' >*/
/* Writing concatenation */
    i__3[0] = 1, a__3[0] = bsl;
    i__3[1] = 1, a__3[1] = "u";
    i__3[2] = 1, a__3[2] = " ";
    i__3[3] = 1, a__3[3] = bsl;
    i__3[4] = 1, a__3[4] = "d";
    s_cat(super + 99, a__3, i__3, &c__5, (ftnlen)11);
/*<       SUPER(3,3) = BSL//'u'//' '//BSL//'d' >*/
/* Writing concatenation */
    i__3[0] = 1, a__3[0] = bsl;
    i__3[1] = 1, a__3[1] = "u";
    i__3[2] = 1, a__3[2] = " ";
    i__3[3] = 1, a__3[3] = bsl;
    i__3[4] = 1, a__3[4] = "d";
    s_cat(super + 110, a__3, i__3, &c__5, (ftnlen)11);
/*<       SUPER(4,3) = BSL//'u'//' '//BSL//'d' >*/
/* Writing concatenation */
    i__3[0] = 1, a__3[0] = bsl;
    i__3[1] = 1, a__3[1] = "u";
    i__3[2] = 1, a__3[2] = " ";
    i__3[3] = 1, a__3[3] = bsl;
    i__3[4] = 1, a__3[4] = "d";
    s_cat(super + 121, a__3, i__3, &c__5, (ftnlen)11);

/*   Point at correct superscript strings */

/*<       IF (SUPTYP.EQ.'DHMS') THEN >*/
    if (s_cmp(suptyp, "DHMS", (ftnlen)4, (ftnlen)4) == 0) {
/*<         SUPPNT = 1 >*/
	suppnt = 1;
/*<       ELSE IF (SUPTYP.EQ.' DMS') THEN >*/
    } else if (s_cmp(suptyp, " DMS", (ftnlen)4, (ftnlen)4) == 0) {
/*<         SUPPNT = 2 >*/
	suppnt = 2;
/*<       ELSE >*/
    } else {
/*<         SUPPNT = 3 >*/
	suppnt = 3;
/*<       END IF >*/
    }

/* CCC */
/*   Days field */
/* CCC */

/*<       IF (WRIT(1)) THEN >*/
    if (writ[1]) {
/*<         LAST = TLEN + 1 >*/
	*last = *tlen + 1;

/*   Write into temporary field */

/*<         FIELD = ' ' >*/
	s_copy(field, " ", (ftnlen)30, (ftnlen)1);
/*<         CALL PGNPL (0, IVAL(1), FLEN) >*/
	pgnpl_(&c__0, &ival[1], &flen);
/*<         WRITE (FIELD, '(I6)') IVAL(1) >*/
	s_wsfi(&io___105);
	do_fio(&c__1, (char *)&ival[1], (ftnlen)sizeof(integer));
	e_wsfi();
/*<         FMAX = 6 >*/
	fmax = 6;
/*<         FST = FMAX - FLEN + 1 >*/
	fst = fmax - flen + 1;

/*   Write output text string with desired superscripting */

/*<         TMPNT = 2 >*/
	tmpnt = 2;
/*<         IF (SIGNF.EQ.'D' .AND. ASIGN.NE.' ') TMPNT = 1 >*/
	if (*(unsigned char *)signf == 'D' && *(unsigned char *)asign != ' ') 
		{
	    tmpnt = 1;
	}

/*<         TMP = ASIGN//FIELD(FST:FMAX)//SUPER(1,SUPPNT) >*/
/* Writing concatenation */
	i__4[0] = 1, a__4[0] = asign;
	i__4[1] = fmax - (fst - 1), a__4[1] = field + (fst - 1);
	i__4[2] = 11, a__4[2] = super + ((suppnt << 2) - 4) * 11;
	s_cat(tmp, a__4, i__4, &c__3, (ftnlen)100);
/*<         TLEN2 = (2 - TMPNT) + FLEN + TRLEN(SUPPNT) >*/
	tlen2 = 2 - tmpnt + flen + trlen[suppnt - 1];

/*<         TEXT(TLEN+1:) = TMP(TMPNT:TMPNT+TLEN2-1) >*/
	i__5 = *tlen;
	s_copy(text + i__5, tmp + (tmpnt - 1), text_len - i__5, tmpnt + tlen2 
		- 1 - (tmpnt - 1));
/*<         TLEN = TLEN + TLEN2 >*/
	*tlen += tlen2;
/*<       END IF >*/
    }

/* CCC */
/*   Hours field */
/* CCC */

/*<       IF (WRIT(2)) THEN >*/
    if (writ[2]) {
/*<         LAST = TLEN + 1 >*/
	*last = *tlen + 1;

/*   Write into temporary field */

/*<         FIELD = ' ' >*/
	s_copy(field, " ", (ftnlen)30, (ftnlen)1);
/*<         CALL PGNPL (0, IVAL(2), FLEN) >*/
	pgnpl_(&c__0, &ival[2], &flen);
/*<         WRITE (FIELD, '(I6)') IVAL(2) >*/
	s_wsfi(&io___111);
	do_fio(&c__1, (char *)&ival[2], (ftnlen)sizeof(integer));
	e_wsfi();
/*<         FMAX = 6 >*/
	fmax = 6;
/*<         FST = FMAX - FLEN + 1 >*/
	fst = fmax - flen + 1;

/*<         IF (DO2 .AND. FLEN.EQ.1) THEN >*/
	if (*do2 && flen == 1) {
/*<           FLEN = FLEN + 1 >*/
	    ++flen;
/*<           FST = FST - 1 >*/
	    --fst;
/*<           FIELD(FST:FST) = '0' >*/
	    *(unsigned char *)&field[fst - 1] = '0';
/*<         END IF >*/
	}

/*   Write output text string with desired superscripting */

/*<         TMPNT = 2 >*/
	tmpnt = 2;
/*<         IF (SIGNF.EQ.'H' .AND. ASIGN.NE.' ') TMPNT = 1 >*/
	if (*(unsigned char *)signf == 'H' && *(unsigned char *)asign != ' ') 
		{
	    tmpnt = 1;
	}

/*<         TMP = ASIGN//FIELD(FST:FMAX)//SUPER(2,SUPPNT) >*/
/* Writing concatenation */
	i__4[0] = 1, a__4[0] = asign;
	i__4[1] = fmax - (fst - 1), a__4[1] = field + (fst - 1);
	i__4[2] = 11, a__4[2] = super + ((suppnt << 2) - 3) * 11;
	s_cat(tmp, a__4, i__4, &c__3, (ftnlen)100);
/*<         TLEN2 = (2 - TMPNT) + FLEN + TRLEN(SUPPNT) >*/
	tlen2 = 2 - tmpnt + flen + trlen[suppnt - 1];

/*<         TEXT(TLEN+1:) = TMP(TMPNT:TMPNT+TLEN2-1) >*/
	i__5 = *tlen;
	s_copy(text + i__5, tmp + (tmpnt - 1), text_len - i__5, tmpnt + tlen2 
		- 1 - (tmpnt - 1));
/*<         TLEN = TLEN + TLEN2 >*/
	*tlen += tlen2;
/*<       END IF >*/
    }

/* CCC */
/*   Minutes field */
/* CCC */

/*<       IF (WRIT(3)) THEN >*/
    if (writ[3]) {
/*<         LAST = TLEN + 1 >*/
	*last = *tlen + 1;

/*   Write into temporary field with desired superscripting */

/*<         FIELD = ' ' >*/
	s_copy(field, " ", (ftnlen)30, (ftnlen)1);
/*<    >*/
	s_wsfi(&io___112);
	do_fio(&c__1, (char *)&ival[3], (ftnlen)sizeof(integer));
	do_fio(&c__1, super + ((suppnt << 2) - 2) * 11, trlen[suppnt - 1]);
	e_wsfi();
/*<         FMAX = 2 + TRLEN(SUPPNT) >*/
	fmax = trlen[suppnt - 1] + 2;

/*<         FST = 1 >*/
	fst = 1;
/*<         IF (FIELD(FST:FST).EQ.' ') THEN >*/
	if (*(unsigned char *)&field[fst - 1] == ' ') {
/*<           IF (DO2) THEN >*/
	    if (*do2) {
/*<             FIELD(FST:FST) = '0' >*/
		*(unsigned char *)&field[fst - 1] = '0';
/*<           ELSE >*/
	    } else {
/*<             FST = FST + 1 >*/
		++fst;
/*<           END IF >*/
	    }
/*<         END IF >*/
	}
/*<         FLEN = FMAX - FST + 1 >*/
	flen = fmax - fst + 1;

/*   Write output text string */

/*<         TMPNT = 2 >*/
	tmpnt = 2;
/*<         IF (SIGNF.EQ.'M' .AND. ASIGN.NE.' ') TMPNT = 1 >*/
	if (*(unsigned char *)signf == 'M' && *(unsigned char *)asign != ' ') 
		{
	    tmpnt = 1;
	}

/*<         TMP = ASIGN//FIELD(FST:FMAX) >*/
/* Writing concatenation */
	i__6[0] = 1, a__5[0] = asign;
	i__6[1] = fmax - (fst - 1), a__5[1] = field + (fst - 1);
	s_cat(tmp, a__5, i__6, &c__2, (ftnlen)100);
/*<         TLEN2 = (2 - TMPNT) + FLEN >*/
	tlen2 = 2 - tmpnt + flen;

/*<         TEXT(TLEN+1:) = TMP(TMPNT:TMPNT+TLEN2-1) >*/
	i__5 = *tlen;
	s_copy(text + i__5, tmp + (tmpnt - 1), text_len - i__5, tmpnt + tlen2 
		- 1 - (tmpnt - 1));
/*<         TLEN = TLEN + TLEN2 >*/
	*tlen += tlen2;
/*<       END IF >*/
    }

/* CCC */
/*   Seconds field */
/* CCC */

/*<       IF (WRIT(4)) THEN >*/
    if (writ[4]) {
/*<         LAST = TLEN + 1 >*/
	*last = *tlen + 1;

/*   Write into temporary field */

/*<         FIELD = ' ' >*/
	s_copy(field, " ", (ftnlen)30, (ftnlen)1);
/*<         FST = 1 >*/
	fst = 1;
/*<         IF (SPREC.GE.1) THEN >*/
	if (*sprec >= 1) {

/*   Fractional label.  Upto 3 places after the decimal point allowed */
/*   Muck around to get the superscript on top of the decimal point */

/*<           IR1 = INT(RVAL) >*/
	    ir1 = (integer) (*rval);
/*<           IR2 = NINT((RVAL - IR1) * 10**SPREC) >*/
	    r__1 = (*rval - ir1) * pow_ii(&c__10, sprec);
	    ir2 = i_nint(&r__1);
/*<           FRMAT = '(I2, A1, A, '//FRMAT2(SPREC)//')' >*/
/* Writing concatenation */
	    i__4[0] = 12, a__4[0] = "(I2, A1, A, ";
	    i__4[1] = 2, a__4[1] = frmat2 + (*sprec - 1 << 1);
	    i__4[2] = 1, a__4[2] = ")";
	    s_cat(frmat, a__4, i__4, &c__3, (ftnlen)30);
/*<    >*/
	    s_wsfi(&io___116);
	    do_fio(&c__1, (char *)&ir1, (ftnlen)sizeof(integer));
	    do_fio(&c__1, ".", (ftnlen)1);
/* Writing concatenation */
	    i__4[0] = 1, a__4[0] = bsl;
	    i__4[1] = 1, a__4[1] = "b";
	    i__4[2] = trlen[suppnt - 1], a__4[2] = super + ((suppnt << 2) - 1)
		     * 11;
	    s_cat(ch__1, a__4, i__4, &c__3, (ftnlen)13);
	    do_fio(&c__1, ch__1, trlen[suppnt - 1] + 2);
	    do_fio(&c__1, (char *)&ir2, (ftnlen)sizeof(integer));
	    e_wsfi();
/*<           IP = 5 + TRLEN(SUPPNT) + 1 >*/
	    ip = trlen[suppnt - 1] + 6;
/*<           IF (FIELD(IP:IP).EQ.' ') FIELD(IP:IP) = '0' >*/
	    if (*(unsigned char *)&field[ip - 1] == ' ') {
		*(unsigned char *)&field[ip - 1] = '0';
	    }
/*<           IF (FIELD(IP+1:IP+1).EQ.' ') FIELD(IP+1:IP+1) = '0' >*/
	    i__5 = ip;
	    if (s_cmp(field + i__5, " ", ip + 1 - i__5, (ftnlen)1) == 0) {
		i__7 = ip;
		s_copy(field + i__7, "0", ip + 1 - i__7, (ftnlen)1);
	    }
/*<           FMAX = 1 + 2 + SPREC >*/
	    fmax = *sprec + 3;
/*<         ELSE >*/
	} else {

/*   Integer label. */

/*<    >*/
	    s_wsfi(&io___118);
	    i__5 = i_nint(rval);
	    do_fio(&c__1, (char *)&i__5, (ftnlen)sizeof(integer));
	    do_fio(&c__1, super + ((suppnt << 2) - 1) * 11, trlen[suppnt - 1])
		    ;
	    e_wsfi();
/*<           FMAX = 0 >*/
	    fmax = 0;
/*<         END IF >*/
	}
/*<         FMAX = FMAX + 2 + TRLEN(SUPPNT) >*/
	fmax = fmax + 2 + trlen[suppnt - 1];

/*<         IF (FIELD(FST:FST).EQ.' ') THEN >*/
	if (*(unsigned char *)&field[fst - 1] == ' ') {
/*<           IF (DO2) THEN >*/
	    if (*do2) {
/*<             FIELD(FST:FST) = '0' >*/
		*(unsigned char *)&field[fst - 1] = '0';
/*<           ELSE >*/
	    } else {
/*<             FST = FST + 1 >*/
		++fst;
/*<           END IF >*/
	    }
/*<         END IF >*/
	}
/*<         FLEN = FMAX - FST + 1 >*/
	flen = fmax - fst + 1;

/*   Write output text string */

/*<         TMPNT = 2 >*/
	tmpnt = 2;
/*<         IF (SIGNF.EQ.'S' .AND. ASIGN.NE.' ') TMPNT = 1 >*/
	if (*(unsigned char *)signf == 'S' && *(unsigned char *)asign != ' ') 
		{
	    tmpnt = 1;
	}
/*<         TMP = ASIGN//FIELD(FST:FMAX) >*/
/* Writing concatenation */
	i__6[0] = 1, a__5[0] = asign;
	i__6[1] = fmax - (fst - 1), a__5[1] = field + (fst - 1);
	s_cat(tmp, a__5, i__6, &c__2, (ftnlen)100);
/*<         TLEN2 = (3 - TMPNT) + FLEN >*/
	tlen2 = 3 - tmpnt + flen;

/*<         TEXT(TLEN+1:) = TMP(TMPNT:TMPNT+TLEN2-1) >*/
	i__5 = *tlen;
	s_copy(text + i__5, tmp + (tmpnt - 1), text_len - i__5, tmpnt + tlen2 
		- 1 - (tmpnt - 1));
/*<         TLEN = TLEN + TLEN2 >*/
	*tlen += tlen2;
/*<       END IF >*/
    }

/*   A trailing blank will occur if no superscripting wanted */

/*<    >*/
    i__5 = *tlen - 5;
/* Writing concatenation */
    i__3[0] = 1, a__3[0] = bsl;
    i__3[1] = 1, a__3[1] = "u";
    i__3[2] = 1, a__3[2] = " ";
    i__3[3] = 1, a__3[3] = bsl;
    i__3[4] = 1, a__3[4] = "d";
    s_cat(ch__2, a__3, i__3, &c__5, (ftnlen)5);
    if (*tlen >= 5 && s_cmp(text + i__5, ch__2, *tlen - i__5, (ftnlen)5) == 0)
	     {
	*tlen += -5;
    }

/*<       RETURN >*/
    return 0;
/*<       END >*/
} /* pgtbx7_ */

