/* /work2/ssa/pgplot/src/pgtick.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__2 = 2;
static real c_b5 = (float)360.;

/* *PGTICK -- draw a single tick mark on an axis */
/* %void cpgtick(float x1, float y1, float x2, float y2, float v, \ */
/* % float tikl, float tikr, float disp, float orient, const char *str); */
/* + */
/*<    >*/
/* Subroutine */ int pgtick_(x1, y1, x2, y2, v, tikl, tikr, disp, orient, str,
	 str_len)
real *x1, *y1, *x2, *y2, *v, *tikl, *tikr, *disp, *orient;
char *str;
ftnlen str_len;
{
    /* System generated locals */
    real r__1, r__2, r__3;

    /* Builtin functions */
    double sqrt(), atan2();
    integer s_cmp();
    double r_mod();

    /* Local variables */
    static real tikx, tiky, xpmm, ypmm, d__, angle, x, y, lenmm;
    extern /* Subroutine */ int pgqcs_();
    static real fjust;
    extern /* Subroutine */ int pgqvp_();
    static real or;
    extern /* Subroutine */ int pgdraw_(), pgmove_(), pgqwin_(), pgptxt_();
    static real xv1, xv2, yv1, yv2, xw1, xw2, yw1, yw2, xch, ych;

/*<       REAL X1, Y1, X2, Y2, V, TIKL, TIKR, DISP, ORIENT >*/
/*<       CHARACTER*(*) STR >*/

/* Draw and label single tick mark on a graph axis. The tick mark is */
/* a short line perpendicular to the direction of the axis (which is not */
/* drawn by this routine). The optional text label is drawn with its */
/* baseline parallel to the axis and reading in the same direction as */
/* the axis (from point 1 to point 2). Current line and text attributes */
/* are used. */

/* Arguments: */
/*  X1, Y1 (input)  : world coordinates of one endpoint of the axis. */
/*  X2, Y2 (input)  : world coordinates of the other endpoint of the axis. */
/*  V      (input)  : draw the tick mark at fraction V (0<=V<=1) along */
/*                    the line from (X1,Y1) to (X2,Y2). */
/*  TIKL   (input)  : length of tick mark drawn to left of axis */
/*                    (as seen looking from first endpoint to second), in */
/*                    units of the character height. */
/*  TIKR   (input)  : length of major tick marks drawn to right of axis, */
/*                    in units of the character height. */
/*  DISP   (input)  : displacement of label text to */
/*                    right of axis, in units of the character height. */
/*  ORIENT (input)  : orientation of label text, in degrees; angle between */
/*                    baseline of text and direction of axis (0-360). */
/*  STR    (input)  : text of label (may be blank). */
/* -- */
/* 25-Mar-1997 - new routine [TJP]. */
/* ----------------------------------------------------------------------- */
/*<       REAL X, Y, XV1, XV2, YV1, YV2, XW1, XW2, YW1, YW2 >*/
/*<       REAL XPMM, YPMM, LENMM, ANGLE, XCH, YCH >*/
/*<       REAL TIKX, TIKY, FJUST, D, OR >*/

/* Check arguments. */

/*<       IF (X1.EQ.X2 .AND. Y1.EQ.Y2) RETURN >*/
    if (*x1 == *x2 && *y1 == *y2) {
	return 0;
    }

/* Get current character height (mm) [note: XCH = YCH]. */

/*<       CALL PGQCS(2, XCH, YCH) >*/
    pgqcs_(&c__2, &xch, &ych);

/* Get x and y scales (units per mm). */

/*<       CALL PGQVP(2, XV1, XV2, YV1, YV2) >*/
    pgqvp_(&c__2, &xv1, &xv2, &yv1, &yv2);
/*<       CALL PGQWIN(XW1, XW2, YW1, YW2) >*/
    pgqwin_(&xw1, &xw2, &yw1, &yw2);
/*<       XPMM  = (XW2-XW1)/(XV2-XV1) >*/
    xpmm = (xw2 - xw1) / (xv2 - xv1);
/*<       YPMM  = (YW2-YW1)/(YV2-YV1) >*/
    ypmm = (yw2 - yw1) / (yv2 - yv1);

/* Length of axis in mm. */

/*<       LENMM = SQRT(((X2-X1)/XPMM)**2 + ((Y2-Y1)/YPMM)**2) >*/
/* Computing 2nd power */
    r__1 = (*x2 - *x1) / xpmm;
/* Computing 2nd power */
    r__2 = (*y2 - *y1) / ypmm;
    lenmm = sqrt(r__1 * r__1 + r__2 * r__2);

/* Angle of axis to horizontal (device coordinates). */

/*<       ANGLE = ATAN2((Y2-Y1)/YPMM, (X2-X1)/XPMM)*57.29577951 >*/
    angle = atan2((*y2 - *y1) / ypmm, (*x2 - *x1) / xpmm) * (float)
	    57.29577951;

/* (x,y) displacement for 1 character height perpendicular to axis. */

/*<       TIKX = (Y1-Y2)*XCH*XPMM/(LENMM*YPMM) >*/
    tikx = (*y1 - *y2) * xch * xpmm / (lenmm * ypmm);
/*<       TIKY = (X2-X1)*XCH*YPMM/(LENMM*XPMM) >*/
    tiky = (*x2 - *x1) * xch * ypmm / (lenmm * xpmm);

/* Draw the tick mark at point (X,Y) on the axis. */

/*<       X = X1 + V*(X2-X1) >*/
    x = *x1 + *v * (*x2 - *x1);
/*<       Y = Y1 + V*(Y2-Y1) >*/
    y = *y1 + *v * (*y2 - *y1);
/*<       CALL PGMOVE(X - TIKR*TIKX, Y - TIKR*TIKY) >*/
    r__1 = x - *tikr * tikx;
    r__2 = y - *tikr * tiky;
    pgmove_(&r__1, &r__2);
/*<       CALL PGDRAW(X + TIKL*TIKX, Y + TIKL*TIKY) >*/
    r__1 = x + *tikl * tikx;
    r__2 = y + *tikl * tiky;
    pgdraw_(&r__1, &r__2);

/* Label the tick mark. */

/*<       D = DISP >*/
    d__ = *disp;
/*<       IF (STR.EQ.' ') RETURN >*/
    if (s_cmp(str, " ", str_len, (ftnlen)1) == 0) {
	return 0;
    }
/*<       OR = MOD(ORIENT, 360.0) >*/
    or = r_mod(orient, &c_b5);
/*<       IF (OR.LT.0.0) OR=OR+360.0 >*/
    if (or < (float)0.) {
	or += (float)360.;
    }
/*<       IF (OR.GT.45.0 .AND. OR.LE.135.0) THEN >*/
    if (or > (float)45. && or <= (float)135.) {
/*<          FJUST = 0.0 >*/
	fjust = (float)0.;
/*<          IF (D.LT.0.0) FJUST = 1.0 >*/
	if (d__ < (float)0.) {
	    fjust = (float)1.;
	}
/*<       ELSE IF (OR.GT.135.0 .AND. OR.LE.225.0) THEN >*/
    } else if (or > (float)135. && or <= (float)225.) {
/*<          FJUST = 0.5 >*/
	fjust = (float).5;
/*<          IF (D.LT.0.0) D = D-1.0 >*/
	if (d__ < (float)0.) {
	    d__ += (float)-1.;
	}
/*<       ELSE IF (OR.GT.225.0 .AND. OR.LE.315.0) THEN >*/
    } else if (or > (float)225. && or <= (float)315.) {
/*<          ANGLE = ANGLE+90.0 >*/
	angle += (float)90.;
/*<          FJUST = 1.0 >*/
	fjust = (float)1.;
/*<          IF (D.LT.0.0) FJUST = 0.0 >*/
	if (d__ < (float)0.) {
	    fjust = (float)0.;
	}
/*<       ELSE >*/
    } else {
/*<          FJUST = 0.5 >*/
	fjust = (float).5;
/*<          IF (D.GT.0.0) D = D+1.0 >*/
	if (d__ > (float)0.) {
	    d__ += (float)1.;
	}
/*<       END IF             >*/
    }
/*<       CALL PGPTXT(X-D*TIKX, Y-D*TIKY, ANGLE-OR, FJUST, STR) >*/
    r__1 = x - d__ * tikx;
    r__2 = y - d__ * tiky;
    r__3 = angle - or;
    pgptxt_(&r__1, &r__2, &r__3, &fjust, str, str_len);
/*<       END >*/
} /* pgtick_ */

