/* /work2/ssa/pgplot/src/pgvect.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* *PGVECT -- vector map of a 2D data array, with blanking */
/* %void cpgvect(const float *a, const float *b, int idim, int jdim, \ */
/* % int i1, int i2, int j1, int j2, float c, int nc, \ */
/* % const float *tr, float blank); */
/* + */
/*<    >*/
/* Subroutine */ int pgvect_(a, b, idim, jdim, i1, i2, j1, j2, c__, nc, tr, 
	blank)
real *a, *b;
integer *idim, *jdim, *i1, *i2, *j1, *j2;
real *c__;
integer *nc;
real *tr, *blank;
{
    /* System generated locals */
    integer a_dim1, a_offset, b_dim1, b_offset, i__1, i__2;
    real r__1, r__2, r__3, r__4, r__5, r__6;

    /* Builtin functions */
    double sqrt();

    /* Local variables */
    static integer i__, j;
    static real x1, y1, x2, y2, cc;
    extern /* Subroutine */ int pgbbuf_(), pgebuf_(), pgarro_();

/*<       INTEGER IDIM, JDIM, I1, I2, J1, J2, NC >*/
/*<       REAL    A(IDIM,JDIM), B(IDIM, JDIM), TR(6), BLANK, C >*/

/* Draw a vector map of two arrays.  This routine is similar to */
/* PGCONB in that array elements that have the "magic value" defined by */
/* the argument BLANK are ignored, making gaps in the vector map.  The */
/* routine may be useful for data measured on most but not all of the */
/* points of a grid. Vectors are displayed as arrows; the style of the */
/* arrowhead can be set with routine PGSAH, and the the size of the */
/* arrowhead is determined by the current character size, set by PGSCH. */

/* Arguments: */
/*  A      (input)  : horizontal component data array. */
/*  B      (input)  : vertical component data array. */
/*  IDIM   (input)  : first dimension of A and B. */
/*  JDIM   (input)  : second dimension of A and B. */
/*  I1,I2  (input)  : range of first index to be mapped (inclusive). */
/*  J1,J2  (input)  : range of second index to be mapped (inclusive). */
/*  C      (input)  : scale factor for vector lengths, if 0.0, C will be */
/*                    set so that the longest vector is equal to the */
/*                    smaller of TR(2)+TR(3) and TR(5)+TR(6). */
/*  NC     (input)  : vector positioning code. */
/*                    <0 vector head positioned on coordinates */
/*                    >0 vector base positioned on coordinates */
/*                    =0 vector centered on the coordinates */
/*  TR     (input)  : array defining a transformation between the I,J */
/*                    grid of the array and the world coordinates. The */
/*                    world coordinates of the array point A(I,J) are */
/*                    given by: */
/*                      X = TR(1) + TR(2)*I + TR(3)*J */
/*                      Y = TR(4) + TR(5)*I + TR(6)*J */
/*                    Usually TR(3) and TR(5) are zero - unless the */
/*                    coordinate transformation involves a rotation */
/*                    or shear. */
/*  BLANK   (input) : elements of arrays A or B that are exactly equal to */
/*                    this value are ignored (blanked). */
/* -- */
/*  4-Sep-1992: derived from PGCONB [J. Crane]. */
/* 26-Nov-1992: revised to use PGARRO [TJP]. */
/* 25-Mar-1994: correct error for NC not =0 [G. Gonczi]. */
/*  5-Oct-1996: correct error in computing max vector length [TJP; */
/*              thanks to David Singleton]. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER  I, J >*/
/*<       REAL X, Y, X1, Y1, X2, Y2 >*/
/*<       REAL CC >*/
/*<       INTRINSIC SQRT, MAX, MIN >*/

/* Define grid to world transformation */

/*<       X(I,J) = TR(1) + TR(2)*I + TR(3)*J >*/
/*<       Y(I,J) = TR(4) + TR(5)*I + TR(6)*J >*/

/* Check arguments. */

/*<    >*/
    /* Parameter adjustments */
    b_dim1 = *idim;
    b_offset = 1 + b_dim1 * 1;
    b -= b_offset;
    a_dim1 = *idim;
    a_offset = 1 + a_dim1 * 1;
    a -= a_offset;
    --tr;

    /* Function Body */
    if (*i1 < 1 || *i2 > *idim || *i1 >= *i2 || *j1 < 1 || *j2 > *jdim || *j1 
	    >= *j2) {
/*        CALL GRWARN('PGVECT: invalid range I1:I2, J1:J2') */
/*<          RETURN >*/
	return 0;
/*<       END IF >*/
    }

/* Check for scale factor C. */

/*<       CC = C >*/
    cc = *c__;
/*<       IF (CC.EQ.0.0) THEN >*/
    if (cc == (float)0.) {
/*<          DO 20 J=J1,J2 >*/
	i__1 = *j2;
	for (j = *j1; j <= i__1; ++j) {
/*<             DO 10 I=I1,I2 >*/
	    i__2 = *i2;
	    for (i__ = *i1; i__ <= i__2; ++i__) {
/*<    >*/
		if (a[i__ + j * a_dim1] != *blank && b[i__ + j * b_dim1] != *
			blank) {
/* Computing MAX */
/* Computing 2nd power */
		    r__3 = a[i__ + j * a_dim1];
/* Computing 2nd power */
		    r__4 = b[i__ + j * b_dim1];
		    r__1 = cc, r__2 = sqrt(r__3 * r__3 + r__4 * r__4);
		    cc = dmax(r__1,r__2);
		}
/*<  10         CONTINUE >*/
/* L10: */
	    }
/*<  20      CONTINUE >*/
/* L20: */
	}
/*<          IF (CC.EQ.0.0) RETURN >*/
	if (cc == (float)0.) {
	    return 0;
	}
/*<          CC = SQRT(MIN(TR(2)**2+TR(3)**2,TR(5)**2+TR(6)**2))/CC >*/
/* Computing MIN */
/* Computing 2nd power */
	r__3 = tr[2];
/* Computing 2nd power */
	r__4 = tr[3];
/* Computing 2nd power */
	r__5 = tr[5];
/* Computing 2nd power */
	r__6 = tr[6];
	r__1 = r__3 * r__3 + r__4 * r__4, r__2 = r__5 * r__5 + r__6 * r__6;
	cc = sqrt((dmin(r__1,r__2))) / cc;
/*<       END IF >*/
    }

/*<       CALL PGBBUF >*/
    pgbbuf_();

/*<       DO 40 J=J1,J2 >*/
    i__1 = *j2;
    for (j = *j1; j <= i__1; ++j) {
/*<          DO 30 I=I1,I2 >*/
	i__2 = *i2;
	for (i__ = *i1; i__ <= i__2; ++i__) {

/* Ignore vector if element of A and B are both equal to BLANK */

/*<             IF (.NOT.(A(I,J).EQ.BLANK .AND. B(I,J).EQ.BLANK)) THEN >*/
	    if (! (a[i__ + j * a_dim1] == *blank && b[i__ + j * b_dim1] == *
		    blank)) {

/* Define the vector starting and end points according to NC. */

/*<                IF (NC.LT.0) THEN >*/
		if (*nc < 0) {
/*<                   X2 = X(I,J) >*/
		    x2 = tr[1] + tr[2] * i__ + tr[3] * j;
/*<                   Y2 = Y(I,J) >*/
		    y2 = tr[4] + tr[5] * i__ + tr[6] * j;
/*<                   X1 = X2 - A(I,J)*CC >*/
		    x1 = x2 - a[i__ + j * a_dim1] * cc;
/*<                   Y1 = Y2 - B(I,J)*CC >*/
		    y1 = y2 - b[i__ + j * b_dim1] * cc;
/*<                ELSE IF (NC.EQ.0) THEN >*/
		} else if (*nc == 0) {
/*<                   X2 = X(I,J) + 0.5*A(I,J)*CC >*/
		    x2 = tr[1] + tr[2] * i__ + tr[3] * j + a[i__ + j * a_dim1]
			     * (float).5 * cc;
/*<                   Y2 = Y(I,J) + 0.5*B(I,J)*CC >*/
		    y2 = tr[4] + tr[5] * i__ + tr[6] * j + b[i__ + j * b_dim1]
			     * (float).5 * cc;
/*<                   X1 = X2 - A(I,J)*CC >*/
		    x1 = x2 - a[i__ + j * a_dim1] * cc;
/*<                   Y1 = Y2 - B(I,J)*CC >*/
		    y1 = y2 - b[i__ + j * b_dim1] * cc;
/*<                ELSE >*/
		} else {
/*<                   X1 = X(I,J) >*/
		    x1 = tr[1] + tr[2] * i__ + tr[3] * j;
/*<                   Y1 = Y(I,J) >*/
		    y1 = tr[4] + tr[5] * i__ + tr[6] * j;
/*<                   X2 = X1 + A(I,J)*CC >*/
		    x2 = x1 + a[i__ + j * a_dim1] * cc;
/*<                   Y2 = Y1 + B(I,J)*CC >*/
		    y2 = y1 + b[i__ + j * b_dim1] * cc;
/*<                END IF >*/
		}

/* Draw vector. */

/*<                CALL PGARRO(X1, Y1, X2, Y2) >*/
		pgarro_(&x1, &y1, &x2, &y2);
/*<             END IF >*/
	    }
/*<  30      CONTINUE >*/
/* L30: */
	}
/*<  40   CONTINUE >*/
/* L40: */
    }

/*<       CALL PGEBUF >*/
    pgebuf_();
/*<       END >*/
} /* pgvect_ */

