/* /work2/ssa/pgplot/src/pgwnad.f -- translated by f2c (version 20000121).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer pgid, pgdevs[8], pgadvs[8], pgnx[8], pgny[8], pgnxc[8], pgnyc[8];
    real pgxpin[8], pgypin[8], pgxsp[8], pgysp[8], pgxsz[8], pgysz[8], pgxoff[
	    8], pgyoff[8], pgxvp[8], pgyvp[8], pgxlen[8], pgylen[8], pgxorg[8]
	    , pgyorg[8], pgxscl[8], pgyscl[8], pgxblc[8], pgxtrc[8], pgyblc[8]
	    , pgytrc[8], trans[6];
    logical pgprmp[8];
    integer pgclp[8], pgfas[8];
    real pgchsz[8];
    integer pgblev[8];
    logical pgrows[8];
    integer pgahs[8];
    real pgaha[8], pgahv[8];
    integer pgtbci[8], pgmnci[8], pgmxci[8], pgcint, pgcmin;
    logical pgpfix[8];
    integer pgitf[8];
    real pghsa[8], pghss[8], pghsp[8];
} pgplt1_;

#define pgplt1_1 pgplt1_

struct {
    char pgclab[32];
} pgplt2_;

#define pgplt2_1 pgplt2_

/* *PGWNAD -- set window and adjust viewport to same aspect ratio */
/* %void cpgwnad(float x1, float x2, float y1, float y2); */
/* + */
/*<       SUBROUTINE PGWNAD (X1, X2, Y1, Y2) >*/
/* Subroutine */ int pgwnad_(x1, x2, y1, y2)
real *x1, *x2, *y1, *y2;
{
    /* System generated locals */
    real r__1, r__2, r__3, r__4;

    /* Local variables */
    static real scale, oxlen, oylen;
    extern /* Subroutine */ int grwarn_();
    extern logical pgnoto_();
    extern /* Subroutine */ int pgswin_();

/*<       REAL X1, X2, Y1, Y2 >*/

/* Change the window in world coordinate space that is to be mapped on */
/* to the viewport, and simultaneously adjust the viewport so that the */
/* world-coordinate scales are equal in x and y. The new viewport is */
/* the largest one that can fit within the previously set viewport */
/* while retaining the required aspect ratio. */

/* Arguments: */
/*  X1     (input)  : the x-coordinate of the bottom left corner */
/*                    of the viewport. */
/*  X2     (input)  : the x-coordinate of the top right corner */
/*                    of the viewport (note X2 may be less than X1). */
/*  Y1     (input)  : the y-coordinate of the bottom left corner */
/*                    of the viewport. */
/*  Y2     (input)  : the y-coordinate of the top right corner of the */
/*                    viewport (note Y2 may be less than Y1). */
/* -- */
/* 25-Sep-1985 - new routine (TJP). */
/* 31-May-1989 - correct error: XVP and YVP not set (TJP). */
/* ----------------------------------------------------------------------- */
/*<       INCLUDE 'pgplot.inc' >*/
/*<       LOGICAL PGNOTO >*/
/* ----------------------------------------------------------------------- */
/* PGPLOT: common block definition. */
/* ----------------------------------------------------------------------- */
/* Maximum number of concurrent devices (should match GRIMAX). */
/* ----------------------------------------------------------------------- */
/*<       PARAMETER (PGMAXD=8) >*/
/* ----------------------------------------------------------------------- */
/* Indentifier of currently selected device. */
/* ----------------------------------------------------------------------- */
/*<       INTEGER PGID >*/
/* ----------------------------------------------------------------------- */
/* Device status (indexed by device identifier). */
/* ----------------------------------------------------------------------- */
/* PGDEVS  =0 if device is not open; 1 if device is open. */
/* PGADVS  Set to 0 by PGBEGIN, set to 1 by PGPAGE; used to suppress */
/*         the prompt for the first page. */
/* PROMPT  If .TRUE., ask user before clearing page; set by PGASK */
/*         and (indirectly) by PGBEGIN, used in PGENV. */
/* PGBLEV  Buffering level: incremented by PGBBUF, decremented by */
/*         PGEBUF. */
/* PGPFIX  TRUE if PGPAP has been called, FALSE otherwise. */

/*<       INTEGER PGDEVS(PGMAXD), PGADVS(PGMAXD), PGBLEV(PGMAXD) >*/
/*<       LOGICAL PGPRMP(PGMAXD), PGPFIX(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Panel parameters (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* NX      Number of panels in x direction */
/* NY      Number of panels in y direction */
/* NXC     Ordinal number of current X panel */
/* NYC     Ordinal number of current Y panel */
/* XSZ     X dimension of panel (device units) */
/* YSZ     Y dimension of panel (device units) */
/* PGROWS  TRUE if panels are used in row order, FALSE for column */
/*         order. */

/*<       INTEGER PGNX  (PGMAXD), PGNY  (PGMAXD) >*/
/*<       INTEGER PGNXC (PGMAXD), PGNYC (PGMAXD) >*/
/*<       REAL    PGXSZ (PGMAXD), PGYSZ (PGMAXD) >*/
/*<       LOGICAL PGROWS(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Attributes (indexed by device identification). */
/* ----------------------------------------------------------------------- */
/* PGCLP   clipping enabled/disabed */
/* PGFAS   fill-area style */
/* PGCHSZ  character height */
/* PGAHS   arrow-head fill style */
/* PGAHA   arrow-head angle */
/* PGAHV   arrow-head vent */
/* PGTBCI  text background color index */
/* PGMNCI  lower range of color indices available to PGGRAY/PGIMAG */
/* PGMXCI  upper range of color indices available to PGGRAY/PGIMAG */
/* PGITF   type of transfer function used by PGGRAY/PGIMAG */
/* PGHSA   hatching line angle */
/* PGHSS   hatching line separation */
/* PGHSP   hatching line phase */

/*<       INTEGER PGCLP (PGMAXD) >*/
/*<       INTEGER PGFAS (PGMAXD) >*/
/*<       REAL    PGCHSZ(PGMAXD) >*/
/*<       INTEGER PGAHS (PGMAXD) >*/
/*<       REAL    PGAHA (PGMAXD) >*/
/*<       REAL    PGAHV (PGMAXD) >*/
/*<       INTEGER PGTBCI(PGMAXD) >*/
/*<       INTEGER PGMNCI(PGMAXD) >*/
/*<       INTEGER PGMXCI(PGMAXD) >*/
/*<       INTEGER PGITF (PGMAXD) >*/
/*<       REAL    PGHSA (PGMAXD) >*/
/*<       REAL    PGHSS (PGMAXD) >*/
/*<       REAL    PGHSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Viewport parameters (indexed by device identification); all are device */
/* coordinates: */
/* ----------------------------------------------------------------------- */
/* PGXOFF  X coordinate of blc of viewport. */
/* PGYOFF  Y coordinate of blc of viewport. */
/* PGXVP   X coordinate of blc of viewport, relative to blc of subpage. */
/* PGYVP   Y coordinate of blc of viewport, relative to blc of subpage. */
/* PGXLEN  Width of viewport. */
/* PGYLEN  Height of viewport. */

/*<       REAL   PGXOFF(PGMAXD), PGYOFF(PGMAXD) >*/
/*<       REAL   PGXVP (PGMAXD), PGYVP (PGMAXD) >*/
/*<       REAL   PGXLEN(PGMAXD), PGYLEN(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Scaling parameters (indexed by device identification): */
/* ----------------------------------------------------------------------- */
/* PGXORG  device coordinate value corresponding to world X=0 */
/* PGYORG  device coordinate value corresponding to world Y=0 */
/* PGXSCL  scale in x (device units per world coordinate unit) */
/* PGYSCL  scale in y (device units per world coordinate unit) */
/* PGXPIN  device x scale in device units/inch */
/* PGYPIN  device y scale in device units/inch */
/* PGXSP   Character X spacing (device units) */
/* PGYSP   Character Y spacing (device units) */

/*<       REAL   PGXORG(PGMAXD), PGYORG(PGMAXD) >*/
/*<       REAL   PGXSCL(PGMAXD), PGYSCL(PGMAXD) >*/
/*<       REAL   PGXPIN(PGMAXD), PGYPIN(PGMAXD) >*/
/*<       REAL   PGXSP (PGMAXD), PGYSP (PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* Window parameters (indexed by device identification); all are world */
/* coordinate values: */
/* ----------------------------------------------------------------------- */
/* PGXBLC  world X at bottom left corner of window */
/* PGXTRC  world X at top right corner of window */
/* PGYBLC  world Y at bottom left corner of window */
/* PGYTRC  world Y at top right corner of window */

/*<       REAL    PGXBLC(PGMAXD), PGXTRC(PGMAXD) >*/
/*<       REAL    PGYBLC(PGMAXD), PGYTRC(PGMAXD) >*/
/* ----------------------------------------------------------------------- */
/* The following parameters are used in the contouring routines to pass */
/* information to the action routine. They do not need to be indexed. */
/* ----------------------------------------------------------------------- */
/* TRANS   Transformation matrix for contour plots; copied */
/*         from argument list by PGCONT and used by PGCP. */

/*<       INTEGER PGCINT, PGCMIN >*/
/*<       REAL    TRANS(6) >*/
/*<       CHARACTER*32 PGCLAB >*/
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*<    >*/
/*<       COMMON  /PGPLT2/ PGCLAB >*/
/*<       SAVE    /PGPLT1/ >*/
/*<       SAVE    /PGPLT2/ >*/
/* ----------------------------------------------------------------------- */
/*<       REAL SCALE,OXLEN,OYLEN >*/

/*<       IF (PGNOTO('PGWNAD')) RETURN >*/
    if (pgnoto_("PGWNAD", (ftnlen)6)) {
	return 0;
    }

/* If invalid arguments are specified, issue warning and leave window */
/* unchanged. */

/*<       IF (X1.EQ.X2) THEN >*/
    if (*x1 == *x2) {
/*<          CALL GRWARN('invalid x limits in PGWNAD: X1 = X2.') >*/
	grwarn_("invalid x limits in PGWNAD: X1 = X2.", (ftnlen)36);
/*<       ELSE IF (Y1.EQ.Y2) THEN >*/
    } else if (*y1 == *y2) {
/*<          CALL GRWARN('invalid y limits in PGWNAD: Y1 = Y2.') >*/
	grwarn_("invalid y limits in PGWNAD: Y1 = Y2.", (ftnlen)36);
/*<       ELSE >*/
    } else {
/*<    >*/
/* Computing MIN */
	r__3 = pgplt1_1.pgxlen[pgplt1_1.pgid - 1] / (r__1 = *x2 - *x1, dabs(
		r__1)) / pgplt1_1.pgxpin[pgplt1_1.pgid - 1], r__4 = 
		pgplt1_1.pgylen[pgplt1_1.pgid - 1] / (r__2 = *y2 - *y1, dabs(
		r__2)) / pgplt1_1.pgypin[pgplt1_1.pgid - 1];
	scale = dmin(r__3,r__4);
/*<          PGXSCL(PGID) = SCALE*PGXPIN(PGID) >*/
	pgplt1_1.pgxscl[pgplt1_1.pgid - 1] = scale * pgplt1_1.pgxpin[
		pgplt1_1.pgid - 1];
/*<          PGYSCL(PGID) = SCALE*PGYPIN(PGID) >*/
	pgplt1_1.pgyscl[pgplt1_1.pgid - 1] = scale * pgplt1_1.pgypin[
		pgplt1_1.pgid - 1];
/*<          OXLEN = PGXLEN(PGID) >*/
	oxlen = pgplt1_1.pgxlen[pgplt1_1.pgid - 1];
/*<          OYLEN = PGYLEN(PGID) >*/
	oylen = pgplt1_1.pgylen[pgplt1_1.pgid - 1];
/*<          PGXLEN(PGID) = PGXSCL(PGID)*ABS(X2-X1) >*/
	pgplt1_1.pgxlen[pgplt1_1.pgid - 1] = pgplt1_1.pgxscl[pgplt1_1.pgid - 
		1] * (r__1 = *x2 - *x1, dabs(r__1));
/*<          PGYLEN(PGID) = PGYSCL(PGID)*ABS(Y2-Y1) >*/
	pgplt1_1.pgylen[pgplt1_1.pgid - 1] = pgplt1_1.pgyscl[pgplt1_1.pgid - 
		1] * (r__1 = *y2 - *y1, dabs(r__1));
/*<          PGXVP(PGID)  = PGXVP(PGID) + 0.5*(OXLEN-PGXLEN(PGID)) >*/
	pgplt1_1.pgxvp[pgplt1_1.pgid - 1] += (oxlen - pgplt1_1.pgxlen[
		pgplt1_1.pgid - 1]) * (float).5;
/*<          PGYVP(PGID)  = PGYVP(PGID) + 0.5*(OYLEN-PGYLEN(PGID)) >*/
	pgplt1_1.pgyvp[pgplt1_1.pgid - 1] += (oylen - pgplt1_1.pgylen[
		pgplt1_1.pgid - 1]) * (float).5;
/*<          PGXOFF(PGID) = PGXVP(PGID) + (PGNXC(PGID)-1)*PGXSZ(PGID) >*/
	pgplt1_1.pgxoff[pgplt1_1.pgid - 1] = pgplt1_1.pgxvp[pgplt1_1.pgid - 1]
		 + (pgplt1_1.pgnxc[pgplt1_1.pgid - 1] - 1) * pgplt1_1.pgxsz[
		pgplt1_1.pgid - 1];
/*<    >*/
	pgplt1_1.pgyoff[pgplt1_1.pgid - 1] = pgplt1_1.pgyvp[pgplt1_1.pgid - 1]
		 + (pgplt1_1.pgny[pgplt1_1.pgid - 1] - pgplt1_1.pgnyc[
		pgplt1_1.pgid - 1]) * pgplt1_1.pgysz[pgplt1_1.pgid - 1];
/*<          CALL PGSWIN(X1, X2, Y1, Y2) >*/
	pgswin_(x1, x2, y1, y2);
/*<       END IF >*/
    }
/*<       END >*/
} /* pgwnad_ */

